# !/usr/bin/python
# -*- coding: utf-8 -*-
# @time    : 2024/2/18 15:14
# @author  : Mo
# @function:


from tqdm import tqdm
import traceback
import json


FourAngleDict = {
    '的': '2762',
    '一': '1000',
    '国': '6010',
    '在': '4021',
    '人': '8000',
    '了': '1720',
    '有': '4022',
    '中': '5000',
    '是': '6080',
    '年': '8050',
    '和': '2690',
    '大': '4080',
    '业': '3210',
    '不': '1090',
    '为': '3402',
    '发': '2340',
    '会': '8073',
    '工': '1010',
    '经': '2711',
    '上': '2110',
    '地': '4411',
    '市': '0022',
    '要': '1040',
    '个': '8020',
    '产': '0020',
    '这': '3030',
    '出': '2277',
    '行': '2122',
    '作': '2821',
    '生': '2510',
    '家': '3023',
    '以': '2870',
    '成': '5320',
    '到': '1210',
    '日': '6010',
    '民': '7774',
    '来': '5090',
    '我': '2355',
    '部': '0762',
    '对': '7440',
    '进': '3530',
    '多': '2720',
    '全': '8010',
    '建': '1540',
    '他': '2421',
    '公': '8073',
    '开': '1044',
    '们': '2722',
    '场': '4712',
    '展': '7723',
    '时': '6400',
    '理': '1611',
    '新': '0292',
    '方': '0022',
    '主': '0010',
    '企': '8010',
    '资': '3780',
    '实': '3080',
    '学': '9040',
    '报': '5704',
    '制': '2220',
    '政': '1814',
    '济': '3012',
    '用': '7722',
    '同': '7722',
    '于': '1040',
    '法': '3413',
    '高': '0022',
    '长': '4273',
    '现': '1711',
    '本': '5023',
    '月': '7722',
    '定': '3080',
    '化': '2421',
    '加': '4600',
    '动': '1472',
    '合': '8060',
    '品': '6066',
    '重': '2010',
    '关': '8080',
    '机': '4791',
    '分': '8022',
    '力': '4002',
    '自': '2600',
    '外': '2320',
    '者': '4460',
    '区': '7171',
    '能': '2221',
    '设': '3774',
    '后': '7226',
    '就': '0391',
    '等': '8834',
    '体': '2523',
    '下': '1023',
    '万': '1022',
    '元': '1021',
    '社': '3421',
    '过': '3430',
    '前': '8022',
    '面': '1060',
    '农': '4073',
    '也': '4471',
    '得': '2624',
    '与': '2112',
    '说': '3871',
    '之': '3030',
    '员': '6080',
    '而': '1022',
    '务': '2742',
    '利': '2290',
    '电': '5071',
    '文': '0040',
    '事': '5000',
    '可': '1062',
    '种': '2590',
    '总': '8033',
    '改': '1874',
    '三': '1010',
    '各': '2760',
    '好': '4744',
    '金': '8010',
    '第': '8822',
    '司': '1762',
    '其': '4480',
    '从': '8800',
    '平': '1040',
    '代': '2324',
    '当': '9017',
    '天': '1080',
    '水': '1290',
    '省': '9060',
    '提': '5608',
    '商': '0022',
    '十': '4000',
    '管': '8877',
    '内': '4022',
    '小': '9000',
    '技': '5404',
    '位': '2021',
    '目': '6010',
    '起': '4780',
    '海': '3815',
    '所': '7222',
    '立': '0010',
    '已': '1771',
    '通': '3730',
    '入': '8000',
    '量': '6010',
    '子': '1740',
    '问': '3760',
    '度': '0024',
    '北': '1211',
    '保': '2629',
    '心': '3300',
    '还': '3130',
    '科': '2490',
    '委': '2040',
    '都': '4762',
    '术': '4390',
    '使': '2520',
    '明': '6702',
    '着': '8060',
    '次': '3718',
    '将': '3714',
    '增': '4816',
    '基': '4410',
    '名': '2760',
    '向': '2722',
    '门': '3700',
    '应': '0021',
    '里': '6010',
    '美': '8080',
    '由': '5060',
    '规': '5781',
    '今': '8020',
    '题': '6180',
    '记': '3771',
    '点': '2133',
    '计': '3470',
    '去': '4073',
    '强': '1623',
    '两': '1022',
    '些': '2210',
    '表': '5073',
    '系': '2090',
    '办': '4033',
    '教': '4844',
    '正': '1010',
    '条': '2790',
    '最': '6044',
    '达': '3430',
    '特': '2454',
    '革': '4450',
    '收': '2874',
    '二': '1010',
    '期': '4782',
    '并': '8044',
    '程': '2691',
    '厂': '7120',
    '如': '4640',
    '道': '3830',
    '际': '7129',
    '及': '1724',
    '西': '1060',
    '口': '6000',
    '京': '0090',
    '华': '2440',
    '任': '2221',
    '调': '3772',
    '性': '9501',
    '导': '7734',
    '组': '2711',
    '东': '4090',
    '路': '6716',
    '活': '3216',
    '广': '0020',
    '意': '0033',
    '比': '2271',
    '投': '5704',
    '决': '3518',
    '交': '0040',
    '统': '2011',
    '党': '9021',
    '南': '4022',
    '安': '3040',
    '此': '2211',
    '领': '8138',
    '结': '2416',
    '营': '4460',
    '项': '1118',
    '情': '9502',
    '解': '2725',
    '议': '3470',
    '义': '4000',
    '山': '2277',
    '先': '2421',
    '车': '4050',
    '然': '2333',
    '价': '2822',
    '放': '0824',
    '世': '4471',
    '间': '3760',
    '因': '6080',
    '共': '4480',
    '院': '7321',
    '步': '2120',
    '物': '2752',
    '界': '6022',
    '集': '2090',
    '把': '5701',
    '持': '5404',
    '无': '1041',
    '但': '2621',
    '城': '4315',
    '相': '4690',
    '书': '5302',
    '村': '4490',
    '求': '4390',
    '治': '3316',
    '取': '1744',
    '原': '7129',
    '处': '2340',
    '府': '0024',
    '研': '1164',
    '质': '7228',
    '信': '2026',
    '四': '6021',
    '运': '3130',
    '县': '7773',
    '军': '3750',
    '件': '2520',
    '育': '0022',
    '局': '7722',
    '干': '1040',
    '队': '7820',
    '团': '6024',
    '又': '7740',
    '造': '3430',
    '形': '1242',
    '级': '2714',
    '标': '4199',
    '联': '1848',
    '专': '5030',
    '少': '9020',
    '费': '5580',
    '效': '0844',
    '据': '5706',
    '手': '2050',
    '施': '0821',
    '权': '4794',
    '江': '3111',
    '近': '3230',
    '深': '3719',
    '更': '1050',
    '认': '3870',
    '果': '6090',
    '格': '4796',
    '几': '7721',
    '看': '2060',
    '没': '3714',
    '职': '1648',
    '服': '7724',
    '台': '2360',
    '式': '4310',
    '益': '8010',
    '想': '4633',
    '数': '9844',
    '单': '8050',
    '样': '4895',
    '只': '6080',
    '被': '3424',
    '亿': '2721',
    '老': '4471',
    '受': '2040',
    '优': '2321',
    '常': '9022',
    '销': '8972',
    '志': '4033',
    '战': '2365',
    '流': '3011',
    '很': '2723',
    '接': '5004',
    '乡': '2020',
    '头': '3480',
    '给': '2816',
    '至': '1010',
    '难': '7041',
    '观': '7741',
    '指': '5206',
    '创': '8270',
    '证': '3171',
    '织': '2618',
    '论': '3871',
    '别': '6240',
    '五': '1010',
    '协': '4403',
    '变': '0040',
    '风': '7721',
    '批': '5201',
    '见': '7721',
    '究': '3041',
    '支': '4040',
    '那': '1752',
    '查': '4010',
    '张': '1223',
    '精': '9592',
    '每': '8075',
    '林': '4499',
    '转': '4553',
    '划': '5200',
    '准': '3011',
    '做': '2824',
    '需': '1022',
    '传': '2523',
    '争': '2750',
    '税': '2891',
    '构': '4792',
    '具': '7780',
    '百': '1060',
    '或': '5310',
    '才': '4020',
    '积': '2698',
    '势': '5542',
    '举': '9050',
    '必': '3300',
    '型': '1210',
    '易': '6022',
    '视': '3721',
    '快': '9508',
    '李': '4040',
    '参': '2320',
    '回': '6060',
    '引': '1220',
    '镇': '8478',
    '首': '8060',
    '推': '5001',
    '思': '6033',
    '完': '3021',
    '消': '3912',
    '值': '2421',
    '该': '3078',
    '走': '4080',
    '装': '3473',
    '众': '8088',
    '责': '5080',
    '备': '2760',
    '州': '3200',
    '供': '2428',
    '包': '2771',
    '副': '1260',
    '极': '4794',
    '整': '5810',
    '确': '1762',
    '知': '8680',
    '贸': '7780',
    '己': '1771',
    '环': '1119',
    '话': '3276',
    '反': '7224',
    '身': '2740',
    '选': '3430',
    '亚': '1010',
    '么': '2073',
    '带': '4422',
    '采': '2090',
    '王': '1010',
    '策': '8890',
    '真': '4080',
    '女': '4040',
    '谈': '3978',
    '严': '1020',
    '斯': '4282',
    '况': '3611',
    '色': '2771',
    '打': '5102',
    '德': '2423',
    '告': '2460',
    '仅': '2724',
    '它': '3071',
    '气': '8001',
    '料': '9490',
    '神': '3520',
    '率': '0040',
    '识': '3678',
    '劳': '4442',
    '境': '4011',
    '源': '3119',
    '青': '5022',
    '护': '5300',
    '列': '1220',
    '兴': '9080',
    '许': '3874',
    '户': '3020',
    '马': '7712',
    '港': '3411',
    '则': '7280',
    '节': '4422',
    '款': '4798',
    '拉': '5001',
    '直': '4010',
    '案': '3090',
    '股': '7724',
    '光': '9021',
    '较': '4054',
    '河': '3112',
    '花': '4421',
    '根': '4793',
    '布': '4022',
    '线': '2315',
    '土': '4010',
    '克': '4021',
    '再': '1044',
    '群': '1865',
    '医': '7171',
    '清': '3512',
    '速': '3530',
    '律': '2520',
    '她': '4441',
    '族': '0828',
    '历': '7122',
    '非': '1111',
    '感': '5333',
    '占': '2160',
    '续': '2418',
    '师': '2102',
    '何': '2122',
    '影': '6292',
    '功': '1412',
    '负': '2780',
    '验': '7811',
    '望': '0710',
    '财': '7480',
    '类': '9080',
    '货': '2480',
    '约': '2712',
    '艺': '4471',
    '售': '2060',
    '连': '3430',
    '纪': '2711',
    '按': '5304',
    '讯': '3771',
    '史': '5000',
    '示': '1090',
    '象': '2723',
    '养': '8022',
    '获': '4428',
    '石': '1060',
    '食': '8073',
    '抓': '5203',
    '富': '3060',
    '模': '4498',
    '始': '4346',
    '住': '2021',
    '赛': '3080',
    '客': '3060',
    '越': '4380',
    '闻': '3740',
    '央': '5080',
    '席': '0022',
    '坚': '2710',
    '份': '2822',
    '士': '4010',
    '热': '5533',
    '限': '7723',
    '米': '9090',
    '银': '8773',
    '息': '2633',
    '校': '4094',
    '均': '4712',
    '房': '3022',
    '周': '7722',
    '游': '3814',
    '千': '2040',
    '失': '2580',
    '八': '8000',
    '检': '4891',
    '足': '6080',
    '配': '1761',
    '存': '4024',
    '九': '4001',
    '命': '8062',
    '尔': '2790',
    '即': '7772',
    '防': '7022',
    '钱': '8375',
    '评': '3174',
    '复': '8040',
    '考': '4402',
    '依': '2023',
    '断': '2272',
    '范': '4411',
    '础': '1267',
    '油': '3516',
    '照': '6733',
    '段': '7744',
    '落': '4416',
    '访': '3072',
    '未': '5090',
    '额': '3168',
    '双': '7744',
    '让': '3171',
    '切': '4772',
    '须': '2128',
    '儿': '2201',
    '便': '2124',
    '空': '3010',
    '往': '2021',
    '你': '2729',
    '层': '7723',
    '低': '2224',
    '奖': '3780',
    '注': '3011',
    '黄': '4480',
    '英': '4480',
    '承': '1723',
    '远': '3130',
    '版': '2204',
    '维': '2011',
    '算': '8844',
    '破': '1464',
    '铁': '8578',
    '乐': '7290',
    '边': '3430',
    '初': '3722',
    '满': '3412',
    '病': '0012',
    '响': '6702',
    '药': '4412',
    '助': '7412',
    '致': '1814',
    '善': '8060',
    '突': '3080',
    '爱': '2040',
    '容': '3060',
    '香': '2060',
    '称': '2799',
    '购': '7782',
    '届': '7726',
    '余': '8090',
    '素': '5090',
    '请': '3572',
    '白': '2600',
    '宣': '3010',
    '健': '2524',
    '牌': '2604',
    '促': '2628',
    '培': '4016',
    '竞': '0021',
    '巴': '7771',
    '稳': '2793',
    '继': '2911',
    '紧': '2790',
    '字': '3040',
    '困': '6090',
    '刘': '0240',
    '旅': '0823',
    '声': '4020',
    '超': '4780',
    '随': '7423',
    '例': '2220',
    '担': '5601',
    '友': '4040',
    '号': '6002',
    '显': '6010',
    '却': '4772',
    '监': '2810',
    '材': '4490',
    '且': '7710',
    '春': '5060',
    '居': '7726',
    '适': '3230',
    '除': '7829',
    '红': '2111',
    '半': '9050',
    '买': '1780',
    '充': '0021',
    '陈': '7429',
    '火': '9080',
    '搞': '5002',
    '图': '6030',
    '阳': '7620',
    '六': '0080',
    '察': '3090',
    '试': '3374',
    '太': '4003',
    '什': '2420',
    '执': '5501',
    '片': '2202',
    '古': '4060',
    '七': '4071',
    '球': '1319',
    '修': '2722',
    '尽': '7730',
    '控': '5301',
    '讲': '3570',
    '排': '5101',
    '粮': '9393',
    '武': '1314',
    '预': '1128',
    '亲': '0090',
    '挥': '5705',
    '卖': '4080',
    '审': '3050',
    '措': '5406',
    '荣': '4490',
    '洲': '3210',
    '卫': '1710',
    '希': '4022',
    '店': '0026',
    '良': '3073',
    '属': '7722',
    '险': '7821',
    '曾': '8060',
    '围': '6052',
    '域': '4315',
    '令': '8030',
    '站': '0116',
    '苏': '4433',
    '龙': '4301',
    '念': '8033',
    '罗': '6020',
    '吨': '6501',
    '器': '6666',
    '汇': '3111',
    '康': '0029',
    '减': '3315',
    '习': '1712',
    '演': '3318',
    '普': '8060',
    '田': '6040',
    '班': '1111',
    '待': '2424',
    '星': '6010',
    '飞': '1201',
    '写': '3712',
    '矿': '1060',
    '轻': '4751',
    '扩': '5000',
    '言': '0060',
    '章': '0040',
    '汽': '3811',
    '靠': '2411',
    '毛': '2071',
    '终': '2713',
    '仍': '2722',
    '景': '6090',
    '置': '6010',
    '底': '0024',
    '福': '3126',
    '止': '2110',
    '离': '0022',
    '泽': '3715',
    '波': '3414',
    '兰': '8010',
    '核': '4098',
    '降': '7725',
    '训': '3270',
    '逐': '3130',
    '票': '1090',
    '菜': '4490',
    '座': '0021',
    '献': '4328',
    '钢': '8772',
    '眼': '6703',
    '损': '5608',
    '宁': '3020',
    '像': '2723',
    '苦': '4460',
    '印': '7772',
    '融': '1523',
    '独': '4523',
    '湖': '3712',
    '早': '6040',
    '予': '1720',
    '夫': '5080',
    '编': '2312',
    '换': '5708',
    '欧': '7778',
    '努': '4742',
    '著': '4460',
    '顾': '7128',
    '征': '2121',
    '升': '2440',
    '态': '4033',
    '套': '4073',
    '介': '8022',
    '送': '3830',
    '某': '4490',
    '斗': '3400',
    '状': '3318',
    '画': '1077',
    '留': '7760',
    '航': '2041',
    '派': '3213',
    '室': '3010',
    '临': '2806',
    '兵': '7280',
    '补': '3320',
    '宝': '3010',
    '略': '6706',
    '黑': '6033',
    '综': '2319',
    '云': '1073',
    '差': '8010',
    '纳': '2412',
    '密': '3077',
    '贫': '8080',
    '剧': '7220',
    '犯': '4721',
    '阿': '7122',
    '击': '5077',
    '遇': '3630',
    '岁': '2220',
    '阶': '7822',
    '烈': '1233',
    '督': '2760',
    '吃': '6801',
    '丰': '5000',
    '馆': '2377',
    '招': '5706',
    '害': '3060',
    '官': '3077',
    '树': '4490',
    '听': '6202',
    '庭': '0024',
    '另': '6042',
    '沙': '3912',
    '私': '2293',
    '针': '8470',
    '胜': '7521',
    '贷': '2380',
    '网': '7722',
    '愿': '7123',
    '托': '5201',
    '缺': '8578',
    '园': '6021',
    '假': '2724',
    '酒': '3116',
    '音': '0060',
    '巨': '7171',
    '既': '7171',
    '判': '9250',
    '输': '4852',
    '讨': '3470',
    '测': '3210',
    '读': '3478',
    '洋': '3815',
    '括': '5206',
    '筑': '8811',
    '欢': '7748',
    '刚': '7220',
    '庆': '0028',
    '久': '2780',
    '陆': '7527',
    '找': '5305',
    '楼': '4994',
    '激': '3814',
    '晚': '6701',
    '绝': '2711',
    '压': '7121',
    '故': '4864',
    '互': '1010',
    '签': '8810',
    '汉': '3714',
    '草': '4440',
    '木': '4090',
    '亩': '0060',
    '短': '8181',
    '绍': '2716',
    '迎': '3730',
    '吸': '6704',
    '警': '4860',
    '藏': '4425',
    '疗': '0012',
    '贵': '5080',
    '纷': '2812',
    '授': '5204',
    '登': '1210',
    '探': '5709',
    '索': '4090',
    '湾': '3012',
    '宏': '3073',
    '录': '1790',
    '申': '5000',
    '诉': '3274',
    '秀': '2022',
    '序': '0022',
    '顺': '2108',
    '死': '1021',
    '卡': '2123',
    '歌': '1768',
    '午': '8040',
    '孩': '1048',
    '桥': '4292',
    '喜': '4060',
    '川': '2200',
    '邓': '7742',
    '扬': '5702',
    '津': '3510',
    '温': '3611',
    '船': '2746',
    '库': '0025',
    '订': '3172',
    '练': '2519',
    '候': '2728',
    '退': '3730',
    '违': '3530',
    '否': '1060',
    '彩': '2292',
    '棉': '4692',
    '帮': '5722',
    '拿': '8050',
    '罪': '6011',
    '币': '2022',
    '角': '2722',
    '召': '1760',
    '灾': '3080',
    '妇': '4747',
    '杨': '4792',
    '奋': '4060',
    '绩': '2518',
    '虽': '6013',
    '煤': '9489',
    '免': '2741',
    '笔': '8871',
    '够': '2762',
    '永': '3090',
    '圳': '4210',
    '停': '2022',
    '奥': '2780',
    '鲜': '2815',
    '朝': '4742',
    '吴': '6080',
    '岛': '2772',
    '觉': '9021',
    '移': '2792',
    '尼': '7721',
    '急': '2733',
    '博': '4304',
    '贯': '7780',
    '拥': '5702',
    '束': '5090',
    '左': '4010',
    '细': '2610',
    '舞': '8025',
    '幅': '4126',
    '语': '3176',
    '俄': '2325',
    '奇': '4062',
    '般': '2744',
    '简': '8822',
    '拍': '5600',
    '脑': '7027',
    '债': '2528',
    '固': '6060',
    '威': '5320',
    '券': '9022',
    '追': '3730',
    '筹': '8834',
    '刻': '0280',
    '映': '6508',
    '繁': '8890',
    '伟': '2522',
    '甚': '4471',
    '饭': '2274',
    '右': '4060',
    '彻': '2722',
    '烟': '9680',
    '沿': '3716',
    '街': '2122',
    '血': '2710',
    '冲': '3510',
    '洪': '3418',
    '植': '4491',
    '誉': '9060',
    '刊': '1240',
    '玉': '1010',
    '厅': '7122',
    '救': '4894',
    '潮': '3712',
    '迅': '3730',
    '伍': '2121',
    '怎': '8033',
    '付': '2420',
    '倍': '2026',
    '顿': '5178',
    '述': '3330',
    '播': '5206',
    '励': '7422',
    '斤': '7222',
    '乎': '2040',
    '纸': '2214',
    '振': '5103',
    '旧': '2600',
    '障': '7024',
    '鼓': '4414',
    '艰': '7743',
    '呼': '6204',
    '吉': '4060',
    '男': '6042',
    '绿': '2719',
    '尚': '9022',
    '夏': '1040',
    '亏': '1002',
    '季': '2040',
    '松': '4893',
    '哈': '6806',
    '祖': '3721',
    '典': '5580',
    '韩': '4542',
    '遍': '3330',
    '夜': '0024',
    '轮': '4851',
    '板': '4294',
    '抗': '5001',
    '摄': '5104',
    '杂': '4090',
    '皮': '4024',
    '贡': '1080',
    '借': '2426',
    '幕': '4422',
    '罚': '6072',
    '伤': '2822',
    '岸': '2224',
    '扶': '5508',
    '乱': '2261',
    '曲': '5560',
    '脱': '7821',
    '践': '6315',
    '危': '2721',
    '澳': '3718',
    '童': '0010',
    '散': '4824',
    '味': '6509',
    '叶': '6400',
    '累': '6090',
    '谢': '3470',
    '孙': '1940',
    '邮': '5762',
    '雄': '4071',
    '兼': '8023',
    '微': '2824',
    '呢': '6701',
    '谁': '3071',
    '惠': '5033',
    '偿': '2923',
    '署': '6060',
    '择': '5705',
    '染': '3490',
    '答': '8860',
    '块': '4518',
    '徐': '2829',
    '鱼': '2710',
    '赞': '2480',
    '课': '3679',
    '盛': '5310',
    '延': '1240',
    '瑞': '1212',
    '怀': '9109',
    '堂': '9010',
    '驻': '7011',
    '零': '1030',
    '辆': '4152',
    '齐': '0022',
    '胡': '4762',
    '途': '3830',
    '封': '4410',
    '似': '2820',
    '润': '3712',
    '守': '3034',
    '毕': '2240',
    '坦': '4611',
    '母': '7775',
    '雨': '1022',
    '败': '7884',
    '朱': '2590',
    '污': '3112',
    '趋': '4780',
    '械': '4395',
    '纺': '2012',
    '租': '2791',
    '灵': '1780',
    '拓': '5103',
    '残': '1325',
    '含': '8060',
    '握': '5701',
    '跨': '6412',
    '衣': '0073',
    '储': '2426',
    '瓦': '1071',
    '蒙': '4423',
    '析': '4292',
    '鉴': '2810',
    '竟': '0021',
    '骨': '7722',
    '档': '4997',
    '秘': '2390',
    '禁': '4490',
    '赵': '4480',
    '宾': '3080',
    '异': '7744',
    '伊': '2720',
    '智': '8660',
    '钟': '8570',
    '键': '8574',
    '辉': '9725',
    '跃': '6218',
    '冷': '3813',
    '倒': '2220',
    '庄': '0021',
    '毒': '5075',
    '仪': '2420',
    '哪': '6702',
    '涉': '3112',
    '泛': '3213',
    '宗': '3090',
    '鹏': '7722',
    '归': '2707',
    '岗': '2222',
    '雷': '1060',
    '礼': '3221',
    '尤': '4301',
    '休': '2429',
    '泰': '5090',
    '疾': '0018',
    '肥': '7721',
    '珠': '1519',
    '叫': '6200',
    '牛': '2500',
    '宜': '3010',
    '抵': '5204',
    '挂': '5401',
    '寻': '1734',
    '父': '8040',
    '攻': '1814',
    '佳': '2421',
    '塞': '3010',
    '架': '4690',
    '符': '8824',
    '裁': '4375',
    '虑': '2123',
    '肉': '4022',
    '启': '3026',
    '丽': '1022',
    '露': '1016',
    '鲁': '2760',
    '秋': '2998',
    '昌': '6060',
    '估': '2426',
    '射': '2420',
    '册': '7744',
    '若': '4460',
    '宽': '3021',
    '厚': '7124',
    '盾': '7226',
    '硬': '1164',
    '末': '5090',
    '轨': '4451',
    '饮': '2778',
    '勤': '4412',
    '茶': '4490',
    '诗': '3474',
    '郑': '8782',
    '冠': '3721',
    '涨': '3213',
    '篇': '8822',
    '泥': '3711',
    '唱': '6606',
    '纯': '2511',
    '坡': '4414',
    '熟': '0533',
    '浙': '3212',
    '晓': '6501',
    '抢': '5801',
    '丝': '2210',
    '锦': '8672',
    '载': '4355',
    '笑': '8880',
    '勇': '1742',
    '杰': '4033',
    '患': '5033',
    '乌': '2712',
    '坐': '8810',
    '雪': '1017',
    '戏': '7345',
    '背': '1222',
    '塔': '4416',
    '翻': '2762',
    '沈': '3411',
    '遗': '3530',
    '聚': '1723',
    '渠': '3190',
    '哥': '1062',
    '享': '0040',
    '迹': '3030',
    '森': '4099',
    '辽': '3730',
    '衡': '2122',
    '掌': '9050',
    '牧': '2451',
    '附': '7420',
    '操': '5609',
    '赶': '4180',
    '览': '2821',
    '野': '6712',
    '盟': '6710',
    '殊': '1529',
    '仁': '2121',
    '错': '8476',
    '萨': '4420',
    '夺': '4034',
    '梅': '4895',
    '误': '3678',
    '词': '3772',
    '董': '4410',
    '潜': '3516',
    '卷': '9071',
    '矛': '1722',
    '腐': '0022',
    '亮': '0021',
    '冒': '6060',
    '盖': '8010',
    '旗': '0828',
    '井': '5500',
    '凡': '7721',
    '震': '1023',
    '峰': '2775',
    '坏': '4119',
    '倾': '2128',
    '距': '6111',
    '壮': '3411',
    '惊': '9009',
    '盘': '2710',
    '梁': '3390',
    '摆': '5603',
    '径': '2721',
    '忠': '5033',
    '冰': '3219',
    '峡': '2578',
    '丹': '7744',
    '避': '3030',
    '珍': '1812',
    '乘': '2090',
    '刑': '1240',
    '扎': '5201',
    '透': '3230',
    '迫': '3630',
    '箱': '8896',
    '莫': '4480',
    '跑': '6711',
    '穿': '3024',
    '祝': '3621',
    '乏': '2030',
    '厦': '7124',
    '渐': '3212',
    '软': '4758',
    '询': '3772',
    '折': '5202',
    '浪': '3313',
    '朋': '7722',
    '敢': '1844',
    '诚': '3375',
    '弱': '1712',
    '疑': '2788',
    '邀': '3830',
    '沉': '3711',
    '端': '0212',
    '床': '0029',
    '络': '2716',
    '疆': '1111',
    '缩': '2316',
    '脚': '7722',
    '甘': '4477',
    '贴': '7186',
    '勒': '4452',
    '荒': '4421',
    '唐': '0026',
    '静': '5725',
    '缓': '2214',
    '侵': '2724',
    '句': '2762',
    '尊': '8034',
    '塑': '8710',
    '肃': '5022',
    '怕': '9600',
    '耕': '5590',
    '痛': '0012',
    '援': '5204',
    '劣': '9042',
    '伙': '2928',
    '挑': '5201',
    '洗': '3411',
    '暴': '6090',
    '冬': '2730',
    '龄': '2873',
    '乔': '2022',
    '餐': '2773',
    '肯': '2122',
    '廉': '0023',
    '跟': '6713',
    '阵': '7425',
    '伐': '2325',
    '悉': '2033',
    '忘': '0033',
    '闭': '3724',
    '奔': '4044',
    '恢': '9408',
    '宋': '3090',
    '泉': '2690',
    '杯': '4199',
    '渡': '3014',
    '吗': '6702',
    '奉': '5050',
    '婚': '4246',
    '赴': '4380',
    '恩': '6033',
    '盐': '4310',
    '掉': '5104',
    '洁': '3416',
    '亡': '0071',
    '洛': '3716',
    '聘': '1542',
    '蔬': '4411',
    '混': '3611',
    '摩': '0025',
    '抽': '5506',
    '鸡': '7742',
    '剂': '0220',
    '胆': '7621',
    '麦': '5040',
    '谋': '3479',
    '雅': '7021',
    '废': '0024',
    '贺': '4680',
    '羊': '8050',
    '阔': '3716',
    '唯': '6001',
    '捐': '5602',
    '返': '3230',
    '隆': '7721',
    '穷': '3042',
    '辛': '0040',
    '猪': '4426',
    '帐': '4223',
    '饰': '2872',
    '郭': '0742',
    '颁': '8128',
    '灯': '9182',
    '绕': '2511',
    '诸': '3476',
    '伴': '2925',
    '顶': '1128',
    '祥': '3825',
    '谓': '3672',
    '恶': '1033',
    '番': '2060',
    '敏': '8874',
    '旦': '6010',
    '劲': '1412',
    '缴': '2814',
    '麻': '0029',
    '屋': '7721',
    '跳': '6211',
    '码': '1762',
    '鞋': '4451',
    '扣': '5600',
    '迈': '3130',
    '忙': '9001',
    '趣': '4780',
    '盈': '1710',
    '棋': '4498',
    '勃': '4442',
    '敬': '4864',
    '辑': '4654',
    '摊': '5001',
    '旺': '6101',
    '纠': '2210',
    '炼': '9589',
    '梦': '4420',
    '偏': '2322',
    '渔': '3711',
    '牙': '7124',
    '侨': '2222',
    '黎': '2790',
    '赔': '7086',
    '裕': '3826',
    '宫': '3060',
    '谷': '8060',
    '概': '4191',
    '稿': '2092',
    '柱': '4091',
    '弹': '1825',
    '殖': '1421',
    '秩': '2598',
    '凭': '2221',
    '拨': '5304',
    '幸': '4040',
    '洞': '3712',
    '伪': '2422',
    '沟': '3712',
    '姓': '4541',
    '遭': '3530',
    '涌': '3712',
    '陶': '7722',
    '迁': '3230',
    '诺': '3476',
    '拔': '5304',
    '畅': '5702',
    '忧': '9301',
    '胞': '7721',
    '丁': '1020',
    '蓄': '4460',
    '贝': '7780',
    '舍': '8060',
    '腾': '7922',
    '杀': '4090',
    '煌': '9681',
    '圆': '6080',
    '伦': '2821',
    '横': '4498',
    '薄': '4414',
    '畜': '0060',
    '毫': '0071',
    '豪': '0023',
    '弟': '8022',
    '呈': '6010',
    '佛': '2522',
    '邦': '5702',
    '您': '2733',
    '墨': '6010',
    '徽': '2824',
    '惯': '9708',
    '循': '2226',
    '蓝': '4410',
    '烧': '9581',
    '触': '2523',
    '陕': '7528',
    '拖': '5801',
    '伯': '2620',
    '盲': '0060',
    '宪': '3021',
    '净': '3715',
    '卢': '2120',
    '炭': '2280',
    '籍': '8896',
    '秦': '5090',
    '粉': '9892',
    '妻': '5040',
    '爆': '9689',
    '欣': '7728',
    '释': '2795',
    '玩': '1111',
    '俊': '2324',
    '欠': '2780',
    '蛋': '1713',
    '猛': '4721',
    '迪': '3530',
    '苗': '4460',
    '暂': '4260',
    '貌': '2621',
    '遵': '3830',
    '锡': '8672',
    '楚': '4480',
    '桂': '4491',
    '昆': '6071',
    '皇': '2610',
    '杜': '4491',
    '醒': '1661',
    '燃': '9383',
    '凤': '7721',
    '截': '4325',
    '铺': '8372',
    '液': '3014',
    '撤': '5804',
    '胶': '7024',
    '慢': '9604',
    '杭': '4091',
    '虚': '2121',
    '辞': '2064',
    '曼': '6040',
    '毅': '0724',
    '咨': '3760',
    '俗': '2826',
    '糖': '9096',
    '忽': '2733',
    '姐': '4741',
    '芳': '4422',
    '耗': '5291',
    '妈': '4742',
    '谊': '3371',
    '浦': '3312',
    '频': '2128',
    '阻': '7721',
    '允': '2321',
    '宅': '3071',
    '窗': '3060',
    '默': '6338',
    '胀': '7223',
    '弃': '0044',
    '倡': '2626',
    '灭': '1080',
    '甲': '6050',
    '症': '0011',
    '埃': '4318',
    '滨': '3318',
    '赏': '9080',
    '莱': '4490',
    '拒': '5101',
    '淡': '3918',
    '坛': '4113',
    '陵': '7424',
    '绘': '2813',
    '虎': '2121',
    '竹': '8822',
    '赢': '0021',
    '锋': '8775',
    '篮': '8810',
    '迷': '3930',
    '纽': '2711',
    '轿': '4252',
    '贩': '7284',
    '递': '3830',
    '娘': '4343',
    '圈': '6071',
    '挖': '5301',
    '炉': '9380',
    '替': '5560',
    '幼': '2472',
    '乃': '1722',
    '郊': '0742',
    '颇': '4128',
    '戴': '4385',
    '滑': '3712',
    '徒': '2428',
    '崇': '2290',
    '涛': '3514',
    '焦': '2033',
    '凝': '3718',
    '墙': '4416',
    '吧': '6701',
    '炎': '9080',
    '刀': '1722',
    '玻': '1414',
    '寿': '5034',
    '履': '7724',
    '圣': '7710',
    '昨': '6801',
    '酸': '1364',
    '朗': '3772',
    '媒': '4449',
    '桑': '7790',
    '铜': '8772',
    '仲': '2520',
    '亦': '0023',
    '诞': '3274',
    '揭': '5602',
    '纵': '2810',
    '漫': '3614',
    '愈': '8033',
    '辟': '7024',
    '赠': '7886',
    '旱': '6040',
    '奶': '4742',
    '泳': '3319',
    '枪': '4891',
    '骗': '7312',
    '虫': '5013',
    '池': '3411',
    '镜': '8071',
    '浓': '3413',
    '拆': '5204',
    '艾': '4440',
    '扫': '5707',
    '娱': '4648',
    '钻': '8176',
    '碍': '1664',
    '寒': '3030',
    '迟': '3730',
    '邻': '8732',
    '曹': '5560',
    '盗': '3710',
    '穆': '2692',
    '豆': '1010',
    '赚': '7883',
    '晨': '6023',
    '浩': '3416',
    '彭': '4212',
    '耳': '1040',
    '瓜': '7223',
    '扭': '5701',
    '脸': '7821',
    '燕': '4433',
    '摇': '5207',
    '寄': '3062',
    '仿': '2022',
    '炮': '9781',
    '晋': '1060',
    '泪': '3610',
    '欲': '8768',
    '饱': '2771',
    '壁': '7010',
    '锁': '8978',
    '刷': '7220',
    '柬': '5090',
    '诊': '3872',
    '磨': '0026',
    '捕': '5302',
    '寨': '3090',
    '滚': '3013',
    '膨': '7222',
    '孔': '1241',
    '添': '3113',
    '帝': '0022',
    '辖': '4356',
    '炸': '9881',
    '旨': '2260',
    '吁': '6104',
    '址': '4111',
    '驶': '7510',
    '抱': '5701',
    '嘉': '4046',
    '拜': '2155',
    '扰': '5301',
    '袋': '2373',
    '佩': '2721',
    '阴': '7722',
    '辈': '1150',
    '锅': '8672',
    '赖': '5798',
    '剩': '2290',
    '押': '5605',
    '怪': '9701',
    '浮': '3214',
    '枚': '4894',
    '栏': '4891',
    '毁': '7714',
    '柳': '4792',
    '恐': '1733',
    '敦': '0844',
    '孟': '1710',
    '旁': '0022',
    '仓': '8071',
    '岩': '2260',
    '伸': '2520',
    '岭': '2873',
    '耐': '1420',
    '懂': '9401',
    '捷': '5508',
    '璃': '1012',
    '溪': '3218',
    '暖': '6204',
    '纤': '2214',
    '汗': '3114',
    '疫': '0014',
    '巧': '1112',
    '旋': '0828',
    '侧': '2220',
    '冶': '3316',
    '陪': '7026',
    '鸣': '6702',
    '瓶': '8141',
    '纲': '2712',
    '挤': '5002',
    '旬': '2762',
    '舆': '7780',
    '喝': '6602',
    '陷': '7727',
    '缘': '2713',
    '稻': '2297',
    '饲': '2772',
    '滩': '3011',
    '隔': '7122',
    '慰': '7433',
    '朴': '4390',
    '隐': '7723',
    '灌': '3411',
    '拟': '5800',
    '偷': '2822',
    '闲': '3790',
    '赫': '4423',
    '恰': '9806',
    '慧': '5533',
    '蒋': '4414',
    '闹': '3722',
    '邹': '2712',
    '牵': '4050',
    '柴': '2290',
    '刺': '5290',
    '滞': '3412',
    '彰': '0242',
    '俱': '2728',
    '勘': '4472',
    '填': '4418',
    '琛': '1719',
    '尝': '9073',
    '贾': '1080',
    '搬': '5704',
    '淮': '3011',
    '奏': '5080',
    '荷': '4422',
    '滋': '3813',
    '覆': '1024',
    '役': '2724',
    '秒': '2992',
    '踏': '6216',
    '巩': '1711',
    '摸': '5408',
    '荡': '4412',
    '辅': '4352',
    '惜': '9406',
    '柜': '4191',
    '肖': '9022',
    '颗': '6198',
    '搏': '5304',
    '氏': '7274',
    '姑': '4446',
    '弄': '1044',
    '姜': '8040',
    '君': '1760',
    '舒': '8762',
    '兑': '8021',
    '宇': '3040',
    '割': '3260',
    '哲': '5260',
    '摘': '5002',
    '钦': '8778',
    '逃': '3230',
    '漠': '3418',
    '忆': '9701',
    '敌': '2864',
    '宿': '3026',
    '啊': '6102',
    '凌': '3414',
    '耀': '9721',
    '闯': '3712',
    '阅': '3721',
    '贪': '8080',
    '赤': '4023',
    '汪': '3111',
    '悲': '1133',
    '抑': '5702',
    '瓷': '3771',
    '冯': '3712',
    '厉': '7122',
    '粗': '9791',
    '菲': '4411',
    '琴': '1120',
    '堡': '2610',
    '斌': '0344',
    '掘': '5707',
    '稀': '2492',
    '衰': '0073',
    '驾': '4612',
    '雕': '7021',
    '牢': '3050',
    '氛': '8021',
    '驱': '7111',
    '妥': '2040',
    '悄': '9902',
    '郎': '3772',
    '巡': '3230',
    '臣': '7171',
    '羽': '1712',
    '灰': '4080',
    '癌': '0017',
    '颖': '2198',
    '姆': '4745',
    '漏': '3712',
    '袭': '4373',
    '贤': '2780',
    '鸟': '2712',
    '暗': '6006',
    '茂': '4425',
    '孤': '1243',
    '惩': '2133',
    '榜': '4092',
    '袁': '4073',
    '桌': '2190',
    '卓': '2140',
    '傅': '2324',
    '剑': '8210',
    '堆': '4011',
    '兆': '3211',
    '狠': '4723',
    '轰': '4044',
    '拳': '9050',
    '妹': '4549',
    '绒': '2315',
    '裂': '1273',
    '潘': '3216',
    '兄': '6021',
    '洽': '3816',
    '叹': '6704',
    '涵': '3717',
    '贿': '7482',
    '侯': '2728',
    '岚': '2221',
    '熊': '2233',
    '绪': '2416',
    '阁': '3760',
    '尾': '7721',
    '碑': '1664',
    '尖': '9080',
    '腿': '7723',
    '涂': '3819',
    '栽': '4395',
    '坝': '4718',
    '犹': '4321',
    '铸': '8574',
    '肩': '3022',
    '闪': '3780',
    '诱': '3272',
    '辩': '0044',
    '芬': '4422',
    '睡': '6201',
    '奠': '8080',
    '伏': '2328',
    '妙': '4942',
    '乙': '1771',
    '绸': '2712',
    '廷': '1240',
    '夕': '2720',
    '恒': '9101',
    '梯': '4892',
    '赁': '2280',
    '霞': '1024',
    '攀': '4450',
    '枝': '4494',
    '译': '3775',
    '描': '5406',
    '湘': '3610',
    '磁': '1863',
    '吕': '6060',
    '硕': '1168',
    '爸': '8071',
    '肝': '7124',
    '峻': '2374',
    '葡': '4422',
    '衷': '0073',
    '搭': '5406',
    '唤': '6708',
    '薪': '4492',
    '挺': '5204',
    '逝': '3230',
    '狗': '4722',
    '蔡': '4490',
    '宴': '3040',
    '蓬': '4430',
    '撞': '5001',
    '铝': '8676',
    '牲': '2551',
    '舰': '2741',
    '胁': '7423',
    '崛': '2777',
    '桃': '4291',
    '斜': '8490',
    '丧': '4073',
    '烂': '9881',
    '屏': '7724',
    '砖': '1563',
    '墓': '4410',
    '详': '3875',
    '逾': '3830',
    '函': '1777',
    '跌': '6518',
    '抚': '5101',
    '插': '5207',
    '戈': '5300',
    '凉': '3019',
    '啤': '6604',
    '脉': '7329',
    '滥': '3811',
    '赋': '7384',
    '柏': '4690',
    '堤': '4618',
    '腰': '7124',
    '泊': '3610',
    '寺': '4034',
    '尘': '9010',
    '蒂': '4422',
    '削': '9220',
    '仙': '2227',
    '踪': '6319',
    '冻': '3419',
    '汤': '3712',
    '睛': '6502',
    '艳': '5701',
    '荐': '4424',
    '劫': '4472',
    '框': '4191',
    '廊': '0022',
    '惑': '5333',
    '页': '1080',
    '拼': '5804',
    '堪': '4411',
    '携': '5002',
    '丈': '5000',
    '乳': '2241',
    '挪': '5702',
    '谱': '3876',
    '舶': '2640',
    '埔': '4312',
    '遥': '3230',
    '菌': '4460',
    '塘': '4016',
    '氧': '8051',
    '晶': '6066',
    '洒': '3116',
    '株': '4599',
    '颜': '0128',
    '虹': '5111',
    '岳': '7277',
    '胸': '7722',
    '忍': '1733',
    '甜': '2467',
    '匹': '7171',
    '瞩': '6702',
    '懈': '9705',
    '爷': '8022',
    '丛': '8810',
    '莲': '4430',
    '叙': '8794',
    '鸿': '3712',
    '逢': '3730',
    '抬': '5306',
    '嘴': '6202',
    '弘': '1233',
    '炒': '9982',
    '喷': '6408',
    '吊': '6022',
    '窝': '3022',
    '衔': '2122',
    '吹': '6708',
    '霸': '1052',
    '仔': '2724',
    '垦': '7710',
    '胎': '7326',
    '慎': '9408',
    '脏': '7021',
    '歧': '2414',
    '疏': '1011',
    '悠': '2833',
    '慕': '4433',
    '漂': '3119',
    '杆': '4194',
    '萍': '4414',
    '舟': '2744',
    '吐': '6401',
    '玲': '1813',
    '凯': '2771',
    '戒': '5340',
    '盼': '6802',
    '偶': '2622',
    '盆': '8010',
    '慨': '9101',
    '弊': '9844',
    '箭': '8822',
    '茅': '4422',
    '衫': '3222',
    '罐': '8471',
    '串': '5000',
    '辐': '4156',
    '腹': '7824',
    '钩': '8772',
    '碰': '1861',
    '昂': '6072',
    '酬': '1260',
    '晰': '6202',
    '姿': '3740',
    '彼': '2742',
    '锻': '8774',
    '飘': '1791',
    '嫁': '4343',
    '竣': '0314',
    '缝': '2713',
    '蹈': '6217',
    '悬': '7733',
    '紫': '2290',
    '浅': '3315',
    '缆': '2811',
    '喊': '6305',
    '昔': '4460',
    '驰': '7411',
    '湿': '3611',
    '剪': '8022',
    '侦': '2128',
    '坑': '4011',
    '姚': '4241',
    '魏': '2641',
    '扑': '5300',
    '挣': '5705',
    '焕': '9788',
    '皆': '2260',
    '狂': '4121',
    '泡': '3711',
    '骤': '7713',
    '堵': '4416',
    '膜': '7428',
    '禽': '8022',
    '锐': '8871',
    '芝': '4430',
    '帽': '4626',
    '擅': '5001',
    '沪': '3310',
    '晤': '6106',
    '婆': '3440',
    '埋': '4611',
    '劝': '7442',
    '碗': '1361',
    '玛': '1712',
    '顷': '2178',
    '鸭': '6752',
    '娃': '4441',
    '豫': '1723',
    '匆': '2742',
    '魂': '1671',
    '哭': '6680',
    '庞': '0021',
    '亭': '0020',
    '屡': '7724',
    '逼': '3130',
    '尺': '7780',
    '撒': '5804',
    '鹿': '0021',
    '讼': '3873',
    '弥': '1729',
    '坊': '4012',
    '碎': '1064',
    '缔': '2012',
    '霍': '1021',
    '壤': '4013',
    '萄': '4472',
    '铃': '8873',
    '稍': '2992',
    '丘': '7210',
    '肿': '7520',
    '烦': '9188',
    '苹': '4440',
    '庙': '0026',
    '雇': '3021',
    '汛': '3711',
    '孝': '4440',
    '辰': '7123',
    '吞': '1060',
    '汰': '3413',
    '怨': '2733',
    '酿': '1363',
    '耶': '1742',
    '咱': '6600',
    '欺': '4788',
    '丢': '2073',
    '琼': '1019',
    '棚': '4792',
    '披': '5404',
    '渴': '3612',
    '屈': '7727',
    '弗': '5502',
    '疲': '0014',
    '帕': '4620',
    '昭': '6706',
    '盒': '8010',
    '仰': '2722',
    '萧': '4422',
    '牺': '2156',
    '撑': '5905',
    '抛': '5401',
    '鼠': '7771',
    '纱': '2912',
    '翼': '1780',
    '兹': '8073',
    '骑': '7412',
    '糊': '9792',
    '契': '5780',
    '铭': '8776',
    '淘': '3712',
    '顽': '1128',
    '撰': '5708',
    '乒': '7220',
    '淑': '3714',
    '妆': '3414',
    '窑': '3077',
    '柔': '1790',
    '姻': '4640',
    '苍': '4471',
    '谨': '3471',
    '卿': '7772',
    '灿': '9287',
    '栋': '4499',
    '敲': '0124',
    '窃': '3072',
    '菊': '4492',
    '郁': '4722',
    '催': '2221',
    '眉': '7726',
    '邱': '7712',
    '揽': '5801',
    '鼎': '2222',
    '韦': '5002',
    '肤': '7528',
    '娜': '4742',
    '俏': '2922',
    '呀': '6104',
    '拚': '5304',
    '寸': '4030',
    '爬': '7723',
    '悟': '9106',
    '尿': '7729',
    '罢': '6073',
    '圭': '4010',
    '葬': '4444',
    '聪': '1843',
    '沃': '3218',
    '肠': '7722',
    '厕': '7122',
    '慈': '8033',
    '恋': '0033',
    '绵': '2612',
    '橡': '4793',
    '圾': '4714',
    '垃': '4011',
    '翁': '8012',
    '粤': '2602',
    '脂': '7226',
    '歹': '1020',
    '憾': '9303',
    '阐': '3750',
    '甸': '2762',
    '巷': '4471',
    '蜂': '5715',
    '轴': '4556',
    '艘': '2744',
    '垄': '4310',
    '衬': '3420',
    '阜': '2740',
    '惨': '9302',
    '冀': '1280',
    '幽': '2277',
    '厘': '7121',
    '崭': '2252',
    '筋': '8822',
    '寓': '3022',
    '迄': '3830',
    '渗': '3312',
    '碘': '1568',
    '碧': '1660',
    '赌': '7486',
    '袖': '3526',
    '奈': '4090',
    '崔': '2221',
    '悦': '9801',
    '捞': '5402',
    '剥': '1290',
    '孕': '1740',
    '逆': '3830',
    '婴': '7740',
    '脆': '7721',
    '缅': '2116',
    '艇': '2244',
    '谭': '3174',
    '笼': '8841',
    '儒': '2122',
    '粒': '9091',
    '诈': '3871',
    '遣': '3530',
    '垂': '2010',
    '磋': '1861',
    '卸': '8712',
    '帜': '4628',
    '枣': '5030',
    '幢': '4021',
    '淀': '3318',
    '帆': '4721',
    '蛇': '5311',
    '宰': '3040',
    '殿': '7724',
    '猎': '4426',
    '叔': '2794',
    '夹': '5080',
    '帅': '2402',
    '沧': '3811',
    '魅': '2551',
    '俩': '2122',
    '牟': '2350',
    '钓': '8772',
    '葛': '4472',
    '罕': '3740',
    '渤': '3412',
    '汕': '3217',
    '溢': '3811',
    '擦': '5309',
    '袱': '3328',
    '嫩': '4844',
    '桶': '4792',
    '殷': '2724',
    '酷': '1466',
    '呆': '6090',
    '卧': '7370',
    '暑': '6060',
    '骄': '7212',
    '幻': '2772',
    '囊': '5073',
    '掀': '5708',
    '醉': '1064',
    '牡': '2451',
    '饼': '2874',
    '扇': '3022',
    '蒸': '4433',
    '赣': '0748',
    '俭': '2821',
    '椅': '4492',
    '枢': '4191',
    '彦': '0022',
    '樊': '4480',
    '吾': '1060',
    '仗': '2520',
    '彬': '4292',
    '砂': '1962',
    '绳': '2611',
    '巾': '4022',
    '喀': '6306',
    '勋': '6482',
    '愁': '2933',
    '碱': '1365',
    '谦': '3873',
    '壳': '4021',
    '轧': '4251',
    '潭': '3114',
    '浆': '3790',
    '挽': '5701',
    '邢': '1742',
    '啥': '6806',
    '焊': '9684',
    '钞': '8972',
    '烤': '9482',
    '廖': '0022',
    '猫': '4426',
    '狱': '4328',
    '腔': '7321',
    '喻': '6802',
    '御': '2722',
    '蕴': '4411',
    '坎': '4718',
    '魔': '0021',
    '刮': '2260',
    '瘤': '0016',
    '茫': '4411',
    '竭': '0612',
    '莉': '4492',
    '链': '8473',
    '淫': '3211',
    '愤': '9408',
    '纹': '2014',
    '咸': '5320',
    '睐': '6509',
    '睹': '6406',
    '裤': '3025',
    '夸': '4002',
    '滴': '3012',
    '雾': '1042',
    '搜': '5704',
    '拘': '5702',
    '龚': '4380',
    '凶': '2277',
    '茨': '4418',
    '傲': '2824',
    '鞍': '4354',
    '鹤': '4722',
    '蚀': '2573',
    '颈': '1118',
    '翠': '1740',
    '卉': '4044',
    '汁': '3410',
    '冈': '7722',
    '狮': '4122',
    '隧': '7823',
    '弯': '0002',
    '胃': '6022',
    '沛': '3512',
    '募': '4442',
    '琳': '1419',
    '疼': '0013',
    '蚕': '1013',
    '泼': '3314',
    '磷': '1965',
    '捧': '5505',
    '炳': '9182',
    '绣': '2212',
    '朵': '7790',
    '涯': '3111',
    '掏': '5702',
    '奎': '4010',
    '聂': '1044',
    '孜': '1844',
    '韵': '0762',
    '浑': '3715',
    '翔': '8752',
    '魄': '2661',
    '掩': '5401',
    '斥': '7224',
    '敞': '9824',
    '腊': '7426',
    '愧': '9601',
    '粘': '9196',
    '丑': '1710',
    '溉': '3111',
    '斑': '1111',
    '啦': '6001',
    '柯': '4192',
    '谐': '3276',
    '烯': '9482',
    '禄': '3729',
    '浴': '3816',
    '涝': '3412',
    '鬼': '2651',
    '薛': '4474',
    '瘦': '0014',
    '挡': '5907',
    '昏': '7260',
    '鹅': '2752',
    '湛': '3411',
    '逻': '3630',
    '虾': '5113',
    '沂': '3212',
    '辱': '7134',
    '叉': '7740',
    '鼻': '2622',
    '厨': '7124',
    '鲍': '2711',
    '鞭': '4154',
    '辣': '0549',
    '潇': '3412',
    '乓': '7203',
    '肺': '7522',
    '尹': '1750',
    '颂': '8178',
    '邵': '1762',
    '澜': '3712',
    '桐': '4792',
    '鹰': '0022',
    '妨': '4042',
    '闽': '3713',
    '屠': '7726',
    '畏': '6073',
    '翰': '4842',
    '塌': '4612',
    '亟': '1710',
    '寂': '3094',
    '赂': '7786',
    '犬': '4380',
    '聊': '1742',
    '暨': '7110',
    '垫': '5510',
    '泄': '3411',
    '漆': '3419',
    '旭': '4601',
    '蕾': '4460',
    '坪': '4114',
    '涤': '3719',
    '挫': '5801',
    '佐': '2421',
    '瞄': '6406',
    '拦': '5801',
    '硫': '1061',
    '棒': '4595',
    '杏': '4060',
    '爽': '4080',
    '碳': '1268',
    '畔': '6905',
    '熙': '7733',
    '襄': '0073',
    '祸': '3622',
    '乾': '4841',
    '淹': '3411',
    '臂': '7022',
    '莎': '4412',
    '辜': '4040',
    '阎': '3777',
    '庸': '0022',
    '砍': '1768',
    '捉': '5608',
    '勾': '2772',
    '垒': '2310',
    '衍': '2122',
    '坤': '4510',
    '噪': '6609',
    '毯': '2971',
    '倪': '2721',
    '扮': '5802',
    '铅': '8776',
    '遏': '3630',
    '哀': '0073',
    '愉': '9802',
    '瑶': '1217',
    '咬': '6004',
    '嫌': '4843',
    '闸': '3750',
    '恳': '7733',
    '齿': '2177',
    '杠': '4191',
    '怒': '4733',
    '兽': '8060',
    '浇': '3511',
    '肇': '3850',
    '鄂': '6722',
    '溶': '3316',
    '哄': '6408',
    '棵': '4699',
    '盯': '6102',
    '梨': '2290',
    '灶': '9481',
    '屯': '5071',
    '狭': '4528',
    '陋': '7121',
    '啡': '6101',
    '浸': '3714',
    '淋': '3419',
    '濒': '3118',
    '脊': '3222',
    '戚': '5320',
    '勉': '2441',
    '膏': '0022',
    '氨': '8041',
    '墅': '6710',
    '沸': '3512',
    '挨': '5308',
    '蔓': '4440',
    '抄': '5902',
    '芒': '4471',
    '秉': '2090',
    '刹': '4290',
    '饶': '2571',
    '厢': '7126',
    '咖': '6600',
    '魁': '2451',
    '骚': '7713',
    '缚': '2314',
    '遂': '3830',
    '恨': '9703',
    '跻': '6012',
    '螺': '5619',
    '辨': '0044',
    '菇': '4446',
    '帷': '4021',
    '凰': '7721',
    '椒': '4794',
    '汝': '3414',
    '瞬': '6205',
    '淄': '3216',
    '舱': '2841',
    '馈': '2578',
    '桩': '4091',
    '炬': '9181',
    '誓': '5260',
    '卜': '2300',
    '麟': '0925',
    '岂': '2271',
    '兔': '2741',
    '眠': '6704',
    '泵': '1090',
    '拐': '5602',
    '肚': '7421',
    '匪': '7171',
    '芦': '4420',
    '匈': '2772',
    '霉': '1075',
    '蜜': '3013',
    '荆': '4240',
    '雁': '7121',
    '窄': '3021',
    '秧': '2598',
    '枯': '4496',
    '仆': '2320',
    '嘱': '6702',
    '壶': '4010',
    '谅': '3079',
    '哨': '6902',
    '肌': '7721',
    '贬': '7283',
    '叠': '7710',
    '稽': '2396',
    '岐': '2474',
    '沫': '3519',
    '肆': '7570',
    '醇': '1064',
    '菱': '4440',
    '彪': '2221',
    '躺': '2922',
    '摔': '5004',
    '膀': '7022',
    '甫': '5322',
    '逊': '3930',
    '凑': '3518',
    '渊': '3210',
    '喂': '6603',
    '藤': '4429',
    '砸': '1161',
    '悔': '9805',
    '杉': '4292',
    '霜': '1096',
    '厄': '7121',
    '忌': '1733',
    '桔': '4496',
    '筒': '8822',
    '丙': '1022',
    '臭': '2680',
    '拾': '5806',
    '芜': '4441',
    '禹': '2022',
    '丸': '5001',
    '蟹': '2713',
    '嘛': '6009',
    '俞': '8022',
    '翅': '4740',
    '尸': '7720',
    '澄': '3211',
    '骂': '6612',
    '睦': '6401',
    '馨': '4760',
    '郝': '4722',
    '贮': '7381',
    '陌': '7126',
    '钧': '8772',
    '轩': '4154',
    '赃': '7081',
    '笋': '8850',
    '歉': '8728',
    '逸': '3730',
    '歪': '1010',
    '巍': '2241',
    '萃': '4440',
    '崖': '2221',
    '窟': '3027',
    '踢': '6612',
    '锣': '8672',
    '萎': '4440',
    '庐': '0020',
    '剖': '0260',
    '籽': '9794',
    '甩': '7721',
    '饥': '2771',
    '苑': '4421',
    '恼': '9007',
    '渣': '3411',
    '痕': '0013',
    '莞': '4421',
    '硅': '1461',
    '晴': '6502',
    '巢': '2290',
    '瘫': '0011',
    '缠': '2011',
    '隶': '5090',
    '筛': '8822',
    '穴': '3080',
    '昼': '7710',
    '埠': '4714',
    '宠': '3041',
    '肢': '7424',
    '饿': '2375',
    '仑': '8071',
    '逮': '3530',
    '兢': '4421',
    '趟': '4980',
    '糕': '9893',
    '妮': '4741',
    '邪': '7722',
    '抹': '5509',
    '俑': '2722',
    '萌': '4462',
    '匠': '7171',
    '扔': '5702',
    '酱': '3760',
    '葱': '4433',
    '礁': '1063',
    '掺': '5302',
    '雀': '9021',
    '髓': '7423',
    '悼': '9104',
    '挚': '5550',
    '蔚': '4424',
    '枫': '4791',
    '庚': '0028',
    '伞': '8040',
    '侃': '2621',
    '僵': '2121',
    '捆': '5600',
    '蒜': '4499',
    '溜': '3716',
    '傻': '2624',
    '蔗': '4423',
    '谜': '3973',
    '斋': '0022',
    '蝶': '5419',
    '沾': '3116',
    '闷': '3733',
    '驳': '7414',
    '耿': '1948',
    '槽': '4596',
    '黔': '6832',
    '吓': '6103',
    '肾': '2722',
    '芽': '4424',
    '栗': '1090',
    '朽': '4192',
    '荫': '4422',
    '榆': '4892',
    '皖': '2361',
    '曰': '6010',
    '徊': '2620',
    '奴': '4744',
    '迭': '3530',
    '僻': '2024',
    '蓉': '4460',
    '靖': '0512',
    '氟': '8051',
    '滔': '3217',
    '羡': '8018',
    '愚': '6033',
    '尧': '5021',
    '俺': '2421',
    '徘': '2121',
    '罩': '6040',
    '磊': '1066',
    '镑': '8072',
    '舌': '2060',
    '曙': '6606',
    '纶': '2811',
    '粪': '9080',
    '匙': '6280',
    '钉': '8172',
    '佼': '2024',
    '扯': '5101',
    '踊': '6712',
    '躲': '2729',
    '猴': '4728',
    '纬': '2512',
    '咽': '6600',
    '酝': '1163',
    '挠': '5501',
    '宛': '3021',
    '瑰': '1611',
    '歇': '6778',
    '抒': '5702',
    '茧': '4413',
    '穗': '2593',
    '祭': '2790',
    '鑫': '8011',
    '趁': '4880',
    '痴': '0016',
    '裙': '3726',
    '猜': '4522',
    '耘': '5193',
    '碌': '1769',
    '锈': '8272',
    '晒': '6106',
    '潍': '3011',
    '弦': '1023',
    '稼': '2393',
    '狼': '4323',
    '拢': '5301',
    '梧': '4196',
    '芯': '4433',
    '眷': '9060',
    '哑': '6101',
    '宙': '3060',
    '厌': '7128',
    '逛': '3130',
    '谴': '3573',
    '邯': '4772',
    '呵': '6102',
    '蜡': '5416',
    '寥': '3020',
    '钥': '8772',
    '耸': '8840',
    '媳': '4643',
    '熏': '2033',
    '蚁': '5410',
    '惕': '9602',
    '颠': '4188',
    '娟': '4642',
    '亨': '0020',
    '吟': '6802',
    '蒲': '4412',
    '梭': '4394',
    '瞻': '6706',
    '渝': '3812',
    '喉': '6708',
    '遮': '3030',
    '慌': '9401',
    '夷': '5080',
    '韶': '0766',
    '焰': '9787',
    '尉': '7420',
    '珊': '1714',
    '胖': '7925',
    '蕉': '4433',
    '粹': '9094',
    '裹': '0073',
    '琦': '1412',
    '秽': '2292',
    '侠': '2528',
    '奸': '4144',
    '挝': '5403',
    '绑': '2712',
    '曝': '6609',
    '棍': '4691',
    '婉': '4341',
    '镶': '8073',
    '熬': '5833',
    '傍': '2022',
    '燥': '9689',
    '氯': '8091',
    '骆': '7716',
    '晃': '6021',
    '鸽': '8762',
    '疯': '0011',
    '琢': '1113',
    '聋': '4340',
    '瑟': '1133',
    '暇': '6704',
    '绥': '2214',
    '禅': '3825',
    '溃': '3518',
    '腺': '7629',
    '垮': '4412',
    '阀': '3725',
    '撼': '5303',
    '煮': '4433',
    '佣': '2722',
    '滕': '7929',
    '淤': '3813',
    '蹲': '6814',
    '栖': '4196',
    '硝': '1962',
    '睁': '6705',
    '荟': '4473',
    '荧': '4480',
    '抖': '5400',
    '坟': '4014',
    '芭': '4471',
    '臻': '1519',
    '锭': '8378',
    '晖': '6705',
    '倦': '2921',
    '倘': '2922',
    '喘': '6202',
    '邑': '6071',
    '锤': '8271',
    '惧': '9708',
    '荔': '4442',
    '毗': '6201',
    '觅': '2021',
    '矮': '8284',
    '恭': '4433',
    '钙': '8172',
    '氮': '8081',
    '缸': '8171',
    '瞧': '6003',
    '颤': '0118',
    '萝': '4420',
    '佑': '2426',
    '怡': '9306',
    '瘾': '0013',
    '寡': '3022',
    '烹': '0033',
    '摧': '5201',
    '棠': '9090',
    '缪': '2712',
    '雏': '2011',
    '韧': '5702',
    '喇': '6200',
    '兜': '7721',
    '坯': '4111',
    '坷': '4112',
    '贞': '2180',
    '仇': '2421',
    '缉': '2614',
    '帘': '3022',
    '竖': '2710',
    '糟': '9596',
    '猖': '4626',
    '懒': '9708',
    '凿': '3277',
    '洼': '3411',
    '喧': '6301',
    '谣': '3277',
    '驼': '7311',
    '烫': '3780',
    '锌': '8074',
    '椰': '4792',
    '崩': '2222',
    '沥': '3112',
    '汾': '3812',
    '磅': '1062',
    '霖': '1099',
    '棘': '5599',
    '扛': '5101',
    '彗': '5517',
    '矩': '8181',
    '瞒': '6402',
    '陇': '7321',
    '绎': '2715',
    '诫': '3375',
    '斐': '1140',
    '卵': '7772',
    '铮': '8775',
    '钾': '8675',
    '宵': '3022',
    '簿': '8814',
    '秤': '2194',
    '畴': '6504',
    '斧': '8022',
    '擂': '5106',
    '剔': '6220',
    '躁': '6619',
    '冤': '3741',
    '讳': '3572',
    '寅': '3080',
    '焚': '4480',
    '漳': '3014',
    '鳖': '9810',
    '哺': '6302',
    '耻': '1141',
    '僧': '2826',
    '琅': '1313',
    '粟': '1090',
    '怖': '9402',
    '咏': '6309',
    '蜀': '6012',
    '淳': '3014',
    '柑': '4497',
    '缕': '2914',
    '烁': '9289',
    '氢': '8011',
    '蔽': '4424',
    '琪': '1418',
    '泣': '3011',
    '阮': '7121',
    '镀': '8074',
    '殴': '7774',
    '虞': '2128',
    '虐': '2121',
    '炊': '9788',
    '搁': '5702',
    '诀': '3578',
    '掠': '5009',
    '坠': '7810',
    '屿': '2172',
    '髦': '7271',
    '酋': '8060',
    '躯': '2121',
    '吵': '6902',
    '遐': '3730',
    '寞': '3080',
    '仕': '2421',
    '稚': '2091',
    '僚': '2429',
    '楠': '4492',
    '矶': '1761',
    '筝': '8850',
    '彝': '2744',
    '叮': '6102',
    '熔': '9386',
    '槐': '4691',
    '潢': '3418',
    '芹': '4422',
    '郸': '8752',
    '匾': '7171',
    '咋': '6801',
    '玄': '0073',
    '裔': '0022',
    '陡': '7428',
    '哗': '6404',
    '怜': '9803',
    '襟': '3429',
    '刃': '1732',
    '脾': '7624',
    '嵌': '2278',
    '拱': '5408',
    '慷': '9009',
    '痪': '0018',
    '跋': '6314',
    '孚': '2040',
    '峪': '2876',
    '钊': '8270',
    '滇': '3418',
    '苟': '4462',
    '晕': '6050',
    '墩': '4814',
    '膝': '7429',
    '羞': '8010',
    '乍': '8021',
    '腻': '7324',
    '詹': '2726',
    '讶': '3174',
    '敷': '5824',
    '肴': '4022',
    '莹': '4410',
    '衢': '2122',
    '柿': '4092',
    '朔': '8742',
    '袜': '3529',
    '枕': '4491',
    '烘': '9488',
    '匀': '2712',
    '歼': '1224',
    '泻': '3712',
    '樱': '4794',
    '吻': '6702',
    '翟': '1721',
    '堰': '4111',
    '苯': '4423',
    '隙': '7929',
    '娇': '4242',
    '獗': '4128',
    '汲': '3714',
    '蛙': '5411',
    '斩': '4252',
    '靡': '0021',
    '沁': '3310',
    '乞': '8071',
    '姨': '4548',
    '翩': '3722',
    '沼': '3716',
    '嘎': '6105',
    '畸': '6402',
    '矫': '8282',
    '骏': '7314',
    '薯': '4460',
    '绚': '2712',
    '窜': '3050',
    '藻': '4419',
    '矗': '4011',
    '皂': '2671',
    '楷': '4296',
    '腕': '7321',
    '篷': '8830',
    '徇': '2722',
    '耽': '1441',
    '娼': '4646',
    '犁': '2250',
    '榻': '4692',
    '茄': '4446',
    '棕': '4399',
    '汹': '3217',
    '峨': '2375',
    '蹄': '6012',
    '昧': '6509',
    '奢': '4060',
    '涩': '3711',
    '灼': '9782',
    '踩': '6219',
    '粥': '1722',
    '拣': '5509',
    '旷': '6000',
    '簇': '8828',
    '溯': '3712',
    '攒': '5408',
    '沓': '1260',
    '呕': '6101',
    '梳': '4091',
    '搅': '5901',
    '砌': '1762',
    '纫': '2712',
    '渭': '3612',
    '澡': '3619',
    '撕': '5202',
    '漓': '3012',
    '葆': '4429',
    '辍': '4754',
    '肪': '7022',
    '祁': '3722',
    '鞠': '4752',
    '蛮': '0013',
    '捏': '5601',
    '诵': '3772',
    '娣': '4842',
    '岱': '2377',
    '瀑': '3619',
    '啸': '6502',
    '裸': '3629',
    '鸦': '7722',
    '瑛': '1418',
    '躬': '2722',
    '舜': '2025',
    '忱': '9401',
    '豹': '2722',
    '纂': '8890',
    '恤': '9701',
    '惟': '9001',
    '赐': '7682',
    '俯': '2024',
    '犀': '7725',
    '媚': '4746',
    '嫂': '4744',
    '嗓': '6709',
    '蚊': '5014',
    '茬': '4421',
    '驭': '7714',
    '缀': '2714',
    '皱': '2414',
    '凳': '1221',
    '钮': '8771',
    '蚂': '5712',
    '姬': '4141',
    '扒': '5800',
    '嫖': '4149',
    '跪': '6711',
    '凹': '7777',
    '揣': '5202',
    '尬': '4801',
    '沦': '3811',
    '尴': '4801',
    '豁': '3866',
    '玫': '1814',
    '殡': '1328',
    '淌': '3912',
    '叭': '6800',
    '唇': '7126',
    '啃': '6102',
    '裘': '4373',
    '卑': '2640',
    '琐': '1918',
    '矢': '8080',
    '拯': '5701',
    '忡': '9500',
    '勿': '2722',
    '盎': '5010',
    '茵': '4460',
    '椎': '4091',
    '脖': '7424',
    '拂': '5502',
    '骅': '7414',
    '葫': '4462',
    '迢': '3730',
    '薇': '4424',
    '龟': '2771',
    '绞': '2014',
    '眶': '6101',
    '沐': '3419',
    '傣': '2529',
    '浊': '3513',
    '舅': '7742',
    '叛': '9254',
    '浚': '3314',
    '窘': '3060',
    '栓': '4891',
    '酶': '1865',
    '笛': '8860',
    '泌': '3310',
    '榄': '4891',
    '惹': '4433',
    '铲': '8070',
    '碟': '1469',
    '捡': '5801',
    '恪': '9706',
    '酯': '1266',
    '滤': '3113',
    '匿': '7171',
    '酵': '1464',
    '砚': '1761',
    '贼': '7385',
    '匮': '7171',
    '熠': '9786',
    '鳞': '2915',
    '麓': '4421',
    '镁': '8878',
    '氓': '0774',
    '苇': '4452',
    '廓': '0022',
    '巫': '1010',
    '踵': '6211',
    '竿': '8840',
    '蘑': '4426',
    '翘': '5721',
    '梓': '4094',
    '贻': '7386',
    '鳗': '2614',
    '帼': '4620',
    '冉': '5044',
    '泓': '3213',
    '狐': '4223',
    '涟': '3413',
    '崎': '2472',
    '窍': '3012',
    '瑜': '1812',
    '讽': '3771',
    '逗': '3130',
    '铎': '8775',
    '掷': '5702',
    '璀': '1211',
    '泗': '3610',
    '浏': '3210',
    '陲': '7221',
    '醋': '1466',
    '苛': '4462',
    '攘': '5003',
    '璧': '7010',
    '瀚': '3812',
    '哩': '6601',
    '暮': '4460',
    '矣': '2380',
    '蚌': '5510',
    '悖': '9404',
    '扼': '5101',
    '漯': '3619',
    '烛': '9583',
    '蝴': '5712',
    '屑': '7722',
    '墟': '4111',
    '俘': '2224',
    '侣': '2626',
    '庇': '0021',
    '陀': '7321',
    '煎': '8033',
    '秸': '2496',
    '弓': '1702',
    '捣': '5702',
    '譬': '7060',
    '炜': '9582',
    '炯': '9782',
    '拌': '5905',
    '扁': '3022',
    '彤': '7242',
    '锚': '8476',
    '禾': '2090',
    '侮': '2825',
    '秆': '2194',
    '绮': '2412',
    '嚣': '6666',
    '樟': '4094',
    '咐': '6400',
    '枉': '4191',
    '窦': '3080',
    '桦': '4494',
    '寇': '3021',
    '哉': '4365',
    '狸': '4621',
    '耍': '1040',
    '馒': '2674',
    '驹': '7712',
    '隋': '7422',
    '冕': '6041',
    '疮': '0011',
    '咄': '6207',
    '妄': '0040',
    '峙': '2474',
    '娄': '9040',
    '溥': '3314',
    '腑': '7024',
    '钠': '8472',
    '栩': '4792',
    '糙': '9493',
    '滦': '3019',
    '呐': '6402',
    '鲻': '2216',
    '娶': '1740',
    '祺': '3428',
    '刨': '2270',
    '褒': '0073',
    '橙': '4291',
    '茹': '4446',
    '谎': '3471',
    '抉': '5508',
    '慑': '9104',
    '媛': '4244',
    '橄': '4894',
    '戎': '5340',
    '迩': '3730',
    '雯': '1040',
    '璨': '1719',
    '雍': '0021',
    '惶': '9601',
    '扳': '5204',
    '桢': '4198',
    '霓': '1021',
    '账': '7283',
    '梗': '4194',
    '炕': '9081',
    '裴': '1173',
    '韬': '5207',
    '杖': '4590',
    '痹': '0012',
    '缤': '2318',
    '沽': '3416',
    '燎': '9489',
    '煞': '2833',
    '删': '7240',
    '辙': '4854',
    '爵': '2074',
    '缭': '2419',
    '劈': '7022',
    '烨': '9484',
    '槌': '4793',
    '媲': '4641',
    '凛': '3019',
    '莆': '4422',
    '颅': '2128',
    '锯': '8776',
    '膳': '7826',
    '澎': '3212',
    '坞': '4712',
    '瓣': '0044',
    '婷': '4042',
    '絮': '4690',
    '酌': '1762',
    '涡': '3612',
    '唁': '6006',
    '秃': '2021',
    '禺': '6022',
    '膊': '7324',
    '棣': '4599',
    '芸': '4473',
    '忻': '9202',
    '炽': '9688',
    '榨': '4391',
    '篆': '8823',
    '憨': '1833',
    '戍': '5320',
    '圩': '4114',
    '爹': '8020',
    '蹊': '6218',
    '饪': '2271',
    '胺': '7324',
    '贱': '7385',
    '睫': '6508',
    '蝇': '5611',
    '惫': '2733',
    '拇': '5705',
    '赈': '7183',
    '泾': '3711',
    '盏': '5310',
    '弧': '1223',
    '剿': '2290',
    '硒': '1166',
    '毓': '8071',
    '皓': '2466',
    '菏': '4412',
    '灸': '2780',
    '湄': '3716',
    '炙': '2780',
    '祠': '3722',
    '荻': '4428',
    '捍': '5604',
    '嚼': '6204',
    '朦': '7423',
    '屹': '2871',
    '紊': '0090',
    '藜': '4490',
    '驴': '7310',
    '寝': '3014',
    '兮': '8002',
    '隘': '7821',
    '祈': '3222',
    '榕': '4396',
    '臧': '2325',
    '蝉': '5815',
    '绢': '2612',
    '瞎': '6306',
    '闵': '3740',
    '鳌': '5810',
    '娥': '4345',
    '藉': '4496',
    '娅': '4141',
    '烽': '9785',
    '楂': '4491',
    '摒': '5704',
    '凄': '3514',
    '凸': '7777',
    '熄': '9683',
    '孵': '7274',
    '叩': '6702',
    '渎': '3418',
    '胳': '7726',
    '匡': '7171',
    '袍': '3721',
    '卒': '0040',
    '怠': '2333',
    '桓': '4191',
    '莽': '4444',
    '倩': '2552',
    '泸': '3110',
    '藕': '4492',
    '陨': '7628',
    '辗': '4753',
    '骋': '7512',
    '峭': '2972',
    '冥': '3780',
    '饺': '2074',
    '亢': '0021',
    '圃': '6022',
    '颐': '7178',
    '擒': '5802',
    '铵': '8374',
    '鳄': '2612',
    '簧': '8880',
    '愣': '9602',
    '璜': '1418',
    '钰': '8171',
    '拙': '5207',
    '瘠': '0012',
    '靳': '4252',
    '隽': '2022',
    '罹': '6091',
    '岑': '2220',
    '镭': '8176',
    '榴': '4796',
    '恕': '4633',
    '毋': '7755',
    '囤': '6071',
    '汀': '3112',
    '绽': '2318',
    '窖': '3060',
    '筷': '8898',
    '擎': '4850',
    '猿': '4423',
    '诲': '3875',
    '碾': '1763',
    '夭': '2080',
    '筐': '8871',
    '邃': '3330',
    '藩': '4416',
    '诬': '3171',
    '芙': '4480',
    '胚': '7121',
    '哇': '6401',
    '垣': '4111',
    '胧': '7321',
    '帖': '4126',
    '殉': '1722',
    '毙': '2221',
    '壑': '2710',
    '绰': '2114',
    '憋': '9833',
    '亥': '0080',
    '涅': '3611',
    '屁': '7721',
    '璞': '1218',
    '缮': '2816',
    '侍': '2424',
    '倚': '2422',
    '稠': '2792',
    '棺': '4397',
    '棱': '4494',
    '葵': '4480',
    '诣': '3276',
    '笨': '8823',
    '橱': '4194',
    '寰': '3073',
    '郡': '1762',
    '垢': '4216',
    '徕': '2529',
    '眺': '6201',
    '胰': '7528',
    '谆': '3074',
    '窥': '3081',
    '霄': '1022',
    '栉': '4492',
    '舸': '2142',
    '蹦': '6212',
    '坂': '4214',
    '瞪': '6201',
    '珲': '1715',
    '釉': '2596',
    '跤': '6014',
    '挟': '5508',
    '侄': '2121',
    '肘': '7420',
    '嘲': '6702',
    '刁': '1712',
    '缎': '2714',
    '嚷': '6003',
    '痒': '0015',
    '敛': '8814',
    '祛': '3423',
    '绅': '2510',
    '孰': '0541',
    '痫': '0012',
    '闺': '3710',
    '椿': '4596',
    '噶': '6402',
    '恍': '9901',
    '伶': '2823',
    '峦': '0077',
    '酥': '1269',
    '萦': '4490',
    '苎': '4410',
    '癫': '0018',
    '涪': '3016',
    '锲': '8778',
    '蜚': '1113',
    '拎': '5803',
    '嵩': '2222',
    '昊': '6080',
    '娴': '4742',
    '涣': '3718',
    '烙': '9786',
    '璋': '1014',
    '笃': '8812',
    '囚': '6080',
    '祯': '3128',
    '篱': '8822',
    '讴': '3171',
    '舷': '2043',
    '纭': '2113',
    '锄': '8472',
    '巅': '2288',
    '卦': '4310',
    '摹': '4450',
    '眸': '6305',
    '柄': '4192',
    '踞': '6716',
    '焉': '1032',
    '辄': '4151',
    '褚': '3426',
    '褐': '3622',
    '湃': '3115',
    '夙': '7721',
    '堕': '7410',
    '岔': '8077',
    '惦': '9006',
    '疚': '0018',
    '谍': '3479',
    '奕': '0080',
    '羚': '8853',
    '帧': '4128',
    '澈': '3814',
    '濮': '3218',
    '捎': '5902',
    '漾': '3819',
    '吼': '6201',
    '锰': '8771',
    '趴': '6810',
    '菩': '4460',
    '簸': '8884',
    '仃': '2122',
    '渲': '3311',
    '札': '4291',
    '谙': '3076',
    '咕': '6406',
    '桨': '3790',
    '咀': '6701',
    '郴': '4792',
    '咳': '6008',
    '呜': '6702',
    '蛟': '5014',
    '拧': '5302',
    '莘': '4440',
    '驯': '7210',
    '庵': '0021',
    '弼': '1722',
    '逞': '3630',
    '蹬': '6211',
    '姥': '4441',
    '撂': '5606',
    '镍': '8679',
    '晏': '6040',
    '疡': '0012',
    '爪': '7223',
    '骥': '7218',
    '楞': '4692',
    '钳': '8477',
    '懋': '4433',
    '寐': '3029',
    '淇': '3418',
    '琉': '1011',
    '杞': '4791',
    '菠': '4414',
    '铨': '8871',
    '翌': '1710',
    '靶': '4751',
    '侗': '2722',
    '瑙': '1216',
    '馅': '2777',
    '丐': '1002',
    '痊': '0011',
    '娓': '4741',
    '侈': '2722',
    '苓': '4430',
    '聆': '1843',
    '睿': '2160',
    '偌': '2426',
    '釜': '8010',
    '噬': '6801',
    '曦': '6805',
    '燮': '9940',
    '哟': '6702',
    '瑾': '1411',
    '瞿': '6621',
    '璇': '1818',
    '拮': '5406',
    '憬': '9609',
    '鹊': '4762',
    '勺': '2732',
    '憧': '9001',
    '嗜': '6406',
    '啼': '6002',
    '檐': '4796',
    '柚': '4596',
    '呱': '6203',
    '渍': '3518',
    '镌': '8072',
    '妃': '4741',
    '溺': '3712',
    '鸥': '7772',
    '粕': '9690',
    '沱': '3311',
    '榭': '4490',
    '隅': '7622',
    '毡': '2171',
    '禧': '3426',
    '瞅': '6908',
    '鲸': '2019',
    '淆': '3412',
    '阪': '7224',
    '茁': '4477',
    '渺': '3912',
    '瞥': '9860',
    '茜': '4460',
    '瘟': '0011',
    '礴': '1464',
    '伺': '2722',
    '谛': '3072',
    '锹': '8978',
    '蔼': '4472',
    '虔': '2124',
    '莺': '4412',
    '迸': '3830',
    '磕': '1461',
    '赡': '7786',
    '泱': '3518',
    '栈': '4395',
    '甄': '1111',
    '镐': '8072',
    '抠': '5101',
    '嬉': '4446',
    '诿': '3274',
    '甬': '1722',
    '绊': '2915',
    '饵': '2174',
    '谬': '3772',
    '梢': '4992',
    '颍': '2198',
    '揪': '5908',
    '琶': '1171',
    '褥': '3124',
    '佟': '2723',
    '腥': '7621',
    '辊': '4651',
    '溅': '3315',
    '琵': '1171',
    '鄯': '8762',
    '拴': '5801',
    '喃': '6402',
    '笙': '8810',
    '酰': '1461',
    '粱': '3390',
    '卤': '2160',
    '芮': '4422',
    '膛': '7921',
    '斓': '0742',
    '潼': '3011',
    '鸵': '2311',
    '侥': '2521',
    '讷': '3472',
    '婿': '4742',
    '吆': '6203',
    '羁': '6052',
    '嗣': '6722',
    '蜒': '5214',
    '栅': '4794',
    '疙': '0011',
    '拷': '5402',
    '戳': '1325',
    '镛': '8072',
    '芷': '4410',
    '钛': '8473',
    '蜿': '5311',
    '铀': '8576',
    '夯': '4042',
    '摞': '5609',
    '雌': '2011',
    '酣': '1467',
    '荼': '4490',
    '蝎': '5612',
    '锥': '8071',
    '姊': '4542',
    '瓢': '1293',
    '祀': '3721',
    '玺': '2710',
    '弛': '1421',
    '犷': '4020',
    '哦': '6305',
    '茸': '4440',
    '鱿': '2311',
    '绷': '2712',
    '茎': '4410',
    '惋': '9301',
    '亘': '1010',
    '珑': '1311',
    '莓': '4475',
    '掂': '5006',
    '迥': '3730',
    '鲤': '2611',
    '殃': '1528',
    '瘩': '0016',
    '叨': '6702',
    '螃': '5012',
    '奄': '4071',
    '腈': '7522',
    '疟': '0011',
    '沭': '3319',
    '钨': '8772',
    '昕': '6202',
    '膺': '0022',
    '涿': '3113',
    '糠': '9099',
    '氰': '8021',
    '揉': '5709',
    '狩': '4324',
    '檀': '4091',
    '悍': '9604',
    '缫': '2219',
    '哮': '6404',
    '衙': '2122',
    '瑚': '1712',
    '潞': '3716',
    '谤': '3072',
    '搀': '5703',
    '洱': '3114',
    '涓': '3612',
    '袤': '0073',
    '痰': '0018',
    '乖': '2011',
    '冗': '3721',
    '芋': '4440',
    '甭': '1022',
    '骸': '7028',
    '幌': '4621',
    '涮': '3210',
    '俨': '2120',
    '敖': '5824',
    '槛': '4891',
    '狄': '4928',
    '牒': '2409',
    '恺': '9201',
    '雹': '1071',
    '赎': '7488',
    '庶': '0023',
    '熨': '7480',
    '蛛': '5519',
    '佰': '2126',
    '蓦': '4412',
    '鄱': '2762',
    '煽': '9382',
    '腌': '7421',
    '黯': '6036',
    '疤': '0011',
    '倔': '2727',
    '剌': '5290',
    '斡': '4844',
    '诽': '3171',
    '锵': '8774',
    '筱': '8824',
    '妍': '4144',
    '掖': '5004',
    '铿': '8771',
    '脐': '7022',
    '捅': '5702',
    '弈': '0044',
    '邸': '7772',
    '湟': '3611',
    '眯': '6909',
    '赦': '4824',
    '拄': '5001',
    '啪': '6600',
    '玮': '1512',
    '轶': '4558',
    '蛾': '5315',
    '麋': '0029',
    '炫': '9083',
    '赊': '7889',
    '靴': '4451',
    '箔': '8816',
    '菁': '4422',
    '撬': '5201',
    '裳': '9073',
    '戌': '5320',
    '缨': '2714',
    '蝗': '5611',
    '撇': '5804',
    '奚': '2080',
    '瀛': '3011',
    '噩': '1010',
    '怯': '9403',
    '蓓': '4426',
    '匕': '2271',
    '咚': '6703',
    '瞰': '6804',
    '佬': '2421',
    '泞': '3312',
    '扉': '3021',
    '皋': '2640',
    '晾': '6009',
    '麒': '0428',
    '姗': '4744',
    '跚': '6714',
    '瘀': '0013',
    '鄙': '6762',
    '猕': '4729',
    '拭': '5304',
    '鲟': '2714',
    '祷': '3524',
    '脯': '7322',
    '砺': '1162',
    '驿': '7715',
    '陛': '7221',
    '瘁': '0014',
    '搓': '5801',
    '舵': '2341',
    '汞': '1090',
    '哼': '6002',
    '胫': '7721',
    '珀': '1610',
    '邬': '2712',
    '磺': '1468',
    '馏': '2776',
    '馍': '2478',
    '铢': '8579',
    '诧': '3371',
    '涧': '3712',
    '吏': '5000',
    '苔': '4460',
    '潺': '3714',
    '邳': '1712',
    '烷': '9381',
    '囿': '6022',
    '斟': '4470',
    '滁': '3819',
    '殆': '1326',
    '酚': '1862',
    '狡': '4024',
    '孺': '1142',
    '恬': '9206',
    '沅': '3111',
    '铬': '8776',
    '湍': '3212',
    '啧': '6508',
    '囱': '2600',
    '蒿': '4422',
    '鹃': '6722',
    '柠': '4392',
    '漱': '3718',
    '胥': '1722',
    '妖': '4248',
    '洙': '3519',
    '珂': '1112',
    '茉': '4490',
    '蹒': '6412',
    '圻': '4212',
    '鬓': '7280',
    '搂': '5904',
    '葩': '4461',
    '佘': '8090',
    '渥': '3711',
    '诙': '3478',
    '袒': '3621',
    '捂': '5106',
    '瞠': '6901',
    '妓': '4444',
    '铐': '8472',
    '澧': '3511',
    '袂': '3528',
    '馁': '2274',
    '汐': '3712',
    '匣': '7171',
    '逍': '3930',
    '谚': '3072',
    '窒': '3010',
    '蔑': '4425',
    '糯': '9192',
    '汶': '3014',
    '壹': '4010',
    '岖': '2171',
    '盔': '4010',
    '嘘': '6101',
    '迂': '3130',
    '嘀': '6002',
    '锢': '8670',
    '讥': '3771',
    '吭': '6001',
    '抨': '5104',
    '屎': '7729',
    '獭': '4728',
    '褪': '3723',
    '咫': '7680',
    '稷': '2694',
    '迦': '3630',
    '檬': '4493',
    '塬': '4119',
    '蠢': '5013',
    '蓟': '4412',
    '咎': '2360',
    '皿': '7710',
    '驮': '7418',
    '俐': '2220',
    '坍': '4714',
    '惭': '9202',
    '垛': '4719',
    '鹭': '6712',
    '鸾': '0012',
    '蹴': '6311',
    '撩': '5409',
    '诠': '3871',
    '恙': '8033',
    '臃': '7021',
    '遨': '3830',
    '睬': '6209',
    '踌': '6514',
    '浒': '3814',
    '搪': '5006',
    '郧': '6782',
    '竺': '8810',
    '翡': '1112',
    '宦': '3071',
    '冽': '3210',
    '憩': '2633',
    '萱': '4410',
    '拽': '5500',
    '卞': '0023',
    '槟': '4398',
    '躇': '6416',
    '蘸': '4463',
    '肋': '7422',
    '呛': '6801',
    '濡': '3112',
    '酮': '1762',
    '眨': '6203',
    '撮': '5604',
    '矸': '1164',
    '垸': '4311',
    '蛀': '5011',
    '黛': '2333',
    '涸': '3610',
    '脓': '7423',
    '徙': '2128',
    '撷': '5108',
    '曳': '5000',
    '峥': '2775',
    '渚': '3416',
    '镖': '8179',
    '钴': '8476',
    '骊': '7112',
    '袅': '2773',
    '磐': '2760',
    '掣': '2250',
    '沌': '3511',
    '埂': '4114',
    '嘿': '6603',
    '琏': '1413',
    '楣': '4796',
    '豚': '7123',
    '诡': '3771',
    '悸': '9204',
    '麝': '0024',
    '煦': '6733',
    '矾': '1761',
    '羲': '8025',
    '唉': '6308',
    '溧': '3119',
    '呻': '6500',
    '覃': '1040',
    '兖': '0021',
    '吱': '6404',
    '惰': '9402',
    '羹': '8080',
    '钝': '8571',
    '枸': '4792',
    '姣': '4044',
    '颓': '2128',
    '铣': '8471',
    '梆': '4792',
    '骇': '7018',
    '淅': '3212',
    '孢': '1741',
    '叱': '6401',
    '谧': '3371',
    '泯': '3714',
    '谟': '3478',
    '恃': '9404',
    '薹': '4410',
    '筵': '8840',
    '鏖': '0021',
    '栾': '0090',
    '鹜': '1812',
    '哽': '6104',
    '掬': '5702',
    '辘': '4051',
    '茗': '4460',
    '瓯': '7171',
    '绛': '2715',
    '筠': '8812',
    '铤': '8274',
    '袄': '3228',
    '殚': '1825',
    '梵': '4421',
    '挎': '5402',
    '遴': '3930',
    '榈': '4792',
    '蜕': '5811',
    '癣': '0015',
    '垠': '4713',
    '厮': '7122',
    '幄': '4721',
    '偕': '2226',
    '焱': '9088',
    '攥': '5809',
    '裨': '3624',
    '炖': '9581',
    '旮': '4060',
    '旯': '6041',
    '蔺': '4422',
    '骡': '7619',
    '娩': '4741',
    '伫': '2321',
    '猝': '4024',
    '窿': '3021',
    '虏': '2122',
    '屉': '7721',
    '缜': '2418',
    '咒': '6621',
    '筏': '8825',
    '骼': '7726',
    '璐': '1716',
    '剃': '8220',
    '涕': '3812',
    '猗': '4422',
    '淼': '1299',
    '侬': '2423',
    '阙': '3748',
    '嗅': '6608',
    '鸳': '2712',
    '嘈': '6506',
    '霏': '1011',
    '珩': '1112',
    '沮': '3711',
    '捺': '5409',
    '硼': '1762',
    '荃': '4410',
    '驷': '7610',
    '漩': '3818',
    '嘻': '6406',
    '眩': '6003',
    '掰': '2255',
    '伽': '2620',
    '脍': '7823',
    '婪': '4440',
    '煜': '9681',
    '鹄': '2762',
    '壕': '4013',
    '崂': '2472',
    '翎': '8732',
    '痞': '0016',
    '兀': '1021',
    '婺': '1840',
    '鸯': '5012',
    '楹': '4791',
    '咤': '6301',
    '徜': '2922',
    '嫉': '4048',
    '篓': '8840',
    '烃': '9781',
    '铂': '8670',
    '咪': '6909',
    '掐': '5707',
    '匝': '7171',
    '杼': '4792',
    '蕃': '4460',
    '箍': '8851',
    '荤': '4450',
    '砾': '1269',
    '嘶': '6202',
    '皑': '2261',
    '宕': '3060',
    '荪': '4449',
    '哎': '6404',
    '汴': '3013',
    '貂': '2726',
    '邡': '0722',
    '淦': '3811',
    '蕙': '4433',
    '弩': '4702',
    '堑': '4210',
    '惬': '9101',
    '偃': '2121',
    '徉': '2825',
    '箴': '8825',
    '赘': '5880',
    '啻': '0060',
    '凋': '3712',
    '穹': '3002',
    '酗': '1267',
    '憎': '9806',
    '芥': '4422',
    '唾': '6201',
    '闫': '3710',
    '晔': '6404',
    '苞': '4471',
    '昶': '3690',
    '甙': '4370',
    '笺': '8850',
    '吝': '0060',
    '蕊': '4433',
    '鳝': '2816',
    '衅': '2915',
    '猩': '4621',
    '薰': '4433',
    '昱': '6010',
    '趾': '6111',
    '淞': '3813',
    '坳': '4412',
    '怅': '9203',
    '翱': '2742',
    '汩': '3610',
    '琥': '1111',
    '岌': '2224',
    '阑': '3790',
    '粼': '9223',
    '羌': '8051',
    '霆': '1040',
    '篡': '8873',
    '塾': '0510',
    '酉': '1060',
    '裱': '3523',
    '韭': '1110',
    '唠': '6402',
    '廿': '4477',
    '闰': '3710',
    '攸': '2824',
    '黝': '6432',
    '蛤': '5816',
    '厥': '7128',
    '荞': '4422',
    '瑕': '1714',
    '柘': '4196',
    '祚': '3821',
    '疵': '0011',
    '愕': '9602',
    '蕨': '4428',
    '牦': '2251',
    '飨': '2823',
    '疹': '0012',
    '嗷': '6804',
    '癖': '0014',
    '芪': '4474',
    '漕': '3516',
    '隍': '7621',
    '徨': '2621',
    '逵': '3430',
    '泠': '3813',
    '嵘': '2479',
    '嗡': '6802',
    '岫': '2576',
    '岷': '2774',
    '擞': '5804',
    '陂': '7424',
    '颊': '5188',
    '咔': '6103',
    '卯': '7772',
    '婶': '4345',
    '椭': '4492',
    '惘': '9702',
    '歙': '8718',
    '幺': '2073',
    '臆': '7023',
    '叽': '6701',
    '缰': '2111',
    '睽': '6208',
    '勐': '1412',
    '暄': '6301',
    '弋': '4300',
    '痔': '0014',
    '秭': '2592',
    '煲': '2680',
    '琮': '1319',
    '嘟': '6702',
    '犊': '2458',
    '玖': '1718',
    '怦': '9104',
    '丕': '1010',
    '溴': '3618',
    '罂': '7777',
    '瓮': '8071',
    '丞': '1710',
    '惮': '9805',
    '癜': '0014',
    '晦': '6805',
    '攫': '5604',
    '镰': '8073',
    '镯': '8672',
    '柞': '4891',
    '舫': '2042',
    '铆': '8772',
    '蹼': '6218',
    '妩': '4141',
    '熹': '4033',
    '铱': '8073',
    '褂': '3320',
    '丫': '8020',
    '笆': '8871',
    '妒': '4340',
    '噢': '6708',
    '噙': '6802',
    '琬': '1311',
    '冼': '3411',
    '荀': '4462',
    '蟾': '5716',
    '捶': '5201',
    '嗒': '6406',
    '町': '6102',
    '嫣': '4142',
    '肮': '7021',
    '皎': '2064',
    '旖': '0822',
    '恣': '3733',
    '钚': '8179',
    '砥': '1264',
    '吩': '6802',
    '茯': '4428',
    '馥': '2864',
    '钎': '8274',
    '甥': '2612',
    '嗦': '6409',
    '蜗': '5612',
    '浔': '3714',
    '谒': '3672',
    '辫': '0044',
    '亳': '0071',
    '彷': '2022',
    '珏': '1111',
    '咯': '6706',
    '淖': '3114',
    '妊': '4241',
    '佤': '2121',
    '玷': '1116',
    '嘹': '6409',
    '崴': '2225',
    '於': '0823',
    '辕': '4453',
    '贲': '4080',
    '扈': '3021',
    '伎': '2424',
    '旎': '0821',
    '孽': '4440',
    '耙': '5791',
    '娠': '4143',
    '戊': '5320',
    '冢': '3723',
    '跷': '6511',
    '砷': '1560',
    '焘': '5033',
    '羔': '8033',
    '圪': '4811',
    '耄': '4471',
    '钼': '8670',
    '悻': '9404',
    '荥': '4490',
    '唑': '6801',
    '稞': '2699',
    '邝': '0722',
    '莅': '4421',
    '杷': '4791',
    '醛': '1461',
    '嗽': '6708',
    '唆': '6304',
    '拗': '5402',
    '碴': '1461',
    '馋': '2773',
    '胱': '7921',
    '琨': '1611',
    '茏': '4441',
    '糜': '0029',
    '懦': '9102',
    '骞': '3012',
    '蜘': '5610',
    '嚓': '6309',
    '怵': '9309',
    '抡': '5801',
    '唢': '6908',
    '腆': '7528',
    '涎': '3214',
    '灏': '3118',
    '臼': '7777',
    '墒': '4012',
    '暹': '3630',
    '椽': '4793',
    '牍': '2408',
    '钒': '8771',
    '猾': '4722',
    '榔': '4792',
    '懵': '9406',
    '枇': '4291',
    '樵': '4093',
    '锶': '8673',
    '籼': '9297',
    '箫': '8822',
    '漪': '3412',
    '帚': '1722',
    '钵': '8573',
    '赓': '0028',
    '捻': '5803',
    '郅': '1712',
    '儋': '2726',
    '烬': '9783',
    '锂': '8671',
    '剽': '1290',
    '锑': '8872',
    '鄢': '1732',
    '鄞': '4712',
    '臾': '7780',
    '喳': '6401',
    '胄': '5022',
    '耋': '4410',
    '阱': '7520',
    '笠': '8810',
    '瓴': '8131',
    '啬': '4060',
    '杳': '4060',
    '萤': '4413',
    '莠': '4422',
    '嶂': '2074',
    '浜': '3218',
    '傩': '2021',
    '遒': '3830',
    '轼': '4354',
    '睢': '6001',
    '倜': '2722',
    '矽': '1762',
    '仉': '2721',
    '唬': '6101',
    '旌': '0821',
    '酪': '1766',
    '腼': '7126',
    '罄': '4777',
    '嬗': '4041',
    '畲': '8060',
    '祟': '2290',
    '桅': '4791',
    '悴': '9004',
    '讹': '3471',
    '憔': '9003',
    '龋': '2272',
    '嵊': '2279',
    '绶': '2214',
    '邕': '2271',
    '忖': '9400',
    '箩': '8820',
    '咆': '6701',
    '晌': '6702',
    '愫': '9509',
    '猷': '8368',
    '帛': '2622',
    '麾': '0021',
    '莒': '4460',
    '觑': '2721',
    '吮': '6301',
    '蟋': '5213',
    '庥': '0029',
    '懊': '9708',
    '阂': '3780',
    '蒯': '4220',
    '阡': '7224',
    '腮': '7623',
    '潸': '3412',
    '晟': '6025',
    '蟀': '5014',
    '臀': '7722',
    '罔': '7722',
    '骁': '7511',
    '崽': '2233',
    '绉': '2717',
    '粽': '9399',
    '忿': '8033',
    '肛': '7121',
    '蠡': '2713',
    '遛': '3730',
    '蜓': '5214',
    '煊': '9381',
    '蚜': '5114',
    '坻': '4214',
    '滹': '3114',
    '銮': '0010',
    '悯': '9702',
    '鼐': '1722',
    '撵': '5505',
    '噼': '6004',
    '忐': '2133',
    '湮': '3111',
    '侏': '2529',
    '粳': '9194',
    '矍': '6640',
    '铄': '8279',
    '坨': '4311',
    '铉': '8073',
    '盂': '1010',
    '锗': '8476',
    '阖': '3710',
    '溟': '3718',
    '俟': '2328',
    '忑': '1033',
    '赝': '7128',
    '鬃': '7290',
    '敝': '9824',
    '宸': '3023',
    '哆': '6702',
    '靓': '5721',
    '揩': '5206',
    '瘸': '0012',
    '鲅': '2314',
    '篝': '8844',
    '氦': '8081',
    '嚎': '6003',
    '浃': '3518',
    '缙': '2116',
    '飚': '7921',
    '锷': '8672',
    '癸': '1280',
    '柩': '4191',
    '蛎': '5112',
    '濂': '3013',
    '榷': '4491',
    '鲨': '3910',
    '钡': '8778',
    '盹': '6501',
    '鲫': '2712',
    '诘': '3476',
    '诩': '3772',
    '迤': '3830',
    '桎': '4191',
    '遁': '3230',
    '尕': '1790',
    '梏': '4496',
    '楫': '4694',
    '赳': '4280',
    '飒': '0711',
    '锃': '8671',
    '雉': '8081',
    '怆': '9801',
    '痼': '0016',
    '劾': '0482',
    '痢': '0012',
    '喽': '6904',
    '霹': '1024',
    '昙': '6073',
    '畹': '6301',
    '胭': '7620',
    '佚': '2528',
    '狈': '4728',
    '瘪': '0011',
    '姹': '4341',
    '吠': '6308',
    '铧': '8474',
    '谏': '3579',
    '雳': '1022',
    '咙': '6301',
    '畦': '6401',
    '荠': '4422',
    '娑': '3940',
    '褶': '3726',
    '忏': '9204',
    '惚': '9703',
    '痉': '0011',
    '橘': '4792',
    '漉': '3011',
    '诏': '3776',
    '呗': '6708',
    '晁': '6011',
    '惆': '9702',
    '砀': '1762',
    '馄': '2671',
    '戟': '4345',
    '峁': '2272',
    '昵': '6701',
    '拈': '5106',
    '蠕': '5112',
    '虱': '1711',
    '洵': '3712',
    '鹦': '7742',
    '蛹': '5712',
    '铛': '8977',
    '挛': '0050',
    '倏': '2728',
    '澍': '3410',
    '濉': '3011',
    '钅': '8070',
    '噜': '6706',
    '咛': '6302',
    '俳': '2121',
    '磬': '4760',
    '蜷': '5911',
    '霎': '1040',
    '肽': '7423',
    '砼': '1861',
    '聿': '5000',
    '怔': '9101',
    '砭': '1263',
    '谌': '3471',
    '箕': '8880',
    '蹶': '6118',
    '孪': '0040',
    '蔷': '4460',
    '糅': '9799',
    '挞': '5403',
    '饨': '2571',
    '惴': '9202',
    '禀': '0090',
    '淙': '3319',
    '哒': '6403',
    '枷': '4690',
    '楝': '4599',
    '闾': '3760',
    '蜻': '5512',
    '嗖': '6704',
    '淬': '3014',
    '垩': '1010',
    '矜': '1822',
    '郗': '4722',
    '蚤': '7713',
    '嫦': '4942',
    '喋': '6409',
    '镉': '8172',
    '饯': '2375',
    '髋': '7321',
    '潦': '3419',
    '镂': '8974',
    '簌': '8898',
    '偎': '2623',
    '鹉': '1712',
    '岙': '2077',
    '踱': '6014',
    '诃': '3172',
    '籁': '8898',
    '宓': '3033',
    '膘': '7129',
    '飙': '4781',
    '涞': '3519',
    '耆': '4460',
    '荏': '4421',
    '渑': '3611',
    '豌': '1311',
    '琰': '1918',
    '俎': '8781',
    '绌': '2217',
    '埭': '4519',
    '幡': '4226',
    '赅': '7088',
    '锆': '8476',
    '崮': '2260',
    '碣': '1662',
    '珞': '1716',
    '腋': '7024',
    '滢': '3411',
    '蓖': '4471',
    '伉': '2021',
    '馗': '4801',
    '聩': '1548',
    '幔': '4624',
    '锨': '8778',
    '蓥': '4410',
    '鹑': '0742',
    '砝': '1463',
    '酩': '1766',
    '枰': '4194',
    '鞘': '4952',
    '苋': '4421',
    '粑': '9791',
    '蹭': '6816',
    '倌': '2327',
    '犟': '1650',
    '俪': '2122',
    '嶙': '2975',
    '砻': '4360',
    '嵋': '2776',
    '滂': '3012',
    '葺': '4440',
    '苒': '4444',
    '枭': '2790',
    '翊': '0712',
    '婀': '4142',
    '飓': '7721',
    '阚': '3744',
    '喟': '6602',
    '傈': '2129',
    '藐': '4421',
    '蜃': '7123',
    '怂': '8833',
    '稣': '2219',
    '亵': '0073',
    '诒': '3376',
    '蜇': '5213',
    '岜': '2271',
    '霁': '1022',
    '瞌': '6401',
    '沏': '3712',
    '卅': '4400',
    '舀': '2077',
    '鹌': '4772',
    '俸': '2525',
    '嵇': '2397',
    '蟒': '5414',
    '汨': '3610',
    '砰': '1164',
    '鞣': '4759',
    '唏': '6402',
    '陉': '7721',
    '佯': '2825',
    '恿': '1733',
    '竽': '8840',
    '瘴': '0014',
    '祉': '3121',
    '焙': '9086',
    '诋': '3274',
    '濠': '3013',
    '螂': '5712',
    '叻': '6402',
    '垅': '4311',
    '谩': '3674',
    '朐': '7722',
    '稔': '2893',
    '芍': '4432',
    '瞳': '6001',
    '惺': '9601',
    '萸': '4480',
    '盅': '5010',
    '啄': '6103',
    '眈': '6401',
    '偻': '2924',
    '爿': '2220',
    '蟠': '5216',
    '炔': '9588',
    '垭': '4111',
    '噎': '6401',
    '蛰': '5513',
    '擘': '7050',
    '锏': '8772',
    '茭': '4440',
    '悌': '9802',
    '喔': '6701',
    '谑': '3171',
    '峋': '2772',
    '妪': '4141',
    '恽': '9705',
    '韫': '5601',
    '褓': '3629',
    '镳': '8073',
    '饽': '2474',
    '杈': '4794',
    '戛': '1050',
    '鸠': '4702',
    '萋': '4440',
    '襁': '3623',
    '榫': '4094',
    '霭': '1072',
    '苄': '4423',
    '跺': '6719',
    '杲': '6090',
    '嗨': '6805',
    '珉': '1714',
    '哌': '6203',
    '娆': '4541',
    '孀': '4146',
    '恸': '9402',
    '缄': '2315',
    '夔': '8040',
    '佗': '2321',
    '饷': '2772',
    '苷': '4477',
    '郜': '2762',
    '鼾': '2124',
    '颌': '8168',
    '訇': '2762',
    '谲': '3772',
    '溘': '3411',
    '咧': '6200',
    '褛': '3924',
    '逄': '3730',
    '颦': '2140',
    '洮': '3211',
    '逶': '3230',
    '嫡': '4042',
    '蠹': '4013',
    '碓': '1061',
    '烩': '9883',
    '醴': '1561',
    '栎': '4299',
    '鎏': '3010',
    '瓤': '0273',
    '伢': '2124',
    '蔫': '4432',
    '怿': '9705',
    '甾': '2260',
    '摈': '5308',
    '畈': '6204',
    '镣': '8479',
    '螨': '5412',
    '秣': '2599',
    '搔': '5703',
    '盱': '6104',
    '痍': '0018',
    '搐': '5006',
    '蹉': '6811',
    '佃': '2620',
    '绂': '2314',
    '疽': '0011',
    '骝': '7716',
    '霾': '1021',
    '悚': '9509',
    '缃': '2610',
    '懿': '4713',
    '咂': '6101',
    '奘': '2480',
    '轱': '4456',
    '邗': '1742',
    '蚝': '5211',
    '瘘': '0014',
    '醚': '1963',
    '湎': '3116',
    '瞑': '6708',
    '掮': '5302',
    '羟': '8751',
    '仨': '2121',
    '砣': '1361',
    '郢': '6712',
    '砧': '1166',
    '鳟': '2814',
    '跛': '6414',
    '踝': '6619',
    '轲': '4152',
    '窠': '3090',
    '郦': '1722',
    '踉': '6313',
    '躏': '6412',
    '戮': '1325',
    '篾': '8825',
    '骐': '7418',
    '鳍': '2416',
    '蹂': '6719',
    '郯': '9782',
    '跎': '6311',
    '倭': '2224',
    '诅': '3771',
    '鄄': '1712',
    '褴': '3821',
    '阆': '3773',
    '缈': '2912',
    '嗯': '6603',
    '妞': '4741',
    '沤': '3111',
    '跄': '6811',
    '箐': '8822',
    '苕': '4460',
    '窕': '3011',
    '楔': '4798',
    '饴': '2376',
    '峄': '2775',
    '腴': '7728',
    '圄': '6060',
    '谕': '3872',
    '揍': '5508',
    '踹': '6212',
    '罡': '6010',
    '佝': '2722',
    '颔': '8168',
    '觊': '2771',
    '篑': '8880',
    '鲢': '2413',
    '綦': '4490',
    '妾': '0040',
    '镗': '8971',
    '啕': '6702',
    '蚬': '5711',
    '窈': '3072',
    '揖': '5604',
    '眙': '6306',
    '蟑': '5014',
    '诛': '3579',
    '钗': '8774',
    '绯': '2111',
    '讣': '3370',
    '睾': '2640',
    '媾': '4544',
    '嗬': '6402',
    '祜': '3426',
    '镢': '8178',
    '囹': '6030',
    '苜': '4460',
    '坭': '4711',
    '蛐': '5516',
    '髯': '7244',
    '搡': '5709',
    '叟': '7740',
    '蹋': '6612',
    '觎': '8721',
    '捱': '5101',
    '碉': '1762',
    '呋': '6508',
    '罘': '6090',
    '荚': '4480',
    '鹫': '0312',
    '岿': '2227',
    '寮': '3090',
    '扪': '5702',
    '焖': '9782',
    '狞': '4322',
    '鳅': '2918',
    '嗄': '6104',
    '嗤': '6203',
    '擀': '5804',
    '痂': '0016',
    '嗟': '6801',
    '颉': '4168',
    '蚧': '5812',
    '儆': '2824',
    '锴': '8276',
    '龛': '8041',
    '嗑': '6401',
    '锟': '8671',
    '俚': '2621',
    '枥': '4192',
    '懑': '3433',
    '讫': '3871',
    '橇': '4291',
    '嗪': '6509',
    '虬': '5211',
    '跆': '6316',
    '骧': '7013',
    '陟': '7122',
    '灞': '3112',
    '恻': '9200',
    '涔': '3212',
    '酐': '1164',
    '鸪': '4762',
    '牯': '2456',
    '钜': '8171',
    '萘': '4490',
    '鲶': '2833',
    '缥': '2119',
    '曜': '6701',
    '蚓': '5210',
    '诤': '3775',
    '埕': '4611',
    '墀': '4715',
    '麸': '5548',
    '蝠': '5116',
    '蛊': '5010',
    '遑': '3630',
    '厩': '7121',
    '趄': '4780',
    '沔': '3112',
    '耦': '5692',
    '疱': '0011',
    '匍': '2722',
    '揿': '5708',
    '蚯': '5211',
    '讪': '3277',
    '唰': '6200',
    '舔': '2163',
    '呷': '6605',
    '蓿': '4426',
    '鹧': '0722',
    '膑': '7328',
    '刍': '2717',
    '耷': '4040',
    '鞑': '4453',
    '裆': '3927',
    '趸': '1080',
    '孑': '1740',
    '鲲': '2611',
    '绫': '2414',
    '埝': '4813',
    '嘭': '6202',
    '舢': '2247',
    '鸢': '4312',
    '螯': '5813',
    '吡': '6201',
    '蝙': '5312',
    '疸': '0011',
    '匐': '2762',
    '桁': '4192',
    '铠': '8271',
    '羸': '0021',
    '鲈': '2110',
    '囵': '6071',
    '唛': '6504',
    '仫': '2223',
    '庖': '0021',
    '劭': '1462',
    '郓': '3752',
    '骜': '5812',
    '粲': '2790',
    '峒': '2772',
    '腓': '7121',
    '鹳': '4722',
    '鳜': '2118',
    '蚶': '5417',
    '囫': '6022',
    '茴': '4460',
    '峤': '2272',
    '蟆': '5418',
    '蘖': '4490',
    '癯': '2122',
    '纾': '2712',
    '僳': '2129',
    '皙': '4260',
    '隰': '7623',
    '缬': '2118',
    '馐': '2871',
    '谪': '3072',
    '捭': '5604',
    '汊': '3714',
    '碜': '1362',
    '塍': '7921',
    '艮': '7773',
    '睑': '6801',
    '狍': '4721',
    '苫': '4460',
    '篦': '8871',
    '蜍': '5819',
    '锉': '8871',
    '沣': '3510',
    '诰': '3476',
    '晗': '6806',
    '喙': '6703',
    '麂': '0021',
    '謇': '3060',
    '蹇': '3080',
    '觐': '4711',
    '啾': '6908',
    '踽': '6212',
    '邈': '3630',
    '壬': '2010',
    '燧': '9883',
    '娲': '4642',
    '猥': '4623',
    '歆': '0768',
    '镒': '8871',
    '茔': '4410',
    '昝': '2360',
    '赭': '4426',
    '狰': '4725',
    '孳': '8040',
    '哧': '6403',
    '舛': '2520',
    '噔': '6201',
    '鹗': '6722',
    '蚣': '5813',
    '逅': '3230',
    '洹': '3111',
    '腱': '7524',
    '锒': '8373',
    '纰': '2211',
    '蛆': '5711',
    '蕤': '4423',
    '姝': '4549',
    '邰': '2762',
    '纣': '2410',
    '嘣': '6202',
    '钹': '8374',
    '衩': '3724',
    '婵': '4845',
    '孱': '7724',
    '蹿': '6315',
    '鲷': '2712',
    '萼': '4402',
    '椁': '4094',
    '浣': '3311',
    '镓': '8373',
    '遽': '3130',
    '赉': '5080',
    '趔': '4280',
    '蕲': '4452',
    '剜': '3220',
    '邂': '3730',
    '仡': '2821',
    '氤': '8061',
    '獐': '4024',
    '幛': '4024',
    '俾': '2624',
    '铋': '8370',
    '嗔': '6408',
    '茌': '4421',
    '氡': '8031',
    '诂': '3476',
    '豢': '9023',
    '桧': '4893',
    '畿': '2265',
    '倥': '2321',
    '捋': '5204',
    '仞': '2722',
    '忒': '4330',
    '疃': '6001',
    '浯': '3116',
    '蜈': '5618',
    '榛': '4599',
    '偬': '2723',
    '稗': '2694',
    '菖': '4460',
    '鲳': '2616',
    '厝': '7126',
    '踮': '6016',
    '叼': '6702',
    '痱': '0011',
    '貉': '2726',
    '玑': '1711',
    '婕': '4548',
    '琚': '1716',
    '疴': '0012',
    '掳': '5102',
    '钤': '8872',
    '垧': '4712',
    '氵': '3010',
    '黠': '6436',
    '跹': '6213',
    '怏': '9508',
    '揄': '5802',
    '氲': '8011',
    '铡': '8270',
    '濯': '3711',
    '芾': '4422',
    '笈': '8824',
    '崆': '2371',
    '钕': '8474',
    '菽': '4494',
    '隼': '2040',
    '傥': '2921',
    '仝': '8010',
    '囗': '6000',
    '芗': '4420',
    '埙': '4618',
    '簪': '8860',
    '暧': '6204',
    '桉': '4394',
    '镝': '8072',
    '蚪': '5410',
    '蜉': '5214',
    '藁': '4490',
    '笳': '8846',
    '菅': '4477',
    '龃': '2771',
    '喹': '6401',
    '橹': '4796',
    '抿': '5704',
    '啮': '6107',
    '蹑': '6114',
    '逖': '3930',
    '唔': '6106',
    '樨': '4795',
    '巽': '7780',
    '揶': '5702',
    '黟': '6732',
    '訾': '2260',
    '钣': '8274',
    '嵯': '2871',
    '凼': '2277',
    '恫': '9702',
    '掇': '5704',
    '剁': '7290',
    '珙': '1418',
    '沆': '3011',
    '噱': '6103',
    '揆': '5208',
    '耒': '5090',
    '铌': '8771',
    '泅': '3610',
    '疝': '0017',
    '葳': '4425',
    '隗': '7621',
    '滟': '3711',
    '龉': '2176',
    '钺': '8375',
    '殒': '1628',
    '蒡': '4422',
    '觇': '2761',
    '黜': '6237',
    '澹': '3716',
    '酊': '1162',
    '垡': '2310',
    '奂': '2780',
    '珈': '1610',
    '濑': '3718',
    '馕': '2573',
    '馊': '2774',
    '嚏': '6408',
    '痿': '0014',
    '岘': '2771',
    '氩': '8011',
    '茱': '4490',
    '滓': '3314',
    '焯': '9184',
    '抻': '5500',
    '豉': '1414',
    '敕': '5894',
    '掸': '5805',
    '碲': '1062',
    '靛': '5328',
    '摁': '5603',
    '淝': '3711',
    '鳏': '2619',
    '盥': '7710',
    '皈': '2264',
    '鲑': '2411',
    '颢': '6198',
    '犄': '2452',
    '翦': '8012',
    '铰': '8074',
    '椐': '4796',
    '胯': '7422',
    '屺': '2771',
    '邛': '1712',
    '庹': '0028',
    '猬': '4622',
    '蓊': '4412',
    '骛': '1812',
    '浠': '3412',
    '桠': '4191',
    '胤': '2201',
    '鸩': '4702',
    '痣': '0013',
    '蛭': '5111',
    '噌': '6806',
    '杵': '4894',
    '啜': '6704',
    '靼': '4651',
    '啶': '6308',
    '煅': '9784',
    '枋': '4092',
    '觥': '2921',
    '毂': '4754',
    '刽': '8270',
    '蝈': '5610',
    '蘅': '4422',
    '芨': '4424',
    '戬': '1365',
    '醮': '1063',
    '疖': '0012',
    '忾': '9801',
    '骷': '7426',
    '洌': '3210',
    '呤': '6803',
    '荦': '4450',
    '觞': '2822',
    '谡': '3674',
    '瀣': '3711',
    '蝣': '5814',
    '糌': '9396',
    '倬': '2124',
    '碚': '1066',
    '蹙': '5380',
    '痘': '0011',
    '砘': '1561',
    '绀': '2417',
    '虢': '2131',
    '蕻': '4478',
    '肓': '0022',
    '蛔': '5610',
    '唧': '6702',
    '桀': '2590',
    '蝌': '5410',
    '侩': '2823',
    '棂': '4798',
    '樯': '4496',
    '挈': '5750',
    '轫': '4752',
    '巳': '7771',
    '崧': '2293',
    '蓑': '4473',
    '藓': '4415',
    '鳕': '2117',
    '瑗': '1214',
    '帙': '4528',
    '馔': '2778',
    '豺': '2420',
    '痤': '0011',
    '郇': '2762',
    '殓': '1821',
    '髅': '7924',
    '轳': '4150',
    '逯': '3730',
    '嗫': '6104',
    '戕': '2325',
    '嚅': '6102',
    '蛳': '5112',
    '琊': '1712',
    '嘤': '6704',
    '疣': '0011',
    '蚱': '5811',
    '钯': '8771',
    '钿': '8670',
    '碇': '1368',
    '咣': '6901',
    '毽': '2571',
    '迳': '3730',
    '喱': '6101',
    '逦': '3130',
    '廪': '0029',
    '邙': '0772',
    '囡': '6040',
    '匏': '4721',
    '扦': '5204',
    '亻': '2020',
    '咝': '6201',
    '凇': '3813',
    '纨': '2511',
    '涠': '3610',
    '庠': '0025',
    '溆': '3714',
    '醺': '1263',
    '炀': '9782',
    '烊': '9885',
    '肄': '2580',
    '龈': '2773',
    '谀': '3778',
    '锱': '8276',
    '瘢': '0014',
    '枞': '4890',
    '皴': '2444',
    '贰': '4380',
    '晷': '6060',
    '闳': '3773',
    '斛': '2420',
    '屐': '7724',
    '讦': '3174',
    '婧': '4542',
    '苣': '4471',
    '蔻': '4421',
    '绺': '2316',
    '渌': '3719',
    '瑁': '1616',
    '螟': '5718',
    '叵': '7171',
    '颀': '7128',
    '穑': '2496',
    '膻': '7021',
    '羧': '8354',
    '螳': '5911',
    '绦': '2719',
    '誊': '9060',
    '蜥': '5212',
    '楦': '4391',
    '恂': '9702',
    '靥': '7126',
    '咿': '6700',
    '翳': '7712',
    '瓒': '1418',
    '枳': '4698',
    '啭': '6503',
    '樽': '4894',
    '嫒': '4244',
    '婊': '4543',
    '搽': '5409',
    '铒': '8174',
    '跗': '6410',
    '凫': '2721',
    '菡': '4477',
    '篁': '8810',
    '髻': '7260',
    '裾': '3726',
    '栲': '4492',
    '癞': '0018',
    '蓼': '4420',
    '氖': '8021',
    '孬': '1044',
    '喏': '6406',
    '砒': '1261',
    '姘': '4844',
    '衽': '3221',
    '缛': '2114',
    '嵬': '2251',
    '挹': '5601',
    '缢': '2811',
    '慵': '9002',
    '呦': '6402',
    '箸': '8860',
    '蹩': '9880',
    '槎': '4891',
    '榇': '4099',
    '舂': '5077',
    '嗲': '6802',
    '胴': '7722',
    '谔': '3672',
    '岢': '2262',
    '圹': '4010',
    '娌': '4641',
    '潋': '3814',
    '蛉': '5813',
    '酃': '1762',
    '鲵': '2711',
    '鲇': '2116',
    '娉': '4542',
    '亓': '1022',
    '碛': '1568',
    '芊': '4440',
    '忪': '9803',
    '谇': '3074',
    '笤': '8860',
    '韪': '6580',
    '勰': '4643',
    '呓': '6401',
    '俣': '2628',
    '圜': '6073',
    '愠': '9601',
    '仄': '7128',
    '炷': '9081',
    '毖': '2233',
    '筚': '8840',
    '伧': '2821',
    '棰': '4291',
    '磴': '1261',
    '滏': '3811',
    '篙': '8822',
    '肱': '7423',
    '笕': '8821',
    '堇': '4410',
    '馑': '2471',
    '荩': '4430',
    '榘': '8190',
    '哐': '6101',
    '傀': '2621',
    '崃': '2579',
    '罱': '6022',
    '痨': '0012',
    '儡': '2626',
    '鹂': '1722',
    '檩': '4099',
    '垴': '4017',
    '仵': '2824',
    '檄': '4894',
    '芎': '4402',
    '阉': '3771',
    '刈': '4200',
    '壅': '0010',
    '馀': '2879',
    '庾': '0028',
    '妯': '4546',
    '躅': '6612',
    '獒': '5880',
    '阊': '3760',
    '笞': '8860',
    '饬': '2872',
    '钏': '8270',
    '硐': '1762',
    '椴': '4794',
    '泔': '3417',
    '硌': '1766',
    '鹘': '7722',
    '鳇': '2611',
    '豇': '1111',
    '狙': '4721',
    '戡': '4375',
    '莨': '4473',
    '啉': '6409',
    '辇': '5550',
    '臬': '2690',
    '殇': '1822',
    '舐': '2264',
    '黍': '2090',
    '薮': '4444',
    '眭': '6401',
    '佻': '2221',
    '嗵': '6703',
    '煨': '9683',
    '莴': '4422',
    '蚴': '5412',
    '妤': '4742',
    '瘐': '0018',
    '擢': '5701',
    '蛏': '5711',
    '蹰': '6114',
    '龊': '2678',
    '辏': '4558',
    '绐': '2316',
    '氘': '8021',
    '骶': '7224',
    '莪': '4455',
    '珐': '1413',
    '缟': '2012',
    '聒': '1246',
    '讧': '3171',
    '岬': '2675',
    '胛': '7625',
    '桷': '4792',
    '谰': '3772',
    '戾': '3028',
    '撸': '5706',
    '鸬': '2722',
    '雒': '2061',
    '嘧': '6307',
    '囔': '6503',
    '铍': '8474',
    '骈': '7814',
    '掊': '5006',
    '茕': '4441',
    '噻': '6301',
    '铯': '8771',
    '柁': '4391',
    '艉': '2741',
    '龌': '2771',
    '硖': '1568',
    '罅': '8174',
    '魇': '7121',
    '酽': '1160',
    '咦': '6508',
    '嶷': '2288',
    '羿': '1744',
    '轸': '4852',
    '趵': '6712',
    '荸': '4440',
    '薜': '4424',
    '踟': '6610',
    '玳': '1314',
    '啖': '6908',
    '蔸': '4421',
    '槁': '4092',
    '鲛': '2014',
    '疥': '0012',
    '砬': '1061',
    '唳': '6308',
    '弭': '1124',
    '曩': '6073',
    '黏': '2196',
    '镊': '8174',
    '泮': '3915',
    '霈': '1012',
    '淠': '3612',
    '柒': '3490',
    '颧': '4128',
    '瘙': '0013',
    '痧': '0012',
    '辋': '4752',
    '郄': '4772',
    '燹': '1180',
    '泫': '3013',
    '郾': '7772',
    '鹞': '2772',
    '钇': '8771',
    '殪': '1421',
    '痈': '0012',
    '甑': '8161',
    '踯': '6712',
    '翥': '4412',
    '婢': '4644',
    '檗': '7090',
    '柽': '4791',
    '啐': '6004',
    '菪': '4460',
    '嶝': '2271',
    '腭': '7622',
    '嗝': '6102',
    '剐': '6220',
    '笏': '8822',
    '蟥': '5418',
    '戢': '6345',
    '阄': '3771',
    '噘': '6108',
    '撅': '5108',
    '尻': '7721',
    '贶': '7681',
    '辚': '4955',
    '蜢': '5711',
    '颞': '1148',
    '忸': '9701',
    '胼': '7824',
    '阕': '3780',
    '竦': '0519',
    '焐': '9186',
    '揠': '5101',
    '邺': '3712',
    '鳙': '2012',
    '啁': '6702',
    '稹': '2498',
    '徵': '2824',
    '诌': '3777',
    '隹': '2021',
    '舨': '2244',
    '哔': '6204',
    '卟': '6300',
    '伥': '2223',
    '苌': '4473',
    '鹚': '8772',
    '箪': '8850',
    '缍': '2211',
    '锇': '8375',
    '蝮': '5814',
    '诟': '3276',
    '洄': '3610',
    '浍': '3813',
    '诨': '3775',
    '犍': '2554',
    '硷': '1861',
    '噤': '6409',
    '垲': '4211',
    '郐': '8772',
    '椤': '4692',
    '嫫': '4448',
    '伲': '9701',
    '脲': '7729',
    '殍': '1224',
    '噗': '6208',
    '溱': '3519',
    '箬': '8860',
    '厍': '7125',
    '钽': '8671',
    '钍': '8471',
    '恹': '9108',
    '鬻': '1722',
    '爰': '2040',
    '砦': '2260',
    '蓁': '4490',
    '胝': '7224',
    '颛': '2128',
    '褙': '3222',
    '鳊': '2312',
    '邴': '1722',
    '铖': '8375',
    '镫': '8271',
    '腚': '7328',
    '钭': '8470',
    '颚': '6128',
    '鲂': '2012',
    '悱': '9101',
    '狒': '4522',
    '佶': '2426',
    '偈': '2622',
    '堀': '4717',
    '绔': '2412',
    '醪': '1762',
    '坜': '4112',
    '疠': '0012',
    '椋': '4099',
    '犸': '4722',
    '暝': '6708',
    '佞': '2124',
    '哝': '6403',
    '瞟': '6109',
    '荨': '4434',
    '芩': '4420',
    '逡': '3330',
    '溽': '3114',
    '裟': '3973',
    '挲': '3950',
    '抟': '5503',
    '暾': '6804',
    '崦': '2471',
    '芫': '4421',
    '荑': '4480',
    '薏': '4433',
    '莸': '4421',
    '欤': '2718',
    '栀': '4291',
    '斫': '1262',
    '镞': '8878',
    '嗳': '6204',
    '鸨': '2742',
    '跸': '6214',
    '骠': '7119',
    '俦': '2524',
    '谠': '3971',
    '簟': '8840',
    '棼': '4422',
    '驸': '7410',
    '掼': '5708',
    '倨': '2726',
    '橛': '4198',
    '犒': '2052',
    '邋': '3230',
    '耧': '5994',
    '蝼': '5914',
    '虻': '5011',
    '铙': '8571',
    '郫': '2742',
    '汔': '3811',
    '诮': '3972',
    '楸': '4998',
    '阒': '3780',
    '绻': '2911',
    '叁': '2310',
    '臊': '7629',
    '钐': '8272',
    '腧': '7822',
    '闩': '3710',
    '菘': '4493',
    '阗': '3780',
    '忝': '1033',
    '橐': '5090',
    '翕': '8012',
    '阋': '3721',
    '踅': '5280',
    '窨': '3060',
    '鹬': '1722',
    '鼋': '1071',
    '樾': '4398',
    '錾': '4210',
    '吒': '6201',
    '旃': '0824',
    '弁': '2344',
    '侪': '2022',
    '坼': '4214',
    '蚩': '2213',
    '嘬': '6604',
    '糍': '9893',
    '骢': '7613',
    '氐': '7274',
    '呃': '6101',
    '榧': '4191',
    '玢': '1812',
    '绋': '2512',
    '蚨': '5518',
    '钆': '8271',
    '岣': '2772',
    '菰': '4443',
    '罟': '6060',
    '嘏': '4764',
    '埚': '4612',
    '绗': '2112',
    '嚯': '6101',
    '藿': '4421',
    '笄': '8844',
    '袈': '4673',
    '羯': '8652',
    '肼': '7520',
    '暌': '6208',
    '啷': '6702',
    '蒗': '4413',
    '蜊': '5210',
    '獠': '4429',
    '鬣': '7271',
    '熳': '9684',
    '黾': '6071',
    '乜': '4071',
    '镆': '8478',
    '怩': '9701',
    '驽': '4712',
    '旆': '0822',
    '髂': '7326',
    '仟': '2224',
    '芡': '4480',
    '谯': '3073',
    '恁': '2233',
    '鳃': '2613',
    '艄': '2942',
    '莳': '4464',
    '艏': '2846',
    '趿': '6714',
    '遢': '3630',
    '鲐': '2316',
    '醍': '1668',
    '僮': '2021',
    '氽': '8090',
    '刎': '2220',
    '芴': '4422',
    '喑': '6006',
    '墉': '4012',
    '昀': '6702',
    '箦': '8880',
    '鄣': '0742',
    '摺': '5706',
    '钲': '8171',
    '贽': '5580',
    '缵': '2418',
    '鏊': '5810',
    '锛': '8474',
    '瓿': '0161',
    '廛': '0021',
    '瘳': '0012',
    '亍': '1020',
    '遄': '3230',
    '褡': '3426',
    '垌': '4712',
    '椟': '4498',
    '酆': '2712',
    '砩': '1562',
    '桴': '4294',
    '赙': '7384',
    '坩': '4417',
    '臌': '7424',
    '曷': '6072',
    '跽': '6713',
    '湫': '3918',
    '榉': '4995',
    '黧': '2733',
    '猁': '4220',
    '钌': '8772',
    '镏': '8776',
    '缦': '2614',
    '殁': '1724',
    '赧': '4724',
    '埤': '4614',
    '悭': '9701',
    '缱': '2513',
    '衾': '8073',
    '鲭': '2512',
    '铩': '8479',
    '猞': '4826',
    '眚': '2560',
    '铈': '8072',
    '谥': '3871',
    '耜': '5797',
    '飕': '7721',
    '饕': '6173',
    '餮': '1873',
    '骰': '7724',
    '乇': '2071',
    '绾': '2317',
    '鹇': '3722',
    '鲞': '9010',
    '爻': '4040',
    '蜴': '5612',
    '镱': '8073',
    '铟': '8670',
    '莜': '4424',
    '祗': '3224',
    '濞': '3612',
    '镔': '8378',
    '逋': '3330',
    '谄': '3777',
    '谶': '3375',
    '酲': '1661',
    '茺': '4421',
    '樗': '4192',
    '憷': '9408',
    '莼': '4411',
    '撺': '5305',
    '柢': '4294',
    '阏': '3723',
    '砜': '1761',
    '垓': '4018',
    '旰': '6104',
    '妫': '4442',
    '衮': '0073',
    '嗥': '6604',
    '郏': '5782',
    '鞯': '4454',
    '徼': '2824',
    '孓': '1740',
    '钪': '8071',
    '侉': '2422',
    '夼': '4022',
    '跬': '6411',
    '铼': '8579',
    '嫘': '4649',
    '蟊': '1713',
    '茆': '4472',
    '睨': '6701',
    '怄': '9101',
    '蹁': '6312',
    '谝': '3372',
    '嘌': '6109',
    '綮': '3890',
    '嫱': '4446',
    '筇': '8812',
    '犰': '4421',
    '穰': '2093',
    '铷': '8670',
    '筲': '8822',
    '哂': '6106',
    '炻': '9186',
    '豕': '1023',
    '秫': '2399',
    '笥': '8862',
    '涑': '3519',
    '铊': '8371',
    '帏': '4021',
    '闱': '3752',
    '鋈': '3210',
    '舾': '2146',
    '屣': '7728',
    '狎': '4625',
    '哓': '6501',
    '噫': '6003',
    '璎': '1714',
    '铕': '8472',
    '宥': '3022',
    '阈': '3715',
    '豸': '2022',
    '辎': '4256',
    '趑': '4780',
    '龇': '2271',
    '捌': '5200',
    '秕': '2291',
    '荜': '4440',
    '愎': '9804',
    '窆': '3030',
    '镲': '8379',
    '谗': '3773',
    '踔': '6114',
    '苁': '4488',
    '酢': '1861',
    '呔': '6403',
    '聃': '1544',
    '镦': '8874',
    '屙': '7722',
    '鲱': '2111',
    '鬲': '1022',
    '膈': '7122',
    '铪': '8876',
    '醐': '1762',
    '獾': '4421',
    '鲩': '2311',
    '虺': '1521',
    '葭': '4424',
    '牮': '2350',
    '礓': '1161',
    '苴': '4410',
    '讵': '3171',
    '颏': '0188',
    '裉': '3723',
    '诳': '3171',
    '栌': '4190',
    '氇': '2771',
    '镙': '8679',
    '哞': '6305',
    '柰': '4090',
    '袢': '3925',
    '帔': '4424',
    '睥': '6604',
    '苤': '4410',
    '嫔': '4348',
    '笸': '8871',
    '氆': '2871',
    '佥': '8010',
    '箧': '8871',
    '跫': '1780',
    '蚋': '5412',
    '鲥': '2410',
    '扌': '5000',
    '狲': '4920',
    '桫': '4992',
    '溏': '3016',
    '铽': '8374',
    '殄': '1822',
    '脘': '7321',
    '洧': '3412',
    '肟': '7122',
    '绡': '2912',
    '咻': '6409',
    '洫': '3711',
    '癔': '0013',
    '洇': '3610',
    '嵛': '2222',
    '磔': '1569',
    '胗': '7822',
    '肫': '7521',
    '赀': '2280',
    '眦': '6201',
    '吖': '6802',
    '瑷': '1214',
    '埯': '4411',
    '畚': '2360',
    '妣': '4241',
    '飑': '7721',
    '豳': '2277',
    '髌': '7328',
    '砗': '1465',
    '铳': '8071',
    '楮': '4496',
    '蔟': '4428',
    '毳': '2071',
    '锝': '8674',
    '堞': '4419',
    '疔': '0012',
    '葑': '4414',
    '缶': '8077',
    '菔': '4424',
    '疳': '0017',
    '彀': '4724',
    '胍': '7223',
    '磙': '1063',
    '顸': '1148',
    '薅': '4444',
    '翮': '1722',
    '猢': '4722',
    '怙': '9406',
    '蒺': '4418',
    '廑': '0021',
    '妗': '4842',
    '髁': '7629',
    '醌': '1661',
    '粝': '9192',
    '魉': '2151',
    '旒': '0821',
    '蝥': '1813',
    '缗': '2716',
    '衲': '3422',
    '呸': '6101',
    '醅': '1066',
    '芘': '4471',
    '蚍': '5211',
    '圮': '4711',
    '榀': '4696',
    '萁': '4480',
    '苘': '4422',
    '逑': '3330',
    '诎': '3277',
    '劬': '2462',
    '蕖': '4490',
    '朊': '7121',
    '剡': '9280',
    '蟮': '5816',
    '椹': '4491',
    '饣': '2770',
    '酞': '1463',
    '帑': '4722',
    '葶': '4420',
    '菟': '4441',
    '魍': '2751',
    '庑': '0021',
    '葸': '4433',
    '氙': '8071',
    '谖': '3274',
    '鞅': '4558',
    '狺': '4026',
    '夤': '2780',
    '嬴': '0021',
    '瘿': '0014',
    '饔': '0073',
    '雩': '1002',
    '鹆': '8762',
    '橼': '4793',
    '赜': '7578',
    '潴': '3416',
    '骓': '7011',
    '缁': '2216',
    '诹': '3774',
    '怍': '9801',
    '杓': '4792',
    '艹': '4400',
    '檫': '4399',
    '媸': '4243',
    '氚': '8021',
    '呲': '6201',
    '殂': '1721',
    '矬': '8881',
    '笪': '8810',
    '迨': '3330',
    '纛': '5099',
    '簦': '8810',
    '玎': '1112',
    '苊': '4421',
    '轭': '4151',
    '匚': '7171',
    '鼢': '7872',
    '呒': '6101',
    '缑': '2718',
    '诖': '3471',
    '炅': '6080',
    '鲧': '2219',
    '唿': '6703',
    '戽': '3024',
    '鬟': '7273',
    '恚': '4033',
    '袷': '3826',
    '瘕': '0014',
    '枧': '4791',
    '洚': '3715',
    '桕': '4797',
    '雎': '7011',
    '蠲': '8612',
    '剀': '2270',
    '诓': '3171',
    '瘌': '0012',
    '镧': '8772',
    '铑': '8471',
    '鳓': '2412',
    '蓠': '4422',
    '呖': '6102',
    '跞': '6219',
    '裢': '3423',
    '裣': '3821',
    '埒': '4214',
    '捩': '5308',
    '鲮': '2414',
    '熘': '9786',
    '嵝': '2974',
    '瘰': '0019',
    '镘': '8674',
    '脒': '7929',
    '腩': '7422',
    '筢': '8851',
    '耪': '5092',
    '辔': '2260',
    '牝': '2251',
    '嘁': '6305',
    '蛴': '5012',
    '戗': '8375',
    '蛩': '1713',
    '巯': '1011',
    '悫': '4033',
    '葚': '4471',
    '熵': '9082',
    '绱': '2912',
    '蛸': '5912',
    '螫': '4813',
    '毹': '8221',
    '妁': '4742',
    '纟': '2010',
    '嗾': '6808',
    '鳎': '2612',
    '绨': '2812',
    '粜': '2290',
    '菀': '4421',
    '沩': '3412',
    '鼯': '7176',
    '牾': '2156',
    '螅': '5613',
    '顼': '1118',
    '泶': '9090',
    '蕈': '4440',
    '鼹': '7674',
    '繇': '2279',
    '苡': '4478',
    '悒': '9601',
    '廴': '1040',
    '吲': '6200',
    '喁': '6602',
    '卣': '2160',
    '牖': '2302',
    '笮': '8821',
    '舴': '2841',
    '罾': '6060',
    '棹': '4194',
    '鸷': '5512',
    '碡': '1565',
    '锕': '8172',
    '嗌': '6801',
    '媪': '4641',
    '龅': '2771',
    '甏': '4271',
    '箅': '8822',
    '傧': '2328',
    '啵': '6404',
    '鹁': '4742',
    '晡': '6302',
    '氅': '9871',
    '魑': '2051',
    '篪': '8821',
    '怛': '9601',
    '籴': '8090',
    '礅': '1864',
    '蒽': '4433',
    '珥': '1114',
    '钫': '8072',
    '绠': '2114',
    '觚': '2223',
    '鸹': '2762',
    '涫': '3317',
    '颃': '0128',
    '篌': '8828',
    '锪': '8773',
    '蠖': '5414',
    '乩': '2261',
    '咭': '6406',
    '赍': '4080',
    '嵴': '2272',
    '铗': '8578',
    '湔': '3812',
    '槿': '4491',
    '赆': '7783',
    '僦': '2321',
    '皲': '3454',
    '佧': '2123',
    '箜': '8810',
    '蒉': '4480',
    '缧': '2619',
    '酹': '1264',
    '嘞': '6402',
    '疬': '0012',
    '臁': '7023',
    '膦': '7925',
    '泷': '3311',
    '蒌': '4440',
    '泺': '3219',
    '荬': '4480',
    '颟': '4128',
    '旄': '0821',
    '泖': '3712',
    '镅': '8776',
    '蠓': '5413',
    '冖': '3700',
    '幂': '3722',
    '耱': '5096',
    '襻': '3425',
    '鼙': '4440',
    '攵': '8040',
    '炝': '9881',
    '愀': '9908',
    '蘧': '4430',
    '氍': '6221',
    '犭': '4020',
    '禳': '3023',
    '桡': '4591',
    '糁': '9392',
    '馓': '2874',
    '酾': '1162',
    '槊': '8790',
    '狻': '4324',
    '锬': '8978',
    '羰': '8258',
    '鼗': '3214',
    '鹈': '8722',
    '畋': '6804',
    '髫': '7260',
    '萜': '4426',
    '堍': '4711',
    '璺': '7710',
    '怃': '9101',
    '崤': '2472',
    '囟': '2600',
    '睚': '6101',
    '痖': '0011',
    '菸': '4423',
    '餍': '7123',
    '徭': '2227',
    '瘗': '0011',
    '唷': '6002',
    '圉': '6040',
    '蜮': '5315',
    '砟': '1861',
    '谵': '3776',
    '澶': '3011',
    '朕': '7828',
    '摭': '5003',
    '轵': '4658',
    '诼': '3173',
    '笫': '8822',
    '廒': '0024',
    '聱': '5840',
    '庳': '0024',
    '髀': '7624',
    '笾': '8830',
    '龀': '2471',
    '裎': '3621',
    '雠': '2021',
    '蝽': '5516',
    '腠': '7528',
    '妲': '4641',
    '刂': '2200',
    '铥': '8273',
    '黩': '6438',
    '怼': '7433',
    '沲': '3811',
    '蘩': '4490',
    '趺': '6518',
    '苻': '4424',
    '拊': '5400',
    '阝': '7722',
    '鲋': '2410',
    '戆': '0733',
    '纥': '2811',
    '哏': '6703',
    '鲠': '2114',
    '笱': '8862',
    '瞽': '4460',
    '庋': '0024',
    '簋': '8810',
    '刿': '2220',
    '掴': '5600',
    '猓': '4629',
    '蚵': '5112',
    '槲': '4490',
    '觳': '4724',
    '萑': '4421',
    '癀': '0018',
    '蟪': '5513',
    '钬': '8978',
    '虮': '5711',
    '掎': '5402',
    '鲣': '2711',
    '囝': '6040',
    '裥': '3722',
    '踺': '6514',
    '茳': '4411',
    '糨': '9693',
    '鹪': '2732',
    '狷': '4622',
    '麇': '0029',
    '芤': '4441',
    '刳': '4220',
    '愦': '9508',
    '髡': '7221',
    '悃': '9600',
    '缡': '2012',
    '鲡': '2112',
    '鳢': '2511',
    '奁': '4071',
    '墚': '4319',
    '尥': '4701',
    '柃': '4893',
    '胪': '7120',
    '镥': '8776',
    '脔': '0022',
    '杩': '4792',
    '劢': '1422',
    '墁': '4614',
    '玟': '1014',
    '蝻': '5412',
    '呶': '6704',
    '搦': '5702',
    '湓': '3811',
    '罴': '6033',
    '蜱': '5614',
    '俜': '2522',
    '鲆': '2114',
    '皤': '2266',
    '镨': '8876',
    '槭': '4395',
    '镪': '8673',
    '黢': '6334',
    '洳': '3610',
    '枘': '4492',
    '芟': '4440',
    '埏': '4214',
    '渖': '3315',
    '筮': '8810',
    '殳': '7740',
    '飧': '2823',
    '溻': '3612',
    '饧': '2772',
    '樘': '4991',
    '醣': '1066',
    '酡': '1361',
    '圬': '4112',
    '粞': '9196',
    '觋': '1711',
    '莶': '4410',
    '霰': '1024',
    '榍': '4792',
    '薤': '4421',
    '髹': '7229',
    '曛': '6203',
    '疋': '1780',
    '迓': '3130',
    '衤': '3020',
    '欹': '4768',
    '佾': '2822',
    '埸': '4612',
    '霪': '1011',
    '茚': '4472',
    '鼬': '7576',
    '伛': '2121',
    '瘵': '0019',
    '骣': '7714',
    '畛': '6802',
    '卮': '7221',
    '轾': '4151',
    '彘': '2771',
    '觯': '2825',
    '锺': '8211',
    '邾': '2792',
    '槠': '4496',
    '谘': '3776',
    '嵫': '2873',
    '髭': '7211',
    '蕞': '4444',
    '犴': '4124',
    '鞴': '4452',
    '畀': '6022',
    '滗': '3811',
    '煸': '9382',
    '褊': '3322',
    '冫': '3010',
    '孛': '4040',
    '羼': '7725',
    '耖': '5992',
    '褫': '3221',
    '彳': '2020',
    '艟': '2041',
    '辶': '3030',
    '茈': '4411',
    '璁': '1613',
    '爨': '7780',
    '榱': '4093',
    '萏': '4477',
    '坫': '4116',
    '鸫': '4792',
    '篼': '8821',
    '簖': '8872',
    '裰': '3724',
    '哚': '6709',
    '蹯': '6216',
    '瀵': '3918',
    '怫': '9502',
    '陔': '7028',
    '筻': '8850',
    '廾': '4400',
    '蛄': '5416',
    '绲': '2611',
    '崞': '2074',
    '蜾': '5619',
    '盍': '4010',
    '荭': '4411',
    '黉': '9080',
    '糇': '9798',
    '骺': '7226',
    '後': '2224',
    '鲎': '9010',
    '煳': '9782',
    '鹕': '4762',
    '冱': '3111',
    '瓠': '4223',
    '逭': '3330',
    '漶': '3513',
    '耠': '5896',
    '镬': '8474',
    '齑': '0022',
    '殛': '1721',
    '鲚': '2012',
    '跏': '6610',
    '蛱': '5518',
    '搛': '5803',
    '缣': '2813',
    '鹣': '8722',
    '僬': '2023',
    '噍': '6003',
    '衿': '3822',
    '缂': '2415',
    '喾': '9060',
    '狯': '4823',
    '纩': '2010',
    '栝': '4296',
    '蛞': '5216',
    '稂': '2393',
    '塄': '4612',
    '嫠': '5824',
    '詈': '6060',
    '蠊': '5013',
    '鹩': '4792',
    '躐': '6211',
    '鹨': '1722',
    '簏': '8821',
    '膂': '0822',
    '脶': '7622',
    '嬷': '4043',
    '昴': '6072',
    '瞀': '1860',
    '浼': '3711',
    '艨': '2443',
    '祢': '3729',
    '縻': '0029',
    '蘼': '4421',
    '芈': '1150',
    '糸': '2290',
    '宀': '3037',
    '眄': '6102',
    '鹋': '4762',
    '杪': '4992',
    '咩': '6805',
    '愍': '7833',
    '麽': '0023',
    '瘼': '0018',
    '鍪': '1810',
    '硇': '1660',
    '猱': '4729',
    '茑': '4412',
    '脬': '7224',
    '蟛': '5212',
    '貔': '2621',
    '仳': '2221',
    '犏': '2352',
    '钋': '8370',
    '芑': '4471',
    '葜': '4480',
    '愆': '2133',
    '锓': '8774',
    '蠼': '5611',
    '筌': '8810',
    '鬈': '7271',
    '蚺': '5514',
    '荛': '4421',
    '埽': '4712',
    '潲': '3912',
    '诜': '3471',
    '埘': '4410',
    '弑': '4394',
    '嗍': '6702',
    '蒴': '4442',
    '鸶': '2212',
    '缌': '2613',
    '澌': '3212',
    '姒': '4840',
    '蔌': '4498',
    '睃': '6304',
    '缇': '2618',
    '梃': '4294',
    '彖': '2723',
    '鼍': '6671',
    '芄': '4451',
    '隈': '7623',
    '鲔': '2412',
    '硪': '1365',
    '忤': '9804',
    '痦': '0016',
    '欷': '4728',
    '僖': '2426',
    '醯': '1061',
    '鼷': '7278',
    '跣': '6411',
    '枵': '4692',
    '忄': '9000',
    '擤': '5602',
    '勖': '6462',
    '痃': '0013',
    '碹': '1361',
    '谳': '3378',
    '轺': '4756',
    '铘': '8772',
    '圯': '4711',
    '纡': '2114',
    '窬': '3022',
    '窳': '3023',
    '饫': '2278',
    '蓣': '4428',
    '瀹': '3812',
    '趱': '4480',
    '驵': '7711',
    '缯': '2816',
    '揸': '5401',
    '笊': '8823',
    '絷': '5590',
    '跖': '6116',
    '舯': '2540',
    '螽': '2713',
    '籀': '8856',
    '舳': '2546',
    '粢': '3790',
    '驺': '7717',
    '陬': '7724',
    '阼': '7821',
    '揞': '5006',
    '菝': '4454',
    '魃': '2351',
    '癍': '0011',
    '鹎': '2742',
    '坌': '8010',
    '狴': '4221',
    '萆': '4440',
    '嬖': '7040',
    '襞': '7073',
    '碥': '1362',
    '髟': '7272',
    '鳔': '2119',
    '醭': '1268',
    '螬': '5516',
    '馇': '2471',
    '虿': '1013',
    '瘥': '0011',
    '惝': '9902',
    '怊': '9706',
    '鸱': '7772',
    '螭': '5012',
    '瘛': '0013',
    '帱': '4524',
    '徂': '2721',
    '汆': '8090',
    '脞': '7821',
    '瘅': '0015',
    '忉': '9702',
    '羝': '8254',
    '睇': '6802',
    '瓞': '7523',
    '鲽': '2419',
    '岽': '2290',
    '胨': '7429',
    '芏': '4410',
    '佴': '2124',
    '燔': '9286',
    '偾': '2428',
    '稃': '2294',
    '郛': '2742',
    '莩': '4440',
    '幞': '4228',
    '澉': '3814',
    '槔': '4694',
    '袼': '3726',
    '搿': '2255',
    '茛': '4473',
    '鞲': '4554',
    '觏': '5741',
    '酤': '1466',
    '牿': '2456',
    '鲴': '2610',
    '宄': '3041',
    '匦': '7171',
    '呙': '6022',
    '馘': '8365',
    '焓': '9886',
    '瘊': '0018',
    '虍': '2120',
    '岵': '2476',
    '鹱': '2414',
    '咴': '6408',
    '隳': '7433',
    '缋': '2518',
    '溷': '3610',
    '夥': '6792',
    '剞': '4260',
    '洎': '3610',
    '恝': '5733',
    '蒹': '4423',
    '谫': '3872',
    '僭': '2126',
    '艽': '4441',
    '挢': '5202',
    '敫': '2824',
    '卺': '1771',
    '冂': '7722',
    '扃': '3022',
    '锔': '8772',
    '窭': '3040',
    '锩': '8971',
    '觖': '2528',
    '劂': '7220',
    '氪': '8021',
    '骒': '7619',
    '哙': '6803',
    '悝': '9601',
    '蝰': '5411',
    '诔': '3579',
    '苈': '4422',
    '篥': '8890',
    '娈': '0040',
    '瞵': '6905',
    '锍': '8776',
    '栊': '4391',
    '癃': '0011',
    '舻': '2140',
    '辂': '4756',
    '稆': '2696',
    '猡': '4622',
    '蛑': '5315',
    '甍': '4471',
    '艋': '2741',
    '敉': '9894',
    '眇': '6902',
    '蠛': '5415',
    '侔': '2325',
    '镎': '8875',
    '肭': '7422',
    '艿': '4422',
    '蛲': '5511',
    '疒': '0010',
    '陧': '7621',
    '衄': '2711',
    '锘': '8476',
    '堋': '4712',
    '庀': '0021',
    '擗': '5004',
    '甓': '7071',
    '螵': '5119',
    '钷': '8171',
    '攴': '2140',
    '桤': '4291',
    '褰': '3073',
    '凵': '2277',
    '肷': '7728',
    '锖': '8572',
    '鞒': '4252',
    '吣': '6300',
    '黥': '6039',
    '俅': '2329',
    '蝤': '5816',
    '璩': '1113',
    '悛': '9304',
    '辁': '4851',
    '肜': '7222',
    '颡': '7198',
    '谂': '3873',
    '礻': '3020',
    '摅': '5103',
    '汜': '3711',
    '溲': '3714',
    '嗉': '6409',
    '荽': '4440',
    '闼': '3730',
    '骀': '7316',
    '炱': '2380',
    '螗': '5016',
    '耥': '5992',
    '裼': '3622',
    '铫': '8271',
    '莛': '4440',
    '亠': '0000',
    '箨': '8855',
    '蕹': '4421',
    '迕': '3830',
    '杌': '4191',
    '寤': '3026',
    '穸': '3020',
    '饩': '2871',
    '舄': '7732',
    '禊': '3728',
    '猃': '4821',
    '绁': '2411',
    '渫': '3419',
    '廨': '0025',
    '獬': '4725',
    '硎': '1260',
    '荇': '4422',
    '鸺': '2722',
    '貅': '2429',
    '糈': '9792',
    '揎': '5301',
    '镟': '8878',
    '獯': '4223',
    '讠': '3070',
    '厣': '7125',
    '罨': '6071',
    '蛘': '5815',
    '鳐': '2217',
    '崾': '2174',
    '舣': '2440',
    '媵': '7924',
    '尢': '4001',
    '蚰': '5516',
    '侑': '2422',
    '狳': '4829',
    '螈': '5119',
    '龠': '8022',
    '昃': '6028',
    '痄': '0011',
    '搌': '5703',
    '浈': '3118',
    '埴': '4411',
    '夂': '2740',
    '黹': '3222',
    '酎': '1460',
    '橥': '4490',
    '丶': '3000',
    '缒': '2713',
    '窀': '3071',
    '菹': '4411',
    '锿': '8073',
    '砹': '1464',
    '茇': '4440',
    '勹': '2702',
    '邶': '1712',
    '鐾': '7010',
    '舭': '2241',
    '忭': '9003',
    '缏': '2114',
    '灬': '3300',
    '瘭': '0019',
    '踣': '6016',
    '钸': '8472',
    '礤': '1469',
    '骖': '7312',
    '黪': '6332',
    '艚': '2546',
    '锸': '8277',
    '猹': '4421',
    '镡': '8174',
    '躔': '6011',
    '蒇': '4425',
    '冁': '8753',
    '鬯': '2271',
    '屮': '2240',
    '枨': '4293',
    '眵': '6702',
    '傺': '2729',
    '搋': '5201',
    '巛': '2222',
    '舡': '2141',
    '楱': '4598',
    '镩': '8375',
    '鹾': '2861',
    '戥': '6315',
    '觌': '4781',
    '阽': '7126',
    '铞': '8672',
    '垤': '4111',
    '揲': '5409',
    '蹀': '6419',
    '耵': '1142',
    '髑': '7622',
    '憝': '0833',
    '鸸': '1722',
    '鲕': '2112',
    '篚': '8871',
    '镄': '8578',
    '鲼': '2418',
    '唪': '6505',
    '祓': '3324',
    '艴': '5701',
    '黻': '3324',
    '黼': '3322',
    '鳆': '2814',
    '尜': '9090',
    '戤': '1315',
    '塥': '4112',
    '哿': '4662',
    '虼': '5811',
    '遘': '3530',
    '桄': '4991',
    '丨': '2000',
    '胲': '7028',
    '醢': '1461',
    '撖': '5804',
    '嚆': '6402',
    '薨': '4421',
    '堠': '4718',
    '烀': '9284',
    '轷': '4254',
    '锾': '8274',
    '缳': '2613',
    '擐': '5603',
    '哕': '6202',
    '阍': '3760',
    '劐': '4240',
    '攉': '5101',
    '丌': '1022',
    '墼': '5710',
    '蕺': '4445',
    '彐': '1717',
    '芰': '4440',
    '哜': '6002',
    '戋': '5300',
    '趼': '6114',
    '楗': '4594',
    '耩': '5594',
    '喈': '6206',
    '卩': '7722',
    '鲒': '2416',
    '骱': '7822',
    '刭': '1210',
    '弪': '1721',
    '獍': '4021',
    '鬏': '7298',
    '鞫': '4752',
    '犋': '2758',
    '屦': '7724',
    '醵': '1163',
    '桊': '9090',
    '爝': '9284',
    '捃': '5706',
    '胩': '7123',
    '锎': '8772',
    '蒈': '4460',
    '莰': '4418',
    '闶': '7171',
    '钶': '8172',
    '锞': '8679',
    '眍': '6101',
    '筘': '8856',
    '阃': '3760',
    '漤': '3414',
    '铹': '8472',
    '栳': '4491',
    '耢': '5492',
    '仂': '2422',
    '泐': '3412',
    '檑': '4196',
    '轹': '4259',
    '蔹': '4414',
    '懔': '9009',
    '垆': '4110',
    '锊': '8274',
    '倮': '2629',
    '蠃': '0021',
    '鞔': '4751',
    '硭': '1461',
    '漭': '3414',
    '猸': '4726',
    '鹛': '7722',
    '钔': '8772',
    '瞢': '4460',
    '礞': '1463',
    '喵': '6406',
    '苠': '4474',
    '鳘': '8810',
    '貊': '2126',
    '貘': '2428',
    '毪': '2371',
    '坶': '4715',
    '攮': '5503',
    '猊': '4721',
    '嬲': '6642',
    '肀': '5000',
    '聍': '1342',
    '甯': '3022',
    '狃': '4721',
    '耨': '5194',
    '孥': '4740',
    '胬': '4722',
    '恧': '1033',
    '蒎': '4413',
    '锫': '8076',
    '陴': '7624',
    '氕': '8021',
    '丿': '2000',
    '裒': '0073',
    '镤': '8278',
    '蜞': '5418',
    '岍': '2174',
    '搴': '3050',
    '箝': '8857',
    '慊': '9803',
    '椠': '4290',
    '蜣': '5811',
    '硗': '1561',
    '劁': '2230',
    '缲': '2619',
    '檎': '4892',
    '螓': '5519',
    '圊': '6022',
    '檠': '4890',
    '謦': '4760',
    '銎': '1710',
    '赇': '7389',
    '鼽': '2421',
    '糗': '9698',
    '麴': '5742',
    '鸲': '2762',
    '磲': '1169',
    '畎': '6308',
    '狨': '4325',
    '蝾': '5419',
    '薷': '4422',
    '襦': '3122',
    '颥': '1128',
    '蓐': '4424',
    '脎': '7429',
    '毵': '2221',
    '磉': '1769',
    '鳋': '2713',
    '唼': '6004',
    '歃': '2778',
    '彡': '2020',
    '骟': '7312',
    '滠': '3114',
    '矧': '8280',
    '胂': '7520',
    '蓍': '4460',
    '鲺': '2711',
    '贳': '4480',
    '搠': '5702',
    '厶': '2073',
    '兕': '7721',
    '锼': '8774',
    '螋': '5714',
    '瞍': '6704',
    '觫': '2529',
    '赕': '7988',
    '铴': '8772',
    '瑭': '1016',
    '慝': '7133',
    '掭': '5103',
    '祧': '3221',
    '龆': '2776',
    '蜩': '5712',
    '鲦': '2719',
    '茼': '4422',
    '酴': '1869',
    '煺': '9783',
    '柝': '4294',
    '腽': '7621',
    '軎': '5060',
    '阌': '3740',
    '阢': '7121',
    '诶': '3378',
    '菥': '4492',
    '蓰': '4428',
    '柙': '4695',
    '祆': '3128',
    '筅': '8821',
    '葙': '4496',
    '蟓': '5713',
    '魈': '2951',
    '躞': '6914',
    '砉': '5060',
    '醑': '1762',
    '儇': '2623',
    '岈': '2174',
    '砑': '1164',
    '珧': '1211',
    '酏': '1461',
    '劓': '2220',
    '堙': '4111',
    '撄': '5704',
    '潆': '3419',
    '舁': '7744',
    '蝓': '5812',
    '燠': '9788',
    '眢': '2760',
    '箢': '8821',
    '掾': '5703',
    '刖': '7220',
    '狁': '4321',
    '拶': '5202',
    '唣': '6601',
    '迮': '3830',
    '帻': '4528',
    '谮': '3176',
    '哳': '6202',
    '齄': '2421',
    '膪': '7026',
    '嫜': '4044',
    '忮': '9404',
    '骘': '7112',
    '膣': '7321',
    '踬': '6218',
    '荮': '4414',
    '瘃': '0013',
    '麈': '0021',
    '疰': '0011',
    '丬': '3210',
    '浞': '3618',
    '禚': '3823',
    '觜': '2222',
    '耔': '5794',
    '腙': '7329',
    '鄹': '1722',
    '鲰': '2714',
    '躜': '6418',
    '撙': '5804',
    '胙': '7821',
    '乂': '4000',
    '夬': '5080',
    '匜': '7171',
    '伋': '2724',
    '甪': '2722',
    '沘': '3211',
    '伾': '2121',
    '抃': '5003',
    '抔': '5109',
    '扺': '5204',
    '毐': '4055',
    '沄': '3113',
    '沚': '3111',
    '汭': '3412',
    '玕': '1114',
    '泜': '3214',
    '玥': '1712',
    '昉': '6002',
    '旻': '6040',
    '杻': '4791',
    '泃': '3712',
    '狉': '4121',
    '玡': '1114',
    '玦': '1518',
    '玠': '1812',
    '矻': '1861',
    '芼': '4471',
    '疢': '0018',
    '垞': '4311',
    '垟': '4815',
    '姞': '4446',
    '姽': '4741',
    '帡': '4824',
    '庤': '0024',
    '弇': '8044',
    '柈': '4995',
    '洨': '3014',
    '洴': '3814',
    '泚': '3211',
    '洺': '3716',
    '洑': '3318',
    '炟': '9681',
    '牁': '2122',
    '眊': '6201',
    '竑': '0413',
    '羑': '8080',
    '茀': '4452',
    '訄': '4001',
    '邽': '4712',
    '郈': '7722',
    '堉': '4012',
    '浥': '3611',
    '倞': '2029',
    '倓': '2928',
    '俵': '2523',
    '俶': '2724',
    '剟': '7240',
    '剕': '1210',
    '勍': '0492',
    '宬': '3025',
    '彧': '5310',
    '悢': '9303',
    '栟': '4894',
    '栒': '4792',
    '浡': '3414',
    '涘': '3318',
    '烜': '9181',
    '烝': '1733',
    '牂': '2825',
    '珣': '1712',
    '盉': '2010',
    '砮': '4760',
    '窅': '3060',
    '郚': '1762',
    '郤': '8762',
    '惇': '9004',
    '晞': '6402',
    '偲': '2623',
    '埼': '4412',
    '堌': '4610',
    '婞': '4444',
    '崟': '2210',
    '捯': '5200',
    '晢': '5260',
    '欸': '2788',
    '淏': '3618',
    '烺': '9383',
    '焌': '9384',
    '珽': '1214',
    '琇': '1212',
    '朘': '7324',
    '莙': '4460',
    '袪': '3423',
    '袗': '3822',
    '棻': '4490',
    '湲': '3214',
    '焜': '9681',
    '琯': '1317',
    '喤': '6601',
    '塈': '7110',
    '嵎': '2672',
    '愔': '9006',
    '扊': '3028',
    '揳': '5708',
    '斝': '6640',
    '棬': '4991',
    '椑': '4694',
    '棨': '3890',
    '湉': '3216',
    '湝': '3216',
    '湨': '3618',
    '湜': '3618',
    '牚': '9024',
    '琫': '1515',
    '琤': '1715',
    '瓻': '4121',
    '畯': '6304',
    '祲': '3724',
    '腒': '7726',
    '菼': '4480',
    '菂': '4462',
    '郿': '7722',
    '靰': '4151',
    '僇': '2722',
    '亶': '0010',
    '廋': '0024',
    '搒': '5002',
    '楯': '4296',
    '溠': '3811',
    '滍': '3213',
    '溦': '3814',
    '滃': '3812',
    '滘': '3716',
    '瑄': '1311',
    '瑀': '1212',
    '祼': '3629',
    '窣': '3040',
    '葖': '4480',
    '萩': '4498',
    '蜎': '5612',
    '跐': '6211',
    '靸': '4754',
    '鄘': '0722',
    '僰': '5580',
    '墈': '4412',
    '嫪': '4742',
    '嫚': '4644',
    '廙': '0028',
    '慥': '9403',
    '摽': '5109',
    '榖': '4794',
    '滫': '3712',
    '瑢': '1316',
    '蒟': '4412',
    '蓂': '4480',
    '蓇': '4422',
    '豨': '1422',
    '靽': '4955',
    '靺': '4559',
    '鞁': '4454',
    '靿': '4452',
    '墦': '4216',
    '奭': '4080',
    '潟': '3712',
    '噀': '6708',
    '嶓': '2276',
    '殣': '1421',
    '潏': '3712',
    '潽': '3816',
    '熥': '9783',
    '熜': '9683',
    '璆': '1712',
    '璈': '1814',
    '膙': '7623',
    '鋆': '4710',
    '魆': '2351',
    '澴': '3613',
    '璘': '1915',
    '璟': '1619',
    '曈': '6001',
    '橦': '4091',
    '澼': '3014',
    '澥': '3715',
    '燊': '9090',
    '燏': '9782',
    '璠': '1216',
    '盦': '8010',
    '禤': '3622',
    '穄': '2799',
    '窸': '3033',
    '翯': '1722',
    '螣': '7923',
    '觱': '5322',
    '蹅': '6411',
    '踶': '6618',
    '鼒': '4022',
    '瞭': '6409',
    '嚄': '6404',
    '幪': '4423',
    '璪': '1619',
    '簉': '8830',
    '簃': '8892',
    '繄': '7790',
    '罽': '6022',
    '蹓': '6716',
    '蹐': '6212',
    '鞡': '4051',
    '嚚': '6666',
    '瀌': '3013',
    '瀍': '3011',
    '礌': '1166',
    '簠': '8810',
    '臑': '7122',
    '蹜': '6316',
    '蹢': '6012',
    '鞨': '4652',
    '鼫': '7176',
    '鼩': '7772',
    '蠋': '5612',
    '齁': '2722',
    '巉': '2771',
    '犨': '2050',
    '耰': '5194',
    '蘘': '4473',
    '鼱': '7572',
    '瓘': '1411',
    '醾': '1069',
    '齉': '2523',
    '亸': '0845',
    '倻': '2722',
    '剅': '1210',
    '勚': '4482',
    '厾': '1771',
    '唝': '6108',
    '啰': '6602',
    '啴': '6805',
    '嗞': '6803',
    '嘚': '6604',
    '嘡': '6901',
    '垍': '4610',
    '垯': '4413',
    '垱': '4917',
    '塃': '4411',
    '塆': '4012',
    '塮': '4410',
    '婳': '4147',
    '屃': '7728',
    '峂': '2773',
    '峣': '2571',
    '峧': '2074',
    '嵖': '2471',
    '嵚': '2278',
    '庼': '0028',
    '慭': '5333',
    '扅': '3022',
    '拃': '5801',
    '拤': '5103',
    '挦': '5704',
    '揾': '5601',
    '旸': '6702',
    '昽': '6301',
    '暅': '6101',
    '杧': '4091',
    '梽': '4493',
    '梾': '4599',
    '棁': '4891',
    '槚': '4198',
    '槜': '4092',
    '檵': '4291',
    '汈': '3712',
    '沨': '3711',
    '洣': '3919',
    '浉': '3112',
    '浐': '3010',
    '浕': '3713',
    '涢': '3618',
    '溇': '3914',
    '滪': '3118',
    '潵': '3814',
    '狝': '4729',
    '猄': '4029',
    '獴': '4423',
    '玙': '1112',
    '玚': '1712',
    '珰': '1917',
    '琎': '1513',
    '疍': '1710',
    '疭': '0018',
    '瘆': '0012',
    '眬': '6301',
    '硁': '1761',
    '硚': '1262',
    '碶': '1768',
    '礳': '1066',
    '祃': '3722',
    '祎': '3522',
    '祾': '3424',
    '秾': '2493',
    '筜': '8817',
    '筼': '8880',
    '箓': '8890',
    '糵': '4490',
    '纴': '2211',
    '纻': '2311',
    '绤': '2816',
    '绹': '2712',
    '翙': '2722',
    '翚': '1750',
    '耲': '5093',
    '臜': '7428',
    '茓': '4480',
    '茝': '4471',
    '荙': '4430',
    '葓': '4418',
    '蕰': '4411',
    '藠': '4466',
    '螠': '5811',
    '袆': '3522',
    '袯': '3324',
    '裈': '3725',
    '襕': '3722',
    '诐': '3474',
    '赑': '7788',
    '赟': '0380',
    '赪': '4128',
    '跶': '6413',
    '蹽': '6419',
    '蹾': '6814',
    '轪': '4458',
    '辀': '4754',
    '辌': '4059',
    '辒': '4651',
    '鄌': '0722',
    '酦': '1364',
    '钘': '8174',
    '铚': '8171',
    '铻': '8176',
    '锜': '8472',
    '锧': '8278',
    '锽': '8671',
    '镃': '8873',
    '镈': '8374',
    '镋': '8971',
    '镚': '8272',
    '镠': '8772',
    '镴': '8271',
    '镵': '8771',
    '闿': '3771',
    '阇': '3760',
    '阘': '3712',
    '鞧': '4856',
    '韂': '4756',
    '韨': '5304',
    '颋': '1148',
    '颙': '6128',
    '飐': '7121',
    '飔': '7621',
    '飗': '7721',
    '饳': '2277',
    '饸': '2876',
    '饹': '2776',
    '饻': '2073',
    '馃': '2679',
    '馉': '2772',
    '馌': '2471',
    '骍': '7014',
    '骎': '7714',
    '骙': '7218',
    '鬶': '5722',
    '鱽': '2712',
    '鱾': '2711',
    '鲀': '2511',
    '鲃': '2711',
    '鲉': '2516',
    '鲊': '2811',
    '鲌': '2610',
    '鲏': '2414',
    '鲙': '2813',
    '鲪': '2716',
    '鲬': '2712',
    '鲯': '2418',
    '鲹': '2312',
    '鲾': '2116',
    '鳀': '2618',
    '鳁': '2611',
    '鳂': '2613',
    '鳈': '2619',
    '鳉': '2714',
    '鳑': '2012',
    '鳚': '2410',
    '鳡': '2313',
    '鳤': '2817',
    '鸤': '7722',
    '鸮': '6722',
    '鸰': '8732',
    '鸻': '2722',
    '鸼': '2742',
    '鹀': '1712',
    '鹐': '2772',
    '鹝': '1722',
    '鹟': '8712',
    '鹠': '7762',
    '鹡': '3722',
    '鹮': '6772',
    '鹲': '4722',
    '黇': '4186',
    '龁': '2871',
    '珮': '1711',
    '镕': '8376',
    '喆': '4466',
    '堃': '0010',
    '峇': '2260',
    '朥': '7922',
    '梿': '4493',
    '○': '0000',
    '槃': '2790',
    '卍': '1221'
}

StructureDict = {
'丨':'0',
'亅':'0',
'乀':'0',
'乁':'0',
'丿':'0',
'一':'0',
'乙':'0',
'乛':'0',
'乚':'0',
'丶':'0',
'丩':'0',
'乃':'0',
'乄':'0',
'九':'0',
'了':'0',
'丁':'0',
'七':'0',
'乜':'0',
'丷':'0',
'八':'0',
'勹':'0',
'匕':'0',
'冫':'0',
'卜':'0',
'厂':'0',
'刀':'0',
'刁':'0',
'刂':'0',
'儿':'0',
'二':'0',
'匚':'0',
'阝':'0',
'几':'0',
'卩':'0',
'冂':'0',
'力':'0',
'冖':'0',
'凵':'0',
'人':'0',
'亻':'0',
'入':'0',
'十':'0',
'厶':'0',
'匸':'0',
'讠':'0',
'廴':'0',
'又':'0',
'丬':'0',
'丫':'0',
'久':'0',
'么':'0',
'丸':'0',
'万':'0',
'三':'0',
'上':'0',
'下':'0',
'与':'0',
'丈':'0',
'乞':'0',
'习':'0',
'乡':'0',
'也':'0',
'之':'0',
'义':'0',
'勺':'0',
'刃':'0',
'亏':'0',
'于':'0',
'凡':'0',
'卫':'0',
'个':'0',
'亡':'0',
'叉':'0',
'及':'0',
'彳':'0',
'川':'0',
'辶':'0',
'寸':'0',
'大':'0',
'飞':'0',
'干':'0',
'工':'0',
'弓':'0',
'广':'0',
'己':'0',
'已':'0',
'彐':'0',
'彑':'0',
'巾':'0',
'口':'0',
'马':'0',
'门':'0',
'宀':'0',
'女':'0',
'犭':'0',
'山':'0',
'彡':'0',
'尸':'0',
'饣':'0',
'士':'0',
'才':'0',
'扌':'0',
'氵':'0',
'纟':'0',
'巳':'0',
'土':'0',
'囗':'0',
'夕':'0',
'小':'0',
'忄':'0',
'幺':'0',
'弋':'0',
'尢':'0',
'夂':'0',
'夊':'0',
'孑':'0',
'孓':'0',
'子':'0',
'孒':'0',
'卝':'0',
'丰':'0',
'中':'0',
'乏':'0',
'乌':'0',
'丹':'0',
'予':'0',
'书':'0',
'无':'0',
'不':'0',
'丑':'0',
'丐':'0',
'丏':'0',
'专':'0',
'为':'0',
'卞':'0',
'兂':'0',
'允':'0',
'元':'0',
'互':'0',
'井':'0',
'亓':'0',
'五':'0',
'云':'0',
'内':'0',
'円':'0',
'办':'0',
'冘':'0',
'內':'0',
'卅':'0',
'升':'0',
'卐':'0',
'午':'0',
'卍':'0',
'屯':'0',
'夭':'0',
'夫':'0',
'夬':'0',
'太':'0',
'巨':'0',
'开':'0',
'廿':'0',
'尺':'0',
'壬':'0',
'巴':'0',
'尤':'0',
'贝':'0',
'灬':'0',
'长':'0',
'车':'0',
'歹':'0',
'斗':'0',
'方':'0',
'父':'0',
'戈':'0',
'户':'0',
'火':'0',
'旡':'0',
'斤':'0',
'耂':'0',
'毛':'0',
'木':'0',
'朩':'0',
'牛':'0',
'牜':'0',
'爿':'0',
'片':'0',
'攵':'0',
'气':'0',
'欠':'0',
'犬':'0',
'日':'0',
'氏':'0',
'礻':'0',
'手':'0',
'水':'0',
'瓦':'0',
'王':'0',
'韦':'0',
'文':'0',
'毌':'0',
'毋':'0',
'心':'0',
'牙':'0',
'曰':'0',
'月':'0',
'止':'0',
'爪':'0',
'丱':'0',
'册':'0',
'玍':'0',
'乎':'0',
'乐':'0',
'乍':'0',
'丘':'0',
'业':'0',
'丙':'0',
'东':'0',
'且':'0',
'世':'0',
'主':'0',
'匆':'0',
'冉':'0',
'凹':'0',
'出':'0',
'击':'0',
'凸':'0',
'半':'0',
'卌':'0',
'发':'0',
'失':'0',
'头':'0',
'央':'0',
'平':'0',
'弗':'0',
'史':'0',
'尔':'0',
'戋':'0',
'戉':'0',
'斥':'0',
'本':'0',
'末':'0',
'术':'0',
'未':'0',
'氐':'0',
'民':'0',
'永':'0',
'氶':'0',
'必':'0',
'曱':'0',
'白':'0',
'甘':'0',
'瓜':'0',
'禾':'0',
'钅':'0',
'立':'0',
'龙':'0',
'皿':'0',
'母':'0',
'目':'0',
'疒':'0',
'鸟':'0',
'皮':'0',
'生':'0',
'矢':'0',
'示':'0',
'罒':'0',
'电':'0',
'甲':'0',
'申':'0',
'田':'0',
'由':'0',
'玄':'0',
'穴':'0',
'疋':'0',
'衤':'0',
'甩':'0',
'用':'0',
'玉':'0',
'乑':'0',
'襾':'0',
'亘':'0',
'亚':'0',
'农':'0',
'产':'0',
'亥':'0',
'亦':'0',
'州':'0',
'夹':'0',
'囟':'0',
'成':'0',
'戍':'0',
'朱':'0',
'朿':'0',
'曲':'0',
'曳':'0',
'臣':'0',
'虫':'0',
'而':'0',
'耳':'0',
'缶':'0',
'艮':'0',
'臼':'0',
'耒':'0',
'米':'0',
'肉':'0',
'舌':'0',
'西':'0',
'覀':'0',
'聿':'0',
'舟':'0',
'竹':'0',
'自':'0',
'页':'0',
'衣':'0',
'血':'0',
'羊':'0',
'串':'0',
'亊':'0',
'两':'0',
'丣':'0',
'卤':'0',
'卣':'0',
'亜':'0',
'弟':'0',
'囱':'0',
'芈':'0',
'来':'0',
'束':'0',
'求':'0',
'更':'0',
'甫':'0',
'良':'0',
'镸':'0',
'車':'0',
'辰':'0',
'赤':'0',
'豆':'0',
'角':'0',
'麦':'0',
'身':'0',
'豕':'0',
'辛':'0',
'言':'0',
'訁':'0',
'酉':'0',
'豸':'0',
'乖':'0',
'其':'0',
'亟':'0',
'垂':'0',
'戼':'0',
'東':'0',
'承':'0',
'秉':'0',
'疌':'0',
'長':'0',
'非':'0',
'釒':'0',
'隶':'0',
'飠':'0',
'雨':'0',
'乗':'0',
'飛':'0',
'禺':'0',
'禹':'0',
'為':'0',
'柬':'0',
'重':'0',
'酋':'0',
'革':'0',
'鬼':'0',
'韭':'0',
'面':'0',
'頁':'0',
'乘':'0',
'畢':'0',
'粛':'0',
'鹵':'0',
'爲':'0',
'肅':'0',
'黽':'0',
'奭':'0',
'龜':'0',
'噩':'0',
'巜':'1',
'乆':'1',
'劜':'1',
'亿':'1',
'乢':'1',
'乣':'1',
'切':'1',
'刅':'1',
'刈':'1',
'邓':'1',
'队':'1',
'阞':'1',
'邒':'1',
'卬':'1',
'劝':'1',
'从':'1',
'以':'1',
'化':'1',
'仇':'1',
'仃':'1',
'仅':'1',
'仂':'1',
'仆':'1',
'仁':'1',
'仍':'1',
'什':'1',
'仉':'1',
'仈':'1',
'仏':'1',
'厸':'1',
'订':'1',
'讣':'1',
'讥':'1',
'计':'1',
'认':'1',
'双':'1',
'収':'1',
'引':'1',
'尹':'1',
'扎':'1',
'圠':'1',
'忆':'1',
'幻':'1',
'孔':'1',
'比':'1',
'饤':'1',
'饥':'1',
'扒':'1',
'打':'1',
'扑':'1',
'扔':'1',
'扐':'1',
'払':'1',
'扏':'1',
'扖':'1',
'汈':'1',
'氾':'1',
'氿':'1',
'汉':'1',
'汇':'1',
'汃':'1',
'汀':'1',
'汁':'1',
'氻':'1',
'汅':'1',
'汄':'1',
'纠':'1',
'圦':'1',
'圤':'1',
'圢':'1',
'外':'1',
'夘':'1',
'夗':'1',
'忉':'1',
'忊':'1',
'忇':'1',
'幼':'1',
'轧':'1',
'北':'1',
'冯':'1',
'冮':'1',
'卟':'1',
'刌':'1',
'刊':'1',
'刉':'1',
'刋':'1',
'邗':'1',
'邝':'1',
'邙':'1',
'阡':'1',
'邛':'1',
'阢':'1',
'邘':'1',
'邚':'1',
'阣':'1',
'邔':'1',
'邖':'1',
'阤':'1',
'邜':'1',
'阠':'1',
'卯':'1',
'印':'1',
'卭':'1',
'功':'1',
'加':'1',
'劢':'1',
'代':'1',
'付':'1',
'仡':'1',
'伋':'1',
'们':'1',
'仫':'1',
'仟':'1',
'仞':'1',
'仨':'1',
'仕':'1',
'他':'1',
'仙':'1',
'仪':'1',
'仔':'1',
'仗':'1',
'仢':'1',
'仛':'1',
'仦':'1',
'仠':'1',
'仜':'1',
'仭':'1',
'仩':'1',
'讧':'1',
'记':'1',
'讦':'1',
'讫':'1',
'让':'1',
'讱':'1',
'讪':'1',
'讨':'1',
'讯':'1',
'训':'1',
'议':'1',
'讬':'1',
'对':'1',
'巧':'1',
'弘':'1',
'归':'1',
'帅':'1',
'帄':'1',
'叭':'1',
'叱':'1',
'叨':'1',
'叼':'1',
'叮':'1',
'叽':'1',
'叫':'1',
'叩':'1',
'叻':'1',
'叶':'1',
'叹':'1',
'叺':'1',
'驭':'1',
'奶':'1',
'奴':'1',
'奵':'1',
'犯':'1',
'犰':'1',
'屷':'1',
'戊':'1',
'札':'1',
'旧':'1',
'礼':'1',
'玌':'1',
'肊':'1',
'癶':'1',
'死':'1',
'戏':'1',
'灯':'1',
'灱':'1',
'灲':'1',
'观':'1',
'朳':'1',
'机':'1',
'朴':'1',
'权':'1',
'朽':'1',
'朼':'1',
'朾':'1',
'朷':'1',
'朹':'1',
'朻':'1',
'朸':'1',
'朲':'1',
'杁':'1',
'牝':'1',
'牞':'1',
'收':'1',
'攷':'1',
'次':'1',
'欢':'1',
'旫':'1',
'旪':'1',
'祁':'1',
'礽':'1',
'玎':'1',
'玑':'1',
'玐':'1',
'玏':'1',
'肌':'1',
'肋':'1',
'肍':'1',
'此':'1',
'癿':'1',
'钆':'1',
'钇':'1',
'饦':'1',
'饧':'1',
'壮':'1',
'扱':'1',
'扛':'1',
'扢':'1',
'扞':'1',
'扣':'1',
'扩':'1',
'扪':'1',
'扦':'1',
'扫':'1',
'托':'1',
'扤':'1',
'扬':'1',
'执':'1',
'扠':'1',
'扡':'1',
'扥':'1',
'扚':'1',
'扝':'1',
'扨':'1',
'扟':'1',
'扜':'1',
'扗':'1',
'扙':'1',
'汊':'1',
'池':'1',
'汏':'1',
'汗':'1',
'汲':'1',
'江':'1',
'汔':'1',
'汝':'1',
'汕':'1',
'汤':'1',
'汜':'1',
'汍':'1',
'污':'1',
'汐':'1',
'汛':'1',
'汙':'1',
'汚':'1',
'汎':'1',
'汓':'1',
'汌':'1',
'汣':'1',
'汒':'1',
'汘':'1',
'汋':'1',
'汢':'1',
'汑':'1',
'汷':'1',
'纥':'1',
'红':'1',
'级':'1',
'纪':'1',
'纩':'1',
'纤':'1',
'纫':'1',
'纨':'1',
'约':'1',
'纡':'1',
'纣':'1',
'场':'1',
'地':'1',
'圪':'1',
'圾':'1',
'圹':'1',
'圮':'1',
'圩':'1',
'圬':'1',
'圯':'1',
'圳':'1',
'圵':'1',
'圱':'1',
'圲':'1',
'圸':'1',
'圷':'1',
'圫':'1',
'圴':'1',
'舛':'1',
'忏':'1',
'忖':'1',
'忓':'1',
'忣':'1',
'忙':'1',
'忛':'1',
'忋':'1',
'忚':'1',
'忔':'1',
'忕':'1',
'孖':'1',
'孙':'1',
'轨':'1',
'艸':'1',
'行':'1',
'羽':'1',
'礼':'1',
'份':'1',
'乩':'1',
'乨':'1',
'冰':'1',
'冲':'1',
'冱':'1',
'决':'1',
'冴':'1',
'创':'1',
'刚':'1',
'划':'1',
'列':'1',
'刘':'1',
'刓':'1',
'刎':'1',
'刑':'1',
'刖':'1',
'则':'1',
'刐':'1',
'刏':'1',
'刔':'1',
'兆':'1',
'阨':'1',
'阪':'1',
'邦':'1',
'邠':'1',
'邡':'1',
'防':'1',
'阶':'1',
'阱':'1',
'阬':'1',
'那':'1',
'阮':'1',
'邬':'1',
'邪':'1',
'邢':'1',
'阳':'1',
'阴':'1',
'阵':'1',
'阧':'1',
'邨':'1',
'邞':'1',
'邟':'1',
'邩':'1',
'阫':'1',
'阰':'1',
'邥':'1',
'阩':'1',
'邷':'1',
'邤':'1',
'阭':'1',
'阦':'1',
'阥':'1',
'邧':'1',
'阯':'1',
'动':'1',
'劤':'1',
'劥':'1',
'劧':'1',
'仰':'1',
'伧':'1',
'伥':'1',
'伡':'1',
'传':'1',
'伐':'1',
'仿':'1',
'伕':'1',
'伏':'1',
'伙':'1',
'伎':'1',
'价':'1',
'件':'1',
'伉':'1',
'伦':'1',
'仳':'1',
'佢':'1',
'任':'1',
'伤':'1',
'似':'1',
'佤':'1',
'伟':'1',
'伪':'1',
'伍':'1',
'仵':'1',
'伈':'1',
'休':'1',
'伢':'1',
'伊':'1',
'优':'1',
'伃':'1',
'伛':'1',
'仲':'1',
'伫':'1',
'伌':'1',
'仯':'1',
'伜':'1',
'伔':'1',
'仾':'1',
'伄':'1',
'伅':'1',
'仮':'1',
'仹':'1',
'仸':'1',
'伒':'1',
'仱':'1',
'伖':'1',
'伂':'1',
'伓':'1',
'伣':'1',
'仼':'1',
'仴':'1',
'伆':'1',
'伩':'1',
'伨':'1',
'伇':'1',
'伝':'1',
'伬':'1',
'伀':'1',
'协':'1',
'讹':'1',
'访':'1',
'讽':'1',
'讳':'1',
'讲':'1',
'讵':'1',
'诀':'1',
'论':'1',
'讷':'1',
'讴':'1',
'设':'1',
'讼':'1',
'讻':'1',
'许':'1',
'讶':'1',
'彴':'1',
'彶':'1',
'彵':'1',
'夶':'1',
'幵':'1',
'巩':'1',
'弛':'1',
'弜':'1',
'弙':'1',
'帆':'1',
'师':'1',
'吖':'1',
'吃':'1',
'吓':'1',
'吗':'1',
'吐':'1',
'吸':'1',
'吁':'1',
'吆':'1',
'吒':'1',
'吋':'1',
'叿':'1',
'吇':'1',
'吀':'1',
'吅':'1',
'吔':'1',
'驰':'1',
'驮':'1',
'驯':'1',
'妃':'1',
'妇':'1',
'奸':'1',
'好':'1',
'妈':'1',
'如':'1',
'妁':'1',
'她':'1',
'妆':'1',
'奼':'1',
'妅':'1',
'妀':'1',
'奺':'1',
'奻':'1',
'奷':'1',
'奾':'1',
'犴':'1',
'犷':'1',
'犸':'1',
'犲':'1',
'犵':'1',
'犱':'1',
'犳':'1',
'屺':'1',
'屼':'1',
'屹':'1',
'屿':'1',
'屽':'1',
'岋':'1',
'屸':'1',
'屻':'1',
'屾':'1',
'乱':'1',
'冻':'1',
'况':'1',
'冷':'1',
'冶':'1',
'冺':'1',
'冹':'1',
'冸':'1',
'初':'1',
'刧':'1',
'刨':'1',
'别':'1',
'刬':'1',
'刜':'1',
'刭':'1',
'利':'1',
'判':'1',
'删':'1',
'刦':'1',
'刪':'1',
'別':'1',
'刟':'1',
'刢':'1',
'刡':'1',
'刞':'1',
'刣':'1',
'阿':'1',
'陂':'1',
'邶':'1',
'邲':'1',
'邴':'1',
'陈':'1',
'邸':'1',
'阽':'1',
'阸':'1',
'附':'1',
'邯':'1',
'际':'1',
'邻':'1',
'陆':'1',
'陇':'1',
'邳':'1',
'邱':'1',
'邵':'1',
'邰':'1',
'陁':'1',
'陀':'1',
'陉':'1',
'邺':'1',
'邮':'1',
'邹':'1',
'阻':'1',
'阼':'1',
'陃':'1',
'阷':'1',
'阺':'1',
'邭':'1',
'阾':'1',
'阹':'1',
'即':'1',
'卵':'1',
'却':'1',
'卲':'1',
'助':'1',
'劫':'1',
'劲':'1',
'励':'1',
'劬':'1',
'劭':'1',
'劰':'1',
'劮':'1',
'劯':'1',
'佁':'1',
'伯':'1',
'伴':'1',
'伻':'1',
'佊':'1',
'伺':'1',
'但':'1',
'低':'1',
'佃':'1',
'佛':'1',
'伽':'1',
'佝':'1',
'估':'1',
'何':'1',
'佧':'1',
'伶':'1',
'你':'1',
'伲':'1',
'佞':'1',
'伾':'1',
'佉':'1',
'伸':'1',
'体':'1',
'佟':'1',
'佗':'1',
'位':'1',
'佚':'1',
'佣':'1',
'佑':'1',
'住':'1',
'作':'1',
'佐':'1',
'佈':'1',
'佔':'1',
'佀':'1',
'佨':'1',
'佖':'1',
'佄':'1',
'佅':'1',
'伱':'1',
'伮':'1',
'伹':'1',
'佋':'1',
'佦':'1',
'伭':'1',
'佡':'1',
'伳':'1',
'伵':'1',
'佒':'1',
'伿':'1',
'佂':'1',
'伷':'1',
'佇':'1',
'诐':'1',
'词':'1',
'诋':'1',
'诂':'1',
'评':'1',
'诎':'1',
'识':'1',
'诉':'1',
'诇':'1',
'译':'1',
'诈':'1',
'诏':'1',
'诊':'1',
'证':'1',
'诌':'1',
'诅':'1',
'诃':'1',
'诒':'1',
'彷':'1',
'役':'1',
'彺':'1',
'彸':'1',
'対':'1',
'弝':'1',
'张':'1',
'弡':'1',
'弞':'1',
'帊':'1',
'帏':'1',
'帐':'1',
'帎':'1',
'吧':'1',
'呗':'1',
'吡':'1',
'吥':'1',
'吵':'1',
'吹':'1',
'呔':'1',
'吨':'1',
'吪':'1',
'呃':'1',
'吠':'1',
'呋':'1',
'吭':'1',
'吽':'1',
'吰':'1',
'呖':'1',
'呒':'1',
'呐':'1',
'呕':'1',
'呛':'1',
'吣':'1',
'吮':'1',
'听':'1',
'吻':'1',
'呜':'1',
'吷':'1',
'呀':'1',
'呓':'1',
'吟':'1',
'吲':'1',
'吱':'1',
'呌':'1',
'吚':'1',
'呎':'1',
'吜':'1',
'吺':'1',
'吤':'1',
'吙':'1',
'呁':'1',
'呅':'1',
'吶':'1',
'吘':'1',
'呏':'1',
'咓':'1',
'呚':'1',
'咞':'1',
'呍':'1',
'驳':'1',
'驴':'1',
'驱':'1',
'驲':'1',
'妣':'1',
'妒':'1',
'妨':'1',
'妋':'1',
'妫':'1',
'妓':'1',
'妗':'1',
'妙':'1',
'妠':'1',
'妞':'1',
'妊':'1',
'姒':'1',
'妩':'1',
'妍':'1',
'妖':'1',
'妤':'1',
'妪':'1',
'妘':'1',
'姊':'1',
'姉':'1',
'妝':'1',
'妉':'1',
'姂':'1',
'妦':'1',
'妚':'1',
'妎':'1',
'妔':'1',
'妌':'1',
'姖':'1',
'妜':'1',
'妑':'1',
'妧':'1',
'妏':'1',
'妡':'1',
'妐':'1',
'妕':'1',
'狈':'1',
'狄':'1',
'犼':'1',
'狂':'1',
'狃':'1',
'犹':'1',
'狁':'1',
'犻':'1',
'犿':'1',
'犺':'1',
'狅':'1',
'狇':'1',
'犽':'1',
'犾':'1',
'狆':'1',
'岐':'1',
'岍':'1',
'岖':'1',
'岘':'1',
'岈':'1',
'岅':'1',
'岠':'1',
'岓':'1',
'岒':'1',
'岏':'1',
'竌':'1',
'竍':'1',
'盯':'1',
'鸡':'1',
'鸠':'1',
'矶':'1',
'矴':'1',
'矵':'1',
'町':'1',
'补':'1',
'虬':'1',
'耴':'1',
'糺':'1',
'臫':'1',
'歼':'1',
'斘':'1',
'我':'1',
'戺':'1',
'灿':'1',
'灺':'1',
'炀':'1',
'灶':'1',
'灼':'1',
'灴':'1',
'灹':'1',
'杓':'1',
'材':'1',
'杈':'1',
'村':'1',
'杕':'1',
'杜':'1',
'杆':'1',
'杠':'1',
'极':'1',
'杩':'1',
'杧':'1',
'杞':'1',
'杉':'1',
'杌':'1',
'杨':'1',
'杝':'1',
'杙':'1',
'杖':'1',
'杇':'1',
'杒':'1',
'杋':'1',
'杚':'1',
'杛':'1',
'杦':'1',
'杄':'1',
'杣':'1',
'杔':'1',
'杤':'1',
'杅':'1',
'杊':'1',
'杍':'1',
'牤':'1',
'牡':'1',
'牣':'1',
'牠':'1',
'改':'1',
'攻':'1',
'攸':'1',
'攼':'1',
'攺':'1',
'欤':'1',
'状':'1',
'旰':'1',
'旷':'1',
'时':'1',
'旸':'1',
'旳':'1',
'昅':'1',
'旴':'1',
'祃':'1',
'社':'1',
'祀':'1',
'祂':'1',
'礿':'1',
'瓨':'1',
'玚':'1',
'玓':'1',
'玕':'1',
'玖':'1',
'玛':'1',
'玘':'1',
'玙':'1',
'玔':'1',
'玒':'1',
'玗':'1',
'韧':'1',
'肠':'1',
'肚':'1',
'肝':'1',
'肛':'1',
'肜':'1',
'肟':'1',
'肘':'1',
'肐':'1',
'肑':'1',
'肞':'1',
'肔':'1',
'肒':'1',
'肕':'1',
'肗':'1',
'私':'1',
'钉':'1',
'钌':'1',
'钋':'1',
'钊':'1',
'针':'1',
'岉':'1',
'岆':'1',
'岄':'1',
'彤':'1',
'形':'1',
'饬':'1',
'饭':'1',
'饪':'1',
'饨':'1',
'饩':'1',
'饮':'1',
'饫':'1',
'壯':'1',
'把':'1',
'扳':'1',
'扮':'1',
'报':'1',
'抃':'1',
'抄':'1',
'扯':'1',
'扽':'1',
'抖':'1',
'扼':'1',
'扶':'1',
'抚':'1',
'护':'1',
'技':'1',
'拒':'1',
'抉':'1',
'抗':'1',
'抠':'1',
'抡':'1',
'拟':'1',
'扭':'1',
'抛':'1',
'批':'1',
'抔':'1',
'抢':'1',
'扰':'1',
'折':'1',
'抒':'1',
'投':'1',
'抟':'1',
'抏':'1',
'抆':'1',
'抈':'1',
'找':'1',
'扺':'1',
'抓':'1',
'抝':'1',
'扷':'1',
'抜':'1',
'抌':'1',
'抙':'1',
'抅':'1',
'抇':'1',
'扴':'1',
'抸':'1',
'扻':'1',
'抂':'1',
'抐':'1',
'扲':'1',
'抋':'1',
'扸':'1',
'抁':'1',
'扵':'1',
'抎':'1',
'抣':'1',
'択':'1',
'抍':'1',
'汳':'1',
'汴':'1',
'沧':'1',
'沉':'1',
'沌':'1',
'泛':'1',
'沣':'1',
'沨':'1',
'沟':'1',
'汩':'1',
'沆':'1',
'沪':'1',
'汫':'1',
'泐':'1',
'沥':'1',
'沦':'1',
'没':'1',
'汶':'1',
'汨':'1',
'沔':'1',
'沐':'1',
'沤':'1',
'沛':'1',
'汽':'1',
'汧':'1',
'沁':'1',
'汭':'1',
'沙':'1',
'沈':'1',
'汰':'1',
'汪':'1',
'沩':'1',
'沃':'1',
'汹':'1',
'沂':'1',
'沅':'1',
'沄':'1',
'汦':'1',
'沚':'1',
'沍':'1',
'沘':'1',
'沖':'1',
'決':'1',
'汵':'1',
'汸':'1',
'汱':'1',
'沕':'1',
'汯':'1',
'汻':'1',
'沎':'1',
'汥':'1',
'泲':'1',
'洰':'1',
'汮':'1',
'沠':'1',
'沒':'1',
'汼':'1',
'沑':'1',
'沜':'1',
'泤':'1',
'沇':'1',
'汿':'1',
'沋':'1',
'沞':'1',
'沢':'1',
'纯':'1',
'纺':'1',
'纲':'1',
'纶':'1',
'纮':'1',
'纳':'1',
'纽':'1',
'纰':'1',
'纴':'1',
'纱':'1',
'纾':'1',
'纬':'1',
'纹':'1',
'纭':'1',
'纼':'1',
'纸':'1',
'纻':'1',
'纵':'1',
'坝':'1',
'坂':'1',
'坊':'1',
'坏':'1',
'均':'1',
'坎':'1',
'坑':'1',
'块':'1',
'坜':'1',
'圻':'1',
'坍':'1',
'坛':'1',
'坞':'1',
'址':'1',
'坘':'1',
'坆':'1',
'圿':'1',
'坈':'1',
'圽':'1',
'坅':'1',
'坉':'1',
'坃':'1',
'坄':'1',
'坁':'1',
'忭':'1',
'怅':'1',
'忱':'1',
'忡':'1',
'怆':'1',
'怀':'1',
'忾':'1',
'快':'1',
'忸':'1',
'怄':'1',
'忪':'1',
'忨':'1',
'怃':'1',
'忤':'1',
'忺':'1',
'忻':'1',
'忧':'1',
'忮':'1',
'忼':'1',
'忰':'1',
'忳':'1',
'忶':'1',
'忦':'1',
'怇':'1',
'忹':'1',
'忯':'1',
'忴':'1',
'忬':'1',
'忲':'1',
'忟':'1',
'忷':'1',
'孜':'1',
'财':'1',
'轪':'1',
'轫':'1',
'轩':'1',
'吩':'1',
'坋':'1',
'坟':'1',
'妢':'1',
'岎':'1',
'帉':'1',
'汾':'1',
'纷':'1',
'門':'1',
'隹':'1',
'顶':'1',
'顷':'1',
'怾':'1',
'昐':'1',
'朌':'1',
'枌':'1',
'虲':'1',
'殁':'1',
'殀':'1',
'歾':'1',
'歿':'1',
'歽':'1',
'於':'1',
'斻':'1',
'斺':'1',
'戗':'1',
'戕':'1',
'所':'1',
'炒':'1',
'炊':'1',
'炖':'1',
'炔':'1',
'炕':'1',
'炜':'1',
'炬':'1',
'炉':'1',
'炝':'1',
'炆':'1',
'炘':'1',
'炞':'1',
'炐':'1',
'炚':'1',
'炌':'1',
'炏':'1',
'炓':'1',
'炑':'1',
'炄':'1',
'炍':'1',
'炋':'1',
'炇':'1',
'炈':'1',
'炂':'1',
'规':'1',
'视':'1',
'现':'1',
'斩':'1',
'斨':'1',
'斦':'1',
'枊':'1',
'杷':'1',
'板':'1',
'杯':'1',
'枨':'1',
'杻':'1',
'杵':'1',
'枞':'1',
'枓':'1',
'枋':'1',
'枫':'1',
'构':'1',
'柜':'1',
'杭':'1',
'枑':'1',
'枧':'1',
'枥':'1',
'林':'1',
'枚':'1',
'杪':'1',
'枇':'1',
'枪':'1',
'枘':'1',
'枢':'1',
'杸':'1',
'松':'1',
'枉':'1',
'析':'1',
'枕':'1',
'枝':'1',
'杼':'1',
'枏':'1',
'柹':'1',
'杴':'1',
'杮':'1',
'杽':'1',
'杶':'1',
'枤':'1',
'枙':'1',
'柉':'1',
'枎':'1',
'杹':'1',
'枅':'1',
'枃':'1',
'枦':'1',
'枆':'1',
'枬':'1',
'枡':'1',
'杫':'1',
'枂':'1',
'杺':'1',
'枔':'1',
'枒':'1',
'枖':'1',
'枍':'1',
'杬':'1',
'枟':'1',
'枛':'1',
'枠':'1',
'牥':'1',
'牦':'1',
'牧':'1',
'物':'1',
'牬':'1',
'牨':'1',
'牫':'1',
'牪':'1',
'牀':'1',
'版':'1',
'攽':'1',
'放':'1',
'玫':'1',
'欧':'1',
'欣':'1',
'欦':'1',
'欥':'1',
'狀':'1',
'昉':'1',
'昒':'1',
'明':'1',
'旺':'1',
'昕':'1',
'昀':'1',
'昄':'1',
'昁':'1',
'昈':'1',
'昛':'1',
'旼':'1',
'昑':'1',
'旽':'1',
'旿':'1',
'昍':'1',
'昖':'1',
'氓':'1',
'祊':'1',
'祈':'1',
'祇':'1',
'祆':'1',
'祎':'1',
'祉':'1',
'祅':'1',
'祌':'1',
'祋':'1',
'祍':'1',
'祄':'1',
'殴':'1',
'沀':'1',
'沝':'1',
'瓯':'1',
'瓭':'1',
'瓬':'1',
'玢':'1',
'玞':'1',
'环':'1',
'玠':'1',
'玦':'1',
'玭':'1',
'玱':'1',
'玩':'1',
'玮':'1',
'玡':'1',
'玥':'1',
'玨':'1',
'玤':'1',
'珁':'1',
'玬':'1',
'玜':'1',
'玪':'1',
'玟':'1',
'玣':'1',
'玧':'1',
'玝':'1',
'怺':'1',
'肮':'1',
'肪':'1',
'肥':'1',
'肺':'1',
'肤':'1',
'服':'1',
'肱':'1',
'股':'1',
'肼':'1',
'肭':'1',
'朋':'1',
'肷':'1',
'朊':'1',
'肽':'1',
'肸':'1',
'肹':'1',
'胁':'1',
'胀':'1',
'肢':'1',
'肿':'1',
'肫':'1',
'肧':'1',
'肬':'1',
'肶':'1',
'肦':'1',
'胏':'1',
'肨':'1',
'肣':'1',
'肵':'1',
'肰':'1',
'肳':'1',
'歧':'1',
'歫':'1',
'爬':'1',
'的':'1',
'秆':'1',
'秄':'1',
'秈':'1',
'秇':'1',
'秅':'1',
'钗':'1',
'钏':'1',
'钓':'1',
'钒':'1',
'钔':'1',
'钕':'1',
'钎':'1',
'钐':'1',
'钍':'1',
'钖':'1',
'钑':'1',
'乵':'1',
'乳':'1',
'净':'1',
'冽':'1',
'冼':'1',
'冿':'1',
'冾':'1',
'卦':'1',
'卧':'1',
'刱':'1',
'刼':'1',
'刹':'1',
'刺':'1',
'到':'1',
'剁':'1',
'刮':'1',
'刿':'1',
'刽':'1',
'剂':'1',
'剀':'1',
'刻':'1',
'刳':'1',
'刲':'1',
'刷':'1',
'制':'1',
'刵':'1',
'刴':'1',
'刾':'1',
'刯':'1',
'剆':'1',
'兓':'1',
'陌':'1',
'陔':'1',
'邽':'1',
'郃':'1',
'郈':'1',
'郇':'1',
'郏':'1',
'降':'1',
'郊':'1',
'郐':'1',
'郎':'1',
'陋':'1',
'陕':'1',
'郋':'1',
'郄':'1',
'限':'1',
'郁':'1',
'郓':'1',
'郑':'1',
'郅':'1',
'邾':'1',
'陒':'1',
'郕':'1',
'陊':'1',
'陏':'1',
'陑':'1',
'郍':'1',
'郂':'1',
'郉':'1',
'郆':'1',
'郀':'1',
'邼':'1',
'郘':'1',
'郱':'1',
'邿':'1',
'陎':'1',
'郔':'1',
'陓':'1',
'凯':'1',
'卹':'1',
'卶':'1',
'劾':'1',
'劼':'1',
'劻':'1',
'効':'1',
'劷':'1',
'劶':'1',
'勆':'1',
'劺':'1',
'劸':'1',
'佰':'1',
'侘':'1',
'侪':'1',
'侈':'1',
'佌':'1',
'佽':'1',
'侗':'1',
'佴':'1',
'供':'1',
'佹':'1',
'佫':'1',
'佷':'1',
'佪':'1',
'佶':'1',
'佳':'1',
'侥':'1',
'佼':'1',
'侃':'1',
'侉':'1',
'侩':'1',
'佬':'1',
'侣':'1',
'侔':'1',
'侬':'1',
'佩':'1',
'侨':'1',
'佺':'1',
'侁':'1',
'使':'1',
'侍':'1',
'佻':'1',
'侹':'1',
'侂':'1',
'侠':'1',
'佯':'1',
'依':'1',
'佾':'1',
'侑':'1',
'侦':'1',
'侄':'1',
'侜':'1',
'侏':'1',
'侚':'1',
'併':'1',
'侒':'1',
'侙':'1',
'侟':'1',
'侢':'1',
'佮':'1',
'侕':'1',
'侅':'1',
'侊':'1',
'佸':'1',
'侭':'1',
'侓':'1',
'侎':'1',
'佲':'1',
'侫':'1',
'侞':'1',
'価':'1',
'侤':'1',
'佭':'1',
'侀':'1',
'俢':'1',
'侐':'1',
'侇':'1',
'協':'1',
'诧':'1',
'诚':'1',
'诞':'1',
'该':'1',
'诟':'1',
'诖':'1',
'诡':'1',
'话':'1',
'诙':'1',
'诨':'1',
'诘':'1',
'诓':'1',
'诔':'1',
'诠':'1',
'诜':'1',
'诗':'1',
'试':'1',
'详':'1',
'诩':'1',
'询':'1',
'诣':'1',
'诤':'1',
'诛':'1',
'取':'1',
'叔':'1',
'苤':'1',
'彼':'1',
'徂':'1',
'径':'1',
'往':'1',
'征':'1',
'徃':'1',
'彿':'1',
'彽':'1',
'彾':'1',
'尀':'1',
'幷':'1',
'弨':'1',
'弧':'1',
'弪':'1',
'弥':'1',
'弢':'1',
'弦':'1',
'弤':'1',
'弣':'1',
'帕':'1',
'帔':'1',
'帖':'1',
'帜':'1',
'帙':'1',
'帗':'1',
'帓':'1',
'呵':'1',
'哎':'1',
'咑':'1',
'咚':'1',
'咄':'1',
'咈':'1',
'咐':'1',
'呷':'1',
'咖':'1',
'咕':'1',
'呱':'1',
'咍':'1',
'和':'1',
'呼':'1',
'咀':'1',
'咔':'1',
'呤':'1',
'咙':'1',
'呣':'1',
'呶':'1',
'呢':'1',
'咛':'1',
'咆':'1',
'呸':'1',
'呿':'1',
'呥':'1',
'呻':'1',
'咝':'1',
'呫':'1',
'味':'1',
'咂':'1',
'咋':'1',
'呪':'1',
'咊':'1',
'呝':'1',
'咏':'1',
'咇':'1',
'咘':'1',
'呬':'1',
'呮':'1',
'呹':'1',
'呾':'1',
'呧':'1',
'咁':'1',
'呴':'1',
'呺':'1',
'呟':'1',
'呡':'1',
'呠':'1',
'呯':'1',
'呞':'1',
'呩':'1',
'咜':'1',
'咃':'1',
'咉':'1',
'呭':'1',
'咗':'1',
'骀':'1',
'驸':'1',
'驹':'1',
'驶':'1',
'驷':'1',
'驼':'1',
'驿':'1',
'驵':'1',
'驻':'1',
'驺':'1',
'姅':'1',
'妲':'1',
'姑':'1',
'姐':'1',
'姆':'1',
'妹':'1',
'妺':'1',
'妮':'1',
'姌':'1',
'姗':'1',
'始':'1',
'姓':'1',
'姁':'1',
'妯':'1',
'妬':'1',
'妷':'1',
'姍':'1',
'妭':'1',
'妼':'1',
'妸':'1',
'姀':'1',
'姈':'1',
'姏':'1',
'姄':'1',
'妳':'1',
'妽':'1',
'妵':'1',
'妶':'1',
'姎':'1',
'妱':'1',
'姃':'1',
'妰':'1',
'狒':'1',
'狗':'1',
'狐':'1',
'狙':'1',
'狞':'1',
'狍':'1',
'狉':'1',
'狌':'1',
'狎':'1',
'狝':'1',
'狖':'1',
'狓':'1',
'狛':'1',
'狋':'1',
'狚':'1',
'狜':'1',
'狑':'1',
'狔':'1',
'狏':'1',
'狘':'1',
'狕':'1',
'竏':'1',
'毑':'1',
'盱':'1',
'盰':'1',
'盳':'1',
'盵':'1',
'鸣':'1',
'鸤':'1',
'皯':'1',
'砀':'1',
'矾':'1',
'矸':'1',
'矼':'1',
'矻':'1',
'矿':'1',
'码':'1',
'矽':'1',
'矺':'1',
'砐':'1',
'矹':'1',
'矷':'1',
'知':'1',
'矤':'1',
'畅':'1',
'甿':'1',
'畂':'1',
'甽':'1',
'畃':'1',
'衩':'1',
'衬':'1',
'衫':'1',
'衦':'1',
'衱':'1',
'衪':'1',
'衧':'1',
'臥':'1',
'臤':'1',
'虮':'1',
'虯':'1',
'虰':'1',
'虭':'1',
'耵':'1',
'耶':'1',
'缷':'1',
'艰':'1',
'耓':'1',
'籵':'1',
'籶':'1',
'舏':'1',
'糾':'1',
'糼':'1',
'糿':'1',
'糽':'1',
'舠':'1',
'軋':'1',
'岣':'1',
'岵':'1',
'岬':'1',
'岭':'1',
'岷':'1',
'峂':'1',
'岫':'1',
'峄':'1',
'岞':'1',
'岰':'1',
'峅':'1',
'岾':'1',
'岻':'1',
'岨':'1',
'岲':'1',
'岯':'1',
'岼':'1',
'岥':'1',
'岶':'1',
'岴':'1',
'岹':'1',
'岮':'1',
'岤':'1',
'岟':'1',
'饱':'1',
'饳':'1',
'饯':'1',
'饰':'1',
'饲':'1',
'饴':'1',
'拗':'1',
'拔':'1',
'拌':'1',
'抱':'1',
'拨':'1',
'拆':'1',
'抻':'1',
'抶':'1',
'抽':'1',
'担':'1',
'抵':'1',
'拂':'1',
'拐':'1',
'拣':'1',
'拘':'1',
'拉':'1',
'拦':'1',
'拎':'1',
'拢':'1',
'抹':'1',
'抿':'1',
'拇':'1',
'拈':'1',
'拧':'1',
'拍':'1',
'拚':'1',
'抨':'1',
'披':'1',
'抪':'1',
'拤':'1',
'拑':'1',
'拓':'1',
'抬':'1',
'拖':'1',
'押':'1',
'拥':'1',
'择':'1',
'拃':'1',
'招':'1',
'拄':'1',
'拙':'1',
'抴':'1',
'拋':'1',
'拕':'1',
'拝':'1',
'抦':'1',
'拀':'1',
'拞':'1',
'抲':'1',
'拁':'1',
'拠':'1',
'拡':'1',
'抺':'1',
'抩':'1',
'抳':'1',
'抷':'1',
'抾':'1',
'抭':'1',
'抰':'1',
'抯':'1',
'抧':'1',
'抮':'1',
'泌':'1',
'波':'1',
'泊':'1',
'沲':'1',
'法':'1',
'沸':'1',
'泭':'1',
'泔':'1',
'沽':'1',
'河':'1',
'泓':'1',
'浅':'1',
'泾':'1',
'泂':'1',
'泃':'1',
'沮':'1',
'泪':'1',
'沴':'1',
'泠':'1',
'泷':'1',
'泸':'1',
'泺':'1',
'泖':'1',
'沬':'1',
'沵':'1',
'泯':'1',
'沫':'1',
'泥':'1',
'泞':'1',
'泮':'1',
'泡':'1',
'泙':'1',
'泼':'1',
'泣':'1',
'泅':'1',
'沭':'1',
'泗':'1',
'沱':'1',
'泄':'1',
'泻':'1',
'泫':'1',
'沿':'1',
'泱':'1',
'泆':'1',
'泳':'1',
'油':'1',
'泽':'1',
'沾':'1',
'沼':'1',
'治':'1',
'注':'1',
'況':'1',
'泜':'1',
'泝':'1',
'泑':'1',
'泍':'1',
'泟':'1',
'沶':'1',
'泹':'1',
'沰':'1',
'沷':'1',
'泒':'1',
'泘':'1',
'泋':'1',
'泇':'1',
'泦':'1',
'泬':'1',
'泏':'1',
'泧':'1',
'泩':'1',
'泀':'1',
'沺':'1',
'泈':'1',
'泎':'1',
'绊':'1',
'绌':'1',
'绐':'1',
'绂':'1',
'绋':'1',
'绀':'1',
'经':'1',
'练':'1',
'绍':'1',
'绅':'1',
'细':'1',
'线':'1',
'绁':'1',
'绎':'1',
'织':'1',
'终':'1',
'绉':'1',
'组':'1',
'巶':'1',
'垇':'1',
'坳':'1',
'坢':'1',
'坼':'1',
'坻':'1',
'坫':'1',
'坩':'1',
'坷':'1',
'坤':'1',
'垃':'1',
'垆':'1',
'坭':'1',
'坯':'1',
'坪':'1',
'坡':'1',
'坦':'1',
'坨':'1',
'坿':'1',
'坵':'1',
'坺':'1',
'坲':'1',
'坸':'1',
'坬':'1',
'垀':'1',
'坥':'1',
'坽':'1',
'垅':'1',
'坶':'1',
'垊':'1',
'垉':'1',
'坮':'1',
'坹':'1',
'坱':'1',
'坧':'1',
'垁':'1',
'坾':'1',
'坰':'1',
'夝':'1',
'怖':'1',
'怊':'1',
'怵':'1',
'怛':'1',
'怫':'1',
'怪':'1',
'怙':'1',
'怜':'1',
'怩':'1',
'怕':'1',
'怦':'1',
'怯':'1',
'怗':'1',
'性':'1',
'怏':'1',
'怡':'1',
'怿':'1',
'怔':'1',
'怳':'1',
'怍':'1',
'怑':'1',
'怉':'1',
'怭':'1',
'怶':'1',
'怲':'1',
'怞':'1',
'怚':'1',
'怟':'1',
'怢':'1',
'怐':'1',
'怋':'1',
'怽':'1',
'怓':'1',
'怌':'1',
'怬':'1',
'怴':'1',
'怰':'1',
'怮':'1',
'怈':'1',
'孢':'1',
'孤':'1',
'孡':'1',
'败':'1',
'贬':'1',
'贩':'1',
'账':'1',
'贮':'1',
'购':'1',
'轭':'1',
'轮':'1',
'软':'1',
'转':'1',
'峒':'1',
'峧':'1',
'峤':'1',
'峙':'1',
'峡':'1',
'峋':'1',
'峣':'1',
'峥':'1',
'峖':'1',
'峸':'1',
'峌':'1',
'峏':'1',
'峐':'1',
'峠':'1',
'峆':'1',
'峘':'1',
'峢':'1',
'峍':'1',
'峈':'1',
'峔':'1',
'峗':'1',
'峫':'1',
'峓':'1',
'饼':'1',
'饵':'1',
'饹':'1',
'饸':'1',
'饺':'1',
'饶':'1',
'饻':'1',
'饷':'1',
'按':'1',
'持':'1',
'挡':'1',
'挏':'1',
'挌':'1',
'拱':'1',
'挂':'1',
'挥':'1',
'挤':'1',
'挢':'1',
'拮':'1',
'拷':'1',
'挎':'1',
'括':'1',
'挠':'1',
'挪':'1',
'拼':'1',
'拾':'1',
'拭':'1',
'拴':'1',
'挞':'1',
'挑':'1',
'挺':'1',
'挖':'1',
'挝':'1',
'挦':'1',
'挟':'1',
'挜':'1',
'拽':'1',
'拶':'1',
'挓':'1',
'挣':'1',
'拯':'1',
'指':'1',
'挀':'1',
'挷':'1',
'拺':'1',
'拸':'1',
'拵':'1',
'挃':'1',
'挕':'1',
'挅':'1',
'挆':'1',
'挄':'1',
'拫':'1',
'拻':'1',
'挍':'1',
'挗':'1',
'挒':'1',
'挘':'1',
'挔':'1',
'捛':'1',
'拰':'1',
'挊':'1',
'拪':'1',
'挻':'1',
'拹':'1',
'捓':'1',
'挧':'1',
'挋':'1',
'浐':'1',
'泚':'1',
'洞':'1',
'洏':'1',
'洱':'1',
'洸':'1',
'浔':'1',
'洪':'1',
'洹':'1',
'洄':'1',
'浍':'1',
'浑':'1',
'活':'1',
'济':'1',
'洎':'1',
'浃':'1',
'浇':'1',
'洁':'1',
'津':'1',
'浕':'1',
'洭':'1',
'洌':'1',
'洛':'1',
'洣':'1',
'洺':'1',
'浓':'1',
'派':'1',
'洴':'1',
'洽':'1',
'洳':'1',
'洒':'1',
'浉':'1',
'洮':'1',
'洟':'1',
'洼':'1',
'洈':'1',
'洧':'1',
'洿':'1',
'洗':'1',
'涎':'1',
'洨':'1',
'洫':'1',
'洵':'1',
'洋':'1',
'洇':'1',
'浈':'1',
'洲':'1',
'洙':'1',
'浊':'1',
'洩':'1',
'洶':'1',
'洝':'1',
'洆':'1',
'洊':'1',
'洉':'1',
'洃':'1',
'洚':'1',
'浄':'1',
'洘':'1',
'洡':'1',
'洠':'1',
'洀':'1',
'浌':'1',
'洦':'1',
'洓':'1',
'浀':'1',
'洤':'1',
'洬':'1',
'涏':'1',
'洐':'1',
'洢':'1',
'浂':'1',
'泿':'1',
'洕':'1',
'洅':'1',
'洔':'1',
'洷':'1',
'绖':'1',
'给':'1',
'绗':'1',
'绘':'1',
'绛':'1',
'绞':'1',
'结':'1',
'绝':'1',
'绔':'1',
'络':'1',
'绕':'1',
'绒':'1',
'统':'1',
'绚':'1',
'垵':'1',
'垞':'1',
'城':'1',
'垯':'1',
'垱':'1',
'垤':'1',
'垌':'1',
'垛':'1',
'垓':'1',
'垢':'1',
'垝':'1',
'垍':'1',
'垲':'1',
'垮':'1',
'垴':'1',
'垧':'1',
'垭':'1',
'埏':'1',
'垟':'1',
'垠':'1',
'垣':'1',
'垜':'1',
'垹':'1',
'垪':'1',
'埩':'1',
'垑':'1',
'垖':'1',
'垘':'1',
'垙':'1',
'垳':'1',
'垎':'1',
'垬':'1',
'垰':'1',
'垏':'1',
'垨':'1',
'垥':'1',
'垗':'1',
'恫':'1',
'恨':'1',
'恒':'1',
'恍':'1',
'恢':'1',
'恛':'1',
'恺':'1',
'恪':'1',
'恇':'1',
'恼':'1',
'恲':'1',
'恰':'1',
'恃':'1',
'恬':'1',
'恌':'1',
'恸':'1',
'恟':'1',
'恤':'1',
'恂':'1',
'恹':'1',
'恽':'1',
'恉':'1',
'恓':'1',
'恠':'1',
'恆':'1',
'恡':'1',
'恜':'1',
'恎':'1',
'恑':'1',
'恗':'1',
'恔':'1',
'恅':'1',
'恾':'1',
'恈':'1',
'恘':'1',
'恮':'1',
'恦':'1',
'恀':'1',
'恄':'1',
'恊':'1',
'恞':'1',
'恱':'1',
'孩':'1',
'贱':'1',
'贶':'1',
'贴':'1',
'贻':'1',
'毗':'1',
'轱':'1',
'轷':'1',
'轲':'1',
'轹':'1',
'临':'1',
'乹':'1',
'凂':'1',
'凁':'1',
'凃':'1',
'剏':'1',
'剉':'1',
'剐':'1',
'剑':'1',
'剌':'1',
'剃':'1',
'削':'1',
'剄':'1',
'則':'1',
'剎':'1',
'剅':'1',
'剈':'1',
'陛':'1',
'除':'1',
'陡':'1',
'郛':'1',
'郜':'1',
'郝':'1',
'郡':'1',
'郦':'1',
'陧':'1',
'郚':'1',
'郗':'1',
'郤':'1',
'险':'1',
'郢':'1',
'院':'1',
'郧':'1',
'陨':'1',
'陟':'1',
'陣':'1',
'陝':'1',
'陘':'1',
'陞':'1',
'郟':'1',
'郣':'1',
'陠':'1',
'陙':'1',
'陦':'1',
'郖':'1',
'郙':'1',
'郠':'1',
'郥':'1',
'陖':'1',
'郞':'1',
'陗':'1',
'陜':'1',
'陥':'1',
'卸':'1',
'卻':'1',
'卽':'1',
'勃':'1',
'勋':'1',
'勅':'1',
'勁':'1',
'勂':'1',
'勀':'1',
'勄':'1',
'勈':'1',
'俎':'1',
'保':'1',
'便':'1',
'俦':'1',
'促':'1',
'俤':'1',
'俄':'1',
'俘':'1',
'俛':'1',
'侯':'1',
'俒':'1',
'俭':'1',
'侷':'1',
'俊':'1',
'俫':'1',
'俚':'1',
'俪':'1',
'俩':'1',
'俍':'1',
'俜':'1',
'俟':'1',
'俏':'1',
'侵':'1',
'俅':'1',
'俗':'1',
'侻':'1',
'侮':'1',
'信':'1',
'修':'1',
'俨':'1',
'俑':'1',
'俣':'1',
'俥':'1',
'俠':'1',
'俓':'1',
'係':'1',
'侼':'1',
'侲':'1',
'侱':'1',
'侸':'1',
'俌':'1',
'俇':'1',
'侰':'1',
'俈':'1',
'侶':'1',
'侽':'1',
'俖':'1',
'俔':'1',
'俕':'1',
'侺':'1',
'俆':'1',
'俬':'1',
'俀':'1',
'俉':'1',
'俙':'1',
'侾':'1',
'俋':'1',
'俁':'1',
'俧':'1',
'侳':'1',
'诶':'1',
'诰':'1',
'诲':'1',
'诫':'1',
'诮':'1',
'说':'1',
'诵':'1',
'诬':'1',
'误':'1',
'诱':'1',
'语':'1',
'诪':'1',
'叛':'1',
'叙':'1',
'叚':'1',
'叝':'1',
'荆':'1',
'荑':'1',
'待':'1',
'很':'1',
'徊':'1',
'律':'1',
'徇':'1',
'徉':'1',
'後':'1',
'徍':'1',
'徆':'1',
'徔':'1',
'封':'1',
'将':'1',
'弭':'1',
'弫':'1',
'帧':'1',
'帥':'1',
'帡':'1',
'帞':'1',
'帢':'1',
'哔':'1',
'咤':'1',
'呲':'1',
'哒':'1',
'咥':'1',
'哆':'1',
'哚':'1',
'咡':'1',
'咯':'1',
'哏':'1',
'咣':'1',
'咶':'1',
'哈':'1',
'咳':'1',
'哄':'1',
'哗':'1',
'咴':'1',
'哕':'1',
'咭':'1',
'哜':'1',
'哙':'1',
'哐':'1',
'咧':'1',
'咪':'1',
'咩':'1',
'哞':'1',
'哪':'1',
'哝':'1',
'哌':'1',
'哂':'1',
'咷':'1',
'哇':'1',
'响':'1',
'哓':'1',
'咲':'1',
'咻':'1',
'哑':'1',
'咽':'1',
'咬':'1',
'咦':'1',
'咱':'1',
'咮':'1',
'咵':'1',
'哅':'1',
'咹':'1',
'唌':'1',
'哋':'1',
'咟':'1',
'咾':'1',
'哖':'1',
'咰':'1',
'哃':'1',
'哘':'1',
'咺':'1',
'哊':'1',
'骇':'1',
'骅':'1',
'骄':'1',
'骆':'1',
'骈':'1',
'骁':'1',
'骃':'1',
'姹':'1',
'姤':'1',
'姽':'1',
'姮':'1',
'姞':'1',
'娇':'1',
'姣':'1',
'姱':'1',
'姥':'1',
'娜':'1',
'姘':'1',
'娆':'1',
'姝':'1',
'娀':'1',
'娃':'1',
'娅':'1',
'姚':'1',
'姨':'1',
'姻':'1',
'姪':'1',
'姙':'1',
'娍':'1',
'姛':'1',
'姶':'1',
'姟':'1',
'姯':'1',
'娂':'1',
'姡':'1',
'姼':'1',
'姧':'1',
'婙':'1',
'姢':'1',
'姰':'1',
'姳':'1',
'姩':'1',
'姵':'1',
'姾':'1',
'姺':'1',
'娰':'1',
'娗':'1',
'姠':'1',
'姲':'1',
'姸':'1',
'娫':'1',
'姷':'1',
'姫':'1',
'独':'1',
'狠':'1',
'狟':'1',
'狡':'1',
'狯':'1',
'狨':'1',
'狮':'1',
'狩':'1',
'狭':'1',
'狰':'1',
'狥':'1',
'狫':'1',
'狢':'1',
'狤':'1',
'狦':'1',
'狧':'1',
'狪':'1',
'狿':'1',
'狣':'1',
'酊':'1',
'趴':'1',
'釔':'1',
'釓':'1',
'项':'1',
'顸':'1',
'须':'1',
'顺':'1',
'羏':'1',
'衂':'1',
'朑':'1',
'洂':'1',
'秎':'1',
'竕':'1',
'衯':'1',
'轳':'1',
'轻':'1',
'轺':'1',
'轶':'1',
'轸':'1',
'轵':'1',
'轴':'1',
'残':'1',
'殂':'1',
'殆':'1',
'殇':'1',
'殄':'1',
'殃':'1',
'殅':'1',
'施':'1',
'斿':'1',
'旀':'1',
'斾':'1',
'飒':'1',
'战':'1',
'炮':'1',
'炳':'1',
'炽':'1',
'炟':'1',
'烀':'1',
'炯':'1',
'烂':'1',
'炼':'1',
'炻':'1',
'烁':'1',
'烃':'1',
'炫':'1',
'炸':'1',
'炷':'1',
'炧':'1',
'炤':'1',
'炦':'1',
'炪':'1',
'炥':'1',
'炾':'1',
'炣':'1',
'炩':'1',
'炶':'1',
'炲':'1',
'炵':'1',
'炠':'1',
'炨':'1',
'炴':'1',
'炡':'1',
'炿':'1',
'炢':'1',
'既':'1',
'觇':'1',
'斫':'1',
'斪':'1',
'柏':'1',
'柈':'1',
'枹':'1',
'柲':'1',
'标':'1',
'柄':'1',
'柽':'1',
'柢':'1',
'栋':'1',
'柮':'1',
'柂':'1',
'柎':'1',
'柑':'1',
'枸':'1',
'枷':'1',
'柩':'1',
'柯':'1',
'枯':'1',
'栏':'1',
'栎':'1',
'柃':'1',
'柳':'1',
'栊':'1',
'栌':'1',
'柅':'1',
'柠':'1',
'枰':'1',
'栅':'1',
'柿':'1',
'柁':'1',
'柝':'1',
'柙':'1',
'枵':'1',
'枻':'1',
'柚':'1',
'柞':'1',
'栈':'1',
'柘':'1',
'栀':'1',
'枳':'1',
'栉':'1',
'柣':'1',
'柊':'1',
'柱':'1',
'柟':'1',
'柺':'1',
'柵':'1',
'栁':'1',
'柪':'1',
'柭':'1',
'柸':'1',
'柀':'1',
'柨':'1',
'枱':'1',
'柌':'1',
'柦':'1',
'柫':'1',
'柧':'1',
'枴':'1',
'柇':'1',
'柾':'1',
'柆':'1',
'栃':'1',
'桞':'1',
'栂':'1',
'枺':'1',
'枿':'1',
'桏':'1',
'栍':'1',
'柖':'1',
'柛':'1',
'枾':'1',
'柕':'1',
'柶':'1',
'柗':'1',
'枮':'1',
'柍':'1',
'柼':'1',
'栐':'1',
'柤':'1',
'柷':'1',
'牯':'1',
'牳':'1',
'牲':'1',
'牴':'1',
'牰':'1',
'牱':'1',
'牭':'1',
'牁':'1',
'牉':'1',
'牊':'1',
'敁':'1',
'故':'1',
'政':'1',
'敂':'1',
'敃':'1',
'敄':'1',
'敀':'1',
'欩':'1',
'欪':'1',
'欨':'1',
'昳':'1',
'昽':'1',
'昧':'1',
'昵':'1',
'昫':'1',
'昡':'1',
'映':'1',
'昭':'1',
'昨':'1',
'昞':'1',
'昹':'1',
'昸':'1',
'昲':'1',
'昿':'1',
'昤':'1',
'昩':'1',
'昢':'1',
'昣':'1',
'祠':'1',
'祓':'1',
'祔':'1',
'祜':'1',
'祢':'1',
'祛':'1',
'神':'1',
'祏':'1',
'祐':'1',
'祗':'1',
'祝':'1',
'祖':'1',
'祚':'1',
'祕':'1',
'祙':'1',
'祒':'1',
'祑':'1',
'拜':'1',
'段':'1',
'殶':'1',
'瓴':'1',
'瓳':'1',
'瓵':'1',
'珌':'1',
'玻':'1',
'玳':'1',
'玷':'1',
'珐':'1',
'珈':'1',
'珏':'1',
'珂':'1',
'玲':'1',
'珑':'1',
'珉':'1',
'珀':'1',
'珊':'1',
'珅':'1',
'珍':'1',
'珎':'1',
'玵':'1',
'玸':'1',
'玽':'1',
'玾':'1',
'珇':'1',
'珋':'1',
'玶':'1',
'珃':'1',
'玿':'1',
'珄':'1',
'珆':'1',
'玹':'1',
'玴':'1',
'韨':'1',
'爼':'1',
'胈':'1',
'胞':'1',
'胆':'1',
'胨':'1',
'朏':'1',
'胍':'1',
'胡':'1',
'胛':'1',
'胫':'1',
'胩':'1',
'胧':'1',
'胪':'1',
'脉':'1',
'胖':'1',
'胚':'1',
'胠':'1',
'朐':'1',
'胂':'1',
'胜':'1',
'胎':'1',
'胗':'1',
'胝':'1',
'胙':'1',
'胇':'1',
'胉':'1',
'胣':'1',
'胊':'1',
'胅':'1',
'胐':'1',
'胕':'1',
'胢':'1',
'朎':'1',
'胟':'1',
'胒':'1',
'胓':'1',
'胑':'1',
'胋':'1',
'胘':'1',
'胦':'1',
'攱':'1',
'皈':'1',
'皅':'1',
'秕':'1',
'种':'1',
'秬':'1',
'科':'1',
'秒':'1',
'秋':'1',
'秭':'1',
'秗':'1',
'秔':'1',
'秖':'1',
'秌':'1',
'秏':'1',
'秐':'1',
'秓':'1',
'钯':'1',
'钣':'1',
'钡':'1',
'钚':'1',
'钞':'1',
'钭':'1',
'钝':'1',
'钫':'1',
'钙':'1',
'钢':'1',
'钩':'1',
'钬':'1',
'钜':'1',
'钧':'1',
'钪':'1',
'钠':'1',
'钮':'1',
'钤':'1',
'钦':'1',
'钛':'1',
'钨':'1',
'钘':'1',
'钥':'1',
'钟':'1',
'竐':'1',
'竓':'1',
'竗':'1',
'竔':'1',
'竑':'1',
'矜':'1',
'眈':'1',
'盹':'1',
'眍':'1',
'眊':'1',
'眄':'1',
'眇':'1',
'盼':'1',
'盻':'1',
'相':'1',
'眨':'1',
'眆':'1',
'盽':'1',
'眃':'1',
'盷':'1',
'盿':'1',
'眀':'1',
'眅':'1',
'眂':'1',
'盺':'1',
'盶':'1',
'鸨':'1',
'鸧':'1',
'鸥':'1',
'鸦':'1',
'鸩':'1',
'甠':'1',
'砭':'1',
'砗':'1',
'砘':'1',
'砜':'1',
'砆':'1',
'砄':'1',
'砍':'1',
'砒':'1',
'砌':'1',
'砂':'1',
'砑':'1',
'研':'1',
'砚':'1',
'砖':'1',
'砏':'1',
'砃':'1',
'砈':'1',
'砎':'1',
'砛':'1',
'砊':'1',
'砅':'1',
'砇':'1',
'砕':'1',
'砙':'1',
'砓':'1',
'砋':'1',
'矩':'1',
'矧':'1',
'矨':'1',
'畈':'1',
'畎':'1',
'畋':'1',
'畑':'1',
'畇':'1',
'畊':'1',
'畉':'1',
'畍':'1',
'畆':'1',
'畒':'1',
'玅':'1',
'袄':'1',
'衭':'1',
'袆':'1',
'衿':'1',
'袂':'1',
'衲':'1',
'衽':'1',
'衴':'1',
'衸':'1',
'袀':'1',
'衹':'1',
'衻':'1',
'袇':'1',
'衵':'1',
'衼':'1',
'衳':'1',
'衶':'1',
'虼':'1',
'虾':'1',
'虹':'1',
'蚂':'1',
'虻':'1',
'蚀':'1',
'蚁':'1',
'虸':'1',
'虵':'1',
'虶':'1',
'虷':'1',
'虳':'1',
'虴':'1',
'耏':'1',
'耐':'1',
'缸':'1',
'耔':'1',
'籹':'1',
'籼':'1',
'籽':'1',
'籸':'1',
'籿':'1',
'籺':'1',
'籾':'1',
'粁':'1',
'粀':'1',
'籷':'1',
'紃':'1',
'紆':'1',
'紅':'1',
'紂':'1',
'紇':'1',
'紈':'1',
'約':'1',
'級':'1',
'紀':'1',
'紉':'1',
'紁':'1',
'羾':'1',
'舡':'1',
'舢':'1',
'舣':'1',
'舤':'1',
'軌':'1',
'覌':'1',
'觔':'1',
'觓':'1',
'計':'1',
'訂':'1',
'訃':'1',
'訆':'1',
'訅':'1',
'铋':'1',
'钵':'1',
'钹':'1',
'铂':'1',
'钸':'1',
'钿':'1',
'铎':'1',
'钴':'1',
'钾':'1',
'钶':'1',
'铃':'1',
'铆':'1',
'钼':'1',
'铌':'1',
'铍':'1',
'钷':'1',
'铅':'1',
'钱':'1',
'钳':'1',
'铈':'1',
'铄':'1',
'铊':'1',
'钽':'1',
'铁':'1',
'铉':'1',
'铀':'1',
'钰':'1',
'钺':'1',
'钲':'1',
'钻':'1',
'铇':'1',
'站':'1',
'竚':'1',
'竝':'1',
'竘':'1',
'竛':'1',
'矝':'1',
'眧':'1',
'眩':'1',
'眬':'1',
'眛':'1',
'眠':'1',
'眜':'1',
'眙':'1',
'眎':'1',
'眡':'1',
'眑':'1',
'眪':'1',
'眣':'1',
'眓':'1',
'眗':'1',
'眖':'1',
'眫':'1',
'眿':'1',
'眤':'1',
'眒':'1',
'眏':'1',
'眕':'1',
'眐':'1',
'眝':'1',
'鸱':'1',
'鸫':'1',
'鸪':'1',
'鸰':'1',
'鸬':'1',
'鸲':'1',
'鸵':'1',
'鸮':'1',
'鸭':'1',
'皱':'1',
'皰':'1',
'甡':'1',
'砹':'1',
'砵':'1',
'础':'1',
'砥':'1',
'砝':'1',
'砩':'1',
'砢':'1',
'硁':'1',
'砬':'1',
'砺':'1',
'砾':'1',
'砰':'1',
'砯':'1',
'破':'1',
'砷':'1',
'砼':'1',
'砣':'1',
'砸':'1',
'砟':'1',
'砧':'1',
'砫':'1',
'砤':'1',
'砲':'1',
'砨':'1',
'砠':'1',
'砿':'1',
'砳':'1',
'砱':'1',
'砞':'1',
'砪':'1',
'砶':'1',
'砽':'1',
'砡':'1',
'祘':'1',
'畔':'1',
'畖':'1',
'畛':'1',
'畝':'1',
'畘':'1',
'玆':'1',
'被':'1',
'袯':'1',
'袢':'1',
'袜':'1',
'袍':'1',
'袪':'1',
'袒':'1',
'袖':'1',
'袗':'1',
'袟':'1',
'袊':'1',
'袐':'1',
'袚':'1',
'袩':'1',
'袛':'1',
'袝':'1',
'袧':'1',
'袔':'1',
'袓':'1',
'袦':'1',
'袮':'1',
'袙':'1',
'袡':'1',
'袑':'1',
'袉':'1',
'袘':'1',
'袥':'1',
'袨':'1',
'袕':'1',
'袎':'1',
'袣':'1',
'袏':'1',
'蚌':'1',
'蚪':'1',
'蚨':'1',
'蚣':'1',
'蚝':'1',
'蚧':'1',
'蚍':'1',
'蚋':'1',
'蚊':'1',
'蚬':'1',
'蚜':'1',
'蚓':'1',
'蚛':'1',
'蚄':'1',
'蚈':'1',
'蚦':'1',
'蚟':'1',
'蚏':'1',
'蚑':'1',
'蚘':'1',
'蚆':'1',
'蚇':'1',
'蚅':'1',
'蚥':'1',
'蚢':'1',
'蚷':'1',
'蚗':'1',
'蚐':'1',
'蚞':'1',
'蚔':'1',
'蚚':'1',
'蚙':'1',
'蚒':'1',
'蚖':'1',
'蚎':'1',
'耻':'1',
'耽':'1',
'耿':'1',
'耼':'1',
'耾':'1',
'耹':'1',
'耺':'1',
'聀':'1',
'缻':'1',
'缺':'1',
'缼':'1',
'虓':'1',
'耙':'1',
'耖':'1',
'耕':'1',
'耗':'1',
'耘':'1',
'耟':'1',
'粑':'1',
'粔':'1',
'粃':'1',
'粇':'1',
'粄':'1',
'粆':'1',
'粋':'1',
'粐':'1',
'粎':'1',
'粈':'1',
'粏':'1',
'粅':'1',
'粌':'1',
'粍':'1',
'艳':'1',
'舐':'1',
'紞':'1',
'紟':'1',
'紕':'1',
'紜':'1',
'純':'1',
'紘':'1',
'納':'1',
'紗':'1',
'紝':'1',
'紙':'1',
'紋':'1',
'紡':'1',
'紐':'1',
'紖':'1',
'紦':'1',
'紣':'1',
'紑':'1',
'紒':'1',
'紤':'1',
'紌':'1',
'紓':'1',
'紏':'1',
'紎':'1',
'翀':'1',
'翃':'1',
'翄':'1',
'肂':'1',
'致':'1',
'般':'1',
'舨':'1',
'舭':'1',
'舱':'1',
'舫':'1',
'航':'1',
'舰':'1',
'舯':'1',
'舩':'1',
'舧':'1',
'舮':'1',
'舥':'1',
'舦':'1',
'貤':'1',
'財':'1',
'镹':'1',
'軏':'1',
'軒':'1',
'軑':'1',
'軔':'1',
'軓':'1',
'軕':'1',
'軐':'1',
'豇':'1',
'谸':'1',
'觙':'1',
'躬':'1',
'訏':'1',
'訑':'1',
'訐':'1',
'訌':'1',
'討':'1',
'訊':'1',
'訕':'1',
'訖':'1',
'託':'1',
'訓':'1',
'記':'1',
'訒':'1',
'訍':'1',
'訋':'1',
'訉':'1',
'訯':'1',
'訙':'1',
'酐':'1',
'酒':'1',
'配':'1',
'酏':'1',
'酎':'1',
'酌':'1',
'酑':'1',
'豹':'1',
'豺':'1',
'豻':'1',
'起':'1',
'趵':'1',
'趿':'1',
'趷':'1',
'趶':'1',
'龀':'1',
'釗':'1',
'針':'1',
'釘':'1',
'釙':'1',
'釕':'1',
'釛':'1',
'釟':'1',
'釖':'1',
'釠':'1',
'釢':'1',
'釚':'1',
'釞':'1',
'閄':'1',
'飣':'1',
'飤':'1',
'飢':'1',
'鱽':'1',
'难':'1',
'髟':'1',
'鬥':'1',
'颀':'1',
'顾':'1',
'顽':'1',
'颁':'1',
'顿':'1',
'颃':'1',
'预':'1',
'顼':'1',
'颂':'1',
'衄':'1',
'羖':'1',
'衃':'1',
'羓':'1',
'﨏':'1',
'浬':'1',
'涜':'1',
'烪':'1',
'粉':'1',
'紛':'1',
'羒':'1',
'羘':'1',
'翂':'1',
'聁':'1',
'蚡':'1',
'峬':'1',
'峨':'1',
'峰':'1',
'峻':'1',
'崃':'1',
'崂':'1',
'峱':'1',
'峭':'1',
'峪':'1',
'峽':'1',
'峴':'1',
'峼':'1',
'峺':'1',
'崅':'1',
'峮':'1',
'峵':'1',
'峿':'1',
'崄':'1',
'彨':'1',
'屔':'1',
'饽':'1',
'饾':'1',
'饿':'1',
'馂':'1',
'馁':'1',
'馀':'1',
'挨':'1',
'捌':'1',
'捕':'1',
'挫':'1',
'捣':'1',
'捍':'1',
'换':'1',
'捡':'1',
'捄':'1',
'挶':'1',
'捐':'1',
'捃':'1',
'捆':'1',
'捞':'1',
'捋':'1',
'捏':'1',
'挼':'1',
'捎':'1',
'损':'1',
'捅':'1',
'捝':'1',
'挽':'1',
'捂':'1',
'挹':'1',
'振':'1',
'捉':'1',
'捘':'1',
'挵':'1',
'挾':'1',
'挱':'1',
'挮':'1',
'捠':'1',
'挬':'1',
'捗':'1',
'挿':'1',
'捈':'1',
'挰':'1',
'捇':'1',
'捀':'1',
'捊':'1',
'挭':'1',
'揤':'1',
'挸':'1',
'捁':'1',
'捔':'1',
'挳':'1',
'挴':'1',
'捒':'1',
'挩':'1',
'捜':'1',
'捖':'1',
'捤':'1',
'捙':'1',
'捑':'1',
'捚':'1',
'浜':'1',
'浡':'1',
'涔':'1',
'涌':'1',
'涤':'1',
'涐':'1',
'浮':'1',
'涡':'1',
'海':'1',
'浛':'1',
'浩':'1',
'涣':'1',
'浣':'1',
'涧':'1',
'浸':'1',
'涓':'1',
'浚':'1',
'涞':'1',
'浪':'1',
'涝':'1',
'涖':'1',
'涟':'1',
'流':'1',
'浼':'1',
'涊':'1',
'涅':'1',
'浦':'1',
'润':'1',
'涩':'1',
'涉':'1',
'涘':'1',
'涑':'1',
'涛':'1',
'涕':'1',
'涂':'1',
'涠':'1',
'浯':'1',
'浠':'1',
'消':'1',
'浥':'1',
'浴':'1',
'涢':'1',
'浞':'1',
'浹':'1',
'涇':'1',
'浧':'1',
'浾':'1',
'浺':'1',
'浱':'1',
'浟':'1',
'浢':'1',
'淓':'1',
'浲':'1',
'浭':'1',
'浫':'1',
'涆':'1',
'涥':'1',
'浤':'1',
'涀':'1',
'浻':'1',
'涃':'1',
'浨':'1',
'浶':'1',
'涙':'1',
'浰':'1',
'浖':'1',
'涁':'1',
'浝':'1',
'浽':'1',
'浿':'1',
'涄':'1',
'浗':'1',
'涗':'1',
'涚':'1',
'洍':'1',
'浵':'1',
'涋':'1',
'涒':'1',
'浘':'1',
'洖':'1',
'涍':'1',
'浳':'1',
'淽':'1',
'绠':'1',
'继':'1',
'绢':'1',
'绥':'1',
'绦':'1',
'绨':'1',
'绤':'1',
'绡':'1',
'绣':'1',
'巸':'1',
'埃':'1',
'埔':'1',
'埕':'1',
'埂':'1',
'埚':'1',
'垾':'1',
'埌':'1',
'埒':'1',
'埋':'1',
'埆':'1',
'埘':'1',
'垿':'1',
'埙':'1',
'垸':'1',
'垻':'1',
'埄':'1',
'埗':'1',
'垺':'1',
'埖':'1',
'埉':'1',
'埐':'1',
'埛':'1',
'埍':'1',
'埈':'1',
'埓':'1',
'埁':'1',
'垷':'1',
'垶':'1',
'埇':'1',
'悖':'1',
'悍':'1',
'悎':'1',
'悔':'1',
'悁':'1',
'悝':'1',
'悃':'1',
'悢':'1',
'悯':'1',
'悂':'1',
'悭':'1',
'悄':'1',
'悛':'1',
'悚':'1',
'悌':'1',
'悟':'1',
'悮':'1',
'悒':'1',
'悦':'1',
'悕':'1',
'悑':'1',
'悜':'1',
'悙':'1',
'悈':'1',
'悧':'1',
'悋':'1',
'悗':'1',
'悩':'1',
'悓':'1',
'悏':'1',
'悇':'1',
'悞':'1',
'悀':'1',
'悅':'1',
'孫':'1',
'孭':'1',
'赅':'1',
'贿':'1',
'赆':'1',
'赂':'1',
'赃':'1',
'贼':'1',
'凋':'1',
'凉':'1',
'凌':'1',
'凄':'1',
'凇':'1',
'准':'1',
'凍':'1',
'凈':'1',
'凎':'1',
'凅':'1',
'凊':'1',
'剙':'1',
'剥':'1',
'剒':'1',
'剟':'1',
'剕':'1',
'剞':'1',
'剧':'1',
'剖':'1',
'剡':'1',
'剔':'1',
'剜':'1',
'剚':'1',
'剗':'1',
'剛':'1',
'剮':'1',
'剠':'1',
'剝':'1',
'剢':'1',
'剤':'1',
'剣':'1',
'剘':'1',
'剦':'1',
'部':'1',
'郴':'1',
'陲':'1',
'郸':'1',
'都':'1',
'郭':'1',
'陵':'1',
'陪':'1',
'郫':'1',
'陴':'1',
'郪':'1',
'郯':'1',
'陶':'1',
'陷':'1',
'陬':'1',
'陸':'1',
'陳':'1',
'陰':'1',
'郰':'1',
'郵':'1',
'郳':'1',
'郩':'1',
'陼':'1',
'陮':'1',
'陫':'1',
'陚':'1',
'陱':'1',
'郲':'1',
'陯':'1',
'郬':'1',
'鄀':'1',
'陹':'1',
'険':'1',
'陭':'1',
'郮':'1',
'勐':'1',
'勍':'1',
'勑':'1',
'勌':'1',
'務':'1',
'勏':'1',
'勎':'1',
'倝':'1',
'俺':'1',
'倍':'1',
'倴':'1',
'俾':'1',
'俵':'1',
'倡':'1',
'倘':'1',
'俶':'1',
'倅':'1',
'倒':'1',
'俸':'1',
'俯':'1',
'倌':'1',
'候':'1',
'健':'1',
'倢':'1',
'借':'1',
'倞':'1',
'俱':'1',
'倨':'1',
'倦':'1',
'倔':'1',
'倥':'1',
'倮':'1',
'倷':'1',
'倪':'1',
'俳':'1',
'倩':'1',
'倾':'1',
'偌':'1',
'倏':'1',
'倜':'1',
'倭':'1',
'倖':'1',
'倚':'1',
'债':'1',
'值':'1',
'倬':'1',
'倳':'1',
'倀':'1',
'倆':'1',
'倈':'1',
'個':'1',
'俽':'1',
'倫':'1',
'倸':'1',
'俻':'1',
'俲':'1',
'倣':'1',
'們':'1',
'倂':'1',
'偖':'1',
'俿':'1',
'倕':'1',
'倓':'1',
'倲':'1',
'俷':'1',
'倱':'1',
'俰':'1',
'俴':'1',
'倹':'1',
'倃':'1',
'倶':'1',
'倰':'1',
'倗':'1',
'倛':'1',
'倿':'1',
'倽':'1',
'倐':'1',
'倯':'1',
'倠':'1',
'倎':'1',
'倇':'1',
'倵':'1',
'俹':'1',
'倄':'1',
'偀':'1',
'俼':'1',
'倁':'1',
'値':'1',
'倊':'1',
'倧':'1',
'谄':'1',
'调':'1',
'读':'1',
'诽':'1',
'课':'1',
'谅':'1',
'诺':'1',
'请':'1',
'谁':'1',
'谂':'1',
'谉':'1',
'谇':'1',
'诿':'1',
'谊':'1',
'谀':'1',
'诸':'1',
'谆':'1',
'诼':'1',
'诹':'1',
'谈':'1',
'叞':'1',
'徕':'1',
'徒':'1',
'徐':'1',
'徑':'1',
'徎':'1',
'従':'1',
'徏':'1',
'射':'1',
'弱':'1',
'弳':'1',
'弰':'1',
'弲':'1',
'弬':'1',
'帱':'1',
'帩':'1',
'帨':'1',
'師':'1',
'帰':'1',
'帪':'1',
'唉':'1',
'哱':'1',
'哺':'1',
'唓':'1',
'哧':'1',
'唗':'1',
'哦':'1',
'哽':'1',
'唝':'1',
'唅':'1',
'哼':'1',
'唤':'1',
'唧':'1',
'唠':'1',
'哩':'1',
'哢':'1',
'唛':'1',
'唦':'1',
'哨':'1',
'唆':'1',
'唢':'1',
'唔':'1',
'唏':'1',
'哯':'1',
'哮':'1',
'唁':'1',
'唣':'1',
'哳':'1',
'哶':'1',
'唡':'1',
'唄':'1',
'唑':'1',
'唕':'1',
'唚':'1',
'哵':'1',
'哣':'1',
'唙':'1',
'唖':'1',
'哹':'1',
'唂':'1',
'唃':'1',
'哻':'1',
'哠':'1',
'哬':'1',
'唊':'1',
'哴':'1',
'唥':'1',
'哰':'1',
'唎':'1',
'哷':'1',
'哤':'1',
'唴':'1',
'唒':'1',
'哾':'1',
'哸':'1',
'唞':'1',
'唋':'1',
'唍':'1',
'唈':'1',
'唀':'1',
'唨':'1',
'哫':'1',
'骋':'1',
'骏':'1',
'骊':'1',
'骎':'1',
'骍':'1',
'验':'1',
'娭':'1',
'娖':'1',
'娣':'1',
'娥':'1',
'姬':'1',
'娟':'1',
'娌':'1',
'娩':'1',
'娘':'1',
'娉':'1',
'娠':'1',
'娲':'1',
'娓':'1',
'娴':'1',
'娱':'1',
'娝':'1',
'娕':'1',
'娊':'1',
'娐':'1',
'娢':'1',
'婲':'1',
'娔':'1',
'娳':'1',
'娏':'1',
'娒':'1',
'娚':'1',
'娞':'1',
'娦':'1',
'娋':'1',
'娧':'1',
'娪':'1',
'娨':'1',
'娙':'1',
'娮':'1',
'娛':'1',
'娯':'1',
'娡':'1',
'狷':'1',
'狼':'1',
'狸':'1',
'猁':'1',
'狻':'1',
'猃':'1',
'狺':'1',
'狳':'1',
'狾':'1',
'狹':'1',
'狽':'1',
'猂':'1',
'狶':'1',
'狵':'1',
'猐':'1',
'猀':'1',
'轿':'1',
'较':'1',
'辂':'1',
'辁':'1',
'轼':'1',
'轾':'1',
'辀':'1',
'珲':'1',
'殊':'1',
'殉':'1',
'殈':'1',
'料':'1',
'旅':'1',
'旄':'1',
'旆':'1',
'旂':'1',
'旃':'1',
'旊':'1',
'戙':'1',
'烦':'1',
'烘':'1',
'烩':'1',
'烬':'1',
'烤':'1',
'烙':'1',
'烧':'1',
'烜':'1',
'烟':'1',
'烊':'1',
'烨':'1',
'烛':'1',
'烔':'1',
'烠':'1',
'烢':'1',
'烥':'1',
'烆':'1',
'烣':'1',
'烄':'1',
'烗':'1',
'焒':'1',
'烞':'1',
'烇':'1',
'烻':'1',
'烒':'1',
'烶':'1',
'烓':'1',
'烚':'1',
'烍':'1',
'烌':'1',
'烅':'1',
'烑':'1',
'烐':'1',
'烵':'1',
'觊':'1',
'毦':'1',
'桉':'1',
'梆':'1',
'栟':'1',
'档':'1',
'栭':'1',
'格':'1',
'根':'1',
'栱':'1',
'栝':'1',
'桄':'1',
'桂':'1',
'桧':'1',
'桁':'1',
'核':'1',
'桦':'1',
'桓':'1',
'校':'1',
'桔':'1',
'桕':'1',
'栲':'1',
'框':'1',
'栳':'1',
'栖':'1',
'桤':'1',
'桥':'1',
'桡':'1',
'栓':'1',
'桃':'1',
'梃':'1',
'桐':'1',
'桅':'1',
'栩':'1',
'栒':'1',
'桠':'1',
'样':'1',
'栘':'1',
'桢':'1',
'桎':'1',
'株':'1',
'桩':'1',
'條':'1',
'栢':'1',
'栧':'1',
'栰':'1',
'栤':'1',
'梴':'1',
'棦':'1',
'栦':'1',
'桘':'1',
'栜':'1',
'栨':'1',
'桗':'1',
'栮':'1',
'栫':'1',
'桝':'1',
'桍':'1',
'栛':'1',
'栵':'1',
'梠':'1',
'桙':'1',
'梛':'1',
'栣':'1',
'栻':'1',
'桋':'1',
'桛':'1',
'栙':'1',
'桖':'1',
'桪':'1',
'栺':'1',
'栶':'1',
'桜':'1',
'柡':'1',
'栯':'1',
'桚':'1',
'栴':'1',
'桟':'1',
'栕':'1',
'栚':'1',
'栬':'1',
'牷':'1',
'特':'1',
'牺':'1',
'牸':'1',
'牂':'1',
'敊':'1',
'敆':'1',
'敖':'1',
'敌':'1',
'敉':'1',
'效':'1',
'敇':'1',
'敋':'1',
'欱':'1',
'欬':'1',
'欮':'1',
'欯':'1',
'欴':'1',
'欫':'1',
'欰':'1',
'欭':'1',
'晖':'1',
'晒':'1',
'晌':'1',
'晓':'1',
'晅':'1',
'晔':'1',
'時':'1',
'晐':'1',
'晎':'1',
'晄':'1',
'晈':'1',
'晇':'1',
'晆':'1',
'晠':'1',
'晀':'1',
'晍':'1',
'晊':'1',
'祧':'1',
'祫':'1',
'祥':'1',
'祯':'1',
'祮':'1',
'祪':'1',
'祣':'1',
'祤':'1',
'祬':'1',
'祩':'1',
'殷':'1',
'殺':'1',
'瓶':'1',
'琤':'1',
'玼':'1',
'珰':'1',
'珥':'1',
'珙':'1',
'珩':'1',
'珞':'1',
'珽':'1',
'珣':'1',
'珧':'1',
'珠':'1',
'珪':'1',
'琊':'1',
'珮':'1',
'珤':'1',
'珹':'1',
'珫':'1',
'珖':'1',
'珔':'1',
'珓':'1',
'珒':'1',
'珢':'1',
'珯':'1',
'珕':'1',
'珟':'1',
'珨':'1',
'珗':'1',
'珦':'1',
'珛':'1',
'珝':'1',
'珬':'1',
'珚':'1',
'珜':'1',
'珱':'1',
'珘':'1',
'恥':'1',
'胺':'1',
'胵':'1',
'脆':'1',
'胴':'1',
'胹':'1',
'胳':'1',
'胱':'1',
'胲':'1',
'胻':'1',
'胶':'1',
'胯':'1',
'脍':'1',
'朗':'1',
'脒':'1',
'脑':'1',
'能':'1',
'脓':'1',
'朒':'1',
'胼':'1',
'脐':'1',
'脎':'1',
'朔':'1',
'朓':'1',
'脡':'1',
'胸':'1',
'脩':'1',
'胭':'1',
'胰':'1',
'脏':'1',
'朕':'1',
'脂':'1',
'脇':'1',
'脈':'1',
'脃':'1',
'脠':'1',
'胿':'1',
'脄':'1',
'脌':'1',
'胮':'1',
'脁':'1',
'歭':'1',
'皊':'1',
'皌':'1',
'瓞':'1',
'秘':'1',
'称':'1',
'秤':'1',
'积':'1',
'秣':'1',
'秫':'1',
'秧':'1',
'秩':'1',
'租':'1',
'秚':'1',
'秡':'1',
'秮':'1',
'秙':'1',
'秝':'1',
'秢':'1',
'秜':'1',
'秥':'1',
'秛':'1',
'秠':'1',
'秞':'1',
'秪':'1',
'秨':'1',
'辅':'1',
'辆':'1',
'殓':'1',
'殍':'1',
'殑':'1',
'殒':'1',
'殌':'1',
'殎':'1',
'殏':'1',
'殐':'1',
'斛':'1',
'斜':'1',
'旌':'1',
'旎':'1',
'旋':'1',
'族':'1',
'旇':'1',
'旍':'1',
'旈':'1',
'戝':'1',
'烽':'1',
'焓':'1',
'焊':'1',
'焕':'1',
'焗':'1',
'焌':'1',
'烺':'1',
'焖':'1',
'烷':'1',
'焐':'1',
'烯':'1',
'烴':'1',
'烱':'1',
'焅':'1',
'焍':'1',
'烰':'1',
'烸':'1',
'焃':'1',
'焀':'1',
'焆':'1',
'烳':'1',
'烿':'1',
'焫':'1',
'焇':'1',
'烼':'1',
'焔':'1',
'旣':'1',
'觋':'1',
'現':'1',
'断':'1',
'斬':'1',
'毭':'1',
'桮':'1',
'梐':'1',
'梣':'1',
'桴':'1',
'梗':'1',
'梏':'1',
'检':'1',
'梮':'1',
'桷':'1',
'梱':'1',
'梾':'1',
'桹':'1',
'梿':'1',
'棂':'1',
'梅':'1',
'桲':'1',
'梫':'1',
'桵':'1',
'梢':'1',
'梳':'1',
'桫':'1',
'梭':'1',
'梼':'1',
'梯':'1',
'桯':'1',
'桶':'1',
'梧':'1',
'械':'1',
'梽':'1',
'棁':'1',
'梓':'1',
'桺':'1',
'梘':'1',
'梩':'1',
'桿':'1',
'梔':'1',
'梎':'1',
'梖':'1',
'桳':'1',
'梹':'1',
'梌':'1',
'桭':'1',
'梑':'1',
'梪':'1',
'桻':'1',
'梻':'1',
'梒':'1',
'椛':'1',
'梙':'1',
'梡':'1',
'梞':'1',
'楖':'1',
'梜':'1',
'桱':'1',
'梋':'1',
'桾':'1',
'桰':'1',
'梸':'1',
'梇':'1',
'梈':'1',
'梂':'1',
'梕':'1',
'梀':'1',
'梚':'1',
'梶':'1',
'桸':'1',
'梬':'1',
'梄':'1',
'梍':'1',
'梉':'1',
'梲':'1',
'牿':'1',
'牼':'1',
'牻':'1',
'牾':'1',
'敍':'1',
'敝':'1',
'敕':'1',
'敚':'1',
'敢':'1',
'教':'1',
'救':'1',
'敛':'1',
'敏':'1',
'敔':'1',
'敗':'1',
'敐':'1',
'敓':'1',
'敎':'1',
'敘':'1',
'敒':'1',
'欸':'1',
'欷':'1',
'欲':'1',
'欵':'1',
'欳':'1',
'欶':'1',
'晡':'1',
'晗':'1',
'晧':'1',
'晦':'1',
'晚':'1',
'晤':'1',
'晞':'1',
'晛':'1',
'晣':'1',
'晘':'1',
'晥':'1',
'晙':'1',
'祷':'1',
'祸':'1',
'祲':'1',
'祶':'1',
'祴':'1',
'祰':'1',
'祵':'1',
'祱':'1',
'祳':'1',
'祦':'1',
'殻':'1',
'殸':'1',
'殹':'1',
'瓻':'1',
'瓺':'1',
'瓹':'1',
'琀':'1',
'琎':'1',
'珺':'1',
'琅':'1',
'理':'1',
'琏':'1',
'琉':'1',
'球':'1',
'琐':'1',
'琇':'1',
'琍':'1',
'珼':'1',
'珵':'1',
'珿':'1',
'珶':'1',
'珴':'1',
'琒':'1',
'琈':'1',
'琌':'1',
'珻':'1',
'琷':'1',
'琁':'1',
'琑':'1',
'琓':'1',
'珳':'1',
'珸':'1',
'琋':'1',
'琄':'1',
'琂':'1',
'斏':'1',
'脖':'1',
'脭':'1',
'脞':'1',
'脰':'1',
'脯':'1',
'脝':'1',
'朘':'1',
'脸':'1',
'脶':'1',
'脢':'1',
'脲':'1',
'脬':'1',
'脤':'1',
'脦':'1',
'脱':'1',
'脘':'1',
'脧':'1',
'脛':'1',
'脗':'1',
'朙':'1',
'脪':'1',
'脨':'1',
'脵':'1',
'脥':'1',
'朖':'1',
'脷':'1',
'脳':'1',
'脮':'1',
'脴':'1',
'脫':'1',
'脕':'1',
'脙':'1',
'脜':'1',
'皑':'1',
'皎':'1',
'皉':'1',
'皏':'1',
'甜':'1',
'甛':'1',
'瓠':'1',
'秽':'1',
'秸':'1',
'稆':'1',
'秾':'1',
'移':'1',
'秺':'1',
'秴':'1',
'秳':'1',
'秹':'1',
'秲':'1',
'秱':'1',
'秵':'1',
'秷':'1',
'秼':'1',
'崞':'1',
'崌':'1',
'崛':'1',
'崆':'1',
'崚':'1',
'崎':'1',
'崤':'1',
'崦':'1',
'崕':'1',
'崍':'1',
'崐':'1',
'崯':'1',
'崘':'1',
'崪':'1',
'崥':'1',
'崠':'1',
'崜':'1',
'崓':'1',
'崡':'1',
'崨':'1',
'崊':'1',
'崏':'1',
'崉':'1',
'崝':'1',
'崢':'1',
'崰':'1',
'彩':'1',
'彫':'1',
'馆':'1',
'馃':'1',
'馄':'1',
'馅':'1',
'捭':'1',
'掺':'1',
'捶':'1',
'措':'1',
'掸':'1',
'捯':'1',
'掂':'1',
'掉':'1',
'掇':'1',
'掆':'1',
'掼':'1',
'掴':'1',
'掎':'1',
'接':'1',
'捷':'1',
'掬':'1',
'据':'1',
'掘':'1',
'掯':'1',
'控':'1',
'捩':'1',
'掳':'1',
'掠':'1',
'描':'1',
'捺':'1',
'捻':'1',
'掿':'1',
'排':'1',
'捧':'1',
'掊':'1',
'掐':'1',
'掮':'1',
'掞':'1',
'授':'1',
'探':'1',
'掏':'1',
'掭':'1',
'推':'1',
'掩':'1',
'掖':'1',
'捴':'1',
'捽':'1',
'掛':'1',
'掗':'1',
'捱':'1',
'捵':'1',
'採':'1',
'捨':'1',
'掄':'1',
'捲':'1',
'掽':'1',
'捫':'1',
'掃':'1',
'捹':'1',
'掤':'1',
'捬':'1',
'掁':'1',
'掫':'1',
'掋':'1',
'掟':'1',
'掶':'1',
'掍':'1',
'掝':'1',
'揵':'1',
'掲':'1',
'掚':'1',
'掕':'1',
'捰':'1',
'掹':'1',
'捪':'1',
'掵':'1',
'掜':'1',
'捿':'1',
'掑':'1',
'捦':'1',
'掅':'1',
'捼':'1',
'掻':'1',
'掓':'1',
'掦':'1',
'捸':'1',
'捥':'1',
'捾':'1',
'捳':'1',
'掙':'1',
'湴':'1',
'淳':'1',
'淙':'1',
'淬':'1',
'淡':'1',
'淀':'1',
'渎':'1',
'淝':'1',
'涪':'1',
'淦':'1',
'涫':'1',
'涵':'1',
'淏':'1',
'涸':'1',
'淴':'1',
'淮':'1',
'混':'1',
'淩':'1',
'渌':'1',
'渑':'1',
'淖':'1',
'淠':'1',
'淇':'1',
'清':'1',
'深':'1',
'渗':'1',
'淌':'1',
'淘':'1',
'添':'1',
'淟':'1',
'涴':'1',
'淆':'1',
'涯':'1',
'淹':'1',
'液':'1',
'淫':'1',
'渔':'1',
'淯':'1',
'渊':'1',
'渚':'1',
'涿':'1',
'淄':'1',
'渍':'1',
'淚':'1',
'淶':'1',
'淒':'1',
'淺':'1',
'渦':'1',
'淪':'1',
'淛':'1',
'淊':'1',
'涼':'1',
'済':'1',
'渀':'1',
'淲':'1',
'淿':'1',
'淐':'1',
'淨':'1',
'淔':'1',
'涰':'1',
'淂':'1',
'淍':'1',
'渉':'1',
'涷':'1',
'渄':'1',
'淈':'1',
'淉':'1',
'渇':'1',
'渮':'1',
'涽':'1',
'淁':'1',
'湕':'1',
'涺':'1',
'淗':'1',
'淃':'1',
'涳':'1',
'淕':'1',
'淥':'1',
'渵':'1',
'淧':'1',
'渂':'1',
'淰':'1',
'淣':'1',
'淎':'1',
'淜':'1',
'渒':'1',
'渏':'1',
'淸':'1',
'淭':'1',
'渃':'1',
'渋':'1',
'涻':'1',
'渖':'1',
'涭':'1',
'涾':'1',
'涶':'1',
'涹':'1',
'渓':'1',
'涬':'1',
'淢':'1',
'渶':'1',
'渁':'1',
'渆':'1',
'涱':'1',
'绷':'1',
'绰':'1',
'绸':'1',
'绯':'1',
'绲':'1',
'绩':'1',
'绫':'1',
'绺':'1',
'绿':'1',
'绵':'1',
'绮':'1',
'绻':'1',
'绱':'1',
'绳':'1',
'绶':'1',
'绾':'1',
'维':'1',
'绪':'1',
'续':'1',
'综':'1',
'绽':'1',
'缀':'1',
'缁':'1',
'绹':'1',
'缍':'1',
'绬':'1',
'埯':'1',
'埠':'1',
'埭':'1',
'堵':'1',
'堆':'1',
'埵':'1',
'堌':'1',
'堀':'1',
'堎':'1',
'埨':'1',
'堄':'1',
'埝':'1',
'培':'1',
'堋':'1',
'埤':'1',
'埽':'1',
'堍':'1',
'埸':'1',
'域':'1',
'堉':'1',
'埴':'1',
'埻':'1',
'埡':'1',
'埼':'1',
'堝':'1',
'埰':'1',
'埳':'1',
'執':'1',
'堓':'1',
'埲':'1',
'埫':'1',
'埱':'1',
'埞':'1',
'埬':'1',
'堈':'1',
'埧':'1',
'埢':'1',
'堁':'1',
'埪':'1',
'堒':'1',
'埥':'1',
'堔':'1',
'埶':'1',
'埣':'1',
'埮':'1',
'埦':'1',
'堐':'1',
'够':'1',
'夠':'1',
'惨':'1',
'惝':'1',
'惆':'1',
'惙':'1',
'悰':'1',
'悴':'1',
'惮':'1',
'悼':'1',
'惦':'1',
'惇':'1',
'悱':'1',
'惯':'1',
'惚':'1',
'惛':'1',
'悸':'1',
'惊':'1',
'惧':'1',
'悾':'1',
'悽':'1',
'惬':'1',
'情':'1',
'惓':'1',
'惕':'1',
'惋':'1',
'惘':'1',
'惟':'1',
'惜':'1',
'悻':'1',
'悵':'1',
'惏':'1',
'惔':'1',
'悺':'1',
'惃':'1',
'惈':'1',
'惤':'1',
'惍':'1',
'惂':'1',
'悷':'1',
'惀':'1',
'惗':'1',
'惸':'1',
'悿':'1',
'惞':'1',
'惐':'1',
'愥':'1',
'孰':'1',
'孮':'1',
'孲':'1',
'赇':'1',
'赊':'1',
'赈':'1',
'铵':'1',
'铲':'1',
'铛':'1',
'铖':'1',
'铳':'1',
'铞':'1',
'铫':'1',
'铤':'1',
'铥':'1',
'铒':'1',
'铬':'1',
'铪':'1',
'铧':'1',
'铗':'1',
'铰':'1',
'铠':'1',
'铐':'1',
'铑':'1',
'铝':'1',
'铓':'1',
'铭':'1',
'铙':'1',
'铨':'1',
'铷':'1',
'铯':'1',
'铩':'1',
'铴':'1',
'铜':'1',
'铣':'1',
'铦':'1',
'铏':'1',
'铘':'1',
'铱':'1',
'铟':'1',
'银':'1',
'铕':'1',
'铡':'1',
'铮':'1',
'铚':'1',
'铢':'1',
'铔':'1',
'竡':'1',
'竫':'1',
'眵':'1',
'眶':'1',
'眯':'1',
'眽':'1',
'眸':'1',
'眭':'1',
'眺':'1',
'眼':'1',
'睁':'1',
'眦':'1',
'眱':'1',
'眰':'1',
'眳':'1',
'眲':'1',
'眴':'1',
'眮':'1',
'眻':'1',
'眹':'1',
'鸸':'1',
'鸽':'1',
'鸹':'1',
'鸻':'1',
'鸺':'1',
'鸼':'1',
'皲':'1',
'硐':'1',
'硌':'1',
'硅':'1',
'硔':'1',
'硭':'1',
'硇':'1',
'硗':'1',
'硚':'1',
'硕':'1',
'硒':'1',
'硖':'1',
'硃':'1',
'硏':'1',
'硋':'1',
'硛':'1',
'硟':'1',
'碀':'1',
'硆':'1',
'硄':'1',
'硊':'1',
'硍':'1',
'硓':'1',
'硉':'1',
'硑':'1',
'硈':'1',
'硘':'1',
'硂':'1',
'硙':'1',
'矫':'1',
'矪':'1',
'略':'1',
'畦':'1',
'畤':'1',
'畡':'1',
'畩':'1',
'玈':'1',
'裆':'1',
'袱':'1',
'袼':'1',
'袿':'1',
'袺':'1',
'裉':'1',
'袴':'1',
'裈':'1',
'袷':'1',
'裀':'1',
'袾':'1',
'袵':'1',
'袹':'1',
'袳':'1',
'袻':'1',
'袸':'1',
'袶':'1',
'裃':'1',
'袽':'1',
'裇':'1',
'裄':'1',
'蛏':'1',
'蛄':'1',
'蚶':'1',
'蛆':'1',
'蛎':'1',
'蛉':'1',
'蚲':'1',
'蚯':'1',
'蚺':'1',
'蛇':'1',
'蚰':'1',
'蚴':'1',
'蚱':'1',
'蛀':'1',
'蚫':'1',
'蚮':'1',
'蚵':'1',
'蚭':'1',
'蛃':'1',
'蛁':'1',
'蚿':'1',
'蚳':'1',
'蛂':'1',
'蚾':'1',
'蚹':'1',
'蚼':'1',
'蛌':'1',
'蚸':'1',
'蚽':'1',
'蛈':'1',
'蛅':'1',
'聃':'1',
'聊':'1',
'聆':'1',
'聍':'1',
'聉':'1',
'职':'1',
'聅':'1',
'聈':'1',
'聄':'1',
'聇':'1',
'缽':'1',
'耞':'1',
'耜':'1',
'耛':'1',
'耝':'1',
'耚':'1',
'粗':'1',
'粝':'1',
'粒':'1',
'粘':'1',
'粕':'1',
'粣':'1',
'粚':'1',
'粓':'1',
'粖':'1',
'粙':'1',
'艴':'1',
'舑':'1',
'紬':'1',
'絅':'1',
'絁':'1',
'紩':'1',
'紺':'1',
'紲':'1',
'紱':'1',
'組':'1',
'紳':'1',
'細':'1',
'紾':'1',
'終':'1',
'紵':'1',
'絃':'1',
'絆':'1',
'紿':'1',
'紼':'1',
'絀':'1',
'紹':'1',
'紴':'1',
'紨':'1',
'紭':'1',
'経':'1',
'絋':'1',
'紷':'1',
'絈':'1',
'紶':'1',
'絇':'1',
'絉':'1',
'紽':'1',
'紻':'1',
'紸':'1',
'絊':'1',
'翎':'1',
'翈':'1',
'翊':'1',
'翉':'1',
'翍':'1',
'翋':'1',
'翑':'1',
'翐':'1',
'舶':'1',
'船':'1',
'舵':'1',
'舸':'1',
'舲':'1',
'舻':'1',
'舷':'1',
'舴':'1',
'舳':'1',
'舺':'1',
'貶':'1',
'販':'1',
'貥':'1',
'貦':'1',
'釈':'1',
'镺':'1',
'軛':'1',
'軟':'1',
'軙':'1',
'軚':'1',
'軖':'1',
'軠':'1',
'軞':'1',
'軜':'1',
'軝':'1',
'軡':'1',
'軗':'1',
'軘':'1',
'転':'1',
'赧':'1',
'赦':'1',
'赥':'1',
'豉':'1',
'谹':'1',
'谻':'1',
'谺':'1',
'規':'1',
'視':'1',
'覒':'1',
'覑':'1',
'觖':'1',
'觕':'1',
'觘':'1',
'觗':'1',
'野':'1',
'麸':'1',
'躯':'1',
'躭':'1',
'躮':'1',
'豝':'1',
'豜':'1',
'豚':'1',
'豘':'1',
'豛':'1',
'訢':'1',
'詎':'1',
'訝':'1',
'訥':'1',
'訟':'1',
'訩':'1',
'許':'1',
'訛':'1',
'設':'1',
'訪':'1',
'訣':'1',
'訬':'1',
'訦':'1',
'訡':'1',
'訤':'1',
'訠':'1',
'訫':'1',
'訮':'1',
'訞':'1',
'訲':'1',
'訳':'1',
'訧':'1',
'訨':'1',
'訰':'1',
'邫':'1',
'酖':'1',
'酘':'1',
'酕':'1',
'酞':'1',
'酗':'1',
'酝':'1',
'酜':'1',
'酛':'1',
'酙':'1',
'酔':'1',
'豽':'1',
'豼':'1',
'趻':'1',
'趺':'1',
'趼':'1',
'距':'1',
'跂':'1',
'跄':'1',
'跃':'1',
'趾':'1',
'跀':'1',
'跁':'1',
'趽':'1',
'趹':'1',
'龁':'1',
'釱':'1',
'釭':'1',
'釫':'1',
'釷':'1',
'釬':'1',
'釦':'1',
'釺':'1',
'釧':'1',
'釤':'1',
'釣':'1',
'釩':'1',
'釵':'1',
'釹':'1',
'釪':'1',
'釰':'1',
'釼':'1',
'釥':'1',
'釯':'1',
'釮':'1',
'釻':'1',
'鈒':'1',
'釶':'1',
'釲':'1',
'釳':'1',
'釸':'1',
'釴':'1',
'釨':'1',
'飦':'1',
'飥':'1',
'飡':'1',
'鱾':'1',
'隿':'1',
'靪':'1',
'骩':'1',
'頂':'1',
'頃':'1',
'頄':'1',
'颅':'1',
'羟':'1',
'颇':'1',
'领':'1',
'颈':'1',
'衅':'1',
'羝':'1',
'羚':'1',
'偾':'1',
'梤':'1',
'毮':'1',
'焑':'1',
'羜':'1',
'訜':'1',
'酚':'1',
'乾':'1',
'乿':'1',
'匏':'1',
'匘':'1',
'凑':'1',
'减':'1',
'凐':'1',
'剱':'1',
'副':'1',
'剳':'1',
'剶':'1',
'剫':'1',
'剬':'1',
'剨':'1',
'剰':'1',
'剭':'1',
'鄂':'1',
'隍':'1',
'鄄':'1',
'隗':'1',
'隆':'1',
'郿':'1',
'鄃':'1',
'鄋':'1',
'隋':'1',
'随':'1',
'隈':'1',
'郾':'1',
'隐':'1',
'隅':'1',
'鄅':'1',
'隂':'1',
'陿':'1',
'陻':'1',
'隄':'1',
'陽':'1',
'隊':'1',
'階':'1',
'鄆':'1',
'鄉':'1',
'隌':'1',
'鄁':'1',
'隀':'1',
'陾':'1',
'鄇':'1',
'郹':'1',
'鄈':'1',
'隉':'1',
'郻':'1',
'隃':'1',
'隇':'1',
'鄊':'1',
'隁':'1',
'郼':'1',
'卾':'1',
'勘':'1',
'勒':'1',
'勔':'1',
'勖':'1',
'勚':'1',
'動':'1',
'勓':'1',
'偝':'1',
'偲':'1',
'偿':'1',
'偁':'1',
'偢':'1',
'偟':'1',
'偈':'1',
'傀':'1',
'偻':'1',
'偭':'1',
'偶':'1',
'偏':'1',
'停':'1',
'偷':'1',
'偎':'1',
'偓':'1',
'偕':'1',
'偃':'1',
'偊':'1',
'偫':'1',
'偬':'1',
'偰':'1',
'偹':'1',
'偪':'1',
'偵':'1',
'偘':'1',
'側':'1',
'偺':'1',
'偽':'1',
'偉':'1',
'偋':'1',
'偛':'1',
'偅':'1',
'偆':'1',
'偒':'1',
'偙':'1',
'偳':'1',
'偔':'1',
'偑':'1',
'偩':'1',
'傦':'1',
'偮':'1',
'偂':'1',
'偼':'1',
'傇':'1',
'偄':'1',
'偗':'1',
'傁':'1',
'傞':'1',
'偍':'1',
'偸':'1',
'偞':'1',
'偦':'1',
'偱':'1',
'偐':'1',
'偣':'1',
'偠':'1',
'偯':'1',
'偤':'1',
'偧':'1',
'偡':'1',
'卙':'1',
'谙':'1',
'谗':'1',
'谌':'1',
'谛':'1',
'谍':'1',
'谔':'1',
'谎':'1',
'谏':'1',
'谜':'1',
'谋':'1',
'谝':'1',
'谓':'1',
'谐':'1',
'谞':'1',
'谖':'1',
'谑':'1',
'谚':'1',
'谒':'1',
'谕':'1',
'谘':'1',
'萍':'1',
'徜':'1',
'得':'1',
'徛':'1',
'徘':'1',
'徙':'1',
'徠':'1',
'從':'1',
'徖':'1',
'徤':'1',
'徣':'1',
'徢':'1',
'徝':'1',
'徟':'1',
'尉':'1',
'將':'1',
'弹':'1',
'弶':'1',
'弸':'1',
'張':'1',
'弴':'1',
'強':'1',
'帼':'1',
'帲':'1',
'帷':'1',
'帻':'1',
'帳':'1',
'帵':'1',
'帾':'1',
'帺':'1',
'帴':'1',
'帹':'1',
'唵':'1',
'啵':'1',
'唱':'1',
'啜':'1',
'啐':'1',
'啖':'1',
'啶':'1',
'啡':'1',
'唪':'1',
'啯':'1',
'啝':'1',
'啈':'1',
'唿':'1',
'唬':'1',
'唶':'1',
'唫':'1',
'啃':'1',
'唻':'1',
'唳':'1',
'啉':'1',
'啰':'1',
'喵':'1',
'啮':'1',
'喏':'1',
'啪':'1',
'啤':'1',
'啥':'1',
'啑':'1',
'唼':'1',
'唰':'1',
'啴':'1',
'啕':'1',
'唾':'1',
'啘':'1',
'喎':'1',
'唯':'1',
'啸':'1',
'唷':'1',
'啧':'1',
'啁':'1',
'啄':'1',
'啞':'1',
'啢':'1',
'唸':'1',
'啗':'1',
'啟':'1',
'啀':'1',
'喯':'1',
'啋':'1',
'啛':'1',
'啲':'1',
'唲':'1',
'啹':'1',
'啒':'1',
'啩':'1',
'啳':'1',
'啱':'1',
'啂':'1',
'唭':'1',
'啌':'1',
'啨':'1',
'唺':'1',
'啍':'1',
'唩':'1',
'啎':'1',
'唽':'1',
'唹':'1',
'喐':'1',
'啫':'1',
'啅':'1',
'骖':'1',
'骒':'1',
'骐':'1',
'骑':'1',
'骕':'1',
'骓':'1',
'骔':'1',
'婢':'1',
'婊':'1',
'婵':'1',
'娼':'1',
'婼':'1',
'婳':'1',
'婚':'1',
'婕':'1',
'婧':'1',
'娵':'1',
'婗':'1',
'婶':'1',
'婠':'1',
'婉':'1',
'婋':'1',
'婞':'1',
'婬':'1',
'媖':'1',
'娬':'1',
'婥':'1',
'媧':'1',
'婦':'1',
'娾':'1',
'婩':'1',
'婄':'1',
'婇':'1',
'婤':'1',
'婃':'1',
'婝':'1',
'婰':'1',
'娻':'1',
'婏':'1',
'婔':'1',
'婟':'1',
'婎':'1',
'婫':'1',
'媎':'1',
'婛':'1',
'婅':'1',
'婮':'1',
'婡':'1',
'婈':'1',
'娽':'1',
'婨':'1',
'婂':'1',
'媌':'1',
'婑':'1',
'娸':'1',
'婍':'1',
'婘':'1',
'婌':'1',
'娷':'1',
'婒':'1',
'婖':'1',
'婐':'1',
'娹':'1',
'婭':'1',
'娺':'1',
'猜':'1',
'猖':'1',
'猝':'1',
'猄':'1',
'猎':'1',
'猡':'1',
'猫':'1',
'猛':'1',
'猊':'1',
'猅':'1',
'猞':'1',
'猇':'1',
'猗':'1',
'猘':'1',
'猪':'1',
'猈':'1',
'猠':'1',
'猓':'1',
'猏':'1',
'猑':'1',
'猍':'1',
'猟':'1',
'猉':'1',
'猚':'1',
'猧':'1',
'猙':'1',
'猔':'1',
'凔':'1',
'凓':'1',
'凒':'1',
'凕':'1',
'割':'1',
'剩':'1',
'剴':'1',
'創':'1',
'隘':'1',
'隞':'1',
'隑':'1',
'隔':'1',
'鄗':'1',
'鄚':'1',
'鄏':'1',
'鄌':'1',
'隙':'1',
'隓':'1',
'隕':'1',
'隖':'1',
'鄖':'1',
'鄔':'1',
'鄒':'1',
'鄐':'1',
'鄍':'1',
'鄎':'1',
'隒':'1',
'鄓':'1',
'鄑':'1',
'勛':'1',
'勝':'1',
'勜':'1',
'傍':'1',
'傧':'1',
'傣':'1',
'傎':'1',
'傅':'1',
'傢':'1',
'傕':'1',
'傈':'1',
'傉':'1',
'傩':'1',
'傥':'1',
'傒':'1',
'備':'1',
'傖':'1',
'傑':'1',
'傜':'1',
'傓':'1',
'傌':'1',
'僃':'1',
'傡':'1',
'傗':'1',
'偨':'1',
'傠':'1',
'傋':'1',
'傐':'1',
'傔':'1',
'僆':'1',
'傛':'1',
'傂':'1',
'傃':'1',
'傝':'1',
'傏':'1',
'傄':'1',
'傚':'1',
'傟':'1',
'傆':'1',
'傊':'1',
'傤':'1',
'博':'1',
'亁':'1',
'谤':'1',
'谠':'1',
'谧':'1',
'谟':'1',
'谦':'1',
'谥':'1',
'谡':'1',
'谣':'1',
'徨':'1',
'循':'1',
'御':'1',
'復':'1',
'徧':'1',
'徦':'1',
'徥':'1',
'徫':'1',
'尌':'1',
'巯':'1',
'强':'1',
'弾':'1',
'弽':'1',
'凱':'1',
'幅':'1',
'帽':'1',
'幈':'1',
'幄':'1',
'幃':'1',
'幉':'1',
'帿':'1',
'幆':'1',
'幁':'1',
'幀':'1',
'啽':'1',
'嗏':'1',
'喳':'1',
'喘':'1',
'嗒':'1',
'喋':'1',
'喊':'1',
'喝':'1',
'喉':'1',
'喤':'1',
'喙':'1',
'嗟':'1',
'喈':'1',
'啾':'1',
'喀':'1',
'喹':'1',
'喟':'1',
'喇':'1',
'喱':'1',
'喨':'1',
'喽':'1',
'喃':'1',
'喷':'1',
'嗖':'1',
'啼':'1',
'嗢':'1',
'喂':'1',
'喔':'1',
'喧':'1',
'喭':'1',
'喓':'1',
'喑':'1',
'喁':'1',
'喻':'1',
'嗞':'1',
'喆':'1',
'喫':'1',
'啣':'1',
'喒':'1',
'喲':'1',
'喺':'1',
'喰':'1',
'喢':'1',
'喠':'1',
'啿':'1',
'喥':'1',
'嘅':'1',
'喼':'1',
'嗗':'1',
'喛':'1',
'喖':'1',
'喚':'1',
'喞':'1',
'喕':'1',
'嗴':'1',
'啺':'1',
'喡':'1',
'喴':'1',
'喅':'1',
'喩':'1',
'喗':'1',
'骙':'1',
'骗':'1',
'骚':'1',
'媕':'1',
'媪':'1',
'媠':'1',
'媿':'1',
'媢':'1',
'媒':'1',
'媚':'1',
'嫂':'1',
'婷':'1',
'媦':'1',
'婿':'1',
'媛':'1',
'媟':'1',
'媮':'1',
'婣':'1',
'媯':'1',
'媬':'1',
'媋':'1',
'媨':'1',
'媅':'1',
'婸':'1',
'媂':'1',
'媏':'1',
'媍':'1',
'媩':'1',
'媓':'1',
'媈':'1',
'婽':'1',
'媘':'1',
'媫':'1',
'嫅':'1',
'媡':'1',
'媄':'1',
'媔':'1',
'婻':'1',
'媆':'1',
'媥':'1',
'媊':'1',
'媇':'1',
'媣':'1',
'媶':'1',
'媃':'1',
'媞':'1',
'媤':'1',
'婾':'1',
'媁':'1',
'媙':'1',
'媉':'1',
'媗':'1',
'婹':'1',
'媀':'1',
'媜':'1',
'媑':'1',
'猹':'1',
'猲':'1',
'猴':'1',
'猢':'1',
'猾':'1',
'猸':'1',
'猱':'1',
'猥':'1',
'猬':'1',
'猩':'1',
'猰':'1',
'猨':'1',
'猶':'1',
'猵':'1',
'猭':'1',
'猦':'1',
'猤':'1',
'猳':'1',
'獇':'1',
'獀':'1',
'猯':'1',
'猣':'1',
'锄':'1',
'锉':'1',
'锇':'1',
'锋':'1',
'锆':'1',
'锅':'1',
'锏':'1',
'锔':'1',
'锎':'1',
'铿':'1',
'铼':'1',
'锒':'1',
'铹':'1',
'锂':'1',
'链':'1',
'锍':'1',
'锊':'1',
'铺':'1',
'锓':'1',
'锐':'1',
'锁':'1',
'铽':'1',
'锑':'1',
'铻':'1',
'销':'1',
'锌':'1',
'锈':'1',
'铸':'1',
'锃':'1',
'竣':'1',
'竦':'1',
'竢':'1',
'竤':'1',
'竧':'1',
'矟':'1',
'睇':'1',
'睋':'1',
'睅':'1',
'睆':'1',
'睑':'1',
'睊':'1',
'睐':'1',
'睄':'1',
'睃':'1',
'睎':'1',
'睍':'1',
'睏':'1',
'睈':'1',
'睉':'1',
'睌':'1',
'痤':'1',
'鹁':'1',
'鹅':'1',
'鹄':'1',
'鹃':'1',
'鹂':'1',
'鹈':'1',
'鹀':'1',
'鹇':'1',
'鹆':'1',
'皴':'1',
'皳':'1',
'甥':'1',
'硠':'1',
'硫':'1',
'硵':'1',
'确':'1',
'硪':'1',
'硝':'1',
'硬':'1',
'硨':'1',
'硯':'1',
'硤':'1',
'硜':'1',
'硶':'1',
'硥':'1',
'硳':'1',
'硲':'1',
'硡':'1',
'硴':'1',
'硷':'1',
'硞':'1',
'硱':'1',
'硦':'1',
'硧':'1',
'硣':'1',
'硢':'1',
'矬':'1',
'短':'1',
'畴':'1',
'畯':'1',
'畮':'1',
'畭':'1',
'疏':'1',
'疎':'1',
'裎':'1',
'裥':'1',
'裤':'1',
'裢':'1',
'裣':'1',
'裙':'1',
'裋':'1',
'裕':'1',
'補':'1',
'裌':'1',
'裡':'1',
'裓':'1',
'裐':'1',
'裍':'1',
'裗':'1',
'裑':'1',
'裞':'1',
'裖':'1',
'蛤':'1',
'蛔':'1',
'蛱':'1',
'蛟':'1',
'蛞':'1',
'蛑':'1',
'蛲':'1',
'蛴':'1',
'蛐':'1',
'蛳':'1',
'蜓':'1',
'蛙':'1',
'蛧':'1',
'蜒':'1',
'蛘':'1',
'蛭':'1',
'蛛':'1',
'蛕':'1',
'蛒':'1',
'蛯':'1',
'蛠':'1',
'蛥':'1',
'蛡':'1',
'蛫':'1',
'蛣':'1',
'蛚':'1',
'蛨':'1',
'蛢':'1',
'蛝':'1',
'蛜':'1',
'蛦':'1',
'聒':'1',
'联':'1',
'聏':'1',
'聠':'1',
'聎':'1',
'聑':'1',
'聐':'1',
'缿':'1',
'缾':'1',
'罀':'1',
'耠':'1',
'粞':'1',
'粧':'1',
'粨':'1',
'粫':'1',
'粭':'1',
'粠':'1',
'粩':'1',
'粬':'1',
'粡':'1',
'絛':'1',
'艵':'1',
'舒':'1',
'絣':'1',
'絓':'1',
'結':'1',
'絡':'1',
'絪':'1',
'絑':'1',
'綁':'1',
'絨':'1',
'絝':'1',
'絰':'1',
'絚':'1',
'絏':'1',
'給':'1',
'絳':'1',
'絶':'1',
'絍':'1',
'絢':'1',
'絎':'1',
'絞':'1',
'統':'1',
'絲':'1',
'絠':'1',
'絔':'1',
'絾':'1',
'絒':'1',
'絘':'1',
'絩':'1',
'絧':'1',
'絥':'1',
'絯':'1',
'絙':'1',
'絵':'1',
'絗':'1',
'絕':'1',
'絖':'1',
'絽':'1',
'紪':'1',
'絟':'1',
'綎':'1',
'絤':'1',
'綖':'1',
'絴':'1',
'絬':'1',
'兟':'1',
'翙':'1',
'翔':'1',
'翛':'1',
'翗':'1',
'翖':'1',
'翓':'1',
'臵':'1',
'臶':'1',
'臸':'1',
'臹':'1',
'艇':'1',
'舾':'1',
'舽':'1',
'舼':'1',
'舿':'1',
'貼':'1',
'貺':'1',
'貯':'1',
'貽':'1',
'貱':'1',
'貾':'1',
'貹':'1',
'释':'1',
'釉':'1',
'镻':'1',
'軱':'1',
'軲':'1',
'軻':'1',
'軹':'1',
'軸':'1',
'軤':'1',
'軫':'1',
'軼':'1',
'軺':'1',
'軪':'1',
'軷':'1',
'軧':'1',
'軩':'1',
'軶':'1',
'軵':'1',
'軥':'1',
'軦':'1',
'軨':'1',
'軳':'1',
'軯':'1',
'軽':'1',
'軮':'1',
'軴':'1',
'覗':'1',
'覘':'1',
'覕':'1',
'覙':'1',
'觚':'1',
'觞':'1',
'觝':'1',
'觛':'1',
'躰':'1',
'豠':'1',
'豟':'1',
'豞':'1',
'辝':'1',
'訸':'1',
'詒':'1',
'詝':'1',
'評':'1',
'証':'1',
'詁':'1',
'訶':'1',
'詛':'1',
'詗':'1',
'診':'1',
'詐':'1',
'訴':'1',
'詆':'1',
'註':'1',
'詑':'1',
'詞':'1',
'詔':'1',
'詘':'1',
'詙':'1',
'詖':'1',
'詀':'1',
'訵':'1',
'詚':'1',
'詄':'1',
'詂':'1',
'詌':'1',
'訽':'1',
'詃':'1',
'詅':'1',
'詉':'1',
'詊':'1',
'詓':'1',
'訷':'1',
'詜':'1',
'訹':'1',
'詇':'1',
'詏':'1',
'詍':'1',
'詠':'1',
'詋':'1',
'辍':'1',
'辊':'1',
'辉':'1',
'辋':'1',
'辎':'1',
'辌':'1',
'殚':'1',
'殛':'1',
'殖':'1',
'殗':'1',
'殘':'1',
'殕':'1',
'殙':'1',
'殔':'1',
'斞':'1',
'旐':'1',
'旔':'1',
'旑':'1',
'戢':'1',
'戟':'1',
'焙':'1',
'焯':'1',
'焠':'1',
'焜':'1',
'焮':'1',
'焰':'1',
'焥':'1',
'焻':'1',
'焧':'1',
'焨':'1',
'焵':'1',
'焿':'1',
'煱':'1',
'焢':'1',
'焝':'1',
'焳':'1',
'煡':'1',
'焞':'1',
'焾':'1',
'焷':'1',
'焩':'1',
'焪':'1',
'焼':'1',
'焺':'1',
'焹':'1',
'煀':'1',
'焟':'1',
'焬':'1',
'焲':'1',
'煐':'1',
'焴':'1',
'旤':'1',
'觌':'1',
'觍':'1',
'斯':'1',
'斮':'1',
'斱':'1',
'毵':'1',
'毲':'1',
'棒':'1',
'棓':'1',
'椑':'1',
'楮':'1',
'棰':'1',
'椎':'1',
'棣':'1',
'椟':'1',
'棡':'1',
'棺':'1',
'棍':'1',
'椁':'1',
'楛':'1',
'棔':'1',
'棘':'1',
'楗':'1',
'椒':'1',
'椐':'1',
'椈':'1',
'椇':'1',
'棵':'1',
'棱':'1',
'椋':'1',
'椤':'1',
'棉':'1',
'棑':'1',
'椪':'1',
'棋':'1',
'棬':'1',
'棯':'1',
'棪':'1',
'椅':'1',
'棫':'1',
'棹':'1',
'椥':'1',
'植':'1',
'椓':'1',
'棕':'1',
'棶':'1',
'棖':'1',
'棟':'1',
'椏':'1',
'棧':'1',
'椗':'1',
'椀':'1',
'極':'1',
'棅':'1',
'棌':'1',
'棎':'1',
'椙':'1',
'椆':'1',
'棇':'1',
'椊':'1',
'棤':'1',
'椡':'1',
'棏':'1',
'椣':'1',
'棴':'1',
'椨':'1',
'椩':'1',
'棝':'1',
'椢':'1',
'棞':'1',
'楇':'1',
'椃':'1',
'検':'1',
'椄':'1',
'椌':'1',
'棙':'1',
'椂':'1',
'棆':'1',
'椚':'1',
'椧':'1',
'棿':'1',
'椖':'1',
'棲':'1',
'棈':'1',
'椦':'1',
'楉':'1',
'椫':'1',
'椮':'1',
'棷':'1',
'棢':'1',
'楧':'1',
'棭':'1',
'椬':'1',
'棛':'1',
'棜':'1',
'楰':'1',
'棳':'1',
'椔':'1',
'犊':'1',
'犄':'1',
'犍':'1',
'犋':'1',
'犉':'1',
'犅':'1',
'犃':'1',
'犈':'1',
'犆':'1',
'牍':'1',
'牌':'1',
'牋':'1',
'敠':'1',
'敧':'1',
'敥':'1',
'敤':'1',
'敡':'1',
'敞':'1',
'敦':'1',
'敬':'1',
'散':'1',
'敩':'1',
'敟':'1',
'敪':'1',
'敜':'1',
'敨':'1',
'欻':'1',
'欿':'1',
'款':'1',
'欺':'1',
'欽':'1',
'欼':'1',
'歄':'1',
'欹':'1',
'猒':'1',
'猌':'1',
'晻':'1',
'晾':'1',
'晴':'1',
'晬':'1',
'暎':'1',
'晿':'1',
'暏':'1',
'晽':'1',
'晲':'1',
'晱':'1',
'晪':'1',
'晩':'1',
'晼':'1',
'暀':'1',
'暁':'1',
'晹':'1',
'晭':'1',
'晫':'1',
'禅':'1',
'祼':'1',
'禄':'1',
'祺':'1',
'祹':'1',
'禆':'1',
'禇':'1',
'禂':'1',
'祻':'1',
'禍':'1',
'祾':'1',
'祿':'1',
'禃':'1',
'祽':'1',
'殽':'1',
'殼':'1',
'殾':'1',
'瓿':'1',
'瓾':'1',
'甁':'1',
'甀':'1',
'琲':'1',
'琫':'1',
'琛':'1',
'琮':'1',
'琱':'1',
'琯':'1',
'琥':'1',
'琚':'1',
'琨':'1',
'琭':'1',
'琪':'1',
'琦':'1',
'琼':'1',
'琬':'1',
'珷':'1',
'琰':'1',
'瑛':'1',
'琢':'1',
'琖':'1',
'琺':'1',
'瑯':'1',
'琣':'1',
'琕':'1',
'琩':'1',
'琡':'1',
'琗':'1',
'琔':'1',
'琽':'1',
'琜':'1',
'琘':'1',
'琝':'1',
'琠':'1',
'琟':'1',
'瑘':'1',
'琙':'1',
'琸':'1',
'琻':'1',
'韩':'1',
'斌':'1',
'腌':'1',
'朝':'1',
'腚':'1',
'腓':'1',
'腑':'1',
'腘':'1',
'腱':'1',
'腈':'1',
'腒':'1',
'腊':'1',
'脾':'1',
'期':'1',
'腔':'1',
'腆':'1',
'腕':'1',
'腋':'1',
'腴':'1',
'腙':'1',
'脹':'1',
'腖':'1',
'腡':'1',
'腗':'1',
'脿':'1',
'腄':'1',
'腏':'1',
'脺':'1',
'腅':'1',
'腍':'1',
'腂':'1',
'脻':'1',
'腃':'1',
'脼':'1',
'腀':'1',
'腉':'1',
'腇':'1',
'腁':'1',
'脽':'1',
'朜':'1',
'朠':'1',
'攲':'1',
'皕':'1',
'皓':'1',
'皖':'1',
'皒':'1',
'皔':'1',
'程':'1',
'稃':'1',
'稇':'1',
'稂':'1',
'稍':'1',
'税':'1',
'稀':'1',
'稉':'1',
'稈':'1',
'秿':'1',
'稌':'1',
'稅':'1',
'稊':'1',
'稄':'1',
'嵖':'1',
'嵯':'1',
'崿':'1',
'嵇':'1',
'嵁':'1',
'嵝':'1',
'嵋':'1',
'嵘':'1',
'嵎':'1',
'嵫':'1',
'崵':'1',
'崼':'1',
'嵈':'1',
'崲':'1',
'嵑':'1',
'嵄':'1',
'崷':'1',
'崹':'1',
'嵉':'1',
'嵃':'1',
'崸':'1',
'崾':'1',
'崳':'1',
'崻':'1',
'嵕':'1',
'彭':'1',
'馇':'1',
'馋':'1',
'馉':'1',
'馈':'1',
'馊':'1',
'壻':'1',
'揞':'1',
'揙':'1',
'摒':'1',
'插':'1',
'搽':'1',
'搀':'1',
'揣':'1',
'搓':'1',
'搭':'1',
'提':'1',
'揥':'1',
'揲':'1',
'摡':'1',
'搁':'1',
'揈':'1',
'搰':'1',
'揃':'1',
'搅':'1',
'揭':'1',
'揪':'1',
'揩':'1',
'揢':'1',
'揆':'1',
'揦':'1',
'揽':'1',
'搂':'1',
'揉':'1',
'揌':'1',
'搔':'1',
'搜':'1',
'揻':'1',
'揾':'1',
'握':'1',
'揳':'1',
'揎':'1',
'揠':'1',
'揜':'1',
'揖':'1',
'揄':'1',
'援':'1',
'掾':'1',
'揸':'1',
'揍':'1',
'揀':'1',
'揕':'1',
'揹':'1',
'揚':'1',
'揷':'1',
'揑':'1',
'揮':'1',
'揊':'1',
'揨':'1',
'揰':'1',
'搥':'1',
'揼':'1',
'揯':'1',
'搄':'1',
'換':'1',
'揘':'1',
'揂':'1',
'揟':'1',
'揁':'1',
'揇':'1',
'搑':'1',
'揓':'1',
'揔':'1',
'揬':'1',
'揋':'1',
'揗':'1',
'揺':'1',
'揝':'1',
'搃':'1',
'渤':'1',
'滁':'1',
'湩':'1',
'渡':'1',
'溉':'1',
'港':'1',
'渹':'1',
'滑':'1',
'湟':'1',
'溅':'1',
'湔':'1',
'湫':'1',
'湝':'1',
'湨':'1',
'渴':'1',
'溃':'1',
'溇':'1',
'湄':'1',
'渼':'1',
'湎':'1',
'渺':'1',
'湣':'1',
'湃':'1',
'湓':'1',
'湿':'1',
'湜':'1',
'溲':'1',
'溚':'1',
'湠':'1',
'湉':'1',
'渟':'1',
'湍':'1',
'湾':'1',
'湋':'1',
'渭':'1',
'温':'1',
'渥':'1',
'渫':'1',
'湑':'1',
'渲':'1',
'湮':'1',
'渰':'1',
'湧':'1',
'渝':'1',
'湲':'1',
'渣':'1',
'溠':'1',
'湛':'1',
'滞':'1',
'滋':'1',
'湊':'1',
'減':'1',
'湞':'1',
'湯':'1',
'渢':'1',
'測':'1',
'湌':'1',
'淵':'1',
'湻':'1',
'溈':'1',
'渾':'1',
'溾':'1',
'湢':'1',
'湐':'1',
'湹':'1',
'湁':'1',
'渧':'1',
'湺':'1',
'湂':'1',
'渪':'1',
'湗':'1',
'溄':'1',
'渱':'1',
'湀':'1',
'湼':'1',
'渙':'1',
'湏':'1',
'湷':'1',
'湱':'1',
'湒':'1',
'溂':'1',
'湅':'1',
'湸':'1',
'湰':'1',
'満':'1',
'湈':'1',
'渳':'1',
'渿':'1',
'湳':'1',
'渜':'1',
'湪':'1',
'溌':'1',
'湆':'1',
'湇':'1',
'溬':'1',
'渞':'1',
'湭':'1',
'湶':'1',
'渘':'1',
'溞':'1',
'渻':'1',
'湦':'1',
'湤':'1',
'湥':'1',
'渨':'1',
'溊':'1',
'渷':'1',
'湙':'1',
'湚':'1',
'溁':'1',
'溋':'1',
'湵':'1',
'湡':'1',
'渽':'1',
'湽':'1',
'编':'1',
'缏':'1',
'缔':'1',
'缎':'1',
'缑':'1',
'缓':'1',
'缋':'1',
'缉':'1',
'缄':'1',
'缂':'1',
'缆':'1',
'缕':'1',
'缅':'1',
'缈':'1',
'缗':'1',
'缌':'1',
'缇':'1',
'缐':'1',
'缃':'1',
'缘':'1',
'缊':'1',
'缒':'1',
'堛':'1',
'堾':'1',
'塔':'1',
'堤':'1',
'堞':'1',
'塅':'1',
'堩':'1',
'堠':'1',
'塃':'1',
'堪':'1',
'塄':'1',
'堧':'1',
'堶':'1',
'塆':'1',
'堰':'1',
'堙':'1',
'堦':'1',
'場':'1',
'堘':'1',
'塊':'1',
'報':'1',
'堖':'1',
'堨':'1',
'堢':'1',
'塠':'1',
'堮':'1',
'堸':'1',
'堚':'1',
'堭':'1',
'堿':'1',
'塂':'1',
'堺':'1',
'堜':'1',
'堳':'1',
'塀':'1',
'堷':'1',
'堗':'1',
'塭':'1',
'塇':'1',
'堣':'1',
'堬':'1',
'堹':'1',
'堟':'1',
'堫':'1',
'夡':'1',
'愊':'1',
'愎':'1',
'惼':'1',
'惵':'1',
'惰':'1',
'愕':'1',
'慌':'1',
'惶':'1',
'愦':'1',
'愧':'1',
'愣':'1',
'愀':'1',
'慅':'1',
'惺':'1',
'愔':'1',
'愉':'1',
'愠':'1',
'惴':'1',
'惾':'1',
'愐':'1',
'愜':'1',
'愒':'1',
'惻':'1',
'惲':'1',
'惽':'1',
'惱':'1',
'愺':'1',
'愖':'1',
'愓':'1',
'愅':'1',
'愲':'1',
'愌':'1',
'愘':'1',
'愞':'1',
'愢':'1',
'惿':'1',
'愄':'1',
'愇':'1',
'愃':'1',
'愋':'1',
'愝':'1',
'愑':'1',
'愡':'1',
'弑':'1',
'就':'1',
'赐':'1',
'赌':'1',
'赋':'1',
'赔':'1',
'赎':'1',
'赒':'1',
'赕':'1',
'酢':'1',
'酦':'1',
'酤':'1',
'酣':'1',
'酥':'1',
'酡':'1',
'酠':'1',
'酟':'1',
'貂':'1',
'貀':'1',
'豿':'1',
'貃':'1',
'豾':'1',
'貁':'1',
'跋':'1',
'跛':'1',
'跌':'1',
'跕':'1',
'跗':'1',
'跏':'1',
'践':'1',
'跔':'1',
'跞':'1',
'跑':'1',
'跚':'1',
'跎':'1',
'跅':'1',
'跖':'1',
'跘':'1',
'跈':'1',
'跙':'1',
'跍':'1',
'跉':'1',
'跊':'1',
'跜':'1',
'跒':'1',
'跆':'1',
'跇':'1',
'跓':'1',
'龂':'1',
'鈇':'1',
'鈜':'1',
'鈚':'1',
'釾':'1',
'鈆':'1',
'鈃':'1',
'鈣':'1',
'鈦':'1',
'鈈':'1',
'鉅':'1',
'鈍':'1',
'鈔':'1',
'鈉':'1',
'鈐':'1',
'鈞':'1',
'鈎':'1',
'鈑':'1',
'鈄':'1',
'鈁':'1',
'鈧':'1',
'鈥':'1',
'鈀':'1',
'鈕':'1',
'鈂':'1',
'鈟':'1',
'鈗':'1',
'鈬':'1',
'鈋':'1',
'鈛':'1',
'釿':'1',
'鈌':'1',
'鈩':'1',
'鈪':'1',
'釽':'1',
'鈊':'1',
'鈙':'1',
'鈓':'1',
'鈤':'1',
'鈫':'1',
'鈢':'1',
'鈘':'1',
'鈠':'1',
'鉯':'1',
'鈏':'1',
'鈝':'1',
'鈨':'1',
'鈅':'1',
'鈡':'1',
'靓':'1',
'靔':'1',
'飧':'1',
'飨':'1',
'飩':'1',
'飪':'1',
'飫':'1',
'飭':'1',
'飯':'1',
'飲':'1',
'飱':'1',
'飰':'1',
'鲃':'1',
'鲂':'1',
'鲀':'1',
'鱿':'1',
'雄':'1',
'雅':'1',
'雃':'1',
'雂':'1',
'靬':'1',
'靸':'1',
'靰':'1',
'靭':'1',
'靱':'1',
'靫':'1',
'靮':'1',
'靯':'1',
'骭':'1',
'骫':'1',
'骪':'1',
'骮':'1',
'骬':'1',
'韌':'1',
'項':'1',
'須':'1',
'頇':'1',
'順':'1',
'馭':'1',
'馮':'1',
'鳦':'1',
'颊':'1',
'颌':'1',
'颉':'1',
'颎':'1',
'颏':'1',
'颍':'1',
'颋':'1',
'衉':'1',
'羠':'1',
'羢':'1',
'﨩':'1',
'﨓':'1',
'徚':'1',
'愤':'1',
'衇':'1',
'衈':'1',
'鈖':'1',
'郌':'1',
'郒':'1',
'酬':'1',
'酪':'1',
'酩':'1',
'酮':'1',
'酰':'1',
'酯':'1',
'酧':'1',
'酫':'1',
'酭':'1',
'貉':'1',
'貆':'1',
'貊':'1',
'貈':'1',
'貇':'1',
'貄':'1',
'跸':'1',
'跐':'1',
'跺':'1',
'跟':'1',
'跪':'1',
'跻':'1',
'跲':'1',
'跤':'1',
'跨':'1',
'跬':'1',
'路':'1',
'跷':'1',
'跳':'1',
'跹':'1',
'跣':'1',
'跩':'1',
'跴':'1',
'跥':'1',
'跡':'1',
'跰':'1',
'跢':'1',
'跮':'1',
'跦':'1',
'跶':'1',
'跧':'1',
'跭':'1',
'跠':'1',
'踭':'1',
'跱':'1',
'龅':'1',
'龃':'1',
'龄':'1',
'龆':'1',
'鉧':'1',
'鉮':'1',
'鉥':'1',
'鈺':'1',
'鉦':'1',
'鉗':'1',
'鈷':'1',
'鉢':'1',
'鉕':'1',
'鈳':'1',
'鈽':'1',
'鈸':'1',
'鉞':'1',
'鉏':'1',
'鉬':'1',
'鉭':'1',
'鈿':'1',
'鉀':'1',
'鈾':'1',
'鉠':'1',
'鈴':'1',
'鉑':'1',
'鉤':'1',
'鉛':'1',
'鉋':'1',
'鉚':'1',
'鉈':'1',
'鈰':'1',
'鉉':'1',
'鉍':'1',
'鈹':'1',
'鈮':'1',
'鉡':'1',
'鉳':'1',
'鈵':'1',
'鉆':'1',
'鉓':'1',
'鈶':'1',
'鉪':'1',
'鉘':'1',
'鉜':'1',
'鈲':'1',
'鉌':'1',
'鉫':'1',
'鉣':'1',
'鉲':'1',
'鉱':'1',
'鉝':'1',
'鈱':'1',
'鉨':'1',
'鉩':'1',
'鉟':'1',
'銏':'1',
'鉎':'1',
'鉂':'1',
'鉃':'1',
'鉇':'1',
'鉐':'1',
'鈻':'1',
'鉰':'1',
'鉄':'1',
'鉖':'1',
'鈯':'1',
'鉔':'1',
'鉙':'1',
'鉊':'1',
'鉁':'1',
'鉒':'1',
'鈼':'1',
'靖':'1',
'靕':'1',
'飾':'1',
'飽':'1',
'飼':'1',
'飿':'1',
'飴':'1',
'飹':'1',
'飶':'1',
'餀':'1',
'飷':'1',
'飻':'1',
'飳':'1',
'飮':'1',
'飵':'1',
'鲅':'1',
'鲍':'1',
'鲌':'1',
'鲋':'1',
'鲈':'1',
'鲇':'1',
'鲏':'1',
'鲆':'1',
'鲐':'1',
'鲉':'1',
'鲊':'1',
'鲄':'1',
'雏':'1',
'雊':'1',
'雎':'1',
'雉':'1',
'靶':'1',
'靳':'1',
'靴':'1',
'靷':'1',
'靹':'1',
'靵':'1',
'靲':'1',
'骱':'1',
'骰':'1',
'骯':'1',
'魂':'1',
'頊':'1',
'頑':'1',
'頓':'1',
'頒':'1',
'頌':'1',
'頎':'1',
'頏':'1',
'預':'1',
'頋':'1',
'頍':'1',
'頉':'1',
'韵':'1',
'韴':'1',
'馱':'1',
'馴':'1',
'馳':'1',
'馰':'1',
'馯':'1',
'馺':'1',
'馲':'1',
'鳩':'1',
'鳪':'1',
'鳭':'1',
'鳮':'1',
'鳨':'1',
'鳰':'1',
'魛':'1',
'魞':'1',
'魝':'1',
'魜':'1',
'幹':'1',
'鼓':'1',
'鼔':'1',
'颐':'1',
'颓':'1',
'颖':'1',
'颔':'1',
'频':'1',
'颒':'1',
'群':'1',
'颕':'1',
'羧':'1',
'﨔':'1',
'嗯':'1',
'硸':'1',
'羥':'1',
'羦':'1',
'羪':'1',
'艈':'1',
'覅':'1',
'銰':'1',
'馚':'1',
'辏':'1',
'辐':'1',
'辑':'1',
'输':'1',
'辒':'1',
'琿':'1',
'殟':'1',
'殜':'1',
'斟':'1',
'旒':'1',
'旓':'1',
'飕':'1',
'戥':'1',
'戤':'1',
'戡':'1',
'戣':'1',
'戦':'1',
'煏':'1',
'煸':'1',
'煅':'1',
'煳':'1',
'煌':'1',
'煤':'1',
'煣':'1',
'煺':'1',
'煨':'1',
'煖':'1',
'煊':'1',
'煜':'1',
'煴':'1',
'煒':'1',
'煉':'1',
'煙':'1',
'煠':'1',
'煩':'1',
'煗':'1',
'煬':'1',
'煇':'1',
'煘':'1',
'煁':'1',
'煈':'1',
'煂':'1',
'煥':'1',
'煍':'1',
'煯':'1',
'煃':'1',
'煷':'1',
'煝':'1',
'煵':'1',
'煔':'1',
'熍':'1',
'煪':'1',
'煰':'1',
'煶':'1',
'煫':'1',
'煓':'1',
'煟':'1',
'煆':'1',
'煋':'1',
'煄':'1',
'觎':'1',
'新':'1',
'毷':'1',
'毹':'1',
'毼':'1',
'毻':'1',
'楂':'1',
'槎':'1',
'榇':'1',
'椽':'1',
'槌':'1',
'椿':'1',
'楤':'1',
'椴':'1',
'楯':'1',
'概':'1',
'榾':'1',
'槐':'1',
'楫':'1',
'楷':'1',
'楬':'1',
'榉':'1',
'榄':'1',
'楞':'1',
'楝':'1',
'楼':'1',
'榈':'1',
'楣':'1',
'楠':'1',
'楄':'1',
'榀':'1',
'椹':'1',
'楒':'1',
'椳':'1',
'楔':'1',
'楦':'1',
'椸':'1',
'楹':'1',
'楢':'1',
'榆':'1',
'楳':'1',
'楊':'1',
'楥':'1',
'楩':'1',
'椶':'1',
'楓':'1',
'楅':'1',
'榋':'1',
'槆':'1',
'楱':'1',
'楴':'1',
'楪':'1',
'椯':'1',
'椱':'1',
'椷':'1',
'楁':'1',
'楜':'1',
'楻':'1',
'椲':'1',
'楎':'1',
'椵':'1',
'椾':'1',
'楐':'1',
'楏':'1',
'楑':'1',
'楋':'1',
'榌':'1',
'椺':'1',
'楾':'1',
'榵':'1',
'楺':'1',
'榊':'1',
'榁':'1',
'榙':'1',
'楟':'1',
'榳':'1',
'楕':'1',
'楲':'1',
'榅':'1',
'楃':'1',
'楿':'1',
'楈':'1',
'椻':'1',
'椼':'1',
'楌':'1',
'楆':'1',
'楀':'1',
'楡':'1',
'棩':'1',
'楨':'1',
'犐':'1',
'犏':'1',
'犌':'1',
'犑':'1',
'牃':'1',
'牒':'1',
'牐':'1',
'牎':'1',
'牑':'1',
'牏':'1',
'敯':'1',
'敮':'1',
'敫':'1',
'数':'1',
'敭':'1',
'歃':'1',
'歇':'1',
'歆':'1',
'歈':'1',
'歂':'1',
'歁':'1',
'歀':'1',
'歅':'1',
'献':'1',
'猷':'1',
'暗':'1',
'暌':'1',
'暖':'1',
'暐':'1',
'暇':'1',
'暄':'1',
'暍':'1',
'暉':'1',
'暘':'1',
'暙':'1',
'暕':'1',
'暔':'1',
'暒':'1',
'暛':'1',
'暊':'1',
'暆':'1',
'禘':'1',
'福':'1',
'禖':'1',
'禊':'1',
'禋':'1',
'禔':'1',
'禎':'1',
'禕':'1',
'禙':'1',
'禈':'1',
'禓':'1',
'禗':'1',
'禑':'1',
'禒':'1',
'禉':'1',
'禐':'1',
'禌':'1',
'殿':'1',
'毂':'1',
'毁':'1',
'毀':'1',
'甄':'1',
'甂':'1',
'瑳':'1',
'瑰':'1',
'瑊':'1',
'瑁':'1',
'瑙':'1',
'瑞':'1',
'瑕':'1',
'瑄':'1',
'瑒':'1',
'瑜':'1',
'瑀':'1',
'瑗':'1',
'瑑':'1',
'瑇':'1',
'瑏':'1',
'瑃':'1',
'瑖':'1',
'瑍':'1',
'瑝':'1',
'瑐':'1',
'琾':'1',
'瑓':'1',
'瑂':'1',
'瑉':'1',
'瑔':'1',
'瑈':'1',
'瑌':'1',
'瑅':'1',
'瑋':'1',
'瑥':'1',
'瑎':'1',
'瑆':'1',
'瑵':'1',
'韫':'1',
'斒':'1',
'腤':'1',
'腷':'1',
'腠':'1',
'腭':'1',
'腹':'1',
'腼':'1',
'腩':'1',
'腻':'1',
'腮':'1',
'腧':'1',
'腾':'1',
'腯':'1',
'腿':'1',
'腽':'1',
'腺':'1',
'腥':'1',
'腰':'1',
'膇':'1',
'腳':'1',
'腣':'1',
'腸':'1',
'腫':'1',
'腦':'1',
'腟':'1',
'腶':'1',
'腞':'1',
'腵':'1',
'腜':'1',
'腝':'1',
'腢':'1',
'腬':'1',
'膄':'1',
'腨':'1',
'腲':'1',
'腛':'1',
'腪':'1',
'朡':'1',
'歱':'1',
'皗':'1',
'皘':'1',
'瓡':'1',
'稗':'1',
'稖':'1',
'稠':'1',
'稞':'1',
'稔':'1',
'稣':'1',
'稙':'1',
'稚':'1',
'稜':'1',
'稒':'1',
'稘':'1',
'稛':'1',
'稑':'1',
'稤':'1',
'稐':'1',
'稝':'1',
'稡':'1',
'稏':'1',
'稢':'1',
'稕':'1',
'稓':'1',
'亂':'1',
'亃':'1',
'亄':'1',
'凗':'1',
'剿':'1',
'剽':'1',
'剷':'1',
'剹':'1',
'剾':'1',
'剻':'1',
'剼':'1',
'剸':'1',
'鄙':'1',
'鄜':'1',
'鄠':'1',
'隟':'1',
'鄢':'1',
'鄞':'1',
'鄘':'1',
'鄣':'1',
'障':'1',
'際':'1',
'隠':'1',
'鄛':'1',
'隝':'1',
'鄝':'1',
'鄤':'1',
'鄡':'1',
'鄥':'1',
'隡':'1',
'隚':'1',
'鄟':'1',
'厀':'1',
'勤':'1',
'勣':'1',
'勦':'1',
'勠':'1',
'勡':'1',
'勧':'1',
'勨':'1',
'傺':'1',
'催':'1',
'傫':'1',
'僇':'1',
'僄':'1',
'傻':'1',
'像':'1',
'債':'1',
'僅':'1',
'傾':'1',
'傴':'1',
'傳':'1',
'僂':'1',
'傷':'1',
'傯':'1',
'傭':'1',
'傰':'1',
'傪':'1',
'傮':'1',
'傸':'1',
'僀':'1',
'働':'1',
'僙':'1',
'傼':'1',
'傹':'1',
'僋':'1',
'僈':'1',
'傶':'1',
'傱':'1',
'僁':'1',
'傿':'1',
'僌':'1',
'傽':'1',
'谫':'1',
'谨':'1',
'谩':'1',
'谬':'1',
'谪':'1',
'蒯':'1',
'徯':'1',
'徭':'1',
'徬':'1',
'徰':'1',
'彀':'1',
'彃':'1',
'彁':'1',
'幌':'1',
'幙':'1',
'幊':'1',
'幏':'1',
'幎':'1',
'幍':'1',
'幐':'1',
'嗄':'1',
'嗳':'1',
'嗌':'1',
'嗷':'1',
'嗔':'1',
'嗤':'1',
'嗲':'1',
'嘟':'1',
'嗝':'1',
'嗨':'1',
'嗐':'1',
'嗥':'1',
'嗑':'1',
'嗫':'1',
'嗙':'1',
'嗛':'1',
'嗪':'1',
'嗓':'1',
'嗜':'1',
'嗣':'1',
'嗉':'1',
'嗦':'1',
'嗡':'1',
'嗅':'1',
'嗈':'1',
'嗬':'1',
'嘩':'1',
'嗊':'1',
'嗎':'1',
'嗩':'1',
'嗶':'1',
'嗆':'1',
'嗚':'1',
'嗁':'1',
'喍':'1',
'嗰':'1',
'嗀':'1',
'嗃':'1',
'嗘':'1',
'嗠':'1',
'嗹':'1',
'嗼':'1',
'嗱':'1',
'嗕':'1',
'嗮':'1',
'嗵':'1',
'嗋':'1',
'嗂':'1',
'骝':'1',
'骟':'1',
'嫒':'1',
'媸':'1',
'媾':'1',
'嫉':'1',
'嫁':'1',
'嫫':'1',
'媲':'1',
'嫔':'1',
'媳':'1',
'嫌':'1',
'媵':'1',
'嫄':'1',
'媽':'1',
'嫋':'1',
'媼':'1',
'嫎':'1',
'媰':'1',
'嬅':'1',
'媹':'1',
'媺':'1',
'嫇':'1',
'嫟':'1',
'嫓':'1',
'嫀':'1',
'嫆':'1',
'媷':'1',
'嫊':'1',
'嫍':'1',
'媱':'1',
'媴':'1',
'嫃':'1',
'猺':'1',
'猿':'1',
'獉':'1',
'獁':'1',
'獅':'1',
'猻':'1',
'獓':'1',
'猼':'1',
'獊':'1',
'獆':'1',
'獏':'1',
'猽':'1',
'獈':'1',
'獂':'1',
'锛':'1',
'锤':'1',
'错':'1',
'锝':'1',
'锭':'1',
'锢':'1',
'锪':'1',
'键':'1',
'锦':'1',
'锯':'1',
'锩':'1',
'锞':'1',
'锟':'1',
'锣':'1',
'锚':'1',
'锰':'1',
'锘':'1',
'锫':'1',
'锖':'1',
'锬':'1',
'锡':'1',
'锨':'1',
'锳':'1',
'锗':'1',
'锧':'1',
'锥':'1',
'锱':'1',
'锜':'1',
'锠':'1',
'竨':'1',
'竩':'1',
'矠':'1',
'睥':'1',
'睬':'1',
'睹':'1',
'睢':'1',
'睫':'1',
'睛':'1',
'睖':'1',
'睩':'1',
'瞄':'1',
'睦':'1',
'睨':'1',
'睒':'1',
'睡':'1',
'睟':'1',
'睚':'1',
'睞':'1',
'睠':'1',
'睔':'1',
'睧':'1',
'睷':'1',
'睙':'1',
'睰':'1',
'睤':'1',
'睗':'1',
'睓':'1',
'睕':'1',
'睜':'1',
'睭':'1',
'鹌':'1',
'鹎':'1',
'鹑':'1',
'鹒':'1',
'鹋':'1',
'鹐':'1',
'鹊':'1',
'鹔':'1',
'鹉':'1',
'鹓':'1',
'鹍':'1',
'皵':'1',
'碍':'1',
'碑':'1',
'碚':'1',
'碜':'1',
'碘':'1',
'碉':'1',
'碇':'1',
'碓':'1',
'硿':'1',
'碌':'1',
'碰':'1',
'碕':'1',
'碏':'1',
'碎':'1',
'碗':'1',
'碔':'1',
'碂':'1',
'硾':'1',
'碙':'1',
'碋':'1',
'碊':'1',
'碅':'1',
'碐':'1',
'碄':'1',
'碖':'1',
'碈':'1',
'碃':'1',
'硹':'1',
'碢':'1',
'硽':'1',
'碒':'1',
'碤':'1',
'硺':'1',
'碛':'1',
'矮':'1',
'畸':'1',
'畹':'1',
'畷':'1',
'裨':'1',
'裱':'1',
'裯':'1',
'褚':'1',
'裰':'1',
'裾':'1',
'裲':'1',
'裸':'1',
'裼':'1',
'裷':'1',
'裺':'1',
'褃':'1',
'裶':'1',
'裪':'1',
'裧':'1',
'裮':'1',
'裭':'1',
'褀':'1',
'裩':'1',
'裬':'1',
'裿':'1',
'褄':'1',
'臦':'1',
'蜍':'1',
'蛾':'1',
'蜂':'1',
'蜉':'1',
'蜐':'1',
'蜊':'1',
'蛸':'1',
'蜕':'1',
'蜗':'1',
'蜈':'1',
'蛹':'1',
'蜖':'1',
'蛽':'1',
'蛼':'1',
'蜔':'1',
'蛿':'1',
'蛻':'1',
'蜏':'1',
'蜣':'1',
'蜎':'1',
'蜆':'1',
'蛺':'1',
'蜋':'1',
'蛖':'1',
'蜌':'1',
'蜅':'1',
'蝍':'1',
'蛶':'1',
'蝆':'1',
'蛷':'1',
'蜹':'1',
'蜄':'1',
'蛵':'1',
'蜁':'1',
'聘':'1',
'聕':'1',
'聗':'1',
'號':'1',
'耢':'1',
'耡':'1',
'粳':'1',
'粮':'1',
'粯':'1',
'糀':'1',
'粴':'1',
'粰':'1',
'綔':'1',
'絺':'1',
'絻':'1',
'綗':'1',
'綆':'1',
'綀':'1',
'經':'1',
'綃':'1',
'絸':'1',
'絹':'1',
'綑':'1',
'綏':'1',
'綉':'1',
'綌':'1',
'綈':'1',
'綐':'1',
'綘':'1',
'綍':'1',
'綒':'1',
'綋':'1',
'綄':'1',
'継':'1',
'綅':'1',
'絿':'1',
'綛':'1',
'綂':'1',
'綊':'1',
'綇':'1',
'続':'1',
'絼':'1',
'綕':'1',
'翝':'1',
'肆':'1',
'肄':'1',
'艀':'1',
'艄':'1',
'艉':'1',
'艅':'1',
'艂':'1',
'艆':'1',
'艃':'1',
'艁':'1',
'賊':'1',
'賄':'1',
'賂':'1',
'賉':'1',
'賅':'1',
'賎':'1',
'賋':'1',
'賆':'1',
'賍':'1',
'輀':'1',
'軿':'1',
'較':'1',
'軾':'1',
'輊':'1',
'輇':'1',
'輈':'1',
'輅':'1',
'輁':'1',
'輄':'1',
'輆':'1',
'軭':'1',
'輌':'1',
'赪':'1',
'赩':'1',
'赨':'1',
'谼':'1',
'覜':'1',
'覛':'1',
'触':'1',
'觥':'1',
'解':'1',
'觧':'1',
'觡':'1',
'觤':'1',
'觟':'1',
'躲':'1',
'躳':'1',
'躱':'1',
'豥':'1',
'豣':'1',
'豤':'1',
'辟':'1',
'辞':'1',
'誄':'1',
'誆':'1',
'試':'1',
'詿':'1',
'詩':'1',
'詰':'1',
'誇':'1',
'詼':'1',
'誠':'1',
'詮':'1',
'誅':'1',
'詵':'1',
'話':'1',
'誕':'1',
'詬':'1',
'詭':'1',
'詢':'1',
'詾':'1',
'諍':'1',
'詶':'1',
'詫':'1',
'該':'1',
'詳':'1',
'詸':'1',
'詣':'1',
'詡':'1',
'誁':'1',
'誀':'1',
'誃':'1',
'誂':'1',
'詷':'1',
'詻':'1',
'詥':'1',
'詪':'1',
'詤':'1',
'詯':'1',
'詺':'1',
'誔':'1',
'詴':'1',
'誈':'1',
'詨':'1',
'詽':'1',
'訿':'1',
'嵴':'1',
'嵲':'1',
'嵊':'1',
'嵠':'1',
'嵦':'1',
'嵭':'1',
'嵢':'1',
'嵣':'1',
'嵮':'1',
'嵥':'1',
'嵪':'1',
'嵧':'1',
'嵰':'1',
'嵶':'1',
'嵨':'1',
'嵱':'1',
'彮':'1',
'馎':'1',
'馏':'1',
'馍':'1',
'馐':'1',
'馌':'1',
'壾':'1',
'摆':'1',
'搒':'1',
'摈':'1',
'搏':'1',
'摛':'1',
'搊':'1',
'搐':'1',
'搋':'1',
'摁':'1',
'搞':'1',
'搳':'1',
'搛':'1',
'搢':'1',
'搕':'1',
'摸':'1',
'搉':'1',
'摋':'1',
'搡':'1',
'摄':'1',
'摅':'1',
'搠':'1',
'搪':'1',
'携':'1',
'摇':'1',
'搌':'1',
'搘':'1',
'損':'1',
'搨':'1',
'搶':'1',
'搇':'1',
'搗':'1',
'摀':'1',
'搤':'1',
'搧':'1',
'搾':'1',
'摑':'1',
'搹':'1',
'摓':'1',
'搆':'1',
'撶':'1',
'搩':'1',
'摃':'1',
'搚':'1',
'搮':'1',
'摙':'1',
'搣':'1',
'搱':'1',
'摂':'1',
'搙':'1',
'搝':'1',
'搼':'1',
'搈':'1',
'摉':'1',
'搷':'1',
'搎':'1',
'搯':'1',
'搲':'1',
'搵':'1',
'搟':'1',
'搖':'1',
'搸':'1',
'滗':'1',
'滨':'1',
'滀':'1',
'滇':'1',
'滏':'1',
'滆':'1',
'滚':'1',
'滈':'1',
'滉':'1',
'溷':'1',
'漷':'1',
'滘':'1',
'溘':'1',
'滥':'1',
'漓':'1',
'溧':'1',
'溜':'1',
'滦':'1',
'滤':'1',
'满':'1',
'漭':'1',
'溟':'1',
'漠':'1',
'溺':'1',
'滂':'1',
'溥':'1',
'溱':'1',
'溶':'1',
'溽':'1',
'滠':'1',
'溻':'1',
'溏':'1',
'滔':'1',
'滃':'1',
'溪':'1',
'溴':'1',
'滟':'1',
'溢':'1',
'溵':'1',
'滢':'1',
'滪':'1',
'源':'1',
'滍':'1',
'滓':'1',
'溝':'1',
'漣':'1',
'滙':'1',
'滅':'1',
'溼':'1',
'滭':'1',
'溳':'1',
'滛':'1',
'滄':'1',
'滌':'1',
'溰':'1',
'滶':'1',
'漨':'1',
'溗':'1',
'滣':'1',
'滜':'1',
'滒':'1',
'溎':'1',
'澕':'1',
'滐':'1',
'溍':'1',
'溓':'1',
'滝':'1',
'溣':'1',
'溤':'1',
'溕':'1',
'溿':'1',
'滊':'1',
'溹':'1',
'溡':'1',
'溮':'1',
'溸':'1',
'滖':'1',
'溑':'1',
'溙':'1',
'溛':'1',
'溫':'1',
'溩':'1',
'滧':'1',
'溔':'1',
'溒':'1',
'溨':'1',
'溭':'1',
'缤':'1',
'缠':'1',
'缞':'1',
'缝':'1',
'缚':'1',
'缟':'1',
'缙':'1',
'缡':'1',
'缛':'1',
'缢':'1',
'缜':'1',
'缣':'1',
'塝':'1',
'塍':'1',
'堽':'1',
'塥':'1',
'塨':'1',
'塓':'1',
'塌':'1',
'塘':'1',
'填':'1',
'塕':'1',
'塮':'1',
'塬':'1',
'塤':'1',
'塏':'1',
'塢':'1',
'塙':'1',
'塚':'1',
'塧':'1',
'塡':'1',
'塖':'1',
'墎':'1',
'塉':'1',
'塪':'1',
'塛':'1',
'塯':'1',
'塻':'1',
'塜':'1',
'塳':'1',
'塒':'1',
'塐':'1',
'塩':'1',
'墷':'1',
'塎':'1',
'尠':'1',
'慊':'1',
'慑':'1',
'慎':'1',
'愫':'1',
'慆':'1',
'慥':'1',
'愽':'1',
'慄':'1',
'愷':'1',
'愴':'1',
'愾':'1',
'愵':'1',
'慠':'1',
'慉':'1',
'愩':'1',
'愰':'1',
'愱':'1',
'慩':'1',
'慏':'1',
'慔':'1',
'愭':'1',
'愼':'1',
'愯':'1',
'慍':'1',
'慀':'1',
'愶':'1',
'慃':'1',
'愮':'1',
'愹':'1',
'愪':'1',
'弒':'1',
'赗':'1',
'赖':'1',
'嶍':'1',
'嶂':'1',
'嵽':'1',
'嶃':'1',
'嶇':'1',
'嶁':'1',
'嶆':'1',
'嵼':'1',
'嶋':'1',
'嵺':'1',
'嵻':'1',
'嵷':'1',
'嶀':'1',
'嶑':'1',
'彰':'1',
'彯':'1',
'馑':'1',
'馒':'1',
'摽':'1',
'摴':'1',
'摐':'1',
'摧':'1',
'撖':'1',
'撂':'1',
'摞':'1',
'摔':'1',
'撄':'1',
'摘':'1',
'摭':'1',
'摶':'1',
'摳':'1',
'撦':'1',
'摣':'1',
'摟':'1',
'摠':'1',
'摺':'1',
'摻':'1',
'摜':'1',
'摬':'1',
'摲':'1',
'摖':'1',
'摌':'1',
'摷':'1',
'摚':'1',
'摤':'1',
'摏':'1',
'摢':'1',
'摕':'1',
'撗':'1',
'摫':'1',
'摦':'1',
'摪':'1',
'摎':'1',
'摼':'1',
'摝':'1',
'摱':'1',
'摵':'1',
'撁':'1',
'摗':'1',
'摍':'1',
'摥':'1',
'撱':'1',
'撾':'1',
'摿':'1',
'撯':'1',
'擆':'1',
'滮':'1',
'漕':'1',
'漘':'1',
'潀':'1',
'漼':'1',
'滴':'1',
'漧':'1',
'澉':'1',
'漍':'1',
'滹':'1',
'漶':'1',
'潢':'1',
'漈':'1',
'漖':'1',
'漤':'1',
'漯':'1',
'潋':'1',
'漏':'1',
'漉':'1',
'漫':'1',
'漰':'1',
'漂':'1',
'漆':'1',
'漙':'1',
'潍':'1',
'潇':'1',
'演':'1',
'漾':'1',
'潆':'1',
'漳':'1',
'潴':'1',
'潈':'1',
'漬':'1',
'漸':'1',
'漚':'1',
'漢':'1',
'滿':'1',
'滷':'1',
'漊':'1',
'濄':'1',
'漁':'1',
'滬':'1',
'滸':'1',
'滾':'1',
'滻':'1',
'滲':'1',
'漲':'1',
'澚':'1',
'漅':'1',
'滯':'1',
'漴':'1',
'漺':'1',
'漎':'1',
'漗':'1',
'潒':'1',
'滼':'1',
'漑':'1',
'潅':'1',
'潂':'1',
'漃':'1',
'滰':'1',
'漌':'1',
'漮':'1',
'滱':'1',
'潉':'1',
'漻':'1',
'漋':'1',
'滵':'1',
'漞':'1',
'潎':'1',
'滳':'1',
'漡':'1',
'潄':'1',
'漟':'1',
'漛':'1',
'潳':'1',
'漥':'1',
'漇':'1',
'漝':'1',
'漵':'1',
'潊':'1',
'漄':'1',
'漹':'1',
'漜':'1',
'潩':'1',
'滽':'1',
'滺':'1',
'潌':'1',
'缧':'1',
'缦':'1',
'缪':'1',
'缥':'1',
'缫':'1',
'缩':'1',
'缨':'1',
'墋':'1',
'墐':'1',
'境':'1',
'墈':'1',
'墚':'1',
'墁':'1',
'墘':'1',
'墙':'1',
'墒':'1',
'塽':'1',
'墟':'1',
'墕':'1',
'墉':'1',
'墴':'1',
'塼':'1',
'塲':'1',
'墖':'1',
'塴':'1',
'墂':'1',
'墄':'1',
'墔':'1',
'墆':'1',
'墑':'1',
'塿':'1',
'塶':'1',
'塷':'1',
'塸':'1',
'墭':'1',
'墛':'1',
'増':'1',
'墇':'1',
'墌':'1',
'墸':'1',
'夥':'1',
'尡':'1',
'憏':'1',
'慷':'1',
'憀':'1',
'慢':'1',
'慓':'1',
'慵':'1',
'慪':'1',
'慳':'1',
'慚':'1',
'憜':'1',
'慟':'1',
'慽':'1',
'慴':'1',
'慘':'1',
'慣':'1',
'慒':'1',
'憆':'1',
'憁':'1',
'慛':'1',
'慖':'1',
'慬':'1',
'慻':'1',
'慺':'1',
'慲':'1',
'憈':'1',
'慯':'1',
'慡':'1',
'慱':'1',
'慞':'1',
'孵':'1',
'赙':'1',
'赚':'1',
'瑴':'1',
'凘':'1',
'劀':'1',
'劂':'1',
'劁':'1',
'劄':'1',
'劃':'1',
'兢':'1',
'鄱':'1',
'鄯':'1',
'隧':'1',
'隤':'1',
'隩':'1',
'隨':'1',
'鄩':'1',
'鄲':'1',
'鄭':'1',
'鄰':'1',
'鄧':'1',
'鄪':'1',
'隥':'1',
'隣':'1',
'鄮':'1',
'隢':'1',
'鄬':'1',
'鄦':'1',
'鄫':'1',
'勩':'1',
'勱':'1',
'勭':'1',
'勫':'1',
'勪':'1',
'勬':'1',
'僝':'1',
'僢':'1',
'僜':'1',
'僭':'1',
'僬':'1',
'儆':'1',
'僦':'1',
'僚':'1',
'僧':'1',
'僳':'1',
'僮':'1',
'僖':'1',
'僔':'1',
'僊':'1',
'僥':'1',
'僡':'1',
'僕':'1',
'僑':'1',
'儁':'1',
'僱':'1',
'僠':'1',
'僤':'1',
'僘':'1',
'僞':'1',
'僫':'1',
'僟':'1',
'僣':'1',
'僒':'1',
'僪':'1',
'僗':'1',
'僯':'1',
'僛':'1',
'僐':'1',
'僓':'1',
'僩':'1',
'僲':'1',
'僴':'1',
'僷':'1',
'僎':'1',
'叆':'1',
'谲':'1',
'谰':'1',
'谱':'1',
'谯':'1',
'谭':'1',
'谮':'1',
'徱':'1',
'徶':'1',
'徳':'1',
'對':'1',
'巰':'1',
'彄':'1',
'彉':'1',
'彅':'1',
'幖':'1',
'幔':'1',
'幛':'1',
'幘':'1',
'幗':'1',
'幓':'1',
'幒':'1',
'嘣':'1',
'嘈':'1',
'嘚':'1',
'嘀':'1',
'嘎':'1',
'嘏':'1',
'嘝':'1',
'嘒':'1',
'嘛':'1',
'嘧':'1',
'嘌':'1',
'嘁':'1',
'嘘':'1',
'嘡':'1',
'嘕':'1',
'嘐':'1',
'嘤':'1',
'嗻':'1',
'嘖':'1',
'嘆':'1',
'嘜':'1',
'嘔':'1',
'嘑':'1',
'嘍':'1',
'嘓':'1',
'噉':'1',
'嘊':'1',
'嘇':'1',
'嘨':'1',
'嘃':'1',
'嘄':'1',
'嘢':'1',
'噑':'1',
'嘙':'1',
'嘥':'1',
'嗺':'1',
'嗿':'1',
'嘋':'1',
'骠':'1',
'骢':'1',
'骡':'1',
'嫦':'1',
'嫡':'1',
'嫪':'1',
'嫘':'1',
'嫠':'1',
'嫚':'1',
'嫖':'1',
'嫱':'1',
'嫣':'1',
'嫕':'1',
'嫜':'1',
'嫰':'1',
'嫗':'1',
'嫧':'1',
'嫷':'1',
'嫨':'1',
'嫭':'1',
'嫮':'1',
'嫤':'1',
'嫝':'1',
'嫲':'1',
'嫹':'1',
'嫥':'1',
'嫙':'1',
'嫞':'1',
'嫬':'1',
'獕':'1',
'獚':'1',
'獍':'1',
'獐':'1',
'獙':'1',
'獑':'1',
'獔':'1',
'獌':'1',
'獡':'1',
'酲':'1',
'酵':'1',
'酷':'1',
'酹':'1',
'酶':'1',
'酿':'1',
'酺':'1',
'酾':'1',
'酸':'1',
'酴':'1',
'酽':'1',
'酻':'1',
'酼':'1',
'酳':'1',
'貌':'1',
'貋':'1',
'貍':'1',
'踌':'1',
'踆':'1',
'跽':'1',
'跼':'1',
'踉':'1',
'踊':'1',
'踁':'1',
'踄':'1',
'踀':'1',
'跿':'1',
'踋':'1',
'踎':'1',
'踇':'1',
'踂':'1',
'踃':'1',
'踍':'1',
'踈':'1',
'龈':'1',
'龇':'1',
'鋋':'1',
'鉷':'1',
'銒':'1',
'鉶':'1',
'銠':'1',
'銬':'1',
'銍':'1',
'鋩':'1',
'鉺':'1',
'銪':'1',
'鋮':'1',
'銕':'1',
'鋣':'1',
'銅':'1',
'鋁':'1',
'銱':'1',
'銦':'1',
'銓':'1',
'鉿':'1',
'銚':'1',
'銖':'1',
'銑':'1',
'銩':'1',
'銛':'1',
'鋌':'1',
'銘':'1',
'鉻':'1',
'錚':'1',
'銫':'1',
'銨':'1',
'鉸':'1',
'銥':'1',
'銃':'1',
'銀':'1',
'銣':'1',
'銭':'1',
'鉼':'1',
'銟':'1',
'鉹':'1',
'銧':'1',
'銗':'1',
'銊':'1',
'銈':'1',
'銡':'1',
'銄':'1',
'銁':'1',
'銙':'1',
'銇':'1',
'鉾':'1',
'銤':'1',
'銆':'1',
'銔':'1',
'銢':'1',
'銋':'1',
'鉽':'1',
'銉':'1',
'銯':'1',
'鉵':'1',
'銝':'1',
'銂':'1',
'銌':'1',
'静':'1',
'靗':'1',
'靘':'1',
'餂':'1',
'餌':'1',
'餄':'1',
'餁':'1',
'餉':'1',
'餎':'1',
'餃':'1',
'餏':'1',
'餅':'1',
'飸':'1',
'餇':'1',
'餆':'1',
'鲕':'1',
'鲑':'1',
'鲘':'1',
'鲚':'1',
'鲛':'1',
'鲒':'1',
'鲙':'1',
'鲖':'1',
'鲔':'1',
'鲜':'1',
'鲟':'1',
'鲗':'1',
'鲓':'1',
'雌':'1',
'雒':'1',
'雑':'1',
'颯':'1',
'靼':'1',
'靺':'1',
'鞅':'1',
'靿':'1',
'靽':'1',
'鞁':'1',
'鞆':'1',
'鞃':'1',
'鞂':'1',
'鞄':'1',
'鞀':'1',
'靾':'1',
'靻':'1',
'骳':'1',
'骶':'1',
'骷':'1',
'骲':'1',
'骵':'1',
'魄':'1',
'靤':'1',
'韍':'1',
'韎':'1',
'馝':'1',
'馛':'1',
'馜':'1',
'頔':'1',
'頗':'1',
'領':'1',
'頖':'1',
'頙':'1',
'頕':'1',
'頚':'1',
'韶':'1',
'韷':'1',
'髚':'1',
'駃':'1',
'馹':'1',
'駄':'1',
'駁':'1',
'駂':'1',
'馾':'1',
'馸':'1',
'駏':'1',
'馿':'1',
'馷':'1',
'駇':'1',
'駆':'1',
'馶':'1',
'馼':'1',
'駅':'1',
'駀':'1',
'馻':'1',
'麧':'1',
'鳴':'1',
'鳲':'1',
'鳵':'1',
'鳱':'1',
'魟':'1',
'魢':'1',
'魡':'1',
'魥':'1',
'魠':'1',
'颗':'1',
'僨':'1',
'羫':'1',
'蝊':'1',
'隫':'1',
'辗':'1',
'辖':'1',
'辕':'1',
'殡':'1',
'殠':'1',
'殞':'1',
'殝':'1',
'斡':'1',
'斠':'1',
'旗':'1',
'旖':'1',
'飖':'1',
'戬':'1',
'戩':'1',
'戧':'1',
'戨':'1',
'戫':'1',
'熇':'1',
'熘':'1',
'熔':'1',
'煽':'1',
'熥':'1',
'熄':'1',
'燁':'1',
'熗':'1',
'熢':'1',
'熚':'1',
'煿':'1',
'煼':'1',
'煾':'1',
'熕':'1',
'煹':'1',
'熆':'1',
'熀':'1',
'熑':'1',
'熐':'1',
'熌':'1',
'煻':'1',
'熓':'1',
'熂':'1',
'熁':'1',
'熖':'1',
'熎':'1',
'熅':'1',
'熉':'1',
'觏':'1',
'斲':'1',
'毾':'1',
'榜':'1',
'槟':'1',
'榱':'1',
'榧':'1',
'榑':'1',
'槔':'1',
'槁':'1',
'槅':'1',
'榥':'1',
'槚':'1',
'槛':'1',
'榤':'1',
'榼':'1',
'榴':'1',
'榠':'1',
'模':'1',
'榷':'1',
'榕':'1',
'榫':'1',
'榻':'1',
'槄':'1',
'樋':'1',
'榲':'1',
'榍':'1',
'榨':'1',
'榛':'1',
'榰':'1',
'槠':'1',
'榦':'1',
'槑':'1',
'槇':'1',
'構':'1',
'榎':'1',
'槤':'1',
'槓':'1',
'榪':'1',
'樺':'1',
'榿':'1',
'槍':'1',
'槨':'1',
'榖':'1',
'榐':'1',
'樄':'1',
'樆':'1',
'槒':'1',
'槝':'1',
'槙':'1',
'槉':'1',
'榢':'1',
'榗':'1',
'樃':'1',
'槏':'1',
'槞':'1',
'榓':'1',
'槈':'1',
'榒':'1',
'槰':'1',
'樥':'1',
'榩':'1',
'槗':'1',
'槡':'1',
'榝':'1',
'榺':'1',
'榯':'1',
'榹':'1',
'榡':'1',
'槂':'1',
'榶':'1',
'樤':'1',
'榽':'1',
'樇':'1',
'様':'1',
'榚':'1',
'榣':'1',
'榏':'1',
'榞':'1',
'榬':'1',
'榸':'1',
'槜':'1',
'槕':'1',
'榟':'1',
'犒':'1',
'犕':'1',
'犓':'1',
'犗':'1',
'犔':'1',
'牄':'1',
'牓':'1',
'牔':'1',
'敲':'1',
'敱':'1',
'敳':'1',
'敶':'1',
'歌':'1',
'歉':'1',
'歍':'1',
'歊':'1',
'歋':'1',
'獃':'1',
'暧':'1',
'暝':'1',
'暢':'1',
'暱':'1',
'暤':'1',
'暞':'1',
'暟':'1',
'暯':'1',
'暣':'1',
'暡':'1',
'暥':'1',
'暚':'1',
'禢':'1',
'禚':'1',
'禛':'1',
'禡':'1',
'禣':'1',
'禞':'1',
'禝':'1',
'禠':'1',
'禟':'1',
'毄':'1',
'毃':'1',
'甈':'1',
'甉':'1',
'瑷':'1',
'璈':'1',
'瑨':'1',
'璃':'1',
'瑢':'1',
'瑭':'1',
'瑱':'1',
'瑶':'1',
'璉':'1',
'瑪':'1',
'瑣':'1',
'瑲':'1',
'瑠':'1',
'瑸':'1',
'璍':'1',
'瑮':'1',
'瑡':'1',
'瑹':'1',
'瑫':'1',
'瑦':'1',
'璓':'1',
'瑤':'1',
'瑧':'1',
'韬':'1',
'朅':'1',
'朄':'1',
'膀':'1',
'膑':'1',
'膊':'1',
'膈':'1',
'膜':'1',
'膍':'1',
'膁':'1',
'膆':'1',
'膌':'1',
'膖':'1',
'膅':'1',
'膃':'1',
'膎':'1',
'膉':'1',
'稨':'1',
'穊':'1',
'稳':'1',
'稬':'1',
'稭':'1',
'稱':'1',
'種':'1',
'稫':'1',
'稲':'1',
'稪':'1',
'稩':'1',
'稵':'1',
'稧':'1',
'穁':'1',
'稰':'1',
'稦':'1',
'稯':'1',
'锿':'1',
'锸':'1',
'镀':'1',
'锻':'1',
'锷':'1',
'镄':'1',
'锾':'1',
'锽':'1',
'锴':'1',
'镂':'1',
'镅':'1',
'镁':'1',
'锵':'1',
'锲':'1',
'锶':'1',
'锼':'1',
'镃':'1',
'锺':'1',
'端':'1',
'竭':'1',
'竰':'1',
'竮':'1',
'竬':'1',
'毓':'1',
'瞅':'1',
'瞆':'1',
'睽':'1',
'瞍':'1',
'瞇':'1',
'睶':'1',
'瞂':'1',
'睴':'1',
'睺':'1',
'睳':'1',
'睸':'1',
'睼':'1',
'瞃':'1',
'睱':'1',
'睲':'1',
'瞁':'1',
'睻':'1',
'睮':'1',
'睵':'1',
'鹚':'1',
'鹗':'1',
'鹘':'1',
'鹖':'1',
'鹕':'1',
'鹛':'1',
'皷':'1',
'皸':'1',
'皹':'1',
'皶':'1',
'碥':'1',
'碴':'1',
'磁':'1',
'磋':'1',
'碲':'1',
'碟':'1',
'碫':'1',
'碱':'1',
'碣':'1',
'磈':'1',
'碶':'1',
'碳':'1',
'碨':'1',
'碹':'1',
'碡':'1',
'碸':'1',
'碪':'1',
'碩':'1',
'碭':'1',
'碮':'1',
'碠':'1',
'磓':'1',
'碷':'1',
'磀':'1',
'磆':'1',
'碦':'1',
'碯':'1',
'碝':'1',
'碵':'1',
'碬':'1',
'畼':'1',
'畻':'1',
'畽':'1',
'疑':'1',
'褙':'1',
'褊':'1',
'褡':'1',
'褝':'1',
'褐':'1',
'褛':'1',
'褪':'1',
'褞':'1',
'褘':'1',
'褕':'1',
'褌':'1',
'褨':'1',
'褈':'1',
'褋':'1',
'褍':'1',
'複':'1',
'褔':'1',
'褆':'1',
'褅':'1',
'褖':'1',
'褉':'1',
'褗':'1',
'裫':'1',
'褑':'1',
'蝉':'1',
'蝈':'1',
'蜾':'1',
'蜡':'1',
'蜽':'1',
'蜢':'1',
'蜱':'1',
'蜞':'1',
'蜻':'1',
'蜷':'1',
'蜩':'1',
'蜿':'1',
'蜥':'1',
'蜴':'1',
'蝇':'1',
'蜮':'1',
'蜯':'1',
'蝄':'1',
'蜠':'1',
'蜫':'1',
'蝋':'1',
'蜶':'1',
'蜟':'1',
'蝂':'1',
'蝀':'1',
'蜺':'1',
'蝕':'1',
'蜨':'1',
'蝸':'1',
'蝃':'1',
'蜳':'1',
'蜬':'1',
'蜭':'1',
'蜛':'1',
'蜧':'1',
'蜦':'1',
'蜙':'1',
'蜪':'1',
'蜼':'1',
'蜲':'1',
'蝧':'1',
'蝫':'1',
'聝':'1',
'聛':'1',
'聡':'1',
'聜':'1',
'聢':'1',
'聙':'1',
'聣':'1',
'罁':'1',
'虠':'1',
'耥':'1',
'耤':'1',
'耣':'1',
'粹':'1',
'精':'1',
'粼':'1',
'糁':'1',
'粽':'1',
'粺':'1',
'粿':'1',
'粷':'1',
'粶':'1',
'粸':'1',
'粻':'1',
'緐':'1',
'舔':'1',
'舓':'1',
'舕':'1',
'綵':'1',
'綝':'1',
'綷':'1',
'緺':'1',
'緉':'1',
'綪':'1',
'緌':'1',
'綯':'1',
'緅':'1',
'綾':'1',
'緒':'1',
'綫':'1',
'綺':'1',
'緋':'1',
'緔':'1',
'綽':'1',
'綥':'1',
'網':'1',
'綱':'1',
'緄':'1',
'綬':'1',
'綸':'1',
'綳':'1',
'綹':'1',
'綢':'1',
'維':'1',
'綿':'1',
'綜':'1',
'綻':'1',
'綰':'1',
'綣':'1',
'綠':'1',
'緇':'1',
'綴':'1',
'緍':'1',
'綼':'1',
'緂':'1',
'総':'1',
'綞':'1',
'綶':'1',
'綟':'1',
'綡':'1',
'緑':'1',
'緢':'1',
'綨':'1',
'緀':'1',
'緕':'1',
'緁':'1',
'綩':'1',
'緆':'1',
'緈':'1',
'緓':'1',
'緎':'1',
'綧':'1',
'緃':'1',
'翤':'1',
'翢':'1',
'翞':'1',
'艋':'1',
'艊':'1',
'艍':'1',
'艌':'1',
'賑':'1',
'賕':'1',
'賖':'1',
'賗':'1',
'賒':'1',
'賐':'1',
'賏':'1',
'賘':'1',
'輒':'1',
'輔':'1',
'輕':'1',
'輓':'1',
'輐':'1',
'輑':'1',
'輎':'1',
'輏':'1',
'輍':'1',
'赫':'1',
'谽':'1',
'覡':'1',
'覠':'1',
'覝':'1',
'覞':'1',
'覟':'1',
'觫':'1',
'觨':'1',
'觩':'1',
'觪':'1',
'躴':'1',
'躵':'1',
'豨':'1',
'豩':'1',
'豧':'1',
'辣':'1',
'辢':'1',
'辡':'1',
'誡':'1',
'語':'1',
'誌':'1',
'誣':'1',
'誖':'1',
'誚':'1',
'誤':'1',
'誥':'1',
'誘':'1',
'誨':'1',
'誑':'1',
'説':'1',
'誦':'1',
'認':'1',
'誝':'1',
'誧':'1',
'誗':'1',
'誎':'1',
'読':'1',
'誐':'1',
'誮':'1',
'誋':'1',
'誩':'1',
'誙':'1',
'誏':'1',
'誛':'1',
'誜':'1',
'說':'1',
'誒':'1',
'誢':'1',
'誟':'1',
'誫':'1',
'镌':'1',
'镑':'1',
'镈':'1',
'镐':'1',
'镉':'1',
'镓':'1',
'镏':'1',
'镆':'1',
'镎':'1',
'镊':'1',
'镍':'1',
'镋':'1',
'镒':'1',
'镇':'1',
'镔':'1',
'镕':'1',
'瞋':'1',
'瞌':'1',
'瞒':'1',
'瞑':'1',
'瞎':'1',
'瞝':'1',
'瞊':'1',
'瞉':'1',
'瞙':'1',
'瞈':'1',
'瞱':'1',
'鹤':'1',
'鹣':'1',
'鹠':'1',
'鹟':'1',
'鹞':'1',
'鹝':'1',
'鹢':'1',
'鹡':'1',
'皺':'1',
'磅':'1',
'磙':'1',
'磕':'1',
'磏':'1',
'碾':'1',
'磉':'1',
'磔':'1',
'碼':'1',
'碻':'1',
'確':'1',
'磑':'1',
'磝':'1',
'碽':'1',
'磂':'1',
'磗':'1',
'磇':'1',
'磎':'1',
'磍':'1',
'磃':'1',
'碿':'1',
'磄':'1',
'磌':'1',
'磘':'1',
'磤':'1',
'磒':'1',
'褫':'1',
'褯':'1',
'褴':'1',
'褵':'1',
'褦':'1',
'褥':'1',
'褳':'1',
'褟':'1',
'褲':'1',
'襅':'1',
'褠':'1',
'褣':'1',
'褬':'1',
'褤':'1',
'蝙':'1',
'蝽':'1',
'蝶':'1',
'蝠':'1',
'蝮':'1',
'蝗':'1',
'蝌':'1',
'蝰':'1',
'蝼':'1',
'蝻':'1',
'蝤':'1',
'蝾':'1',
'螋':'1',
'蝎':'1',
'蝣':'1',
'蝓':'1',
'蝿':'1',
'蝜':'1',
'蝘':'1',
'蝟':'1',
'蝯':'1',
'蝦':'1',
'蝹':'1',
'螁':'1',
'蝭':'1',
'蝩':'1',
'螆':'1',
'蝳':'1',
'螝':'1',
'螖':'1',
'蝔':'1',
'蝷':'1',
'蝐':'1',
'蝞':'1',
'蝒':'1',
'蝚':'1',
'蝺':'1',
'蝡':'1',
'蝪':'1',
'蝏':'1',
'蝛':'1',
'蝑':'1',
'蝢':'1',
'蝖':'1',
'蜵':'1',
'蝝':'1',
'蝬':'1',
'聪':'1',
'聩':'1',
'聤':'1',
'聦':'1',
'聥':'1',
'聧':'1',
'聭':'1',
'聨':'1',
'聫':'1',
'虢':'1',
'耧':'1',
'耦':'1',
'糍':'1',
'糇':'1',
'糅':'1',
'糈':'1',
'糌':'1',
'糂':'1',
'糉':'1',
'糄':'1',
'糋':'1',
'糎':'1',
'糆':'1',
'糃':'1',
'糔':'1',
'緜':'1',
'舖':'1',
'舗':'1',
'縆':'1',
'緘':'1',
'緛':'1',
'緼':'1',
'緰':'1',
'緙':'1',
'緗':'1',
'練':'1',
'緬':'1',
'緲':'1',
'緹':'1',
'緝':'1',
'緦':'1',
'緩':'1',
'緞':'1',
'緶':'1',
'線':'1',
'緥':'1',
'縋':'1',
'緱':'1',
'締':'1',
'縂':'1',
'編':'1',
'緪':'1',
'縁':'1',
'緯':'1',
'緾':'1',
'緽':'1',
'緟':'1',
'縒':'1',
'緫':'1',
'緿':'1',
'緮':'1',
'縎':'1',
'緷':'1',
'緡':'1',
'縌':'1',
'緧':'1',
'縙':'1',
'縇':'1',
'縄':'1',
'緭':'1',
'縅':'1',
'縀':'1',
'緤':'1',
'緖':'1',
'縃':'1',
'緸':'1',
'緣':'1',
'緵':'1',
'翩':'1',
'翪':'1',
'翫':'1',
'翭':'1',
'翧':'1',
'艑':'1',
'艖':'1',
'艓':'1',
'艎':'1',
'艏':'1',
'艘':'1',
'艔':'1',
'艐':'1',
'艒':'1',
'賧':'1',
'賦':'1',
'賬':'1',
'賭':'1',
'賤':'1',
'賜':'1',
'賙':'1',
'賠':'1',
'賝':'1',
'賩':'1',
'賥':'1',
'賟':'1',
'镼':'1',
'輗':'1',
'輫':'1',
'輣':'1',
'輚':'1',
'輝':'1',
'輙':'1',
'輛':'1',
'輥':'1',
'輞':'1',
'輪':'1',
'輨':'1',
'輟':'1',
'輜':'1',
'輠':'1',
'輡':'1',
'輘':'1',
'輬':'1',
'輧':'1',
'輢':'1',
'輖':'1',
'輤':'1',
'赭':'1',
'豌':'1',
'豍':'1',
'谾':'1',
'覩':'1',
'覥':'1',
'覢':'1',
'覣':'1',
'覤':'1',
'觭':'1',
'觯':'1',
'觰':'1',
'觮':'1',
'觬':'1',
'麹':'1',
'躺':'1',
'躶':'1',
'躷':'1',
'躸':'1',
'躹':'1',
'躻':'1',
'躼':'1',
'豫':'1',
'豬':'1',
'辤':'1',
'諔':'1',
'諓':'1',
'諙':'1',
'請':'1',
'諾':'1',
'諸':'1',
'諏':'1',
'諑':'1',
'課':'1',
'誹':'1',
'諗':'1',
'論':'1',
'諉':'1',
'誰':'1',
'諛':'1',
'調':'1',
'諂':'1',
'誼':'1',
'誶':'1',
'諄':'1',
'諒':'1',
'談':'1',
'諀':'1',
'諘':'1',
'誯':'1',
'諃':'1',
'誺':'1',
'誴':'1',
'諎':'1',
'諌':'1',
'諣':'1',
'諕':'1',
'誱':'1',
'諊':'1',
'誳':'1',
'誽':'1',
'諚':'1',
'諩':'1',
'諆':'1',
'誻':'1',
'誷':'1',
'誸':'1',
'誵':'1',
'諈':'1',
'諁':'1',
'郶':'1',
'醇':'1',
'醋':'1',
'醌':'1',
'醂':'1',
'醁':'1',
'醅':'1',
'醄':'1',
'醊':'1',
'醉':'1',
'醃':'1',
'醆':'1',
'醈':'1',
'醏':'1',
'醀':'1',
'貓':'1',
'貏':'1',
'貎':'1',
'踣':'1',
'踩':'1',
'踟':'1',
'踔':'1',
'踧':'1',
'踮':'1',
'踝':'1',
'踑':'1',
'踺':'1',
'踞':'1',
'踡':'1',
'踦':'1',
'踏':'1',
'踢':'1',
'踠':'1',
'踒':'1',
'踯':'1',
'踬':'1',
'踪':'1',
'踖':'1',
'踐':'1',
'踫':'1',
'踜':'1',
'踓':'1',
'踤':'1',
'踻':'1',
'踕':'1',
'踘':'1',
'踛':'1',
'踚':'1',
'蹃':'1',
'踗':'1',
'踙':'1',
'踥':'1',
'踷':'1',
'踨':'1',
'龊':'1',
'龉':'1',
'銶':'1',
'鋗':'1',
'鋜':'1',
'鋕':'1',
'鋙':'1',
'銾':'1',
'鋱':'1',
'鋪':'1',
'銷':'1',
'鋤':'1',
'鋰':'1',
'鋥':'1',
'鋇':'1',
'銼':'1',
'鋯':'1',
'鋝':'1',
'銹':'1',
'鋨':'1',
'鋒':'1',
'鋅':'1',
'鋶':'1',
'鋭':'1',
'銻':'1',
'鋃':'1',
'鋟':'1',
'鋦':'1',
'錒':'1',
'鋲':'1',
'鋍':'1',
'鋓':'1',
'鋑':'1',
'鋀':'1',
'銳':'1',
'錺':'1',
'銽':'1',
'銲':'1',
'鋎':'1',
'鋡':'1',
'鋐':'1',
'鋘':'1',
'錵':'1',
'鋏':'1',
'鋄':'1',
'鋞':'1',
'銵':'1',
'錓':'1',
'鋛':'1',
'鋢':'1',
'鋂':'1',
'銸':'1',
'鋠':'1',
'鋖':'1',
'鋉':'1',
'鋵':'1',
'鋔':'1',
'鋧':'1',
'銿':'1',
'鋊':'1',
'鋴':'1',
'鋳':'1',
'靚':'1',
'餔':'1',
'餗':'1',
'餑':'1',
'餖':'1',
'餒':'1',
'餘':'1',
'餓':'1',
'餕':'1',
'餝':'1',
'餙':'1',
'鲠':'1',
'鲧':'1',
'鲩':'1',
'鲫':'1',
'鲣':'1',
'鲪':'1',
'鲡':'1',
'鲤':'1',
'鲢':'1',
'鲥':'1',
'鲦':'1',
'鲬':'1',
'雓':'1',
'鞍':'1',
'鞑':'1',
'鞒':'1',
'鞋':'1',
'鞈':'1',
'鞎':'1',
'鞊':'1',
'鞐':'1',
'鞉':'1',
'鞗':'1',
'鞇':'1',
'骴':'1',
'骼':'1',
'骸':'1',
'骺':'1',
'骹':'1',
'骻':'1',
'骿':'1',
'韐':'1',
'頞':'1',
'頠':'1',
'頫':'1',
'頡':'1',
'頜':'1',
'頟':'1',
'頲':'1',
'頦':'1',
'頨':'1',
'頧':'1',
'頬':'1',
'頢':'1',
'頛':'1',
'頪':'1',
'頩':'1',
'頝':'1',
'頣':'1',
'髛':'1',
'駜':'1',
'駉':'1',
'駓':'1',
'駔':'1',
'駛':'1',
'駟':'1',
'駈':'1',
'駙':'1',
'駒':'1',
'駝':'1',
'駐':'1',
'駘':'1',
'駖':'1',
'駠':'1',
'駍':'1',
'駊':'1',
'駞':'1',
'駚':'1',
'駋':'1',
'駗':'1',
'駎':'1',
'黆':'1',
'黅':'1',
'鹶':'1',
'麨':'1',
'麩':'1',
'麪':'1',
'麫':'1',
'鴃':'1',
'鳾':'1',
'鴉':'1',
'鴇':'1',
'鴆':'1',
'鴁':'1',
'鳻':'1',
'鳷':'1',
'鴋':'1',
'鴀':'1',
'鳺':'1',
'鴔':'1',
'鴂':'1',
'鴅':'1',
'鳽':'1',
'鴎':'1',
'鴄':'1',
'鳹':'1',
'鳼':'1',
'鳿':'1',
'魬':'1',
'魣':'1',
'魷':'1',
'魨':'1',
'魴':'1',
'魮':'1',
'魤':'1',
'魧':'1',
'魱':'1',
'魪':'1',
'鮔':'1',
'魲':'1',
'魩':'1',
'魹':'1',
'魶':'1',
'魸':'1',
'魦':'1',
'魫':'1',
'魳':'1',
'魭':'1',
'魰':'1',
'黓':'1',
'颙':'1',
'颚':'1',
'颛':'1',
'羯':'1',
'额':'1',
'颜':'1',
'羰':'1',
'羬':'1',
'﨧':'1',
'墳':'1',
'幩':'1',
'憤':'1',
'獖':'1',
'瞓':'1',
'羭':'1',
'魵':'1',
'嶓':'1',
'嶒':'1',
'嶝':'1',
'嶙':'1',
'嶟':'1',
'嶢':'1',
'嶠':'1',
'嶗':'1',
'嶕':'1',
'嶥':'1',
'嶱':'1',
'嶛':'1',
'嶖':'1',
'影':'1',
'馓':'1',
'馔':'1',
'壿':'1',
'播':'1',
'撑':'1',
'撺':'1',
'撮':'1',
'撴':'1',
'撝':'1',
'撅':'1',
'撧':'1',
'撩':'1',
'撸':'1',
'撵':'1',
'撚':'1',
'撬':'1',
'擒':'1',
'撰':'1',
'撞':'1',
'撙':'1',
'撡':'1',
'撳':'1',
'撓':'1',
'撻':'1',
'撐':'1',
'撲':'1',
'撣':'1',
'撫':'1',
'擕':'1',
'撟':'1',
'撈':'1',
'撥':'1',
'撏':'1',
'撪':'1',
'撜':'1',
'撘':'1',
'撢':'1',
'撌':'1',
'撔':'1',
'撠':'1',
'擖':'1',
'摾':'1',
'撹':'1',
'擑':'1',
'擏':'1',
'撛':'1',
'摨':'1',
'撍':'1',
'撋':'1',
'撨':'1',
'撊':'1',
'擛':'1',
'撎':'1',
'擙':'1',
'澳':'1',
'潺':'1',
'澈':'1',
'澄':'1',
'濆':'1',
'澔':'1',
'澒':'1',
'潓':'1',
'澜':'1',
'潦':'1',
'潾':'1',
'潖':'1',
'潘':'1',
'潽':'1',
'潜':'1',
'潵':'1',
'潸':'1',
'潠':'1',
'澾':'1',
'潭':'1',
'潼':'1',
'潫':'1',
'澫':'1',
'潕':'1',
'潝':'1',
'潟':'1',
'潔':'1',
'澆':'1',
'澘':'1',
'澐':'1',
'澁':'1',
'潛':'1',
'潿':'1',
'潰':'1',
'澂':'1',
'潷':'1',
'潨':'1',
'澇':'1',
'澗':'1',
'潑':'1',
'潯':'1',
'潤':'1',
'潹':'1',
'澊':'1',
'濎':'1',
'潡':'1',
'澓':'1',
'潙':'1',
'澏':'1',
'潶':'1',
'澋':'1',
'澅':'1',
'潗':'1',
'濈':'1',
'潐':'1',
'潏':'1',
'澑':'1',
'澛':'1',
'潣':'1',
'澝':'1',
'漒':'1',
'潬':'1',
'潻':'1',
'濍':'1',
'潥':'1',
'澻':'1',
'漽':'1',
'澙':'1',
'澖':'1',
'潱':'1',
'潪':'1',
'潧':'1',
'濐':'1',
'缭':'1',
'缮':'1',
'缯':'1',
'墺':'1',
'墀':'1',
'墫':'1',
'墦':'1',
'墝':'1',
'墠':'1',
'墡':'1',
'增':'1',
'墶':'1',
'墢':'1',
'墱':'1',
'墥':'1',
'墹':'1',
'墤':'1',
'墲':'1',
'墣':'1',
'墧':'1',
'墰':'1',
'墵':'1',
'夦':'1',
'懊':'1',
'憯':'1',
'憧':'1',
'懂':'1',
'憓':'1',
'憬':'1',
'憭':'1',
'憔':'1',
'憎':'1',
'憒':'1',
'憚':'1',
'憮':'1',
'憞':'1',
'憐':'1',
'憫':'1',
'憡':'1',
'憕':'1',
'憱':'1',
'憣':'1',
'憍':'1',
'憢':'1',
'憰':'1',
'懏':'1',
'憦':'1',
'憉':'1',
'憽':'1',
'憟':'1',
'憛':'1',
'憳':'1',
'憘':'1',
'憪':'1',
'赜':'1',
'凛':'1',
'凙':'1',
'凜':'1',
'凚':'1',
'劎':'1',
'劐':'1',
'劌':'1',
'劇':'1',
'劍':'1',
'劊':'1',
'劉':'1',
'劅':'1',
'劋':'1',
'劆':'1',
'劏':'1',
'鄳':'1',
'險':'1',
'鄴':'1',
'鄵':'1',
'鄷':'1',
'鄶':'1',
'鄸':'1',
'隦':'1',
'勰':'1',
'勯':'1',
'勮':'1',
'僶':'1',
'僾':'1',
'儋':'1',
'僵':'1',
'儌':'1',
'僻':'1',
'僿':'1',
'儇':'1',
'僽':'1',
'價':'1',
'儂':'1',
'儍':'1',
'儉':'1',
'儈':'1',
'億':'1',
'儀':'1',
'儏':'1',
'儃':'1',
'儊':'1',
'儅':'1',
'僼':'1',
'僸':'1',
'儚':'1',
'儙':'1',
'僺':'1',
'儎':'1',
'叇':'1',
'谴':'1',
'谵':'1',
'德':'1',
'徵':'1',
'徲':'1',
'徸':'1',
'徺':'1',
'彈':'1',
'幢':'1',
'幡':'1',
'幞':'1',
'幠':'1',
'幟':'1',
'幝':'1',
'幜':'1',
'幥':'1',
'噌':'1',
'嘬':'1',
'噇':'1',
'噔':'1',
'噁':'1',
'噶':'1',
'嘿':'1',
'噍':'1',
'噘':'1',
'嘹':'1',
'噜':'1',
'噢':'1',
'嘭':'1',
'噗':'1',
'噙':'1',
'噎':'1',
'嘻':'1',
'噏':'1',
'噀':'1',
'嘱':'1',
'噂':'1',
'噴':'1',
'嘵':'1',
'嘠':'1',
'噠':'1',
'嘽':'1',
'嘸':'1',
'嘷':'1',
'嘮':'1',
'噚':'1',
'噝':'1',
'嘰':'1',
'噃':'1',
'噆':'1',
'噄':'1',
'噈':'1',
'嘾':'1',
'嘳':'1',
'噅':'1',
'噋':'1',
'噒':'1',
'嘪':'1',
'噛':'1',
'嘺':'1',
'嘫':'1',
'噓':'1',
'噧':'1',
'噖':'1',
'噊':'1',
'骣':'1',
'嬎':'1',
'嫽':'1',
'嬉':'1',
'嬈':'1',
'嬋':'1',
'嬀':'1',
'嫵':'1',
'嬌':'1',
'嫻':'1',
'嫺':'1',
'嫿':'1',
'嬁':'1',
'嬞':'1',
'嬏':'1',
'嫴':'1',
'嫶':'1',
'嬇':'1',
'嫾':'1',
'嬍':'1',
'嫼':'1',
'嬘':'1',
'嬆':'1',
'嬄':'1',
'嫸':'1',
'嬂':'1',
'獗':'1',
'獠':'1',
'獋':'1',
'獛':'1',
'獤':'1',
'獦':'1',
'獜':'1',
'獞':'1',
'獟':'1',
'獢':'1',
'獝':'1',
'辘':'1',
'殣':'1',
'殢':'1',
'殤':'1',
'殦':'1',
'殥':'1',
'斢':'1',
'飘':'1',
'戮':'1',
'戯':'1',
'戭':'1',
'熛':'1',
'熯':'1',
'熳':'1',
'熰':'1',
'熵':'1',
'熠':'1',
'熝':'1',
'熜':'1',
'熣':'1',
'熩':'1',
'熿':'1',
'熞':'1',
'熲':'1',
'熦':'1',
'熴':'1',
'熮':'1',
'熡':'1',
'熤':'1',
'熪':'1',
'熼':'1',
'熫':'1',
'觐':'1',
'觑':'1',
'斳':'1',
'毿':'1',
'氀':'1',
'槽':'1',
'樘':'1',
'樗':'1',
'樀':'1',
'橄':'1',
'横':'1',
'槲':'1',
'槥':'1',
'樫':'1',
'槿':'1',
'樛':'1',
'槺':'1',
'槭':'1',
'樯':'1',
'橡':'1',
'樱':'1',
'樟':'1',
'檛':'1',
'樁':'1',
'標':'1',
'樞':'1',
'樏':'1',
'樓':'1',
'樅':'1',
'樑':'1',
'樣':'1',
'橢':'1',
'槹':'1',
'槱':'1',
'樔':'1',
'樬':'1',
'槯':'1',
'槢':'1',
'樚':'1',
'槪':'1',
'樌':'1',
'槣':'1',
'槶':'1',
'槻':'1',
'槴':'1',
'槬':'1',
'槵':'1',
'樭':'1',
'樠':'1',
'樐':'1',
'槾':'1',
'橗':'1',
'樒':'1',
'樢':'1',
'樈':'1',
'槫':'1',
'権':'1',
'槮':'1',
'樧':'1',
'樉':'1',
'樎':'1',
'樕':'1',
'樰':'1',
'樮':'1',
'槸':'1',
'槦':'1',
'樍':'1',
'樝':'1',
'樜':'1',
'樦':'1',
'犙':'1',
'牅':'1',
'牖':'1',
'牕':'1',
'牗':'1',
'敺':'1',
'敷':'1',
'敵':'1',
'數':'1',
'敹':'1',
'歔':'1',
'歎':'1',
'歐':'1',
'歑':'1',
'歓':'1',
'歏':'1',
'歒':'1',
'暵':'1',
'曄':'1',
'暷':'1',
'暰':'1',
'曃':'1',
'暭':'1',
'曂':'1',
'暳':'1',
'暩':'1',
'暪':'1',
'暶':'1',
'暲':'1',
'禤':'1',
'禩':'1',
'禥':'1',
'毅':'1',
'毆':'1',
'滕':'1',
'潁':'1',
'甎':'1',
'甌':'1',
'甋':'1',
'甊':'1',
'瑽':'1',
'璁':'1',
'璀':'1',
'瑾':'1',
'璊':'1',
'璆':'1',
'璅':'1',
'璎':'1',
'璋':'1',
'璂':'1',
'璡':'1',
'瑺':'1',
'璄':'1',
'瑻':'1',
'璖':'1',
'璌':'1',
'瑼':'1',
'膘':'1',
'膗':'1',
'膵':'1',
'膛':'1',
'膝':'1',
'膣':'1',
'膞':'1',
'膕':'1',
'膓':'1',
'膠':'1',
'膔':'1',
'膢':'1',
'膟':'1',
'膒':'1',
'膷':'1',
'膤':'1',
'膡':'1',
'膼':'1',
'歵':'1',
'爴':'1',
'皝':'1',
'皚':'1',
'皞':'1',
'皜':'1',
'皣':'1',
'稻':'1',
'稿':'1',
'穀':'1',
'稽':'1',
'稷':'1',
'稹':'1',
'稺':'1',
'稴':'1',
'穃':'1',
'穂':'1',
'稸':'1',
'稶':'1',
'稼':'1',
'辚':'1',
'殪':'1',
'殨':'1',
'殫':'1',
'殩':'1',
'殧':'1',
'旙':'1',
'旘':'1',
'飙':'1',
'戰':'1',
'戱':'1',
'燔':'1',
'熸':'1',
'燎':'1',
'燋':'1',
'燃':'1',
'燊':'1',
'燧':'1',
'燖':'1',
'燠':'1',
'燏':'1',
'燄':'1',
'熺':'1',
'燒':'1',
'燀':'1',
'熾':'1',
'燉':'1',
'燜':'1',
'燈':'1',
'燪':'1',
'熶':'1',
'燵':'1',
'燑':'1',
'燝':'1',
'燇':'1',
'燗':'1',
'燤':'1',
'燐':'1',
'燘':'1',
'燂':'1',
'燆':'1',
'燍':'1',
'熻':'1',
'燅':'1',
'熷':'1',
'斴':'1',
'氄':'1',
'氃':'1',
'橙':'1',
'橱':'1',
'樲':'1',
'橘':'1',
'橛':'1',
'橹':'1',
'橇':'1',
'樵':'1',
'檎':'1',
'橪':'1',
'檨':'1',
'橦':'1',
'樨':'1',
'橼':'1',
'樾':'1',
'檇':'1',
'樽':'1',
'橈':'1',
'樹':'1',
'樸':'1',
'檝':'1',
'橋':'1',
'機':'1',
'橺':'1',
'橴':'1',
'橧':'1',
'橕':'1',
'橖':'1',
'檙':'1',
'橻':'1',
'橁':'1',
'橽':'1',
'檤':'1',
'橂':'1',
'橝':'1',
'橷':'1',
'橔':'1',
'橃':'1',
'橎':'1',
'橰':'1',
'橭':'1',
'橫':'1',
'橞':'1',
'橶':'1',
'橌':'1',
'橏':'1',
'橸':'1',
'樻':'1',
'橑':'1',
'橯':'1',
'橉':'1',
'橊':'1',
'橮':'1',
'橅':'1',
'橣':'1',
'橠':'1',
'橬':'1',
'橩':'1',
'橍':'1',
'橵':'1',
'樿':'1',
'橳':'1',
'橓':'1',
'檧':'1',
'檖':'1',
'橀':'1',
'橲':'1',
'樳':'1',
'樴':'1',
'橒':'1',
'樼':'1',
'樶':'1',
'犜':'1',
'犞':'1',
'犝':'1',
'敽':'1',
'敼':'1',
'敿':'1',
'敾':'1',
'歙':'1',
'歘':'1',
'歕':'1',
'歚':'1',
'歖':'1',
'獣':'1',
'曈':'1',
'暾':'1',
'曀':'1',
'曊':'1',
'曍':'1',
'暻':'1',
'曔':'1',
'暸':'1',
'暽':'1',
'曋':'1',
'暺':'1',
'暿':'1',
'曉':'1',
'禫':'1',
'禧':'1',
'禪':'1',
'禨':'1',
'禭':'1',
'毈':'1',
'毇':'1',
'甑':'1',
'甐':'1',
'甒':'1',
'璠':'1',
'璟':'1',
'璘':'1',
'璞':'1',
'璕':'1',
'璢':'1',
'璣':'1',
'璒':'1',
'璝':'1',
'璭':'1',
'璤':'1',
'璥':'1',
'璚':'1',
'璙':'1',
'璲':'1',
'璏':'1',
'璑':'1',
'璔':'1',
'斓':'1',
'膪':'1',
'膰':'1',
'膙':'1',
'膫':'1',
'膦':'1',
'膳':'1',
'膩':'1',
'臈':'1',
'朣':'1',
'膧':'1',
'膬':'1',
'膭':'1',
'膴':'1',
'膲':'1',
'臇':'1',
'朥':'1',
'膸':'1',
'膯':'1',
'膮':'1',
'膶':'1',
'膱':'1',
'皡':'1',
'皠':'1',
'皟':'1',
'瓢':'1',
'穇':'1',
'穄':'1',
'穆':'1',
'穑':'1',
'積':'1',
'穌':'1',
'穅':'1',
'穎':'1',
'穔':'1',
'穋':'1',
'穐':'1',
'穓':'1',
'穏':'1',
'嶰':'1',
'嶩':'1',
'嶧':'1',
'嶼':'1',
'嶮':'1',
'嶦':'1',
'嶫':'1',
'嶬':'1',
'嶵':'1',
'操':'1',
'撼':'1',
'擐':'1',
'擓':'1',
'擂':'1',
'擗':'1',
'撽':'1',
'擅':'1',
'擋':'1',
'據':'1',
'擄':'1',
'擇':'1',
'撿':'1',
'擔':'1',
'擈':'1',
'擉':'1',
'擜':'1',
'擭':'1',
'擳':'1',
'擝':'1',
'擃':'1',
'擌':'1',
'擁':'1',
'澠':'1',
'濒':'1',
'澶':'1',
'澹':'1',
'澤':'1',
'澴':'1',
'激':'1',
'澽':'1',
'澧':'1',
'濂':'1',
'潞':'1',
'濛':'1',
'澼':'1',
'澨':'1',
'澥':'1',
'澡':'1',
'澣':'1',
'濇':'1',
'濃':'1',
'濁':'1',
'澱':'1',
'澦':'1',
'濭':'1',
'澯':'1',
'濸':'1',
'濋':'1',
'澬':'1',
'濨':'1',
'澸':'1',
'澢':'1',
'濩':'1',
'澮':'1',
'濊':'1',
'濅':'1',
'澰':'1',
'濓':'1',
'澟':'1',
'澪':'1',
'澷':'1',
'濗':'1',
'澿':'1',
'濏':'1',
'濖':'1',
'潚':'1',
'澲':'1',
'澺':'1',
'澭':'1',
'澞':'1',
'澵':'1',
'瀄':'1',
'缳':'1',
'缰':'1',
'缴':'1',
'缱':'1',
'缲':'1',
'壈':'1',
'墻':'1',
'壋':'1',
'壇':'1',
'壒':'1',
'墽':'1',
'壊':'1',
'壃':'1',
'壉':'1',
'壀':'1',
'壌':'1',
'墿':'1',
'憴':'1',
'懆':'1',
'憷':'1',
'憺':'1',
'憾':'1',
'懔':'1',
'懁':'1',
'懞':'1',
'懌':'1',
'憹':'1',
'憶':'1',
'懍':'1',
'懓':'1',
'懐':'1',
'憿':'1',
'懅':'1',
'懜':'1',
'懄':'1',
'懎':'1',
'憻':'1',
'懀':'1',
'憸':'1',
'懙':'1',
'赠':'1',
'镚':'1',
'镖':'1',
'镝':'1',
'镜':'1',
'镠':'1',
'镘':'1',
'镗':'1',
'镛':'1',
'镙':'1',
'镟':'1',
'竱':'1',
'瞠':'1',
'瞛':'1',
'瞜':'1',
'瞟':'1',
'瞚':'1',
'瞞':'1',
'瞘':'1',
'瞗':'1',
'瞡':'1',
'瞣':'1',
'瞔':'1',
'瞕':'1',
'鹨':'1',
'鹦':'1',
'鹧':'1',
'皻':'1',
'磺':'1',
'磡':'1',
'磜':'1',
'磲':'1',
'磧':'1',
'磚':'1',
'磠':'1',
'磟':'1',
'磖':'1',
'磣':'1',
'磢':'1',
'磭':'1',
'磪':'1',
'磥':'1',
'磮':'1',
'磞':'1',
'磦':'1',
'磩':'1',
'磫':'1',
'疀':'1',
'疁':'1',
'褾':'1',
'襀':'1',
'褶':'1',
'襐':'1',
'褸':'1',
'襒':'1',
'褿':'1',
'襔':'1',
'褹':'1',
'襂':'1',
'褷':'1',
'螭':'1',
'蟆':'1',
'螨':'1',
'蟒':'1',
'螟':'1',
'螃':'1',
'螓':'1',
'融':'1',
'螗':'1',
'螅':'1',
'螠':'1',
'螈':'1',
'螕':'1',
'螛':'1',
'螊':'1',
'螧':'1',
'螎':'1',
'螦':'1',
'螩':'1',
'螣':'1',
'螉':'1',
'螞':'1',
'螘':'1',
'螄':'1',
'螥':'1',
'螒':'1',
'螏':'1',
'螇':'1',
'螔':'1',
'螐':'1',
'螑':'1',
'螤':'1',
'聮':'1',
'聬':'1',
'虣':'1',
'虤':'1',
'虥':'1',
'虦':'1',
'耩':'1',
'耨':'1',
'耪':'1',
'糒':'1',
'糙':'1',
'糕':'1',
'糗':'1',
'糖':'1',
'糏':'1',
'糐':'1',
'糓':'1',
'糘':'1',
'糢':'1',
'糑':'1',
'糚':'1',
'縢':'1',
'縣':'1',
'舘':'1',
'縠':'1',
'縑':'1',
'縓':'1',
'縚':'1',
'縛':'1',
'縝':'1',
'縟':'1',
'緻':'1',
'縉':'1',
'縧':'1',
'縫':'1',
'縭':'1',
'縗':'1',
'縞':'1',
'縊':'1',
'縍':'1',
'縪':'1',
'縐':'1',
'縦':'1',
'縨':'1',
'縘':'1',
'縺':'1',
'縸':'1',
'縔':'1',
'縤':'1',
'縕':'1',
'縖':'1',
'縜':'1',
'縡':'1',
'縥':'1',
'翱':'1',
'翰':'1',
'翮':'1',
'翴':'1',
'臻':'1',
'艗':'1',
'艙':'1',
'艕':'1',
'臲':'1',
'賴':'1',
'賵':'1',
'賰':'1',
'賯':'1',
'賱':'1',
'賳':'1',
'輴':'1',
'輹':'1',
'輮':'1',
'輶':'1',
'輷':'1',
'輳':'1',
'輻':'1',
'輭':'1',
'輯':'1',
'輼':'1',
'輲':'1',
'輸':'1',
'輵':'1',
'輱':'1',
'輰':'1',
'輺':'1',
'赬':'1',
'赮':'1',
'覦':'1',
'親':'1',
'覨':'1',
'鹾':'1',
'麺':'1',
'躾':'1',
'躽':'1',
'豭':'1',
'豱':'1',
'辥':'1',
'諴':'1',
'謏':'1',
'諠':'1',
'謊':'1',
'諶':'1',
'謀':'1',
'諜':'1',
'諫':'1',
'謔':'1',
'謁':'1',
'謂':'1',
'諤':'1',
'諢':'1',
'諼':'1',
'諭':'1',
'諡':'1',
'諷':'1',
'諦':'1',
'諳':'1',
'諺':'1',
'諮':'1',
'謎':'1',
'諞':'1',
'諱':'1',
'諝':'1',
'諧':'1',
'諰':'1',
'諟':'1',
'謉':'1',
'諨':'1',
'諽':'1',
'諻':'1',
'諵':'1',
'諿':'1',
'諪':'1',
'謃':'1',
'諹':'1',
'諲':'1',
'諥':'1',
'諯':'1',
'郺':'1',
'醐':'1',
'醚':'1',
'醛':'1',
'醍':'1',
'醎':'1',
'醒':'1',
'醑':'1',
'醖':'1',
'醜':'1',
'醕':'1',
'醝':'1',
'醗':'1',
'醙':'1',
'醓':'1',
'貒':'1',
'貐':'1',
'貑':'1',
'蹅':'1',
'踸':'1',
'踹':'1',
'踳':'1',
'蹉':'1',
'踶':'1',
'蹀':'1',
'踱':'1',
'踽':'1',
'蹁':'1',
'蹂':'1',
'蹄':'1',
'踵':'1',
'踴':'1',
'踾':'1',
'踰':'1',
'踲':'1',
'踼':'1',
'蹆':'1',
'踿':'1',
'鋹':'1',
'錞':'1',
'錤':'1',
'鎯':'1',
'錡':'1',
'錔':'1',
'錣':'1',
'鍺':'1',
'錯':'1',
'鍩':'1',
'錨':'1',
'錆':'1',
'錛':'1',
'錸':'1',
'鋼':'1',
'鍀':'1',
'錁':'1',
'錫':'1',
'錮':'1',
'鍋':'1',
'錕':'1',
'錘':'1',
'鍃':'1',
'錐':'1',
'錦':'1',
'鍁':'1',
'錟':'1',
'錠':'1',
'錇':'1',
'錈':'1',
'鍆':'1',
'鍵':'1',
'鋸':'1',
'錳':'1',
'録':'1',
'錌':'1',
'錍':'1',
'錋':'1',
'錶':'1',
'鋿':'1',
'錩':'1',
'鋽':'1',
'錭':'1',
'鍅':'1',
'錀':'1',
'錷':'1',
'錎':'1',
'錧':'1',
'錿':'1',
'錢':'1',
'錬':'1',
'錽':'1',
'錹':'1',
'錑':'1',
'鍄':'1',
'錂':'1',
'錄':'1',
'錴':'1',
'錉':'1',
'錼':'1',
'錗':'1',
'鋷':'1',
'錜':'1',
'錰':'1',
'鋾':'1',
'錪':'1',
'鋺':'1',
'錻':'1',
'錏':'1',
'鍈':'1',
'鎁':'1',
'錥':'1',
'鍣':'1',
'錙':'1',
'錝':'1',
'錊':'1',
'隷':'1',
'閷':'1',
'靛':'1',
'靜':'1',
'餤':'1',
'餩':'1',
'餦':'1',
'餠':'1',
'餞':'1',
'餜':'1',
'餛':'1',
'餚':'1',
'餧':'1',
'餡':'1',
'館':'1',
'餢':'1',
'餣':'1',
'餟':'1',
'鲳':'1',
'鲷':'1',
'鲱':'1',
'鲴':'1',
'鲸':'1',
'鲲':'1',
'鲮':'1',
'鲵':'1',
'鲯':'1',
'鲭':'1',
'鲺':'1',
'鲻':'1',
'鲰':'1',
'鲹':'1',
'鲶':'1',
'霕':'1',
'霒':'1',
'雕':'1',
'雔':'1',
'鞔':'1',
'鞘':'1',
'鞓':'1',
'鞕':'1',
'鞙':'1',
'鞖':'1',
'骾':'1',
'骽':'1',
'靦':'1',
'韒':'1',
'馞':'1',
'馠':'1',
'馟':'1',
'頮':'1',
'頹':'1',
'頼':'1',
'頭':'1',
'頤':'1',
'頰':'1',
'頸':'1',
'頻':'1',
'頷':'1',
'頴':'1',
'頳':'1',
'頶':'1',
'頯':'1',
'頱':'1',
'頺':'1',
'頽':'1',
'頵':'1',
'韸':'1',
'駬':'1',
'駪':'1',
'駰':'1',
'駱':'1',
'駭':'1',
'駢':'1',
'駮':'1',
'駳':'1',
'駧':'1',
'駫':'1',
'駩':'1',
'駥':'1',
'駣':'1',
'駨':'1',
'駤':'1',
'駲':'1',
'駯':'1',
'黇':'1',
'黈':'1',
'鹷':'1',
'麬':'1',
'麭':'1',
'麮':'1',
'鴣':'1',
'鴨':'1',
'鴞':'1',
'鴒':'1',
'鴟':'1',
'鴝':'1',
'鴕':'1',
'鴥':'1',
'鴪':'1',
'鴱':'1',
'鴢':'1',
'鴓':'1',
'鵖':'1',
'鴘':'1',
'鴏':'1',
'鴠':'1',
'鴚':'1',
'鴩':'1',
'鴡':'1',
'鴗':'1',
'鴖':'1',
'鴫':'1',
'鴧':'1',
'鴊':'1',
'鴙':'1',
'鴤':'1',
'鮅':'1',
'鮄':'1',
'鮈':'1',
'魾':'1',
'鮀':'1',
'鮇':'1',
'鮣':'1',
'鮁':'1',
'鮃':'1',
'鮎':'1',
'鮋':'1',
'鮓':'1',
'鮒':'1',
'鮊':'1',
'鮑':'1',
'鮌':'1',
'鮍':'1',
'鮐':'1',
'鮘':'1',
'鮉':'1',
'鮗':'1',
'魺':'1',
'鮕':'1',
'魽':'1',
'魿':'1',
'鮂':'1',
'魼':'1',
'鮖':'1',
'魻':'1',
'鮏':'1',
'黕':'1',
'默':'1',
'黔':'1',
'黗':'1',
'黖':'1',
'鼽':'1',
'鼼':'1',
'齓':'1',
'颟':'1',
'颞':'1',
'颠':'1',
'颡':'1',
'羱':'1',
'朆':'1',
'橨':'1',
'燌':'1',
'膹':'1',
'豮':'1',
'鍂':'1',
'餴':'1',
'黺':'1',
'凞':'1',
'劒':'1',
'劔':'1',
'劓':'1',
'劑':'1',
'隰':'1',
'鄹':'1',
'鄺':'1',
'隯':'1',
'隭':'1',
'隮':'1',
'隬':'1',
'隱':'1',
'隲':'1',
'勵':'1',
'勳':'1',
'儜':'1',
'儒':'1',
'儓':'1',
'儛':'1',
'儔':'1',
'儕':'1',
'儐':'1',
'儗':'1',
'儘':'1',
'儑':'1',
'儫':'1',
'儣':'1',
'儖':'1',
'儞':'1',
'儝':'1',
'亸':'1',
'叡':'1',
'徼':'1',
'徻':'1',
'彊':'1',
'彋':'1',
'彇':'1',
'幨':'1',
'幪':'1',
'幧':'1',
'幯':'1',
'噫':'1',
'嚆':'1',
'嚄':'1',
'噭':'1',
'噤':'1',
'噱':'1',
'噼':'1',
'噻':'1',
'噬':'1',
'噪':'1',
'噣':'1',
'嘴':'1',
'噸':'1',
'噦':'1',
'噹':'1',
'噥':'1',
'噯':'1',
'噲':'1',
'噰':'1',
'嘯':'1',
'噡':'1',
'噷':'1',
'嚃':'1',
'噺':'1',
'噞':'1',
'噳':'1',
'噮':'1',
'嬗':'1',
'嬙':'1',
'嬡':'1',
'嬔':'1',
'嬝':'1',
'嬠':'1',
'嬨':'1',
'嬒':'1',
'嬓':'1',
'嬐':'1',
'嬚':'1',
'嬢':'1',
'嬛':'1',
'嬕':'1',
'嬑':'1',
'嬟':'1',
'嬩':'1',
'嬳':'1',
'獲':'1',
'獴':'1',
'獬':'1',
'獧':'1',
'獨':'1',
'獫':'1',
'獪':'1',
'獩':'1',
'獥':'1',
'凟':'1',
'劕':'1',
'鄾':'1',
'鄽':'1',
'鄿':'1',
'鄻':'1',
'鄼':'1',
'勴':'1',
'儡':'1',
'儧':'1',
'優':'1',
'償':'1',
'儲':'1',
'儤':'1',
'儦':'1',
'儥':'1',
'儬':'1',
'儠':'1',
'儢':'1',
'儩':'1',
'儰':'1',
'儨':'1',
'彍':'1',
'彌':'1',
'幬':'1',
'幭':'1',
'嚓':'1',
'嚎':'1',
'嚅':'1',
'嚏':'1',
'噽':'1',
'嚇':'1',
'嚐':'1',
'嚀':'1',
'嚌':'1',
'嚋':'1',
'嚁':'1',
'嚉':'1',
'嚂':'1',
'嚝':'1',
'嚍':'1',
'嚒':'1',
'嚊':'1',
'嚑':'1',
'嚈':'1',
'噾':'1',
'噿':'1',
'骤':'1',
'嬷':'1',
'嬭':'1',
'嬪':'1',
'嬶':'1',
'嬦':'1',
'嬥':'1',
'嬧':'1',
'嬤':'1',
'嬵':'1',
'嬺':'1',
'嬣':'1',
'嬬':'1',
'嬫':'1',
'嬯':'1',
'獯':'1',
'獮':'1',
'獰':'1',
'獷':'1',
'獱':'1',
'獳':'1',
'镩':'1',
'镫':'1',
'镦':'1',
'镢':'1',
'镧':'1',
'镣':'1',
'镥':'1',
'镤':'1',
'镨':'1',
'镡':'1',
'竲':'1',
'竴':'1',
'竳':'1',
'瞪':'1',
'瞭':'1',
'瞵':'1',
'瞧':'1',
'瞫':'1',
'瞤':'1',
'瞬':'1',
'瞳':'1',
'瞩':'1',
'瞶':'1',
'瞯':'1',
'瞷':'1',
'瞴':'1',
'瞨':'1',
'瞦':'1',
'瞲':'1',
'瞸':'1',
'鹪':'1',
'鹩':'1',
'鹬':'1',
'皼':'1',
'磴':'1',
'磾':'1',
'礅':'1',
'磵':'1',
'礁':'1',
'磷':'1',
'磻':'1',
'礃':'1',
'磽':'1',
'礄':'1',
'磯':'1',
'磹':'1',
'磸':'1',
'礀':'1',
'礍':'1',
'磱':'1',
'磰':'1',
'磼':'1',
'磶':'1',
'礂':'1',
'礇':'1',
'磳':'1',
'礈':'1',
'矰':'1',
'矯':'1',
'疃':'1',
'疄':'1',
'襕':'1',
'襁':'1',
'襚':'1',
'襍':'1',
'襖':'1',
'襌':'1',
'襇':'1',
'襉':'1',
'襏':'1',
'襎':'1',
'襊':'1',
'襆':'1',
'襋':'1',
'襈':'1',
'襓':'1',
'褼':'1',
'襑':'1',
'臨':'1',
'螬':'1',
'蟥':'1',
'螺':'1',
'螵':'1',
'蟀':'1',
'螳':'1',
'蟋':'1',
'蟓':'1',
'蟏':'1',
'蟑':'1',
'蟐':'1',
'蟍':'1',
'蠎':'1',
'蟂':'1',
'螮':'1',
'螲':'1',
'螾':'1',
'蟅':'1',
'蟌':'1',
'蟎':'1',
'螻':'1',
'蟈':'1',
'螹':'1',
'蟉':'1',
'螰':'1',
'蟃':'1',
'螼':'1',
'蟝':'1',
'螪':'1',
'聴':'1',
'聰':'1',
'聯':'1',
'罅':'1',
'罆':'1',
'艱':'1',
'虧':'1',
'虨':'1',
'耬':'1',
'耫':'1',
'糠':'1',
'糟':'1',
'糡':'1',
'糝':'1',
'糛':'1',
'繇':'1',
'縩':'1',
'繀':'1',
'縯':'1',
'績':'1',
'縹':'1',
'縷':'1',
'縵':'1',
'繃':'1',
'總':'1',
'縱':'1',
'縴':'1',
'縮':'1',
'繆':'1',
'繅':'1',
'繈':'1',
'縬':'1',
'繉':'1',
'縳':'1',
'縲':'1',
'繂':'1',
'縿':'1',
'繌':'1',
'縰':'1',
'繊':'1',
'繍':'1',
'縼':'1',
'翶':'1',
'翵':'1',
'翲':'1',
'艚':'1',
'艜':'1',
'艛':'1',
'艝':'1',
'購':'1',
'賹':'1',
'賻':'1',
'賺':'1',
'賶':'1',
'賸':'1',
'轂':'1',
'轅':'1',
'輾':'1',
'轄':'1',
'輽':'1',
'轋':'1',
'轁':'1',
'轀':'1',
'轃':'1',
'赯':'1',
'豏':'1',
'豁':'1',
'谿':'1',
'豀':'1',
'覯':'1',
'覬':'1',
'覭':'1',
'覫':'1',
'觳':'1',
'觲':'1',
'豰':'1',
'豲':'1',
'豯':'1',
'辪':'1',
'謋':'1',
'謟':'1',
'謌':'1',
'講':'1',
'譁':'1',
'謨':'1',
'殭':'1',
'殮':'1',
'殬':'1',
'斣':'1',
'旚':'1',
'戲':'1',
'燬':'1',
'燥':'1',
'燦':'1',
'燭':'1',
'燴':'1',
'燷':'1',
'燣':'1',
'燫':'1',
'燯':'1',
'燶':'1',
'燩':'1',
'燰':'1',
'燨':'1',
'熽':'1',
'燲':'1',
'燡':'1',
'燱':'1',
'燳':'1',
'斶':'1',
'斵':'1',
'氉':'1',
'氋':'1',
'氈':'1',
'檦':'1',
'檞':'1',
'櫆':'1',
'檑':'1',
'檩':'1',
'檬':'1',
'檀':'1',
'檐':'1',
'檥':'1',
'檉':'1',
'檣':'1',
'檔':'1',
'檢':'1',
'檜':'1',
'櫛':'1',
'檘':'1',
'檚':'1',
'檊':'1',
'檴':'1',
'檅':'1',
'檓':'1',
'檟':'1',
'橿':'1',
'橚':'1',
'檋':'1',
'檪':'1',
'櫣':'1',
'檁':'1',
'檂':'1',
'檏':'1',
'橾':'1',
'檆':'1',
'檡':'1',
'檈':'1',
'檍':'1',
'檌':'1',
'犠':'1',
'牆':'1',
'斀':'1',
'斁':'1',
'斂':'1',
'歟':'1',
'歗':'1',
'歜':'1',
'歛':'1',
'歝':'1',
'曚':'1',
'曙':'1',
'曖':'1',
'曒':'1',
'曕':'1',
'曗':'1',
'曎':'1',
'禬':'1',
'禮':'1',
'禯':'1',
'濌':'1',
'甔':'1',
'璨':'1',
'環':'1',
'璐':'1',
'璩':'1',
'璪':'1',
'璫':'1',
'璵':'1',
'璦':'1',
'璴':'1',
'瓂':'1',
'璯':'1',
'璬':'1',
'璱':'1',
'璛':'1',
'璮':'1',
'璳':'1',
'瓁':'1',
'臌':'1',
'臁':'1',
'朦':'1',
'臊':'1',
'膻':'1',
'臆':'1',
'臃':'1',
'膿':'1',
'臉':'1',
'膾':'1',
'膽':'1',
'臅':'1',
'臄':'1',
'臒':'1',
'皤':'1',
'皥':'1',
'皢':'1',
'穗':'1',
'穟':'1',
'穉':'1',
'穛':'1',
'穖':'1',
'穚':'1',
'穞':'1',
'穙':'1',
'穕':'1',
'穘':'1',
'穜':'1',
'穝':'1',
'嶹':'1',
'巁':'1',
'嶸':'1',
'嶿':'1',
'嶾':'1',
'擦':'1',
'擩':'1',
'擿':'1',
'擤':'1',
'擢':'1',
'擡':'1',
'擣':'1',
'擰':'1',
'擯':'1',
'擠':'1',
'擴':'1',
'擱':'1',
'擬':'1',
'攃':'1',
'擮':'1',
'擟':'1',
'攁':'1',
'擨':'1',
'擫':'1',
'擲':'1',
'濞':'1',
'濲':'1',
'濠':'1',
'濮':'1',
'濡':'1',
'瀁':'1',
'濯':'1',
'濔':'1',
'濤':'1',
'濫':'1',
'濬':'1',
'濕':'1',
'濘':'1',
'濱':'1',
'濶':'1',
'濜':'1',
'澀':'1',
'濰':'1',
'濵':'1',
'瀞':'1',
'濢':'1',
'濧':'1',
'濻':'1',
'濟':'1',
'濪':'1',
'濿':'1',
'濹':'1',
'瀎':'1',
'濝':'1',
'瀡':'1',
'瀇':'1',
'濣':'1',
'濥':'1',
'濦':'1',
'濙':'1',
'濚':'1',
'濴':'1',
'壕':'1',
'壎':'1',
'壙':'1',
'壔':'1',
'壗':'1',
'壏':'1',
'壖':'1',
'懤':'1',
'懧':'1',
'懦':'1',
'懝':'1',
'懨':'1',
'懛':'1',
'懠':'1',
'懭':'1',
'懢':'1',
'懱':'1',
'懡':'1',
'懗':'1',
'懩':'1',
'懚':'1',
'懥':'1',
'孺':'1',
'孻':'1',
'赡':'1',
'謖':'1',
'謡':'1',
'謝':'1',
'謅':'1',
'謗':'1',
'謐':'1',
'謚':'1',
'謙':'1',
'謄':'1',
'謸':'1',
'謓':'1',
'謘':'1',
'謞':'1',
'謧':'1',
'謰':'1',
'謒':'1',
'謜':'1',
'謆':'1',
'謕':'1',
'謑':'1',
'謠':'1',
'謢':'1',
'醠':'1',
'醢':'1',
'醨':'1',
'醣':'1',
'醡':'1',
'醘':'1',
'醞':'1',
'貘':'1',
'貔':'1',
'貕':'1',
'貖':'1',
'蹈':'1',
'蹎':'1',
'蹐':'1',
'蹓':'1',
'蹍':'1',
'蹑':'1',
'蹒':'1',
'蹊':'1',
'蹋':'1',
'蹕':'1',
'蹌':'1',
'蹏':'1',
'蹥':'1',
'龋':'1',
'龌':'1',
'鎝':'1',
'鍮':'1',
'鍚':'1',
'鍿':'1',
'鍥':'1',
'鍊':'1',
'鍼':'1',
'鍇':'1',
'鍘':'1',
'鍶':'1',
'鍔':'1',
'鍰':'1',
'鍤':'1',
'鍬':'1',
'鍛':'1',
'鎪':'1',
'鍠':'1',
'鎄':'1',
'鍍':'1',
'鎂':'1',
'鎡':'1',
'鎇':'1',
'鍽':'1',
'鎈':'1',
'鍖':'1',
'鍉':'1',
'鎚':'1',
'鍴':'1',
'鍑':'1',
'鍢':'1',
'鎅':'1',
'鍧':'1',
'鍭':'1',
'鍸':'1',
'鍓':'1',
'鍻':'1',
'鍕':'1',
'鍞':'1',
'鍨':'1',
'鍷':'1',
'鍲':'1',
'鎃':'1',
'鎆':'1',
'鍒':'1',
'鍟':'1',
'鍦':'1',
'鎹':'1',
'鍗':'1',
'鍎':'1',
'鍐':'1',
'鍏':'1',
'鍡':'1',
'鎾':'1',
'鍜':'1',
'鍱':'1',
'鎀':'1',
'鍹':'1',
'鍝':'1',
'鍾':'1',
'鍯':'1',
'鎺':'1',
'隸':'1',
'餲':'1',
'餬':'1',
'餭':'1',
'餳':'1',
'餷':'1',
'餫':'1',
'餶':'1',
'餵':'1',
'餿':'1',
'餱':'1',
'餽':'1',
'餯':'1',
'餰':'1',
'餪':'1',
'餸':'1',
'饂':'1',
'鲾':'1',
'鳊':'1',
'鲿':'1',
'鲽':'1',
'鳄':'1',
'鳆':'1',
'鳇':'1',
'鳉':'1',
'鳈':'1',
'鳃':'1',
'鳀':'1',
'鳂':'1',
'鳁':'1',
'鳅':'1',
'鳋':'1',
'雘':'1',
'雖':'1',
'鞞':'1',
'鞬':'1',
'鞠':'1',
'鞚':'1',
'鞟':'1',
'鞝':'1',
'鞛':'1',
'鞜':'1',
'髀':'1',
'髁':'1',
'魏':'1',
'馘':'1',
'韔':'1',
'韓':'1',
'韕':'1',
'馣':'1',
'馡':'1',
'馢':'1',
'顆':'1',
'顇':'1',
'顀':'1',
'顁':'1',
'顄':'1',
'顈':'1',
'顂':'1',
'顅':'1',
'顉':'1',
'顃':'1',
'顊':'1',
'韺':'1',
'鬴':'1',
'騃':'1',
'駹':'1',
'騁':'1',
'騂':'1',
'駿':'1',
'駸':'1',
'騀':'1',
'駴':'1',
'駻':'1',
'駶':'1',
'駺':'1',
'駵':'1',
'駷':'1',
'駼':'1',
'駾':'1',
'駽':'1',
'黊':'1',
'麰':'1',
'麯':'1',
'鵁':'1',
'鴳':'1',
'鵂':'1',
'鴴':'1',
'鴯':'1',
'鴰':'1',
'鵃':'1',
'鴻':'1',
'鵄':'1',
'鴭':'1',
'鵈':'1',
'鴿':'1',
'鵅':'1',
'鴶':'1',
'鴼':'1',
'鴾':'1',
'鵇':'1',
'鵧':'1',
'鴺':'1',
'鴮':'1',
'鴹':'1',
'鴵':'1',
'鴲':'1',
'鴸':'1',
'鮟':'1',
'鮰':'1',
'鮠':'1',
'鮨':'1',
'鮡':'1',
'鮭':'1',
'鮚':'1',
'鮞':'1',
'鮪':'1',
'鮦':'1',
'鮜':'1',
'鮫':'1',
'鮮':'1',
'鮩':'1',
'鯎':'1',
'鯈':'1',
'鮙':'1',
'鮲':'1',
'鮥':'1',
'鮯':'1',
'鮳':'1',
'鮬':'1',
'鮱':'1',
'鯅':'1',
'鮛':'1',
'鮧':'1',
'鮴':'1',
'鮢':'1',
'黜':'1',
'點':'1',
'黚':'1',
'黏':'1',
'黻':'1',
'鼤':'1',
'鼣':'1',
'鼾':'1',
'鼿':'1',
'齢':'1',
'齔':'1',
'龍':'1',
'鲼':'1',
'鼢':'1',
'謹':'1',
'謳':'1',
'謼':'1',
'謾':'1',
'謫':'1',
'謬':'1',
'謲':'1',
'謤':'1',
'謵':'1',
'謻':'1',
'謥':'1',
'謴':'1',
'譀':'1',
'謭':'1',
'謯':'1',
'謱':'1',
'謪':'1',
'謶':'1',
'謣':'1',
'譃':'1',
'謮':'1',
'譇':'1',
'醪':'1',
'醦':'1',
'醧':'1',
'醥':'1',
'醩':'1',
'貙':'1',
'貗':'1',
'蹦':'1',
'躇':'1',
'蹢':'1',
'蹛':'1',
'蹡':'1',
'蹚':'1',
'蹟':'1',
'蹧':'1',
'蹣':'1',
'蹤':'1',
'蹠':'1',
'蹖':'1',
'躀':'1',
'蹞':'1',
'蹘':'1',
'蹗':'1',
'蹜':'1',
'蹝':'1',
'鎞':'1',
'鎟':'1',
'鎓':'1',
'鏵':'1',
'鏌':'1',
'鎘':'1',
'鎭':'1',
'鎛':'1',
'鎖':'1',
'鎧':'1',
'鎗':'1',
'鎿':'1',
'鏈':'1',
'鎩':'1',
'鎸':'1',
'鎳':'1',
'鎢':'1',
'鎦':'1',
'鎌':'1',
'鎋':'1',
'鎵':'1',
'鎔':'1',
'鎊':'1',
'鎬':'1',
'鎰':'1',
'鎻':'1',
'鏎':'1',
'鎉':'1',
'鎽':'1',
'鏠':'1',
'鎠':'1',
'鎑':'1',
'鎶':'1',
'鎒':'1',
'鎤':'1',
'鎫':'1',
'鎎':'1',
'鎷':'1',
'鎍':'1',
'鎙':'1',
'鎨':'1',
'鎕':'1',
'鎲':'1',
'鎮':'1',
'鎼':'1',
'鎴':'1',
'鏅':'1',
'鎐':'1',
'鎱':'1',
'靝':'1',
'饆':'1',
'饁':'1',
'饃':'1',
'餺':'1',
'餼':'1',
'餾':'1',
'饈':'1',
'餻':'1',
'餹':'1',
'饀':'1',
'鳏':'1',
'鳑':'1',
'鳍':'1',
'鳎':'1',
'鳐':'1',
'鳒':'1',
'雝':'1',
'雛':'1',
'雞':'1',
'雜':'1',
'離':'1',
'雗':'1',
'鞭':'1',
'鞮':'1',
'鞥':'1',
'鞨':'1',
'鞯':'1',
'鞫':'1',
'鞦':'1',
'鞧':'1',
'鞣':'1',
'鞢':'1',
'鞰':'1',
'鞩':'1',
'鞳':'1',
'髅':'1',
'髂':'1',
'髃':'1',
'韞':'1',
'韚':'1',
'韖':'1',
'韘':'1',
'韗':'1',
'馥':'1',
'馤':'1',
'馧':'1',
'顑':'1',
'顋':'1',
'顒':'1',
'顎':'1',
'額':'1',
'顔':'1',
'顓':'1',
'顐':'1',
'顝':'1',
'顕':'1',
'顏':'1',
'頿':'1',
'韹':'1',
'髜':'1',
'騑':'1',
'騧':'1',
'騏':'1',
'騎':'1',
'騍':'1',
'騐':'1',
'騅':'1',
'騆':'1',
'騉':'1',
'騋':'1',
'騄':'1',
'騈':'1',
'騝':'1',
'騒':'1',
'騇':'1',
'騊':'1',
'験':'1',
'騌':'1',
'麱':'1',
'麲':'1',
'鵏':'1',
'鵙':'1',
'鵎':'1',
'鵐':'1',
'鵓':'1',
'鵑':'1',
'鵒':'1',
'鵠':'1',
'鵝':'1',
'鵜':'1',
'鵣':'1',
'鵍':'1',
'鵋':'1',
'鵊':'1',
'鵤':'1',
'鵛':'1',
'鵔':'1',
'鵕':'1',
'鵘':'1',
'鵢':'1',
'鵌':'1',
'鵚':'1',
'鵗':'1',
'鮸':'1',
'鯁':'1',
'鯉':'1',
'鯀':'1',
'鯇':'1',
'鯒':'1',
'鮶':'1',
'鯽':'1',
'鯆':'1',
'鮵':'1',
'鯌':'1',
'鯏':'1',
'鯍':'1',
'鮾':'1',
'鮼':'1',
'鯄':'1',
'鯋':'1',
'鮹':'1',
'鯓':'1',
'鯂':'1',
'鮻':'1',
'鮷':'1',
'鯃':'1',
'鯑':'1',
'鮽':'1',
'鮿':'1',
'鯐':'1',
'黠':'1',
'黟':'1',
'鼥':'1',
'鼩':'1',
'鼪':'1',
'鼫':'1',
'鼧':'1',
'鼬':'1',
'鼦':'1',
'鼨':'1',
'齀':'1',
'齕':'1',
'颢':'1',
'颣':'1',
'羳':'1',
'羵':'1',
'殯':'1',
'旛':'1',
'旞':'1',
'戳':'1',
'燻':'1',
'爗':'1',
'燿':'1',
'燼':'1',
'燽':'1',
'燺':'1',
'爀':'1',
'爌':'1',
'爁':'1',
'爄':'1',
'爃':'1',
'燸':'1',
'斷':'1',
'檫':'1',
'檵':'1',
'檰':'1',
'檷':'1',
'檯':'1',
'檮':'1',
'櫃':'1',
'檻':'1',
'檸':'1',
'檳':'1',
'櫂':'1',
'櫈':'1',
'櫉':'1',
'櫄':'1',
'檺':'1',
'櫊':'1',
'櫎':'1',
'櫅':'1',
'櫭':'1',
'櫔':'1',
'櫚':'1',
'櫗':'1',
'櫁':'1',
'檽':'1',
'櫙':'1',
'櫇':'1',
'檱':'1',
'櫀':'1',
'檶':'1',
'櫒':'1',
'檲':'1',
'檹':'1',
'檭':'1',
'檼':'1',
'櫡':'1',
'犡':'1',
'歞':'1',
'曛':'1',
'曜':'1',
'曠':'1',
'曞':'1',
'曘':'1',
'禱':'1',
'禰':'1',
'禲':'1',
'璿':'1',
'瓊':'1',
'璸':'1',
'璾':'1',
'璶':'1',
'璼':'1',
'瓀':'1',
'璹':'1',
'瓍':'1',
'瓋':'1',
'璻':'1',
'斔':'1',
'臑':'1',
'臏':'1',
'臍':'1',
'臓':'1',
'臎':'1',
'臗':'1',
'臐':'1',
'歸':'1',
'皦':'1',
'皧':'1',
'穡':'1',
'穫':'1',
'穢':'1',
'穠':'1',
'穣':'1',
'穥':'1',
'酂':'1',
'酀':'1',
'冁':'1',
'儭':'1',
'儵':'1',
'儮':'1',
'儯':'1',
'幮':'1',
'嚜':'1',
'嚙':'1',
'嚕':'1',
'嚗':'1',
'嚡':'1',
'嚛':'1',
'嚖':'1',
'嚟':'1',
'嚠':'1',
'嚤':'1',
'嚔':'1',
'嚘':'1',
'嬸':'1',
'嬻':'1',
'嬼':'1',
'獵':'1',
'獶':'1',
'镮':'1',
'镬':'1',
'镭':'1',
'镰':'1',
'镱':'1',
'镯':'1',
'竵':'1',
'矇':'1',
'瞻':'1',
'矁':'1',
'瞼':'1',
'瞹':'1',
'瞺':'1',
'矆':'1',
'矀':'1',
'矂':'1',
'鹱':'1',
'鹮':'1',
'鹲':'1',
'鹯':'1',
'皽':'1',
'礓':'1',
'礌':'1',
'礞':'1',
'礎':'1',
'礉':'1',
'礡':'1',
'礠':'1',
'礑':'1',
'礆':'1',
'礚':'1',
'礔':'1',
'礏':'1',
'礒':'1',
'礖':'1',
'礋':'1',
'矱':'1',
'疅':'1',
'襜':'1',
'襟':'1',
'襢':'1',
'襠':'1',
'襝':'1',
'襘':'1',
'襙':'1',
'襡':'1',
'襛':'1',
'襗':'1',
'蟪':'1',
'蟠':'1',
'蟛':'1',
'蟮':'1',
'蟵':'1',
'蟽':'1',
'蟡':'1',
'蟩':'1',
'蠄':'1',
'蠇':'1',
'蟟':'1',
'蟱':'1',
'蟖':'1',
'蟘':'1',
'蟢':'1',
'蟫':'1',
'蟯':'1',
'蟬':'1',
'蟣':'1',
'蟦':'1',
'蟜':'1',
'蟭':'1',
'蟧':'1',
'蟔':'1',
'蠂':'1',
'蟳':'1',
'蟙':'1',
'蟤':'1',
'聵':'1',
'職':'1',
'罈':'1',
'罇':'1',
'罉':'1',
'虩':'1',
'耮':'1',
'耭':'1',
'糨':'1',
'糧':'1',
'糦':'1',
'糥':'1',
'糣':'1',
'糤':'1',
'繛':'1',
'繟':'1',
'繨':'1',
'繙':'1',
'繦':'1',
'繐':'1',
'繸':'1',
'繞':'1',
'繚':'1',
'織':'1',
'繕':'1',
'繒':'1',
'繱':'1',
'繣':'1',
'繢':'1',
'繝':'1',
'繑':'1',
'繘':'1',
'繗':'1',
'繎':'1',
'繖':'1',
'繥':'1',
'繏':'1',
'繧':'1',
'繜':'1',
'繓':'1',
'翻':'1',
'翺':'1',
'翷':'1',
'翸':'1',
'艟':'1',
'艠':'1',
'艥':'1',
'艞':'1',
'賾':'1',
'贁':'1',
'贂':'1',
'賿':'1',
'贃':'1',
'轇':'1',
'轊':'1',
'轉':'1',
'轆':'1',
'轈':'1',
'轌':'1',
'豃':'1',
'豂':'1',
'覲':'1',
'覰':'1',
'覷':'1',
'観':'1',
'觴':'1',
'觵':'1',
'躿':'1',
'軀':'1',
'軁':'1',
'豵':'1',
'豴':'1',
'攆':'1',
'擷':'1',
'攄':'1',
'擻':'1',
'擺':'1',
'擼':'1',
'攂':'1',
'攅':'1',
'擶':'1',
'擸':'1',
'擽':'1',
'擵':'1',
'擾':'1',
'擹':'1',
'瀑':'1',
'瀌':'1',
'瀍':'1',
'濽':'1',
'瀔':'1',
'瀆':'1',
'瀦':'1',
'濾':'1',
'濺':'1',
'濼':'1',
'瀏':'1',
'瀋':'1',
'瀉':'1',
'瀅':'1',
'瀓':'1',
'瀢':'1',
'瀈':'1',
'瀐':'1',
'瀂':'1',
'瀊':'1',
'瀒':'1',
'瀃':'1',
'瀀':'1',
'壝':'1',
'懵':'1',
'懴':'1',
'懪':'1',
'懳':'1',
'懰':'1',
'懮':'1',
'懫':'1',
'髊':'1',
'髄':'1',
'巆':'1',
'攒':'1',
'攉':'1',
'攌':'1',
'攈':'1',
'攋':'1',
'攊':'1',
'攎':'1',
'攐':'1',
'攑':'1',
'攇':'1',
'攍':'1',
'攚':'1',
'瀣':'1',
'瀛':'1',
'瀨':'1',
'瀝':'1',
'瀕':'1',
'瀟':'1',
'瀘':'1',
'瀯':'1',
'瀠':'1',
'瀩':'1',
'瀫':'1',
'瀤':'1',
'瀖':'1',
'瀳':'1',
'瀬':'1',
'瀮':'1',
'濳':'1',
'瀙':'1',
'瀜':'1',
'瀭':'1',
'瀗':'1',
'瀥':'1',
'缵':'1',
'壢':'1',
'壚':'1',
'壜':'1',
'壞':'1',
'壡':'1',
'壛':'1',
'懷':'1',
'懶':'1',
'懻':'1',
'劖':'1',
'酃':'1',
'隴':'1',
'酁':'1',
'酄':'1',
'隵':'1',
'勷':'1',
'勸':'1',
'儱':'1',
'儴':'1',
'儳':'1',
'谶':'1',
'彟':'1',
'幰':'1',
'幱':'1',
'嚯':'1',
'嚬':'1',
'嚭':'1',
'嚥':'1',
'嚦':'1',
'嚫':'1',
'嚪':'1',
'嚧':'1',
'嚰':'1',
'嚩':'1',
'骥':'1',
'嬾':'1',
'嬹':'1',
'嬿':'1',
'嬽':'1',
'獺':'1',
'獹':'1',
'譊':'1',
'譔':'1',
'謿':'1',
'譆':'1',
'譚':'1',
'譖':'1',
'譙':'1',
'譌':'1',
'識':'1',
'譜':'1',
'譎':'1',
'譪':'1',
'譒':'1',
'譂':'1',
'譈':'1',
'譓':'1',
'譏':'1',
'譑':'1',
'譋':'1',
'譕':'1',
'譢':'1',
'譛':'1',
'譄':'1',
'譗':'1',
'證':'1',
'譐':'1',
'醭':'1',
'醮':'1',
'醰':'1',
'醯':'1',
'醱':'1',
'貚':'1',
'蹭':'1',
'蹰':'1',
'蹴':'1',
'蹿':'1',
'蹲':'1',
'蹬':'1',
'蹾':'1',
'蹯':'1',
'蹶':'1',
'蹻':'1',
'蹽':'1',
'蹼':'1',
'蹺':'1',
'蹳':'1',
'蹱':'1',
'躂':'1',
'蹫':'1',
'蹸':'1',
'蹨':'1',
'蹹':'1',
'蹪':'1',
'蹮':'1',
'鏦':'1',
'鐄':'1',
'鏚':'1',
'鐯':'1',
'鏗':'1',
'鏢':'1',
'鏤':'1',
'鏜':'1',
'鏝':'1',
'鏰':'1',
'鏡':'1',
'鏑':'1',
'鏟':'1',
'鏞':'1',
'鏃':'1',
'鏇':'1',
'鏘':'1',
'鏁':'1',
'鏐':'1',
'鏕':'1',
'鏒':'1',
'鏪':'1',
'鏛':'1',
'鏙':'1',
'鏆':'1',
'鐹':'1',
'鏩':'1',
'鏮':'1',
'鏂':'1',
'鏫':'1',
'鏀':'1',
'鏍':'1',
'鏋':'1',
'鏲':'1',
'鏉':'1',
'鏣':'1',
'鏯':'1',
'鏄':'1',
'鏏':'1',
'鏭':'1',
'鏬':'1',
'鐌':'1',
'鏥':'1',
'鐊':'1',
'鏔':'1',
'鏱':'1',
'鏓':'1',
'饉':'1',
'饅':'1',
'饄':'1',
'饇':'1',
'鳔':'1',
'鳗':'1',
'鳚':'1',
'鳕':'1',
'鳓':'1',
'鳙':'1',
'鳛':'1',
'難':'1',
'雡':'1',
'颿':'1',
'颽':'1',
'颻':'1',
'鞴':'1',
'鞲':'1',
'鞾':'1',
'鞵':'1',
'鞱':'1',
'鞹':'1',
'鞸':'1',
'髋':'1',
'髈':'1',
'髆':'1',
'髌':'1',
'髉':'1',
'髇':'1',
'韛':'1',
'韡':'1',
'韝':'1',
'韜':'1',
'韠':'1',
'韟':'1',
'馦':'1',
'顜':'1',
'顗':'1',
'顛':'1',
'願':'1',
'類':'1',
'顙':'1',
'顖':'1',
'顚':'1',
'韻':'1',
'韼':'1',
'鬷':'1',
'騞':'1',
'騠':'1',
'騢':'1',
'騣':'1',
'騲':'1',
'騟':'1',
'騙':'1',
'騷':'1',
'騤':'1',
'騘':'1',
'騛':'1',
'騔':'1',
'騩':'1',
'騜':'1',
'騗':'1',
'騚':'1',
'騡':'1',
'騥':'1',
'騦':'1',
'騪':'1',
'騨':'1',
'騕':'1',
'鹸':'1',
'麒':'1',
'麴':'1',
'麳':'1',
'鵩':'1',
'鶄':'1',
'鵾':'1',
'鶂':'1',
'鵬':'1',
'鶆':'1',
'鵡':'1',
'鵲':'1',
'鶓':'1',
'鶇':'1',
'鵶':'1',
'鵪':'1',
'鵰':'1',
'鵮':'1',
'鵯':'1',
'鵷':'1',
'鶉':'1',
'鶊':'1',
'鵽':'1',
'鶏':'1',
'鵳':'1',
'鶁':'1',
'鵴':'1',
'鶋':'1',
'鶌':'1',
'鵼':'1',
'鵦':'1',
'鵱':'1',
'鶜':'1',
'鵸':'1',
'鶀':'1',
'鶈':'1',
'鵭':'1',
'鵿':'1',
'鵨':'1',
'鶐':'1',
'鵵':'1',
'鵺':'1',
'鶃':'1',
'鶍':'1',
'鶧':'1',
'鵻':'1',
'鵫':'1',
'鶅':'1',
'鶎':'1',
'鯖':'1',
'鯪':'1',
'鯕':'1',
'鯫':'1',
'鯝':'1',
'鯤':'1',
'鯧':'1',
'鯡':'1',
'鯰':'1',
'鯢':'1',
'鯨':'1',
'鯔':'1',
'鯴':'1',
'鯦':'1',
'鯵':'1',
'鯙':'1',
'鯳':'1',
'鯛':'1',
'鯟':'1',
'鯱':'1',
'鯚':'1',
'鯯':'1',
'鰎':'1',
'鯠':'1',
'鯥':'1',
'鯩':'1',
'鯭':'1',
'鯘':'1',
'鯜':'1',
'鰙':'1',
'鯣':'1',
'鯲':'1',
'鯞':'1',
'鯺':'1',
'鯮':'1',
'黢':'1',
'黣':'1',
'黼':'1',
'鼭':'1',
'鼮':'1',
'齁':'1',
'齘':'1',
'齗':'1',
'齖':'1',
'颤':'1',
'曢':'1',
'羶':'1',
'羷':'1',
'豶':'1',
'轒':'1',
'殰':'1',
'殱':'1',
'旝':'1',
'旟':'1',
'旜':'1',
'爊':'1',
'爆':'1',
'爍':'1',
'爑':'1',
'爉':'1',
'爎':'1',
'爈':'1',
'爅':'1',
'櫕':'1',
'櫞':'1',
'櫝':'1',
'櫧':'1',
'櫟':'1',
'櫓':'1',
'櫥':'1',
'櫖':'1',
'櫠':'1',
'櫘':'1',
'櫤':'1',
'櫵':'1',
'櫑':'1',
'櫋':'1',
'櫏':'1',
'櫦':'1',
'櫢':'1',
'櫌':'1',
'櫲':'1',
'櫍':'1',
'犢':'1',
'犦':'1',
'犣':'1',
'犤':'1',
'犥':'1',
'牘':'1',
'歠':'1',
'獸':'1',
'曝':'1',
'瓅':'1',
'瓈':'1',
'瓄':'1',
'璷':'1',
'瓃':'1',
'瓇':'1',
'瓉':'1',
'瓆':'1',
'臕':'1',
'臘':'1',
'臔':'1',
'皩':'1',
'穨':'1',
'穤':'1',
'穩':'1',
'穪':'1',
'穧':'1',
'穬':'1',
'穦':'1',
'镲':'1',
'矎':'1',
'矃':'1',
'矌':'1',
'矋':'1',
'矈':'1',
'矊':'1',
'矉':'1',
'矄':'1',
'矅':'1',
'礤':'1',
'礪':'1',
'礙':'1',
'礦':'1',
'礘':'1',
'礛':'1',
'礣':'1',
'礟':'1',
'礗':'1',
'礝':'1',
'礢':'1',
'疆':'1',
'疇':'1',
'襣':'1',
'襦':'1',
'襪':'1',
'襤':'1',
'襥':'1',
'襨':'1',
'襧':'1',
'蠅':'1',
'蟾':'1',
'蠖':'1',
'蠊':'1',
'蠓':'1',
'蠏':'1',
'蟰':'1',
'蟕':'1',
'蠋':'1',
'蟶':'1',
'蠍':'1',
'蟻':'1',
'蟺':'1',
'蠀':'1',
'蟷':'1',
'蠉':'1',
'蠌':'1',
'聸':'1',
'聼':'1',
'耯':'1',
'糫':'1',
'糭':'1',
'糩':'1',
'糬':'1',
'艶':'1',
'舚':'1',
'繩':'1',
'繮':'1',
'繯':'1',
'繾':'1',
'繰':'1',
'繪':'1',
'繳':'1',
'繡':'1',
'繵':'1',
'繲':'1',
'繷':'1',
'纄':'1',
'繬':'1',
'繺':'1',
'繹':'1',
'繶':'1',
'翾':'1',
'翽':'1',
'艨':'1',
'艢':'1',
'艣':'1',
'艤':'1',
'艡':'1',
'艧':'1',
'贉':'1',
'贈':'1',
'贆':'1',
'贌':'1',
'贎':'1',
'镽':'1',
'轕':'1',
'轎':'1',
'轔':'1',
'轐':'1',
'轓':'1',
'轑':'1',
'轏':'1',
'辴':'1',
'覵':'1',
'覴':'1',
'覸':'1',
'覶':'1',
'觶':'1',
'觹':'1',
'軃':'1',
'軂':'1',
'軅':'1',
'軄':'1',
'豷':'1',
'辭':'1',
'镴':'1',
'镳':'1',
'競':'1',
'竷':'1',
'矒':'1',
'矏':'1',
'皾':'1',
'礧':'1',
'礫':'1',
'礥':'1',
'礩':'1',
'矲':'1',
'襮':'1',
'襫':'1',
'襭':'1',
'襬':'1',
'襩':'1',
'蠛':'1',
'蠕':'1',
'蠘':'1',
'蠙':'1',
'蠣':'1',
'蠐':'1',
'蠔':'1',
'蠑':'1',
'蠗':'1',
'聹':'1',
'聺':'1',
'糯':'1',
'糰':'1',
'糲':'1',
'糮':'1',
'纀':'1',
'繻':'1',
'纁':'1',
'繽':'1',
'纊':'1',
'繼':'1',
'繿':'1',
'纃':'1',
'耀':'1',
'翿':'1',
'艦':'1',
'艩':'1',
'贍':'1',
'釋':'1',
'轘':'1',
'轖':'1',
'轗':'1',
'轙':'1',
'豑':'1',
'覻':'1',
'覹':'1',
'觸':'1',
'軆':'1',
'譝':'1',
'譞':'1',
'譟':'1',
'護':'1',
'譴':'1',
'譯':'1',
'譭':'1',
'譫':'1',
'議':'1',
'譡':'1',
'譮':'1',
'譤':'1',
'譧':'1',
'譨':'1',
'譲':'1',
'譠':'1',
'譣':'1',
'譩':'1',
'醵':'1',
'醴':'1',
'醲':'1',
'醷':'1',
'醶':'1',
'醸':'1',
'醳':'1',
'躈':'1',
'躁':'1',
'躅':'1',
'躃':'1',
'躆':'1',
'鐍':'1',
'鏻':'1',
'鏺':'1',
'鐥':'1',
'鐒':'1',
'鐃':'1',
'鐐':'1',
'鐔':'1',
'鐝':'1',
'鏷':'1',
'鐫':'1',
'鐘':'1',
'鐠':'1',
'鐓':'1',
'鐋':'1',
'鐦':'1',
'鐧':'1',
'鐗':'1',
'鐨':'1',
'鐙':'1',
'鏹':'1',
'鏳':'1',
'鏿':'1',
'鐽':'1',
'鐡':'1',
'鐤':'1',
'鐇':'1',
'鐞':'1',
'鏸':'1',
'鏶':'1',
'鐖':'1',
'鐎':'1',
'鐀':'1',
'鐂':'1',
'鐈':'1',
'鐑':'1',
'鐉':'1',
'鏾':'1',
'鏼':'1',
'鐁':'1',
'鐩':'1',
'鐟':'1',
'鐷':'1',
'鐚':'1',
'鐛':'1',
'鐭':'1',
'鐕':'1',
'鐣':'1',
'鐏':'1',
'饐':'1',
'饒':'1',
'饋':'1',
'饍':'1',
'饊':'1',
'饌':'1',
'饑':'1',
'饓':'1',
'饎':'1',
'鳜':'1',
'鳞':'1',
'鳝':'1',
'鳟':'1',
'霴':'1',
'飄':'1',
'飁':'1',
'鞻':'1',
'鞺':'1',
'髎':'1',
'髏':'1',
'髍':'1',
'顣':'1',
'顠':'1',
'顢':'1',
'顟':'1',
'顡':'1',
'韽':'1',
'鬸':'1',
'驊':'1',
'騮':'1',
'騶':'1',
'騸':'1',
'騰':'1',
'騯':'1',
'驆':'1',
'騬':'1',
'騳':'1',
'騱':'1',
'騴':'1',
'騵':'1',
'鹹':'1',
'鹺':'1',
'麵':'1',
'鶘':'1',
'鶒':'1',
'鶡':'1',
'鶚':'1',
'鶻':'1',
'鷀':'1',
'鶤':'1',
'鶥':'1',
'鶕':'1',
'鶝':'1',
'鶣':'1',
'鶙':'1',
'鶨':'1',
'鶞':'1',
'鶫':'1',
'鶛':'1',
'鶪':'1',
'鶔':'1',
'鶟':'1',
'鶠':'1',
'鶢':'1',
'鰆':'1',
'鯻':'1',
'鰊':'1',
'鰌':'1',
'鰇':'1',
'鰕':'1',
'鰏':'1',
'鰂':'1',
'鰃':'1',
'鰓':'1',
'鯷':'1',
'鰛':'1',
'鰐':'1',
'鰒':'1',
'鰍':'1',
'鰉':'1',
'鰁':'1',
'鯿':'1',
'鯶':'1',
'鯾':'1',
'鰈':'1',
'鰔':'1',
'鯸':'1',
'鰗':'1',
'鰀':'1',
'鰠':'1',
'鰰':'1',
'鰘':'1',
'鰖':'1',
'鰄':'1',
'鯹':'1',
'鰚':'1',
'鰋':'1',
'鰑':'1',
'鰅':'1',
'鰦':'1',
'鯼':'1',
'黪':'1',
'黩':'1',
'黥':'1',
'黦':'1',
'黤':'1',
'鼯':'1',
'鼰':'1',
'齟':'1',
'齚':'1',
'齣':'1',
'齙':'1',
'齠':'1',
'齝':'1',
'齡':'1',
'齛':'1',
'齞':'1',
'颥':'1',
'衊':'1',
'羺':'1',
'瀵':'1',
'鐼':'1',
'饙':'1',
'巉':'1',
'巄':'1',
'巏':'1',
'巊':'1',
'攘':'1',
'攖':'1',
'攔':'1',
'攙':'1',
'攕':'1',
'攗':'1',
'攓':'1',
'攏':'1',
'灌':'1',
'瀽':'1',
'瀼':'1',
'瀹':'1',
'瀧':'1',
'瀰':'1',
'瀺':'1',
'瀻':'1',
'瀿':'1',
'瀱':'1',
'瀸':'1',
'灂':'1',
'瀾':'1',
'灆':'1',
'瀲':'1',
'瀶':'1',
'灀':'1',
'瀷':'1',
'瀴':'1',
'灁':'1',
'壤':'1',
'壠':'1',
'壥':'1',
'壣':'1',
'壦':'1',
'懽':'1',
'懺':'1',
'懹':'1',
'孾':'1',
'酆':'1',
'酅':'1',
'儶':'1',
'忁':'1',
'徿':'1',
'忀':'1',
'嚾':'1',
'嚼':'1',
'嚷':'1',
'嚲':'1',
'嚨':'1',
'嚶':'1',
'嚵':'1',
'嚽':'1',
'嚸':'1',
'嚿':'1',
'嚹':'1',
'嚺':'1',
'嚱':'1',
'骦':'1',
'骧':'1',
'孀':'1',
'孅':'1',
'孃':'1',
'孉':'1',
'孂':'1',
'孄':'1',
'孆':'1',
'獾':'1',
'獼':'1',
'獽':'1',
'爓':'1',
'爔':'1',
'爐':'1',
'爘':'1',
'爏':'1',
'爒':'1',
'爋':'1',
'櫶':'1',
'櫨':'1',
'櫪':'1',
'櫸':'1',
'櫬':'1',
'欂':'1',
'櫮':'1',
'櫰':'1',
'櫷':'1',
'櫴':'1',
'櫹':'1',
'櫯':'1',
'櫩':'1',
'櫿':'1',
'犧':'1',
'斅':'1',
'斆':'1',
'獻':'1',
'曦':'1',
'曤':'1',
'曥':'1',
'曣':'1',
'甗':'1',
'瓒':'1',
'瓑':'1',
'瓌':'1',
'瓎':'1',
'瓐':'1',
'臛':'1',
'臜':'1',
'臙':'1',
'臚':'1',
'皪':'1',
'皫':'1',
'穮':'1',
'穭':'1',
'穯':'1',
'殲':'1',
'爝':'1',
'爚':'1',
'爛':'1',
'爟':'1',
'爖':'1',
'爙':'1',
'櫼':'1',
'櫳':'1',
'櫻':'1',
'櫺':'1',
'權':'1',
'欄':'1',
'欌':'1',
'欃':'1',
'欍':'1',
'欅':'1',
'欀':'1',
'櫾':'1',
'歡':'1',
'曨':'1',
'禳':'1',
'禴':'1',
'瓘':'1',
'瓏':'1',
'瓖':'1',
'瓔':'1',
'瓓':'1',
'斕':'1',
'朇':'1',
'朧':'1',
'臟':'1',
'皬':'1',
'龝':'1',
'攝':'1',
'攜':'1',
'攡':'1',
'攛':'1',
'灊':'1',
'灋':'1',
'灃':'1',
'灄':'1',
'灕':'1',
'灇':'1',
'灍':'1',
'灅':'1',
'灈':'1',
'灐':'1',
'灉':'1',
'懾':'1',
'懼':'1',
'赣':'1',
'矐':'1',
'矑':'1',
'礴':'1',
'礳':'1',
'礮':'1',
'礰':'1',
'礭':'1',
'礯':'1',
'襯':'1',
'襰':'1',
'蠟':'1',
'蠩':'1',
'蠝':'1',
'耰':'1',
'纇':'1',
'纆':'1',
'纈':'1',
'續':'1',
'纎':'1',
'纏':'1',
'纐':'1',
'纅':'1',
'纋':'1',
'纉':'1',
'艪':'1',
'贑':'1',
'贐':'1',
'贓':'1',
'镾':'1',
'轜':'1',
'轞':'1',
'轛':'1',
'覼':'1',
'觼':'1',
'軇':'1',
'譸':'1',
'讁':'1',
'譺':'1',
'譵':'1',
'譹':'1',
'讂':'1',
'譳':'1',
'譅':'1',
'醺':'1',
'醻':'1',
'醹':'1',
'躏':'1',
'躊':'1',
'躋':'1',
'躑':'1',
'躍':'1',
'躎':'1',
'躌':'1',
'鑀':'1',
'鐻':'1',
'鐳':'1',
'鐵':'1',
'鑊':'1',
'鐺':'1',
'鐸':'1',
'鐶':'1',
'鐲':'1',
'鐿':'1',
'鐮':'1',
'鏽':'1',
'鐴':'1',
'鐰':'1',
'鑉':'1',
'鐬':'1',
'鐱':'1',
'鏴':'1',
'鐪':'1',
'鑝':'1',
'鑓':'1',
'鑁':'1',
'饘':'1',
'饚':'1',
'饛':'1',
'饖':'1',
'鳡':'1',
'鳠':'1',
'鳢':'1',
'鳣':'1',
'飆':'1',
'飊':'1',
'鞽':'1',
'韃':'1',
'鞼':'1',
'鞿':'1',
'髓':'1',
'髐':'1',
'髒':'1',
'靧':'1',
'韢':'1',
'顥':'1',
'顧':'1',
'顦':'1',
'顤':'1',
'鬺':'1',
'騿':'1',
'驅':'1',
'驃':'1',
'騾':'1',
'驄':'1',
'驂':'1',
'騼':'1',
'騹':'1',
'騻':'1',
'騽':'1',
'驉':'1',
'鹻':'1',
'麶':'1',
'鶺':'1',
'鷇':'1',
'鷉':'1',
'鷊':'1',
'鷃':'1',
'鷂':'1',
'鷄':'1',
'鶬':'1',
'鶲':'1',
'鶹':'1',
'鶵':'1',
'鷁':'1',
'鶼':'1',
'鶴':'1',
'鷝':'1',
'鷎':'1',
'鶾':'1',
'鶮':'1',
'鷨':'1',
'鷅':'1',
'鷌':'1',
'鶸':'1',
'鶳':'1',
'鶽':'1',
'鶶':'1',
'鷈':'1',
'鷆':'1',
'鷏':'1',
'鷋':'1',
'鶷':'1',
'鷍':'1',
'鶰':'1',
'鰧':'1',
'鰭':'1',
'鰱':'1',
'鰣':'1',
'鰨':'1',
'鰥':'1',
'鰩':'1',
'鰷':'1',
'鰟':'1',
'鰜':'1',
'鰪':'1',
'鰝':'1',
'鰡':'1',
'鰢':'1',
'鰬':'1',
'鱃':'1',
'鰯':'1',
'鰤':'1',
'鰮':'1',
'鰞':'1',
'鰫':'1',
'鱁':'1',
'黯':'1',
'黮':'1',
'黭':'1',
'黬':'1',
'黫':'1',
'鼱':'1',
'齦':'1',
'齜':'1',
'齩':'1',
'齨':'1',
'齥':'1',
'龡':'1',
'羻':'1',
'馩':'1',
'劘':'1',
'劗':'1',
'酈':'1',
'酇':'1',
'儸':'1',
'儺':'1',
'儷':'1',
'儼':'1',
'儹':'1',
'忂':'1',
'飜':'1',
'囁':'1',
'囈':'1',
'囀':'1',
'囃':'1',
'囆':'1',
'囄':'1',
'孈':'1',
'孇':'1',
'儻':'1',
'囋':'1',
'囅':'1',
'囉':'1',
'囌':'1',
'囇':'1',
'囎':'1',
'孋':'1',
'孊':'1',
'孍':'1',
'玁':'1',
'玀':'1',
'獿':'1',
'玂':'1',
'镶':'1',
'镵':'1',
'竸':'1',
'矓':'1',
'矔':'1',
'鹳':'1',
'鹴':'1',
'礵':'1',
'礶':'1',
'礷':'1',
'礲':'1',
'襶':'1',
'襴':'1',
'襷':'1',
'襳':'1',
'蠴':'1',
'蠨':'1',
'蠦':'1',
'聽':'1',
'罏':'1',
'罎':'1',
'耲':'1',
'耱':'1',
'糴':'1',
'纑':'1',
'纒':'1',
'艫':'1',
'贖':'1',
'贕':'1',
'贘':'1',
'轢':'1',
'轠':'1',
'豄':'1',
'覿':'1',
'覾':'1',
'觽':'1',
'觻':'1',
'戵':'1',
'爡':'1',
'爞':'1',
'爜':'1',
'爠':'1',
'氍':'1',
'欋':'1',
'欉':'1',
'欇':'1',
'欆':'1',
'欈':'1',
'禵':'1',
'瓙':'1',
'瓗':'1',
'懿':'1',
'臞':'1',
'皭':'1',
'瓤':'1',
'穰':'1',
'穱':'1',
'巎':'1',
'巗':'1',
'巑':'1',
'巕':'1',
'彲':'1',
'攧':'1',
'攦':'1',
'攢':'1',
'攤':'1',
'攞':'1',
'攟':'1',
'攠':'1',
'灑':'1',
'灔':'1',
'灒':'1',
'灘':'1',
'灖':'1',
'灗':'1',
'壧':'1',
'戂':'1',
'讀':'1',
'讅':'1',
'譾':'1',
'譿':'1',
'讄':'1',
'讉':'1',
'讃':'1',
'躔':'1',
'躐':'1',
'躚':'1',
'躓':'1',
'躒':'1',
'躕':'1',
'躖':'1',
'鑌':'1',
'鑄':'1',
'鑑':'1',
'鑔':'1',
'鑛':'1',
'鑃':'1',
'鑅':'1',
'鑇':'1',
'鑧':'1',
'鑎':'1',
'鑖':'1',
'鑈':'1',
'鑏':'1',
'鑐':'1',
'鑂':'1',
'鑆':'1',
'鳤':'1',
'霼':'1',
'韂':'1',
'韁':'1',
'韄':'1',
'韀':'1',
'髑':'1',
'體':'1',
'韣':'1',
'顫':'1',
'顩':'1',
'顪':'1',
'顭':'1',
'頀':'1',
'髝':'1',
'驐':'1',
'驍':'1',
'驕':'1',
'驋':'1',
'驓':'1',
'驔':'1',
'驎':'1',
'驑':'1',
'驒':'1',
'驈':'1',
'驏':'1',
'鷗':'1',
'鷓':'1',
'鷚':'1',
'鷐':'1',
'鷬':'1',
'鷑':'1',
'鷜':'1',
'鷞':'1',
'鷵':'1',
'鷒':'1',
'鷛':'1',
'鷠':'1',
'鰶':'1',
'鱇':'1',
'鰼':'1',
'鱈':'1',
'鰹':'1',
'鰾':'1',
'鰳':'1',
'鰻':'1',
'鱅':'1',
'鱂':'1',
'鰺':'1',
'鱑':'1',
'鰿':'1',
'鱄':'1',
'鰽':'1',
'鰸':'1',
'鱋':'1',
'鱌':'1',
'鱜':'1',
'鱆':'1',
'黱':'1',
'黰':'1',
'黐':'1',
'鼴':'1',
'鼲':'1',
'鼳':'1',
'鼵':'1',
'齂':'1',
'齬':'1',
'齪':'1',
'齫':'1',
'龢':'1',
'讔':'1',
'讌':'1',
'讇':'1',
'讍':'1',
'讈':'1',
'醼':'1',
'躜':'1',
'躙':'1',
'鑣':'1',
'鑢':'1',
'鑚':'1',
'鑤':'1',
'鑠':'1',
'鑕':'1',
'鑥':'1',
'鑞':'1',
'鑡':'1',
'鑟':'1',
'鑙':'1',
'鑘':'1',
'鑗':'1',
'鑜':'1',
'鑦':'1',
'靆':'1',
'韈':'1',
'韅':'1',
'髕':'1',
'髖':'1',
'魗':'1',
'韤':'1',
'馪':'1',
'顯':'1',
'顬':'1',
'顮':'1',
'髞':'1',
'驛':'1',
'驗':'1',
'驌':'1',
'驖':'1',
'驜':'1',
'驙':'1',
'麟':'1',
'鷭':'1',
'鷯':'1',
'鷦':'1',
'鷼':'1',
'鷳':'1',
'鷸':'1',
'鷱':'1',
'鷮':'1',
'鷶':'1',
'鷤':'1',
'鷻':'1',
'鷡':'1',
'鷴':'1',
'鷧':'1',
'鷣':'1',
'鷷':'1',
'鱚':'1',
'鱏':'1',
'鱖':'1',
'鱓':'1',
'鱔':'1',
'鱒':'1',
'鱗':'1',
'鱘':'1',
'鱍':'1',
'鱕':'1',
'鱎':'1',
'鱙':'1',
'鱪':'1',
'鱊':'1',
'鱛':'1',
'黴':'1',
'黲':'1',
'鼆':'1',
'鼷':'1',
'鼹':'1',
'鼶':'1',
'鼸':'1',
'齄':'1',
'齃':'1',
'齯':'1',
'齮':'1',
'齰':'1',
'齭':'1',
'齱':'1',
'龓':'1',
'颧':'1',
'鱝':'1',
'欐':'1',
'欏':'1',
'欑':'1',
'欕':'1',
'曬':'1',
'曪':'1',
'曮':'1',
'禷':'1',
'禶':'1',
'瓚':'1',
'臢':'1',
'劙':'1',
'劚':'1',
'儽':'1',
'奲':'1',
'彏':'1',
'囐':'1',
'囏':'1',
'囒':'1',
'孏':'1',
'玃':'1',
'襱':'1',
'襵':'1',
'襺':'1',
'襼':'1',
'蠲':'1',
'蠸':'1',
'蠬':'1',
'蠰':'1',
'蠮':'1',
'蠳':'1',
'罐':'1',
'纓':'1',
'纔':'1',
'纖':'1',
'纕':'1',
'艬':'1',
'轤':'1',
'轣':'1',
'觾':'1',
'巘':'1',
'攫':'1',
'攥':'1',
'攩':'1',
'攪':'1',
'攨':'1',
'灛':'1',
'灙':'1',
'灚':'1',
'灡':'1',
'灜':'1',
'戄':'1',
'戃':'1',
'巙':'1',
'攬':'1',
'攭':'1',
'灞':'1',
'灠':'1',
'灝':'1',
'灟':'1',
'壩':'1',
'儾':'1',
'囓':'1',
'囑':'1',
'囍':'1',
'囕':'1',
'孎':'1',
'讙':'1',
'讕':'1',
'讓':'1',
'讖':'1',
'讒':'1',
'讑':'1',
'釂':'1',
'醾':'1',
'釀':'1',
'醽':'1',
'醿':'1',
'貛':'1',
'躘':'1',
'躞':'1',
'躤':'1',
'躝':'1',
'躟':'1',
'鑪':'1',
'鑮':'1',
'鑩':'1',
'鑬':'1',
'饝':'1',
'靅':'1',
'韆':'1',
'韇':'1',
'韥':'1',
'驞':'1',
'驝':'1',
'驟':'1',
'鹼':'1',
'鸊':'1',
'鸌':'1',
'鸇':'1',
'鷫':'1',
'鸏':'1',
'鸀':'1',
'鸈':'1',
'鷾':'1',
'鸃':'1',
'鸆':'1',
'鸅':'1',
'鱦':'1',
'鱥':'1',
'鱯':'1',
'鱤':'1',
'鱧':'1',
'鱢':'1',
'鱠':'1',
'鱮':'1',
'鱣':'1',
'鱫':'1',
'鱞':'1',
'鱩':'1',
'鱰':'1',
'鱐':'1',
'鱡':'1',
'齆':'1',
'齅':'1',
'齶':'1',
'齲':'1',
'齷':'1',
'齵':'1',
'齴':'1',
'齳':'1',
'衢':'1',
'爤':'1',
'爣':'1',
'欓':'1',
'欔':'1',
'欗':'1',
'曭':'1',
'瓛':'1',
'穳':'1',
'穲':'1',
'矙':'1',
'矖':'1',
'礸':'1',
'礹':'1',
'襻':'1',
'襸':'1',
'襹':'1',
'蠵':'1',
'蠷':'1',
'艷':'1',
'纗':'1',
'艭':'1',
'贛':'1',
'贚':'1',
'贜':'1',
'豅':'1',
'觀':'1',
'軈':'1',
'矡':'1',
'矘':'1',
'襽':'1',
'糶':'1',
'纘':'1',
'纚':'1',
'纙':'1',
'豒':'1',
'觿':'1',
'讛':'1',
'讘':'1',
'讗':'1',
'躥':'1',
'躡':'1',
'躣':'1',
'躢':'1',
'鑶':'1',
'鑱':'1',
'鑰':'1',
'鑲':'1',
'鑭':'1',
'鑵':'1',
'鑯':'1',
'鑳':'1',
'鑨':'1',
'饟':'1',
'饞':'1',
'靉':'1',
'韉':'1',
'髗':'1',
'顱':'1',
'顲':'1',
'鸐':'1',
'鸍':'1',
'鸋':'1',
'鱭':'1',
'鱨':'1',
'鱱':'1',
'鱴':'1',
'鱬':'1',
'鱶':'1',
'黵':'1',
'齇':'1',
'齻':'1',
'齸':'1',
'齺':'1',
'龣':'1',
'馕':'1',
'攮':'1',
'灣':'1',
'灢':'1',
'壪':'1',
'彠':'1',
'囔':'1',
'爥':'1',
'爦':'1',
'斸':'1',
'欙':'1',
'欛':'1',
'欖':'1',
'欚':'1',
'欘':'1',
'犪':'1',
'曯':'1',
'氎':'1',
'欜':'1',
'灤':'1',
'灦':'1',
'灎':'1',
'矚':'1',
'蠼':'1',
'虪':'1',
'糷':'1',
'轥':'1',
'讚':'1',
'讝':'1',
'釃':'1',
'釅':'1',
'釄':'1',
'躧':'1',
'躦':'1',
'躪':'1',
'鑷':'1',
'鑹':'1',
'鑸':'1',
'鑺':'1',
'鑴':'1',
'飌':'1',
'顴':'1',
'驥':'1',
'驢':'1',
'驣':'1',
'驠':'1',
'鸔':'1',
'鸓':'1',
'鱲':'1',
'鱵':'1',
'鱳':'1',
'龤':'1',
'龥':'1',
'讞':'1',
'讜':'1',
'貜':'1',
'躩':'1',
'鑼':'1',
'鑽':'1',
'鑻':'1',
'饠':'1',
'饡':'1',
'顳':'1',
'驩':'1',
'驦':'1',
'驤':'1',
'驧':'1',
'鸕':'1',
'鸖':'1',
'鱷':'1',
'鱸':'1',
'黷':'1',
'齈':'1',
'蠾':'1',
'纝':'1',
'纜':'1',
'豓':'1',
'軉':'1',
'灨':'1',
'灧':'1',
'豔':'1',
'爧':'1',
'欞':'1',
'欟':'1',
'躨':'1',
'钁':'1',
'钂':'1',
'钄':'1',
'钀':'1',
'驨':'1',
'鸘':'1',
'鸛':'1',
'鸚':'1',
'鸙':'1',
'鱹':'1',
'黸':'1',
'鼺':'1',
'齼':'1',
'齽':'1',
'囖':'1',
'纞':'1',
'讟':'1',
'钃':'1',
'韊':'1',
'驪':'1',
'麷':'1',
'鸜':'1',
'饢':'1',
'麣':'1',
'鸝':'1',
'鱺':'1',
'灩':'1',
'灪':'1',
'爩':'1',
'龖':'1',
'齉':'1',
'丂':'2',
'丆':'2',
'丄':'2',
'丅':'2',
'亠':'2',
'亇':'2',
'乇':'2',
'丌':'2',
'兀':'2',
'亍':'2',
'亐':'2',
'凣':'2',
'凢':'2',
'亼':'2',
'亽':'2',
'千':'2',
'夨':'2',
'乊':'2',
'乥':'2',
'分':'2',
'丒':'2',
'乤':'2',
'公':'2',
'六':'2',
'兮':'2',
'厃':'2',
'亖':'2',
'兯':'2',
'冗':'2',
'仓':'2',
'介':'2',
'今':'2',
'仑':'2',
'仌':'2',
'仒':'2',
'仐':'2',
'卆':'2',
'厹':'2',
'亢':'2',
'亣':'2',
'艺':'2',
'天':'2',
'弖':'2',
'币':'2',
'帀':'2',
'屲':'2',
'少':'2',
'尐':'2',
'戶':'2',
'戸':'2',
'见':'2',
'攴':'2',
'殳':'2',
'尣':'2',
'爻':'2',
'爫':'2',
'支':'2',
'卡':'2',
'丕':'2',
'丛':'2',
'丝':'2',
'乧':'2',
'乬':'2',
'冭':'2',
'卢':'2',
'占':'2',
'刍':'2',
'兄':'2',
'亗':'2',
'兰':'2',
'冎':'2',
'务':'2',
'写':'2',
'冚':'2',
'令':'2',
'仝':'2',
'仺':'2',
'仧':'2',
'仚':'2',
'卉':'2',
'去':'2',
'厼':'2',
'厺':'2',
'叐':'2',
'叏':'2',
'艾':'2',
'艽':'2',
'节':'2',
'艻':'2',
'艿':'2',
'艼':'2',
'芁':'2',
'芀':'2',
'夯':'2',
'夲':'2',
'夰':'2',
'夳':'2',
'巪':'2',
'弁':'2',
'市':'2',
'古':'2',
'号':'2',
'另':'2',
'台':'2',
'召':'2',
'只':'2',
'叾':'2',
'叧':'2',
'叴':'2',
'宄':'2',
'宁':'2',
'它':'2',
'宂':'2',
'屶':'2',
'屵':'2',
'屴':'2',
'屳':'2',
'壭':'2',
'圣':'2',
'圥':'2',
'尕':'2',
'尒':'2',
'尓':'2',
'冬':'2',
'孕':'2',
'灭':'2',
'朰':'2',
'旦':'2',
'正':'2',
'歺':'2',
'乓':'2',
'乒':'2',
'乔':'2',
'丢':'2',
'丟':'2',
'両':'2',
'丠':'2',
'丞':'2',
'买':'2',
'乫':'2',
'乮':'2',
'乯':'2',
'乭':'2',
'屰':'2',
'共':'2',
'兴':'2',
'兲':'2',
'争':'2',
'光':'2',
'先':'2',
'兊':'2',
'兇':'2',
'关':'2',
'凫':'2',
'再':'2',
'劣':'2',
'军':'2',
'会':'2',
'企':'2',
'伞':'2',
'全':'2',
'华':'2',
'卋':'2',
'充':'2',
'交':'2',
'芏':'2',
'芨':'2',
'芒':'2',
'芃':'2',
'芑':'2',
'芊':'2',
'芍':'2',
'芄':'2',
'芗':'2',
'芎':'2',
'芋':'2',
'芝':'2',
'芆':'2',
'芉':'2',
'芐':'2',
'芇':'2',
'芕':'2',
'芌':'2',
'芅':'2',
'芖':'2',
'芓':'2',
'巟':'2',
'导':'2',
'寺':'2',
'寻':'2',
'夺':'2',
'夸':'2',
'夼':'2',
'夻':'2',
'夵':'2',
'并':'2',
'年':'2',
'弚':'2',
'异':'2',
'当':'2',
'吊':'2',
'各':'2',
'吉':'2',
'吏':'2',
'吕':'2',
'名':'2',
'吂':'2',
'安':'2',
'守':'2',
'宇':'2',
'宅':'2',
'宆':'2',
'妄':'2',
'岌':'2',
'岂':'2',
'岁':'2',
'岀':'2',
'岃':'2',
'尽':'2',
'圭':'2',
'圶':'2',
'赱':'2',
'尧':'2',
'多':'2',
'夛':'2',
'尘':'2',
'尖':'2',
'尗':'2',
'夅':'2',
'字':'2',
'负':'2',
'贞':'2',
'贠':'2',
'毕':'2',
'危':'2',
'爷':'2',
'灮':'2',
'考':'2',
'老':'2',
'朵':'2',
'杀':'2',
'杂':'2',
'朶':'2',
'牟':'2',
'旮':'2',
'旯':'2',
'早':'2',
'旨':'2',
'氒':'2',
'汆':'2',
'氽':'2',
'氼':'2',
'毎':'2',
'忈':'2',
'有':'2',
'肎':'2',
'百':'2',
'甶':'2',
'穵':'2',
'甪':'2',
'糸':'2',
'齐':'2',
'色':'2',
'糹':'2',
'至':'2',
'系':'2',
'貝':'2',
'釆':'2',
'辵':'2',
'谷':'2',
'見':'2',
'里':'2',
'邑':'2',
'走':'2',
'足':'2',
'弅':'2',
'芬':'2',
'严':'2',
'丽':'2',
'乲':'2',
'兵':'2',
'羌':'2',
'兌':'2',
'免':'2',
'龟':'2',
'兕':'2',
'兎':'2',
'児':'2',
'劳':'2',
'努':'2',
'罕':'2',
'冝':'2',
'佥':'2',
'佘':'2',
'余':'2',
'县':'2',
'亩':'2',
'亪':'2',
'叓':'2',
'芺':'2',
'芭':'2',
'芘':'2',
'苄':'2',
'苍':'2',
'苌':'2',
'苁':'2',
'苊':'2',
'芳':'2',
'芾':'2',
'芙':'2',
'芣':'2',
'芥':'2',
'芴':'2',
'花':'2',
'芰':'2',
'苣':'2',
'芤':'2',
'苈':'2',
'芦':'2',
'芼':'2',
'苉':'2',
'芪':'2',
'芡':'2',
'芹':'2',
'芩':'2',
'芮':'2',
'芟':'2',
'苏':'2',
'苇':'2',
'芜':'2',
'苋':'2',
'芯':'2',
'芧':'2',
'芽':'2',
'芫':'2',
'苡':'2',
'芸':'2',
'芷':'2',
'苎':'2',
'芿':'2',
'芚':'2',
'芲':'2',
'苅':'2',
'苀':'2',
'芶':'2',
'芵':'2',
'芞':'2',
'苂':'2',
'茾':'2',
'苆':'2',
'芢':'2',
'芛':'2',
'芠':'2',
'苃':'2',
'寿':'2',
'寽':'2',
'夿':'2',
'奀':'2',
'奂':'2',
'奁':'2',
'奆':'2',
'夽':'2',
'弄':'2',
'弃':'2',
'希':'2',
'帋':'2',
'呈':'2',
'呆':'2',
'否':'2',
'告':'2',
'呙':'2',
'含':'2',
'君':'2',
'吝':'2',
'吞':'2',
'吾':'2',
'吴':'2',
'员':'2',
'吢':'2',
'吳':'2',
'吿':'2',
'呄':'2',
'呇':'2',
'呑':'2',
'宏':'2',
'宋':'2',
'完':'2',
'宊':'2',
'宑':'2',
'宍':'2',
'宎':'2',
'宐':'2',
'宒':'2',
'妥':'2',
'妛':'2',
'妟':'2',
'岙':'2',
'岜':'2',
'岑':'2',
'岔':'2',
'岛':'2',
'岗':'2',
'岚':'2',
'岇':'2',
'岊':'2',
'岕':'2',
'壳':'2',
'声':'2',
'売':'2',
'坌':'2',
'坚':'2',
'坠':'2',
'坐':'2',
'坒':'2',
'坔':'2',
'坖':'2',
'坓':'2',
'坕':'2',
'圼':'2',
'囪':'2',
'夆':'2',
'孚':'2',
'孝':'2',
'孞':'2',
'贡':'2',
'灸':'2',
'灵':'2',
'灾':'2',
'災':'2',
'灻':'2',
'灷':'2',
'李':'2',
'条':'2',
'杏':'2',
'杢':'2',
'杗':'2',
'牢':'2',
'旱':'2',
'旵':'2',
'旲':'2',
'汞':'2',
'汖':'2',
'斈':'2',
'毐':'2',
'忌':'2',
'忍':'2',
'忐':'2',
'忑':'2',
'忘':'2',
'志':'2',
'忎':'2',
'肓':'2',
'肖':'2',
'肙':'2',
'步':'2',
'皀':'2',
'皂':'2',
'皁':'2',
'皃':'2',
'秃':'2',
'秀':'2',
'秂':'2',
'禿':'2',
'盀':'2',
'盁':'2',
'每':'2',
'矣':'2',
'男':'2',
'甼':'2',
'甹':'2',
'究':'2',
'穷':'2',
'甬':'2',
'羋':'2',
'卥':'2',
'事':'2',
'丧':'2',
'兩':'2',
'並':'2',
'乶':'2',
'乷':'2',
'乴':'2',
'鼡':'2',
'典':'2',
'具':'2',
'券':'2',
'兔':'2',
'兒':'2',
'些':'2',
'凭':'2',
'冐':'2',
'势':'2',
'劵':'2',
'劽':'2',
'冞':'2',
'罙':'2',
'侖':'2',
'侌':'2',
'佱':'2',
'卑':'2',
'单':'2',
'卒':'2',
'卖':'2',
'卓':'2',
'亝':'2',
'参':'2',
'叁':'2',
'叀':'2',
'享':'2',
'兖':'2',
'变':'2',
'受':'2',
'叕':'2',
'茇':'2',
'苞':'2',
'苯':'2',
'苾':'2',
'范':'2',
'苻':'2',
'茀':'2',
'苷':'2',
'苟':'2',
'苦':'2',
'茄':'2',
'茎':'2',
'苴':'2',
'苛':'2',
'苓':'2',
'茏':'2',
'茆':'2',
'茅':'2',
'茂':'2',
'苗':'2',
'苠':'2',
'茉':'2',
'苜':'2',
'茑':'2',
'苧':'2',
'苹':'2',
'苘':'2',
'茕':'2',
'苒':'2',
'若':'2',
'苫':'2',
'茓':'2',
'苢':'2',
'茚':'2',
'英':'2',
'苑':'2',
'苲':'2',
'茁':'2',
'茌':'2',
'苽':'2',
'苝':'2',
'苪':'2',
'苩':'2',
'茐':'2',
'苐':'2',
'苖':'2',
'苵':'2',
'苳':'2',
'苰':'2',
'苸':'2',
'苙':'2',
'苺':'2',
'苨':'2',
'苼':'2',
'茒':'2',
'苿':'2',
'苮':'2',
'苬':'2',
'苭':'2',
'苚':'2',
'茋':'2',
'茊':'2',
'奔':'2',
'奉':'2',
'奇':'2',
'奈':'2',
'奅':'2',
'奄':'2',
'奃':'2',
'奌':'2',
'奍':'2',
'幸':'2',
'弩':'2',
'弆':'2',
'录':'2',
'彔':'2',
'帛':'2',
'帘':'2',
'帑':'2',
'帒':'2',
'咎':'2',
'命':'2',
'咒':'2',
'咅':'2',
'黾':'2',
'驾':'2',
'驽':'2',
'宝':'2',
'宠':'2',
'宕':'2',
'定':'2',
'官':'2',
'宓':'2',
'审':'2',
'实':'2',
'宛':'2',
'宜':'2',
'宙':'2',
'宗':'2',
'宖':'2',
'実':'2',
'宔':'2',
'妻':'2',
'妾':'2',
'委':'2',
'妿':'2',
'姇':'2',
'妴':'2',
'岸':'2',
'岱':'2',
'岽':'2',
'岢':'2',
'岿':'2',
'峁':'2',
'岧':'2',
'峃':'2',
'岩':'2',
'岳':'2',
'峀':'2',
'岪':'2',
'岦':'2',
'岺':'2',
'岝':'2',
'垄':'2',
'垈':'2',
'坴':'2',
'坣':'2',
'尭':'2',
'夜':'2',
'尚':'2',
'忝':'2',
'尙':'2',
'备':'2',
'季':'2',
'孟':'2',
'孥':'2',
'学':'2',
'孠':'2',
'孧':'2',
'贯':'2',
'货':'2',
'贫':'2',
'贪':'2',
'贤':'2',
'责':'2',
'炁':'2',
'轰':'2',
'卺':'2',
'卷':'2',
'爸':'2',
'戔':'2',
'炅':'2',
'炎':'2',
'炙':'2',
'炗':'2',
'炛':'2',
'烎':'2',
'觅':'2',
'斧':'2',
'者':'2',
'毟':'2',
'毞':'2',
'杲':'2',
'杰':'2',
'枭':'2',
'杳':'2',
'枣':'2',
'枈':'2',
'枀':'2',
'枩':'2',
'昂':'2',
'昌':'2',
'昊':'2',
'昏':'2',
'昆':'2',
'旻':'2',
'昙':'2',
'昔':'2',
'易':'2',
'昃':'2',
'昇':'2',
'旾':'2',
'昘':'2',
'昋':'2',
'旹':'2',
'昗':'2',
'沓':'2',
'汬':'2',
'瓮':'2',
'瓫':'2',
'斉':'2',
'忽':'2',
'念':'2',
'怂':'2',
'态':'2',
'忠':'2',
'忩':'2',
'忞':'2',
'忢':'2',
'曶':'2',
'肯':'2',
'肾':'2',
'肴':'2',
'育':'2',
'肻':'2',
'爭':'2',
'歨':'2',
'歩':'2',
'秊':'2',
'竎':'2',
'盂':'2',
'盲':'2',
'直':'2',
'鸢':'2',
'罗':'2',
'畀':'2',
'甾':'2',
'畁':'2',
'畄':'2',
'空':'2',
'穹':'2',
'穸':'2',
'穻':'2',
'臾':'2',
'臽':'2',
'籴':'2',
'肏':'2',
'舍':'2',
'舎':'2',
'肃':'2',
'竻':'2',
'竺':'2',
'采':'2',
'齿':'2',
'阜':'2',
'金':'2',
'靑':'2',
'青':'2',
'鱼':'2',
'表':'2',
'奋':'2',
'忿':'2',
'炃':'2',
'癷':'2',
'罖':'2',
'虿':'2',
'虽':'2',
'蚃':'2',
'蚤':'2',
'耑':'2',
'耎':'2',
'耍':'2',
'耷':'2',
'舁':'2',
'类':'2',
'粂':'2',
'要':'2',
'羿':'2',
'笃':'2',
'竿':'2',
'笈':'2',
'竽':'2',
'竾':'2',
'笁':'2',
'笀':'2',
'竼':'2',
'笂':'2',
'貞':'2',
'負':'2',
'貟':'2',
'軍':'2',
'食':'2',
'骨':'2',
'首':'2',
'香':'2',
'音':'2',
'羍':'2',
'兺':'2',
'衁':'2',
'乽':'2',
'乼':'2',
'乻':'2',
'乺':'2',
'举':'2',
'美':'2',
'羑':'2',
'前':'2',
'兹':'2',
'养':'2',
'冒':'2',
'冑':'2',
'勇':'2',
'冠':'2',
'冟':'2',
'俞':'2',
'侴':'2',
'兪':'2',
'南':'2',
'単':'2',
'亮':'2',
'亲':'2',
'亭':'2',
'亱':'2',
'兗':'2',
'叟':'2',
'叜':'2',
'草':'2',
'茬':'2',
'茶':'2',
'茺':'2',
'荈':'2',
'茈':'2',
'茨':'2',
'荙':'2',
'荅':'2',
'荡':'2',
'茯':'2',
'荄':'2',
'茖':'2',
'茛':'2',
'荭':'2',
'荁':'2',
'荒':'2',
'茴':'2',
'荟':'2',
'荤':'2',
'荠':'2',
'荚':'2',
'茧':'2',
'荐':'2',
'茳':'2',
'茭':'2',
'荩':'2',
'莒':'2',
'荖':'2',
'荔':'2',
'荦':'2',
'荬':'2',
'茫':'2',
'茗':'2',
'荨':'2',
'茜':'2',
'荞':'2',
'荍':'2',
'荃':'2',
'荏':'2',
'茸':'2',
'荣':'2',
'茹':'2',
'荪':'2',
'莛':'2',
'茼':'2',
'荥':'2',
'荇':'2',
'荀':'2',
'药':'2',
'茵':'2',
'荫':'2',
'荮':'2',
'茱':'2',
'茘':'2',
'茲':'2',
'荘':'2',
'荌':'2',
'茷':'2',
'荝':'2',
'茞':'2',
'荿':'2',
'荎':'2',
'茦':'2',
'茤':'2',
'荋':'2',
'荂':'2',
'茩':'2',
'茪':'2',
'茥':'2',
'茠':'2',
'茍':'2',
'茮':'2',
'荕':'2',
'荊':'2',
'茢':'2',
'荓':'2',
'茙':'2',
'荗':'2',
'茟':'2',
'莚':'2',
'茰':'2',
'荢':'2',
'茽':'2',
'茿':'2',
'茡':'2',
'専':'2',
'奖':'2',
'奎':'2',
'契':'2',
'奕':'2',
'奓':'2',
'奐':'2',
'奒':'2',
'差':'2',
'巬':'2',
'巭':'2',
'弮':'2',
'弯':'2',
'弇':'2',
'弈':'2',
'巹':'2',
'巻':'2',
'彖':'2',
'帮':'2',
'带':'2',
'帝':'2',
'帣':'2',
'帤':'2',
'帟':'2',
'帠':'2',
'哀':'2',
'咨':'2',
'呰':'2',
'咢':'2',
'哛':'2',
'咠':'2',
'骂':'2',
'宬':'2',
'宫':'2',
'宦':'2',
'客':'2',
'室':'2',
'宪':'2',
'宣':'2',
'宥':'2',
'宩':'2',
'宨':'2',
'姜':'2',
'娄':'2',
'娈':'2',
'姿':'2',
'姕':'2',
'姴':'2',
'姭':'2',
'峦':'2',
'峕':'2',
'峝':'2',
'峇':'2',
'峉':'2',
'峎':'2',
'峊':'2',
'峜':'2',
'峛':'2',
'峚':'2',
'峑':'2',
'峞':'2',
'峟':'2',
'彦':'2',
'彥':'2',
'壴':'2',
'巷':'2',
'巼':'2',
'垫':'2',
'垩':'2',
'垡':'2',
'垕':'2',
'垦':'2',
'垒':'2',
'型':'2',
'垐':'2',
'埅':'2',
'垔':'2',
'尝':'2',
'复':'2',
'変':'2',
'夈':'2',
'孪':'2',
'贷':'2',
'费':'2',
'贵':'2',
'贺':'2',
'贸':'2',
'贳':'2',
'毖':'2',
'毘':'2',
'点':'2',
'炰':'2',
'炭':'2',
'觉':'2',
'览':'2',
'耇':'2',
'毠':'2',
'查':'2',
'架':'2',
'某':'2',
'柰':'2',
'柒':'2',
'染':'2',
'柔':'2',
'枲':'2',
'栆':'2',
'査':'2',
'柋':'2',
'枼':'2',
'牮':'2',
'牵':'2',
'狊':'2',
'昪':'2',
'春':'2',
'昴':'2',
'昰':'2',
'是':'2',
'显':'2',
'星':'2',
'昱':'2',
'昝':'2',
'昼':'2',
'昺':'2',
'昬':'2',
'昻':'2',
'昦':'2',
'昷':'2',
'昚':'2',
'昜':'2',
'昮':'2',
'拏':'2',
'泵':'2',
'泉':'2',
'泴':'2',
'沗':'2',
'沯':'2',
'怠':'2',
'怼':'2',
'急':'2',
'怒':'2',
'思':'2',
'怹':'2',
'怨':'2',
'怎':'2',
'总':'2',
'怱':'2',
'怤':'2',
'怘':'2',
'怷':'2',
'怸':'2',
'怣':'2',
'曷':'2',
'背':'2',
'胃':'2',
'胥':'2',
'胄':'2',
'爰':'2',
'爯':'2',
'歪':'2',
'皇':'2',
'皆':'2',
'皍':'2',
'癸':'2',
'癹':'2',
'発':'2',
'甚':'2',
'竖':'2',
'竒':'2',
'盆':'2',
'盈':'2',
'盅':'2',
'盇':'2',
'盃':'2',
'盄':'2',
'毒':'2',
'看':'2',
'省':'2',
'県':'2',
'砉':'2',
'罚':'2',
'罘':'2',
'界':'2',
'畏':'2',
'畐':'2',
'畓':'2',
'窆':'2',
'穿':'2',
'窃':'2',
'突':'2',
'窀':'2',
'穽':'2',
'窂':'2',
'穼':'2',
'穾':'2',
'甭':'2',
'甮':'2',
'羞':'2',
'剓':'2',
'党':'2',
'兼':'2',
'冓':'2',
'冔':'2',
'冥':'2',
'冤':'2',
'冢':'2',
'冣':'2',
'冦':'2',
'冧':'2',
'倉':'2',
'亳':'2',
'茝':'2',
'莼':'2',
'莝':'2',
'荻':'2',
'莪':'2',
'莩':'2',
'莞':'2',
'荷':'2',
'获':'2',
'莙':'2',
'莰':'2',
'莱':'2',
'莨':'2',
'莉':'2',
'莅':'2',
'莲':'2',
'莓':'2',
'莫':'2',
'莆':'2',
'莎':'2',
'莘':'2',
'莳':'2',
'荼':'2',
'荽':'2',
'莴':'2',
'莶':'2',
'莹':'2',
'莜':'2',
'莸':'2',
'莠':'2',
'華':'2',
'莕':'2',
'莢':'2',
'莖':'2',
'莧':'2',
'莂':'2',
'荹':'2',
'莗':'2',
'莀':'2',
'莐':'2',
'莡':'2',
'荳':'2',
'荰':'2',
'莑':'2',
'荴':'2',
'莄':'2',
'莟':'2',
'莋':'2',
'莭':'2',
'荲':'2',
'莔':'2',
'莬':'2',
'莈':'2',
'莯':'2',
'莮':'2',
'莻':'2',
'莥':'2',
'菦':'2',
'莍':'2',
'菃':'2',
'荵':'2',
'莦':'2',
'莤':'2',
'荾':'2',
'莏':'2',
'莵':'2',
'莌':'2',
'莣':'2',
'荱':'2',
'茣':'2',
'莁':'2',
'莃':'2',
'荶':'2',
'荺':'2',
'莇':'2',
'莊':'2',
'尃':'2',
'套':'2',
'奘':'2',
'奙':'2',
'弉':'2',
'帬':'2',
'哥':'2',
'哿':'2',
'哭':'2',
'哲':'2',
'唘':'2',
'員':'2',
'唟':'2',
'唜':'2',
'宾':'2',
'宸':'2',
'家':'2',
'宽':'2',
'宭':'2',
'容':'2',
'宵':'2',
'宧':'2',
'宰':'2',
'宲':'2',
'宮':'2',
'宺':'2',
'宼':'2',
'宷':'2',
'宯':'2',
'宱':'2',
'娿':'2',
'娑':'2',
'娎':'2',
'娤':'2',
'狴':'2',
'崁':'2',
'崀':'2',
'峩':'2',
'峯':'2',
'崋':'2',
'峲':'2',
'峷':'2',
'峹':'2',
'峾':'2',
'峳':'2',
'壶':'2',
'垽':'2',
'堲':'2',
'埊':'2',
'垼':'2',
'埑':'2',
'圅':'2',
'夞':'2',
'恭':'2',
'离':'2',
'夎':'2',
'夏':'2',
'孬':'2',
'贾':'2',
'赁':'2',
'贽':'2',
'赀':'2',
'资':'2',
'毙':'2',
'羔':'2',
'烈':'2',
'热':'2',
'烝':'2',
'烋':'2',
'爹':'2',
'烫':'2',
'烉':'2',
'烡':'2',
'烮':'2',
'笕':'2',
'耄':'2',
'耆':'2',
'耊':'2',
'笔':'2',
'毣':'2',
'案':'2',
'柴':'2',
'桨':'2',
'桀':'2',
'桊':'2',
'栗':'2',
'栾':'2',
'桑':'2',
'桌':'2',
'栔':'2',
'栞':'2',
'栠':'2',
'桇':'2',
'枽':'2',
'栥':'2',
'牶':'2',
'晁':'2',
'晃':'2',
'晋':'2',
'晟':'2',
'晕':'2',
'晉':'2',
'晑':'2',
'挛':'2',
'拿':'2',
'挈':'2',
'拳':'2',
'挚':'2',
'挐':'2',
'拲':'2',
'挙':'2',
'浆':'2',
'洯':'2',
'泰':'2',
'洜':'2',
'瓷':'2',
'珡':'2',
'斋':'2',
'斊':'2',
'恶':'2',
'恩':'2',
'恚':'2',
'恝':'2',
'恳':'2',
'恐':'2',
'恋':'2',
'恁':'2',
'恧':'2',
'恕':'2',
'息':'2',
'恙':'2',
'恣':'2',
'恏':'2',
'恵':'2',
'恖':'2',
'恷':'2',
'書':'2',
'曺':'2',
'曻':'2',
'脊':'2',
'胷':'2',
'脋':'2',
'脀':'2',
'脅':'2',
'爱':'2',
'歬':'2',
'秦':'2',
'竜':'2',
'盎':'2',
'盍':'2',
'盉':'2',
'监':'2',
'盐':'2',
'益':'2',
'盏':'2',
'盌':'2',
'盋':'2',
'眚':'2',
'眢':'2',
'眔':'2',
'眘':'2',
'鸶':'2',
'鸯':'2',
'鸳':'2',
'砻':'2',
'砮':'2',
'祟':'2',
'罢':'2',
'罡':'2',
'罛':'2',
'罟':'2',
'罝':'2',
'罞':'2',
'罠':'2',
'罜':'2',
'畚':'2',
'畜':'2',
'留':'2',
'畠':'2',
'畕':'2',
'窎':'2',
'窍':'2',
'窊':'2',
'窅':'2',
'窈':'2',
'窄':'2',
'窇':'2',
'窉':'2',
'窋':'2',
'窌':'2',
'疍':'2',
'丵':'2',
'玺':'2',
'芻':'2',
'蚕':'2',
'蚩':'2',
'蚉':'2',
'聂':'2',
'耸':'2',
'缹':'2',
'舀':'2',
'粊':'2',
'紧':'2',
'素':'2',
'索':'2',
'紊':'2',
'紥':'2',
'覂':'2',
'翁':'2',
'翆':'2',
'笆':'2',
'笓':'2',
'笏':'2',
'笄':'2',
'笅':'2',
'笋':'2',
'笑':'2',
'笊':'2',
'笫':'2',
'笒':'2',
'笐':'2',
'笉':'2',
'笍':'2',
'笇':'2',
'笌':'2',
'笖':'2',
'笎':'2',
'臭':'2',
'臬':'2',
'貢':'2',
'貣':'2',
'軎':'2',
'辱':'2',
'豈':'2',
'覍':'2',
'訔':'2',
'趸':'2',
'釜':'2',
'釡':'2',
'隽':'2',
'隼':'2',
'隻':'2',
'鬯':'2',
'高':'2',
'衾':'2',
'衰':'2',
'袁':'2',
'衮':'2',
'袅':'2',
'羙':'2',
'袃':'2',
'蛋':'2',
'蛊':'2',
'蚻':'2',
'聋':'2',
'舂':'2',
'粜':'2',
'累':'2',
'紮':'2',
'胬':'2',
'翌':'2',
'習':'2',
'翇':'2',
'翏':'2',
'笨':'2',
'笾':'2',
'笞':'2',
'笪':'2',
'笛':'2',
'第':'2',
'符':'2',
'笰':'2',
'笴':'2',
'笱':'2',
'笳':'2',
'笺':'2',
'笠':'2',
'笭':'2',
'笢':'2',
'笯':'2',
'笸':'2',
'筇':'2',
'笙':'2',
'笥':'2',
'笤':'2',
'笮':'2',
'笩':'2',
'笣':'2',
'笧':'2',
'笚':'2',
'笗':'2',
'笲':'2',
'笵':'2',
'笟':'2',
'笷':'2',
'笽':'2',
'笝':'2',
'笡':'2',
'笻':'2',
'笘':'2',
'笶':'2',
'笹':'2',
'笜':'2',
'貪':'2',
'責':'2',
'貧':'2',
'貨':'2',
'貫':'2',
'軣':'2',
'覔':'2',
'覓':'2',
'象':'2',
'豙':'2',
'酓':'2',
'雪':'2',
'雩':'2',
'雫':'2',
'雭':'2',
'雀':'2',
'黒':'2',
'麥':'2',
'袭':'2',
'袤':'2',
'袋':'2',
'袈':'2',
'羕':'2',
'羛':'2',
'袰':'2',
'剪':'2',
'亀':'2',
'兜':'2',
'冕':'2',
'勗':'2',
'冨':'2',
'參':'2',
'叄':'2',
'菝':'2',
'菢':'2',
'菶':'2',
'萆':'2',
'菠':'2',
'菜':'2',
'菖':'2',
'菙':'2',
'菆':'2',
'萃':'2',
'萏':'2',
'菪':'2',
'菂':'2',
'菲':'2',
'菔':'2',
'菰':'2',
'菇':'2',
'菓':'2',
'菡':'2',
'菏':'2',
'萑':'2',
'菅':'2',
'菨':'2',
'菁':'2',
'菊':'2',
'菌':'2',
'菻':'2',
'菱':'2',
'菉':'2',
'萝':'2',
'萌':'2',
'萘':'2',
'萁':'2',
'萨':'2',
'萐':'2',
'菽':'2',
'菘':'2',
'菼':'2',
'萄':'2',
'菾':'2',
'萜':'2',
'菟':'2',
'萚':'2',
'菀':'2',
'菵':'2',
'萎':'2',
'菋':'2',
'菥':'2',
'萧':'2',
'菸':'2',
'萸':'2',
'著':'2',
'菑':'2',
'菹':'2',
'菴':'2',
'萇':'2',
'萅':'2',
'萊':'2',
'萡':'2',
'萗':'2',
'菭':'2',
'菗':'2',
'莿':'2',
'萕':'2',
'菿':'2',
'菧':'2',
'萣':'2',
'菄':'2',
'萉':'2',
'菒':'2',
'菮':'2',
'萖':'2',
'萂':'2',
'萀':'2',
'萈':'2',
'菺':'2',
'菫':'2',
'菳':'2',
'萛':'2',
'菤':'2',
'萒':'2',
'菎':'2',
'菈':'2',
'蓈':'2',
'菞':'2',
'菕':'2',
'莾':'2',
'菛':'2',
'萠':'2',
'菍':'2',
'萢':'2',
'菬':'2',
'菣':'2',
'萔':'2',
'蒁':'2',
'萵':'2',
'萓':'2',
'萟':'2',
'菚':'2',
'萙':'2',
'菷':'2',
'巢':'2',
'巣':'2',
'專':'2',
'奢':'2',
'奟':'2',
'奝':'2',
'奜':'2',
'奛':'2',
'奞':'2',
'彗':'2',
'常':'2',
'啬':'2',
'商':'2',
'售':'2',
'啓':'2',
'啚':'2',
'啇':'2',
'啔':'2',
'啠':'2',
'寄':'2',
'寂':'2',
'寇':'2',
'密':'2',
'宿':'2',
'寅':'2',
'寀':'2',
'寃':'2',
'寉':'2',
'寈':'2',
'寁':'2',
'婪':'2',
'婆':'2',
'娶':'2',
'婴':'2',
'婁':'2',
'婓':'2',
'婜':'2',
'婯':'2',
'婱':'2',
'崩':'2',
'崇':'2',
'崔':'2',
'崮':'2',
'崖':'2',
'崟':'2',
'崭':'2',
'崒':'2',
'崧':'2',
'崬':'2',
'崗':'2',
'崑':'2',
'崙':'2',
'崈':'2',
'崫':'2',
'崣':'2',
'壷':'2',
'渠':'2',
'堕':'2',
'基':'2',
'堇':'2',
'堑':'2',
'堂':'2',
'埜':'2',
'堊':'2',
'堅':'2',
'堃':'2',
'埿':'2',
'堏':'2',
'埾':'2',
'禼':'2',
'孯':'2',
'赉':'2',
'焘':'2',
'烹':'2',
'焉':'2',
'焎':'2',
'焄':'2',
'焏':'2',
'旉':'2',
'戛':'2',
'烲':'2',
'烾':'2',
'焂':'2',
'焁':'2',
'焈':'2',
'焋':'2',
'耈':'2',
'毫':'2',
'梵':'2',
'梨':'2',
'梁':'2',
'梦':'2',
'桼':'2',
'椘':'2',
'梊':'2',
'梷':'2',
'桬':'2',
'梥':'2',
'桽':'2',
'梺':'2',
'犁':'2',
'牽':'2',
'晨':'2',
'晢':'2',
'晝':'2',
'晜':'2',
'挲':'2',
'斍':'2',
'患':'2',
'您':'2',
'悫':'2',
'悉':'2',
'悬':'2',
'恿':'2',
'悠':'2',
'悤':'2',
'悪':'2',
'悡':'2',
'悆':'2',
'悐':'2',
'悘':'2',
'悥':'2',
'悊':'2',
'曹':'2',
'脟':'2',
'望':'2',
'朚':'2',
'皐':'2',
'秶':'2',
'龚':'2',
'龛':'2',
'笼':'2',
'盛':'2',
'盗':'2',
'盖':'2',
'盒':'2',
'盔':'2',
'盘':'2',
'盕':'2',
'盓':'2',
'眷':'2',
'着':'2',
'眥':'2',
'眾':'2',
'鸾':'2',
'鸷':'2',
'產':'2',
'砦':'2',
'祭':'2',
'票':'2',
'祡':'2',
'罣':'2',
'異':'2',
'畧':'2',
'畣':'2',
'畨':'2',
'率':'2',
'窕':'2',
'窑':'2',
'窒':'2',
'窚':'2',
'窐':'2',
'窏':'2',
'窔':'2',
'羡':'2',
'凖':'2',
'兠':'2',
'募':'2',
'勞':'2',
'凿':'2',
'傘':'2',
'喪':'2',
'叅':'2',
'亵':'2',
'葆':'2',
'萹':'2',
'葧':'2',
'蒇':'2',
'蒂':'2',
'董':'2',
'萼':'2',
'葑':'2',
'葍':'2',
'葛':'2',
'蓇':'2',
'葓':'2',
'葫':'2',
'葭':'2',
'蒋':'2',
'蒈':'2',
'葵':'2',
'落':'2',
'蒌':'2',
'葎':'2',
'葩':'2',
'蒎':'2',
'葡':'2',
'葺':'2',
'葜':'2',
'萩':'2',
'葚':'2',
'葇':'2',
'葹':'2',
'蒐':'2',
'葶':'2',
'葖':'2',
'葳':'2',
'葸':'2',
'葈':'2',
'葙':'2',
'萱':'2',
'葉':'2',
'葢':'2',
'萬':'2',
'蒉':'2',
'葅':'2',
'葠':'2',
'萲':'2',
'蒍':'2',
'葷':'2',
'葒':'2',
'葦':'2',
'葤':'2',
'萻':'2',
'葊':'2',
'萯':'2',
'萴':'2',
'蒢':'2',
'萶':'2',
'蒫':'2',
'葮':'2',
'葐':'2',
'蒄':'2',
'葔':'2',
'葟':'2',
'萿':'2',
'葪':'2',
'蔇':'2',
'葌':'2',
'葏':'2',
'葥':'2',
'葁':'2',
'葝':'2',
'萭':'2',
'葰':'2',
'萪':'2',
'葀':'2',
'葻':'2',
'萰':'2',
'萺':'2',
'葿':'2',
'葞':'2',
'蒾':'2',
'葂':'2',
'萳':'2',
'蓱':'2',
'葴':'2',
'葋':'2',
'葲':'2',
'蒅':'2',
'萷':'2',
'蓃':'2',
'蓚':'2',
'葨':'2',
'萫':'2',
'葕':'2',
'葯':'2',
'葽':'2',
'萾':'2',
'蒏':'2',
'萮':'2',
'葾':'2',
'蒀':'2',
'葃':'2',
'蒃':'2',
'葼':'2',
'葄':'2',
'尊':'2',
'奡':'2',
'奥':'2',
'奠':'2',
'奤':'2',
'奣':'2',
'彘':'2',
'幂':'2',
'幇':'2',
'啻':'2',
'善':'2',
'喜':'2',
'喌':'2',
'啙':'2',
'喬':'2',
'單':'2',
'喦':'2',
'喸':'2',
'喣':'2',
'骛':'2',
'骘':'2',
'富':'2',
'寒':'2',
'寐':'2',
'寔':'2',
'寓':'2',
'寎':'2',
'寏':'2',
'寋':'2',
'寑':'2',
'寊':'2',
'婺':'2',
'媭':'2',
'媝':'2',
'嵌':'2',
'嵚':'2',
'崴':'2',
'嵬':'2',
'嵛':'2',
'嵗':'2',
'嵐':'2',
'嵳':'2',
'崶':'2',
'嵅':'2',
'嵆':'2',
'嵙':'2',
'嵂':'2',
'嵍':'2',
'嵒':'2',
'嵜':'2',
'嵔':'2',
'嵓':'2',
'崺':'2',
'崱':'2',
'嵀':'2',
'嵏':'2',
'壺':'2',
'巽':'2',
'堡':'2',
'塟':'2',
'堼':'2',
'堻':'2',
'堥':'2',
'塈':'2',
'堯':'2',
'塦':'2',
'舜':'2',
'尞':'2',
'悲':'2',
'禽':'2',
'孳':'2',
'赍':'2',
'赏':'2',
'琵':'2',
'焦':'2',
'然':'2',
'煮':'2',
'無':'2',
'焣':'2',
'辈':'2',
'辇':'2',
'爺':'2',
'戞':'2',
'煚':'2',
'煑':'2',
'焤':'2',
'焸':'2',
'焭':'2',
'焽':'2',
'耋':'2',
'棐':'2',
'棨':'2',
'椠':'2',
'棠':'2',
'棗':'2',
'椉':'2',
'棄':'2',
'琹':'2',
'棊':'2',
'棃':'2',
'椝':'2',
'棽':'2',
'棾':'2',
'椞':'2',
'棸':'2',
'犂':'2',
'猆':'2',
'景':'2',
'普':'2',
'晵':'2',
'暑':'2',
'暂':'2',
'智':'2',
'晳':'2',
'暃':'2',
'掣':'2',
'掌':'2',
'掔':'2',
'淾':'2',
'琶':'2',
'琴':'2',
'斐':'2',
'惫':'2',
'惩':'2',
'惠':'2',
'惑':'2',
'惎':'2',
'惄':'2',
'惪':'2',
'惡':'2',
'惥':'2',
'惌':'2',
'悳':'2',
'悹':'2',
'惒':'2',
'惖':'2',
'惁':'2',
'惉':'2',
'惣':'2',
'牚':'2',
'曾':'2',
'替':'2',
'最':'2',
'朁':'2',
'朂':'2',
'腎':'2',
'朞':'2',
'歯':'2',
'登':'2',
'發':'2',
'稁':'2',
'童':'2',
'矞':'2',
'盜':'2',
'盙':'2',
'盚':'2',
'睂':'2',
'硩':'2',
'硰':'2',
'罦':'2',
'罥':'2',
'罤':'2',
'番':'2',
'畬':'2',
'畲':'2',
'畱':'2',
'畳':'2',
'窗':'2',
'窜':'2',
'窖':'2',
'窘':'2',
'窝':'2',
'窛':'2',
'窙':'2',
'茻':'2',
'蛮':'2',
'蛩':'2',
'蛰':'2',
'蛪':'2',
'蛬':'2',
'蜑':'2',
'蛗':'2',
'聓':'2',
'舄':'2',
'舃':'2',
'粟':'2',
'粤':'2',
'粢':'2',
'粦':'2',
'絜':'2',
'絮':'2',
'絷':'2',
'紫':'2',
'絭':'2',
'絫':'2',
'脔':'2',
'胔':'2',
'覃':'2',
'覄':'2',
'翚':'2',
'翕':'2',
'筆':'2',
'筚':'2',
'策':'2',
'答':'2',
'筜':'2',
'等':'2',
'筏':'2',
'筀':'2',
'筋':'2',
'筥':'2',
'筐':'2',
'筈':'2',
'笿':'2',
'筌':'2',
'筛':'2',
'筳':'2',
'筒':'2',
'筅':'2',
'筵':'2',
'筝':'2',
'筑':'2',
'筘':'2',
'筍':'2',
'筊':'2',
'筬':'2',
'筂':'2',
'筕':'2',
'筓':'2',
'筙':'2',
'筁':'2',
'筎':'2',
'筄':'2',
'筃':'2',
'筗':'2',
'臯':'2',
'臰':'2',
'臮':'2',
'貰':'2',
'賁':'2',
'貴':'2',
'買':'2',
'貸':'2',
'貿':'2',
'費':'2',
'賀':'2',
'軰':'2',
'量':'2',
'辜':'2',
'詈':'2',
'詟':'2',
'靟':'2',
'鲁':'2',
'雳':'2',
'雱':'2',
'雯':'2',
'雲':'2',
'雬':'2',
'雮':'2',
'集':'2',
'雋':'2',
'雈':'2',
'颪':'2',
'韮':'2',
'髠':'2',
'鼎':'2',
'黑':'2',
'鼋':'2',
'黍':'2',
'黹':'2',
'装':'2',
'裒':'2',
'裂':'2',
'褁':'2',
'衆':'2',
'棼':'2',
'焚':'2',
'粪':'2',
'蒊':'2',
'雰':'2',
'㙓':'2',
'蜀':'2',
'蜇':'2',
'聖':'2',
'舅':'2',
'粲':'2',
'粱':'2',
'粵':'2',
'綤':'2',
'裚':'2',
'翜':'2',
'筧':'2',
'筴':'2',
'筹':'2',
'筻':'2',
'筦':'2',
'简':'2',
'筠':'2',
'筷':'2',
'筢':'2',
'签':'2',
'筲':'2',
'筮':'2',
'筭':'2',
'筱':'2',
'筼':'2',
'筯':'2',
'筰':'2',
'筞':'2',
'筩':'2',
'節':'2',
'筟':'2',
'筸':'2',
'筶':'2',
'筨':'2',
'筺':'2',
'筤':'2',
'筣':'2',
'筽':'2',
'筡':'2',
'筪':'2',
'筿':'2',
'筫':'2',
'賈':'2',
'賃':'2',
'資':'2',
'賌':'2',
'貲':'2',
'輂':'2',
'農':'2',
'豋':'2',
'豊':'2',
'觜':'2',
'觠':'2',
'觢':'2',
'豢':'2',
'辠':'2',
'誊':'2',
'誉':'2',
'詹':'2',
'訾':'2',
'詧':'2',
'酱':'2',
'跫':'2',
'鉴':'2',
'飬':'2',
'雹':'2',
'雷':'2',
'零':'2',
'雾':'2',
'電':'2',
'雸':'2',
'雴':'2',
'雼':'2',
'雽':'2',
'雺':'2',
'雵':'2',
'雍':'2',
'髢':'2',
'髡':'2',
'馵':'2',
'麁':'2',
'鳧':'2',
'鼌':'2',
'鼠':'2',
'裔':'2',
'裟':'2',
'裘':'2',
'裏':'2',
'裝':'2',
'裠':'2',
'羣':'2',
'蒶':'2',
'羨':'2',
'義':'2',
'兾':'2',
'厁':'2',
'勢':'2',
'亶':'2',
'亷':'2',
'叠':'2',
'蒡':'2',
'蓓':'2',
'蓖':'2',
'蔀':'2',
'蓧':'2',
'蒽':'2',
'蒿':'2',
'蒦':'2',
'蒺':'2',
'蓟':'2',
'蒹':'2',
'蒟':'2',
'蓝':'2',
'蒗':'2',
'蓠':'2',
'蓏':'2',
'蒙':'2',
'蓂':'2',
'蓦':'2',
'蒳':'2',
'蓬':'2',
'蒱':'2',
'蒲':'2',
'蓉':'2',
'蓐':'2',
'蒻':'2',
'蒒':'2',
'蓍':'2',
'蒴':'2',
'蒜':'2',
'蓑':'2',
'蓨':'2',
'蓊':'2',
'蓄':'2',
'蓥':'2',
'蓣':'2',
'蓁':'2',
'蓋':'2',
'蓮':'2',
'蓽':'2',
'蒼':'2',
'蒨':'2',
'蒞':'2',
'蓡':'2',
'蓆':'2',
'蓀':'2',
'蒓':'2',
'蔭':'2',
'蔜':'2',
'蓛':'2',
'蔯':'2',
'蒭':'2',
'蓫':'2',
'蓌':'2',
'蓕':'2',
'蓘':'2',
'蒝':'2',
'蒩':'2',
'蓢':'2',
'蒚':'2',
'蓤':'2',
'蒥':'2',
'蓅':'2',
'蓩':'2',
'蒘':'2',
'蒰':'2',
'蓜':'2',
'蒪':'2',
'蒛':'2',
'蔱':'2',
'蒔':'2',
'蒣':'2',
'蓎':'2',
'蓪':'2',
'蒤':'2',
'蓞':'2',
'蒠':'2',
'蒵':'2',
'蓒':'2',
'蓔':'2',
'蒑':'2',
'蒮':'2',
'蒬':'2',
'蒕':'2',
'蒷':'2',
'蒖':'2',
'蓗':'2',
'蓙':'2',
'奨':'2',
'奧':'2',
'奦':'2',
'彂':'2',
'弿':'2',
'彚':'2',
'彙':'2',
'幕':'2',
'幋':'2',
'嗇':'2',
'嗸':'2',
'嗭':'2',
'嗧':'2',
'喿':'2',
'骜':'2',
'骞':'2',
'寞':'2',
'寝':'2',
'寘':'2',
'寛':'2',
'寖':'2',
'寗':'2',
'寜':'2',
'寙':'2',
'嫯':'2',
'嫑':'2',
'媻':'2',
'媐':'2',
'嫈':'2',
'嶅':'2',
'嵩':'2',
'嵤':'2',
'嵵':'2',
'嵞':'2',
'嵡':'2',
'準':'2',
'塱':'2',
'墓':'2',
'塑':'2',
'塗':'2',
'塋':'2',
'塰':'2',
'塣':'2',
'夢':'2',
'孴':'2',
'孶':'2',
'煎':'2',
'煞':'2',
'煦':'2',
'照':'2',
'煭':'2',
'辔':'2',
'旕':'2',
'煲':'2',
'煢':'2',
'楚':'2',
'榃':'2',
'業':'2',
'榘':'2',
'槩':'2',
'楍':'2',
'楶':'2',
'楽':'2',
'楘':'2',
'犎':'2',
'暋':'2',
'暈':'2',
'暓':'2',
'晸':'2',
'揅':'2',
'揫':'2',
'揧':'2',
'揱':'2',
'湬':'2',
'甃':'2',
'甆':'2',
'瑟':'2',
'愁':'2',
'慈':'2',
'感':'2',
'愍':'2',
'愆':'2',
'想':'2',
'愚':'2',
'愈':'2',
'愛':'2',
'愙':'2',
'惷':'2',
'愂':'2',
'愗':'2',
'會':'2',
'歲':'2',
'歳':'2',
'皙':'2',
'稟':'2',
'竪':'2',
'盝':'2',
'盟':'2',
'盞':'2',
'督':'2',
'睪':'2',
'睝':'2',
'碁':'2',
'碆':'2',
'硻':'2',
'禁':'2',
'署':'2',
'罨':'2',
'罭':'2',
'罩':'2',
'置':'2',
'罪':'2',
'罫':'2',
'罧':'2',
'罬':'2',
'畵':'2',
'窦':'2',
'窠':'2',
'窟':'2',
'窥':'2',
'窣':'2',
'窩':'2',
'窞':'2',
'窤':'2',
'窢':'2',
'窡':'2',
'窧':'2',
'琧':'2',
'琞':'2',
'凳':'2',
'凴':'2',
'勥':'2',
'冩':'2',
'僰':'2',
'蔼':'2',
'蔽':'2',
'蔡':'2',
'蔟':'2',
'蔸':'2',
'蔊':'2',
'蔧':'2',
'蔻':'2',
'蔹':'2',
'蓼':'2',
'蔺':'2',
'蔓':'2',
'蔫':'2',
'蔷':'2',
'蕖':'2',
'蔌':'2',
'蓷':'2',
'蔚':'2',
'蓰':'2',
'箫':'2',
'蓿':'2',
'蔗':'2',
'蓺':'2',
'蓴':'2',
'蔕':'2',
'蔂':'2',
'蔞':'2',
'蔥':'2',
'蔦':'2',
'蓯':'2',
'蔔':'2',
'蔆':'2',
'蔴':'2',
'蔣':'2',
'薌':'2',
'蓭':'2',
'蔈':'2',
'蔢':'2',
'蔵':'2',
'蓸':'2',
'蕏':'2',
'蔍':'2',
'蔖':'2',
'蔋':'2',
'蔐':'2',
'蓲':'2',
'蔉':'2',
'蔮':'2',
'蔛':'2',
'蔰':'2',
'蔒':'2',
'蔪':'2',
'蓵':'2',
'蓳':'2',
'蓻':'2',
'蔨':'2',
'薖':'2',
'蔲':'2',
'蕯':'2',
'蓾':'2',
'蔄':'2',
'蔝':'2',
'蔤':'2',
'蔳':'2',
'蔘':'2',
'蔏':'2',
'蔎':'2',
'蓶':'2',
'蔙':'2',
'蔅':'2',
'蔩':'2',
'蔶':'2',
'蔁':'2',
'蔠':'2',
'奩':'2',
'奪':'2',
'奬':'2',
'彆':'2',
'弊':'2',
'幣':'2',
'幚':'2',
'箒':'2',
'嘉':'2',
'嘦':'2',
'察':'2',
'寡':'2',
'寥':'2',
'寤':'2',
'實':'2',
'寣':'2',
'寠':'2',
'寬':'2',
'寧':'2',
'寢':'2',
'嫳':'2',
'嫛':'2',
'嫢':'2',
'嵸':'2',
'嶄':'2',
'嵾':'2',
'嶉':'2',
'嶌':'2',
'嵿':'2',
'嶞':'2',
'嶐':'2',
'嶈':'2',
'嶎':'2',
'嶊':'2',
'夀':'2',
'塾':'2',
'墅':'2',
'墍':'2',
'塹':'2',
'墊':'2',
'墜':'2',
'墬':'2',
'墮':'2',
'墏':'2',
'舞':'2',
'夤':'2',
'夣':'2',
'慕':'2',
'夐':'2',
'赛':'2',
'赘':'2',
'箦':'2',
'煕':'2',
'熬':'2',
'熙':'2',
'熊':'2',
'熏':'2',
'熈':'2',
'熒':'2',
'煛':'2',
'熋':'2',
'熃':'2',
'槃':'2',
'槊':'2',
'槖':'2',
'槀':'2',
'榮':'2',
'犖':'2',
'敻':'2',
'獒':'2',
'暠':'2',
'暨':'2',
'暮':'2',
'曅':'2',
'暜':'2',
'摹':'2',
'搴':'2',
'摮':'2',
'搫':'2',
'搻':'2',
'滎':'2',
'甍':'2',
'甇':'2',
'慁':'2',
'慝':'2',
'慇':'2',
'愨':'2',
'慂':'2',
'愬':'2',
'態':'2',
'慐':'2',
'愳':'2',
'愻':'2',
'愸':'2',
'爾':'2',
'膏':'2',
'膋':'2',
'膂':'2',
'朢':'2',
'爳':'2',
'歰':'2',
'監':'2',
'盡':'2',
'盠':'2',
'盢':'2',
'睾':'2',
'瞀':'2',
'睿':'2',
'睯':'2',
'鹜':'2',
'鹙':'2',
'甧':'2',
'碧':'2',
'碞':'2',
'罱':'2',
'罳':'2',
'罰':'2',
'罯':'2',
'窭':'2',
'窨':'2',
'窬':'2',
'窪':'2',
'窫':'2',
'疐':'2',
'蜚':'2',
'蜜':'2',
'蝅':'2',
'蜝':'2',
'蜰':'2',
'蝁':'2',
'蜸':'2',
'蜤':'2',
'聚':'2',
'聟':'2',
'罂':'2',
'舆':'2',
'綦':'2',
'綮':'2',
'緊':'2',
'裳':'2',
'裴':'2',
'製':'2',
'裻':'2',
'翠':'2',
'翟':'2',
'翡':'2',
'翣':'2',
'翥':'2',
'肇':'2',
'肈':'2',
'箄':'2',
'箔':'2',
'箣':'2',
'箪':'2',
'箙':'2',
'箍':'2',
'管':'2',
'箕':'2',
'箘':'2',
'箜':'2',
'箩':'2',
'箧':'2',
'箐':'2',
'箑':'2',
'算':'2',
'箨':'2',
'箢':'2',
'箸':'2',
'箝':'2',
'箋':'2',
'箎':'2',
'箇':'2',
'箠':'2',
'箓':'2',
'箃':'2',
'箥':'2',
'箁':'2',
'箈':'2',
'箉':'2',
'箌':'2',
'箛':'2',
'箟':'2',
'箂':'2',
'箖':'2',
'箞':'2',
'箊':'2',
'箚':'2',
'箏':'2',
'箤':'2',
'賓':'2',
'賔':'2',
'豪':'2',
'誓':'2',
'踅':'2',
'跾':'2',
'銮':'2',
'銎':'2',
'銐':'2',
'銞':'2',
'鈭':'2',
'養':'2',
'鲞':'2',
'鲝':'2',
'霁':'2',
'霆':'2',
'需':'2',
'雿':'2',
'髧':'2',
'髦':'2',
'髨':'2',
'髤':'2',
'髥':'2',
'髣':'2',
'髩':'2',
'髪':'2',
'馽':'2',
'鳶':'2',
'鼐':'2',
'鼑':'2',
'鼏':'2',
'齊':'2',
'蝥':'2',
'螀':'2',
'蝨':'2',
'蝱':'2',
'蝵':'2',
'齑':'2',
'褜':'2',
'翦':'2',
'翬':'2',
'翨':'2',
'箯':'2',
'篅':'2',
'篌':'2',
'篁':'2',
'箭':'2',
'篑':'2',
'篓':'2',
'篇':'2',
'箱':'2',
'篂':'2',
'箴':'2',
'篆':'2',
'篋':'2',
'範':'2',
'箲':'2',
'箷':'2',
'篨':'2',
'箺':'2',
'箹':'2',
'箽':'2',
'篈':'2',
'篐':'2',
'篊':'2',
'箶':'2',
'箿':'2',
'箻':'2',
'篃':'2',
'篎':'2',
'箳':'2',
'篏':'2',
'箾':'2',
'篍':'2',
'箵':'2',
'篒':'2',
'箰':'2',
'箼':'2',
'箮':'2',
'賢':'2',
'賣':'2',
'賨':'2',
'賛':'2',
'賚':'2',
'質':'2',
'輦':'2',
'輩':'2',
'辳':'2',
'豎':'2',
'諅':'2',
'諐':'2',
'靠':'2',
'鋬':'2',
'鋈':'2',
'鋆':'2',
'鋫':'2',
'銴':'2',
'鋚':'2',
'銺':'2',
'餈':'2',
'飺':'2',
'餋':'2',
'鲨':'2',
'霉':'2',
'霂':'2',
'霈':'2',
'霄':'2',
'霅':'2',
'震':'2',
'霃':'2',
'霊':'2',
'鞌':'2',
'鞏':'2',
'韏':'2',
'髲':'2',
'髳':'2',
'髯':'2',
'髫':'2',
'髰':'2',
'髮':'2',
'髴':'2',
'髱':'2',
'髬':'2',
'駑':'2',
'駕':'2',
'駌':'2',
'麄':'2',
'鴌':'2',
'鴍':'2',
'魯':'2',
'鼒':'2',
'黙':'2',
'黎':'2',
'齒':'2',
'羮':'2',
'蕡':'2',
'劈':'2',
'勲':'2',
'冪':'2',
'蕃':'2',
'蕙':'2',
'蕺':'2',
'蕉':'2',
'蕨':'2',
'蕢':'2',
'蕲':'2',
'蕤':'2',
'蕊':'2',
'蔬':'2',
'蕣':'2',
'蕰':'2',
'蕈':'2',
'薁':'2',
'蕴':'2',
'蕞':'2',
'蕓':'2',
'蕘':'2',
'薘':'2',
'蕋':'2',
'蕚':'2',
'蕒':'2',
'蕪':'2',
'蕎':'2',
'蕕':'2',
'蕆':'2',
'蔾':'2',
'蕫':'2',
'蕩':'2',
'蕁':'2',
'蕔':'2',
'蕇':'2',
'薡':'2',
'蕟':'2',
'蕜':'2',
'蕧':'2',
'蕀':'2',
'蕑':'2',
'蕳':'2',
'蔃':'2',
'蕝':'2',
'蕌':'2',
'蕄':'2',
'蕅':'2',
'蕠':'2',
'蕱':'2',
'蕂':'2',
'蕬':'2',
'蕵':'2',
'蕛':'2',
'蔿':'2',
'蕮':'2',
'蕸':'2',
'蕦':'2',
'蕥':'2',
'蓹':'2',
'蕍':'2',
'導':'2',
'奫':'2',
'幤':'2',
'嘼':'2',
'噵':'2',
'噕':'2',
'寯':'2',
'寮':'2',
'審':'2',
'寫':'2',
'寭':'2',
'寪':'2',
'嬃':'2',
'嶴':'2',
'嶔':'2',
'嶡':'2',
'嶯':'2',
'嵹':'2',
'嶣':'2',
'嶜':'2',
'嶚':'2',
'嶤':'2',
'嶘':'2',
'嶲':'2',
'墨':'2',
'墪':'2',
'墯':'2',
'慙':'2',
'熟':'2',
'熱':'2',
'熨':'2',
'熭':'2',
'熧':'2',
'樊':'2',
'槷':'2',
'橥':'2',
'樂':'2',
'槳':'2',
'槼':'2',
'樖':'2',
'槧':'2',
'犚':'2',
'獘':'2',
'獎':'2',
'暴':'2',
'曏':'2',
'暫':'2',
'暼':'2',
'暬':'2',
'摯':'2',
'撃':'2',
'撆':'2',
'摰':'2',
'撀':'2',
'漿':'2',
'漀':'2',
'漐':'2',
'璜':'2',
'憋':'2',
'憃':'2',
'憨':'2',
'慧':'2',
'慜':'2',
'慼':'2',
'慰':'2',
'憂':'2',
'慤':'2',
'慾':'2',
'憇':'2',
'慫':'2',
'慗':'2',
'慸':'2',
'慦':'2',
'慿':'2',
'憅':'2',
'慭':'2',
'慹':'2',
'憄':'2',
'歶':'2',
'稾':'2',
'盤':'2',
'瞏':'2',
'磐':'2',
'禜':'2',
'罶':'2',
'罵':'2',
'罸':'2',
'罷':'2',
'罼':'2',
'畿':'2',
'窳':'2',
'窯':'2',
'窰':'2',
'窮':'2',
'窲':'2',
'窴':'2',
'窱':'2',
'瑩':'2',
'瑬':'2',
'厳':'2',
'薆':'2',
'薄':'2',
'薜':'2',
'薋':'2',
'薅':'2',
'蕻':'2',
'蕾':'2',
'薐':'2',
'蕗':'2',
'薮':'2',
'薙':'2',
'薇':'2',
'薳':'2',
'蕹':'2',
'薤':'2',
'薢':'2',
'薪':'2',
'薛':'2',
'薏':'2',
'薔':'2',
'薑':'2',
'薟':'2',
'薈':'2',
'薊':'2',
'蕿':'2',
'薦':'2',
'蕭':'2',
'薩':'2',
'蕷':'2',
'薉':'2',
'薬':'2',
'薭':'2',
'薒':'2',
'薠':'2',
'薣':'2',
'薃':'2',
'薧':'2',
'薕':'2',
'蕶':'2',
'薍':'2',
'薎':'2',
'蕽':'2',
'薓':'2',
'薥':'2',
'蕼':'2',
'薞':'2',
'薚':'2',
'薀':'2',
'薂':'2',
'藇':'2',
'薫':'2',
'薗':'2',
'薝':'2',
'薽':'2',
'奯':'2',
'幦':'2',
'器':'2',
'寰':'2',
'嬖':'2',
'嬴':'2',
'嬜':'2',
'嶪':'2',
'嶨':'2',
'嶭':'2',
'嶶':'2',
'夁':'2',
'壁':'2',
'墼':'2',
'壅':'2',
'壄':'2',
'墾':'2',
'壆':'2',
'壂':'2',
'學':'2',
'孹':'2',
'赟':'2',
'赞':'2',
'熹':'2',
'營':'2',
'燙':'2',
'燚':'2',
'氅':'2',
'檠':'2',
'橤':'2',
'檃':'2',
'橜':'2',
'樷':'2',
'橆':'2',
'犟':'2',
'整':'2',
'曌':'2',
'曇':'2',
'曁':'2',
'撉':'2',
'擎':'2',
'澃':'2',
'甏':'2',
'憝':'2',
'憩':'2',
'憙':'2',
'憖':'2',
'憲':'2',
'憗':'2',
'憊':'2',
'憼':'2',
'憠':'2',
'憥':'2',
'憑':'2',
'憌':'2',
'朤':'2',
'穒':'2',
'盥':'2',
'盦':'2',
'瞥':'2',
'瞖':'2',
'螶':'2',
'鹥':'2',
'磬':'2',
'磛':'2',
'罹':'2',
'罻':'2',
'罺':'2',
'窿':'2',
'窶':'2',
'窵':'2',
'窺':'2',
'窻':'2',
'窼':'2',
'窽':'2',
'窷':'2',
'窹':'2',
'褧':'2',
'瑿':'2',
'螯':'2',
'蟇':'2',
'螌':'2',
'螙':'2',
'螡':'2',
'螴':'2',
'螜':'2',
'螚':'2',
'螢':'2',
'聱':'2',
'罃':'2',
'舉':'2',
'縏':'2',
'縈':'2',
'膐':'2',
'褰':'2',
'褩':'2',
'褮':'2',
'翯':'2',
'篦':'2',
'篰':'2',
'篪':'2',
'篘':'2',
'篡':'2',
'篚':'2',
'篙':'2',
'篝':'2',
'篮':'2',
'篱':'2',
'篥':'2',
'篢':'2',
'篷':'2',
'篠':'2',
'簉':'2',
'篤':'2',
'築':'2',
'篳':'2',
'篩':'2',
'簑':'2',
'篛':'2',
'篬':'2',
'篴':'2',
'篕':'2',
'篧':'2',
'篯':'2',
'篭':'2',
'篞':'2',
'篣':'2',
'篟':'2',
'篖':'2',
'篔':'2',
'篗':'2',
'篜':'2',
'篫':'2',
'賲':'2',
'賮':'2',
'覧':'2',
'觱':'2',
'諬':'2',
'醔':'2',
'錾':'2',
'鋻':'2',
'錖':'2',
'錅':'2',
'錃':'2',
'錱':'2',
'餐':'2',
'霏':'2',
'霍':'2',
'霖':'2',
'霓':'2',
'霙':'2',
'霑':'2',
'霐':'2',
'霗':'2',
'霋':'2',
'霌':'2',
'霔':'2',
'韰':'2',
'髻':'2',
'髹':'2',
'髭':'2',
'髵':'2',
'髶':'2',
'髸':'2',
'髺':'2',
'髷':'2',
'鬇':'2',
'駡':'2',
'駦':'2',
'鴛':'2',
'鴦':'2',
'鴐':'2',
'鴑':'2',
'羲':'2',
'﨟':'2',
'奮':'2',
'燓':'2',
'燞':'2',
'㵘':'2',
'':'2',
'蟊':'2',
'螫':'2',
'螽':'2',
'蟄':'2',
'蠁':'2',
'蟞':'2',
'螿':'2',
'螷':'2',
'螱':'2',
'蟁':'2',
'螸':'2',
'聲':'2',
'聳':'2',
'罄':'2',
'舊':'2',
'繁':'2',
'繄':'2',
'縶':'2',
'繋':'2',
'繤':'2',
'膥':'2',
'褽':'2',
'襄':'2',
'褺':'2',
'翳':'2',
'簇':'2',
'篼':'2',
'簖':'2',
'簧':'2',
'簕':'2',
'簏':'2',
'簌':'2',
'篿':'2',
'簻':'2',
'篲':'2',
'簍':'2',
'簃':'2',
'簆':'2',
'篻':'2',
'簎':'2',
'簅':'2',
'篵':'2',
'簓':'2',
'簂':'2',
'簄':'2',
'簊':'2',
'簗':'2',
'簐':'2',
'篺':'2',
'簈':'2',
'簁':'2',
'簔':'2',
'簘':'2',
'篶':'2',
'簀':'2',
'贅':'2',
'賽':'2',
'覮':'2',
'謷':'2',
'謇':'2',
'謩':'2',
'謍':'2',
'醟':'2',
'醤':'2',
'蹇':'2',
'鍪':'2',
'鍙':'2',
'鍳':'2',
'鍫':'2',
'鍌':'2',
'餥':'2',
'霜':'2',
'霞':'2',
'霡':'2',
'霘':'2',
'霟':'2',
'霛':'2',
'霝':'2',
'霚':'2',
'霠':'2',
'雚':'2',
'鬁':'2',
'髽':'2',
'髼':'2',
'鬀':'2',
'鬂':'2',
'髾':'2',
'髿':'2',
'麉':'2',
'麊':'2',
'鴷':'2',
'鴜':'2',
'鵉':'2',
'鵀':'2',
'鴽':'2',
'鮺':'2',
'鮆':'2',
'鮝':'2',
'鮤':'2',
'黛':'2',
'黿':'2',
'糞':'2',
'隳':'2',
'勶':'2',
'藊':'2',
'藏':'2',
'藂':'2',
'薾':'2',
'藉':'2',
'藐':'2',
'薿':'2',
'薸':'2',
'藑':'2',
'薷':'2',
'藓':'2',
'薰':'2',
'藍':'2',
'薻':'2',
'薺':'2',
'薴':'2',
'藎':'2',
'薼':'2',
'薵':'2',
'藋':'2',
'藡':'2',
'薱':'2',
'藅':'2',
'藃':'2',
'藱':'2',
'藆':'2',
'藈':'2',
'薶':'2',
'藌':'2',
'薲':'2',
'藄':'2',
'藒':'2',
'藗':'2',
'藬':'2',
'藀':'2',
'幫':'2',
'嚮':'2',
'寱':'2',
'寲':'2',
'嬰':'2',
'嬱':'2',
'嬮':'2',
'嶷':'2',
'嶽':'2',
'嶺':'2',
'嶻':'2',
'篸':'2',
'壑':'2',
'壐':'2',
'壓':'2',
'壍':'2',
'毚':'2',
'燮':'2',
'燛':'2',
'燢':'2',
'檗':'2',
'檒':'2',
'檕':'2',
'斃':'2',
'曐':'2',
'曑':'2',
'擘':'2',
'擧':'2',
'擊':'2',
'澩':'2',
'甓':'2',
'甕':'2',
'懋':'2',
'懑':'2',
'懃':'2',
'懇':'2',
'憵':'2',
'臂':'2',
'臀':'2',
'爵':'2',
'盨':'2',
'盩':'2',
'盪':'2',
'鹫':'2',
'禦':'2',
'羁':'2',
'罽':'2',
'罾':'2',
'罿':'2',
'窾':'2',
'竂':'2',
'竀':'2',
'竁':'2',
'璗':'2',
'羀':'2',
'叢':'2',
'藨':'2',
'藩':'2',
'藠':'2',
'藟':'2',
'藜':'2',
'藕':'2',
'藤':'2',
'藝':'2',
'藪':'2',
'藷':'2',
'藭':'2',
'藴':'2',
'藵':'2',
'藣':'2',
'藸':'2',
'藳':'2',
'藧':'2',
'藞':'2',
'藰':'2',
'藥':'2',
'藘':'2',
'藦':'2',
'藲':'2',
'藖':'2',
'藫':'2',
'藔':'2',
'藯':'2',
'藛':'2',
'藚':'2',
'藙':'2',
'藢':'2',
'奰':'2',
'巂':'2',
'巀':'2',
'壘':'2',
'夑':'2',
'爇':'2',
'燾':'2',
'燹':'2',
'檾':'2',
'簮':'2',
'擥':'2',
'毉':'2',
'濷':'2',
'甖':'2',
'懟':'2',
'懣':'2',
'懘':'2',
'懖':'2',
'皨':'2',
'盫':'2',
'盬':'2',
'瞽':'2',
'瞿':'2',
'瞾':'2',
'鹭':'2',
'礐':'2',
'礊':'2',
'礕':'2',
'礜':'2',
'羂':'2',
'羃':'2',
'竅':'2',
'竄':'2',
'竆':'2',
'璧':'2',
'臩':'2',
'蟚':'2',
'蠆':'2',
'蟲':'2',
'蟼':'2',
'蟴':'2',
'繠':'2',
'繭':'2',
'覆':'2',
'簦':'2',
'簡':'2',
'簩':'2',
'簰':'2',
'簞':'2',
'簣':'2',
'簙':'2',
'簤':'2',
'簜':'2',
'簥':'2',
'簝':'2',
'簶':'2',
'簢':'2',
'簲':'2',
'簯':'2',
'簱':'2',
'簛':'2',
'簭':'2',
'簨':'2',
'篽':'2',
'贄':'2',
'贀':'2',
'豐':'2',
'覱':'2',
'謦':'2',
'謺':'2',
'鄨':'2',
'醫':'2',
'醬':'2',
'蹩':'2',
'蹙':'2',
'蹔':'2',
'鏊':'2',
'鎏':'2',
'鎣':'2',
'鎜':'2',
'鎥':'2',
'餮':'2',
'鳌':'2',
'霤':'2',
'霢':'2',
'霧':'2',
'霩':'2',
'霥':'2',
'霣':'2',
'雙':'2',
'鞤':'2',
'鞪':'2',
'頾':'2',
'鬅':'2',
'鬈':'2',
'鬃':'2',
'鬆':'2',
'鬄':'2',
'鬶':'2',
'鬵':'2',
'鵞':'2',
'鵟':'2',
'鵥':'2',
'鯊':'2',
'鯗':'2',
'鼂':'2',
'鼀':'2',
'鼁':'2',
'鼕':'2',
'鼖':'2',
'蟹':'2',
'蠃':'2',
'蟸':'2',
'蠞':'2',
'蟿':'2',
'蠈':'2',
'罋':'2',
'罊':'2',
'糪':'2',
'繴':'2',
'繫':'2',
'臋':'2',
'覈':'2',
'覇':'2',
'襞':'2',
'簸':'2',
'簿':'2',
'籁':'2',
'籀':'2',
'籆':'2',
'簹':'2',
'簽':'2',
'簾':'2',
'簫':'2',
'簳':'2',
'簼':'2',
'籈':'2',
'簴':'2',
'簬':'2',
'簵':'2',
'簺':'2',
'籂':'2',
'簷':'2',
'籅':'2',
'贇':'2',
'贊':'2',
'警':'2',
'謽':'2',
'躉':'2',
'蹵':'2',
'鐅':'2',
'鏨':'2',
'鏧':'2',
'鐆':'2',
'鳖':'2',
'鳘':'2',
'霭':'2',
'霨':'2',
'霪':'2',
'霫':'2',
'霦':'2',
'霳':'2',
'霬':'2',
'鞶':'2',
'鞷':'2',
'韲':'2',
'鬌':'2',
'鬋':'2',
'鬏':'2',
'鬎':'2',
'鬍':'2',
'鬉':'2',
'鬊':'2',
'騭':'2',
'騖':'2',
'麓':'2',
'麗':'2',
'鵹':'2',
'鶑':'2',
'鯬':'2',
'鼃':'2',
'鼄':'2',
'鼗':'2',
'齍':'2',
'羹':'2',
'蘒':'2',
'蘅':'2',
'藿':'2',
'蘑':'2',
'蘧':'2',
'藻':'2',
'蘀':'2',
'藶':'2',
'蘆':'2',
'蘋':'2',
'蘓':'2',
'蘇':'2',
'藹':'2',
'蘐':'2',
'蘂':'2',
'藺':'2',
'蘁':'2',
'蘕':'2',
'蘄':'2',
'蘎':'2',
'蘏':'2',
'蘔':'2',
'藾':'2',
'蘉':'2',
'藮':'2',
'藽':'2',
'蘒':'2',
'蘣':'2',
'蘈':'2',
'蘊':'2',
'藼':'2',
'蘍':'2',
'蘟':'2',
'嚴':'2',
'寴':'2',
'巅':'2',
'巌':'2',
'夒':'2',
'孼':'2',
'爕':'2',
'櫫':'2',
'櫐':'2',
'曡':'2',
'曟':'2',
'攀':'2',
'懲':'2',
'懯':'2',
'羅':'2',
'羆':'2',
'羄':'2',
'璽':'2',
'蘩':'2',
'蘖':'2',
'蘘':'2',
'蘡':'2',
'蘢':'2',
'蘤':'2',
'蘞':'2',
'蘚':'2',
'蘭':'2',
'蘪':'2',
'蘗':'2',
'蘯':'2',
'蘫':'2',
'蘳':'2',
'蘮':'2',
'蘜':'2',
'蘝':'2',
'蘦':'2',
'蘰':'2',
'蘠':'2',
'蘶':'2',
'蘨':'2',
'蘙':'2',
'蘌':'2',
'蘛':'2',
'蘥':'2',
'嚳':'2',
'寵':'2',
'孁':'2',
'巍':'2',
'巈':'2',
'巃':'2',
'壟':'2',
'櫱':'2',
'櫽':'2',
'犨':'2',
'曧':'2',
'瀪':'2',
'懸':'2',
'臖':'2',
'盭':'2',
'礬':'2',
'礨':'2',
'疉':'2',
'竇':'2',
'璺':'2',
'蠚':'2',
'蠒':'2',
'聻':'2',
'罌':'2',
'舋':'2',
'籍':'2',
'籋':'2',
'籊':'2',
'籎':'2',
'籌':'2',
'籇':'2',
'籄':'2',
'籃':'2',
'籏':'2',
'籉':'2',
'籕':'2',
'贏':'2',
'轚':'2',
'轝':'2',
'覺':'2',
'觷':'2',
'譬':'2',
'譽':'2',
'譥':'2',
'躄':'2',
'鐜':'2',
'饗':'2',
'饏':'2',
'霰':'2',
'霮':'2',
'霵':'2',
'霯':'2',
'霱':'2',
'馨':'2',
'響':'2',
'韾':'2',
'鬓':'2',
'鬑':'2',
'鬐':'2',
'鬒':'2',
'鬕':'2',
'鬔':'2',
'驀':'2',
'騫':'2',
'驁':'2',
'鶖':'2',
'鶿':'2',
'鶩':'2',
'鶦':'2',
'鱀':'2',
'黧':'2',
'鼍':'2',
'龏':'2',
'鐢':'2',
'蠢':'2',
'蠡':'2',
'蠜':'2',
'蠫':'2',
'蠠':'2',
'蠤':'2',
'罍':'2',
'纍':'2',
'籑':'2',
'籖':'2',
'籐':'2',
'籓':'2',
'籔':'2',
'籒':'2',
'贒':'2',
'轟':'2',
'覽':'2',
'觺':'2',
'譼':'2',
'譻':'2',
'鐾':'2',
'霸':'2',
'露':'2',
'霹':'2',
'霿':'2',
'靀':'2',
'霶':'2',
'霺':'2',
'霷':'2',
'雤':'2',
'顨':'2',
'鬘':'2',
'鬗':'2',
'鬖':'2',
'鬹':'2',
'騺':'2',
'驇':'2',
'鶱':'2',
'鶯':'2',
'鷔':'2',
'鶭':'2',
'鰲':'2',
'鼅':'2',
'鼙':'2',
'鼚':'2',
'鼛':'2',
'齧':'2',
'齤':'2',
'龑':'2',
'颦':'2',
'霻':'2',
'卛':'2',
'蘺':'2',
'蘴':'2',
'蘬':'2',
'蘲':'2',
'蘵':'2',
'寷':'2',
'巋':'2',
'巐':'2',
'夔':'2',
'犩':'2',
'曩':'2',
'臝':'2',
'亹':'2',
'蘼':'2',
'蘸':'2',
'蘽':'2',
'蘿':'2',
'蘹':'2',
'蘾':'2',
'蘻':'2',
'虀':'2',
'蘱':'2',
'奱':'2',
'彎':'2',
'囊':'2',
'孌':'2',
'巓':'2',
'巒':'2',
'巖':'2',
'孿':'2',
'礱':'2',
'羇':'2',
'疊':'2',
'竊':'2',
'竉':'2',
'瓕':'2',
'蠧':'2',
'蠥':'2',
'蠭':'2',
'糱':'2',
'糵':'2',
'籧':'2',
'籝':'2',
'籙':'2',
'籜':'2',
'籟':'2',
'籛':'2',
'籚':'2',
'籡':'2',
'籘':'2',
'籗':'2',
'轡':'2',
'讆':'2',
'躗':'2',
'鑒':'2',
'鑋':'2',
'鑍':'2',
'饕':'2',
'饔':'2',
'霾':'2',
'霽':'2',
'鬙':'2',
'鬚':'2',
'鬜':'2',
'鬝':'2',
'鬻':'2',
'驚':'2',
'鷩':'2',
'鷟':'2',
'鷙':'2',
'鷖':'2',
'鷘':'2',
'鷕':'2',
'鰵':'2',
'鱉':'2',
'鼜':'2',
'鼘':'2',
'龒':'2',
'蠱':'2',
'蠪':'2',
'聾':'2',
'覉':'2',
'襲':'2',
'籠':'2',
'籣':'2',
'籥':'2',
'籤':'2',
'籢':'2',
'籨':'2',
'籞':'2',
'籦':'2',
'贙':'2',
'變':'2',
'讐':'2',
'讏':'2',
'躠':'2',
'躛':'2',
'靁':'2',
'魙':'2',
'鬟':'2',
'鬠':'2',
'鬞':'2',
'驘':'2',
'鷲':'2',
'鷥':'2',
'鷪':'2',
'黳':'2',
'鼇':'2',
'龔':'2',
'龕':'2',
'虃':'2',
'虇':'2',
'虄':'2',
'虅':'2',
'巔':'2',
'巚':'2',
'壨':'2',
'欒':'2',
'曫':'2',
'攣':'2',
'毊':'2',
'灓':'2',
'戀':'2',
'戁':'2',
'虉':'2',
'虆':'2',
'虁':'2',
'虂':'2',
'虈':'2',
'斖':'2',
'瓥':'2',
'矕':'2',
'羈':'2',
'羉':'2',
'蠶':'2',
'纛':'2',
'籩':'2',
'籪':'2',
'籬':'2',
'讋':'2',
'靄':'2',
'靃':'2',
'靂':'2',
'靈':'2',
'顰':'2',
'鬡':'2',
'鬢':'2',
'黌':'2',
'鹽':'2',
'鷺':'2',
'鷽':'2',
'鸄':'2',
'鸁':'2',
'鷿':'2',
'鸉':'2',
'鸒':'2',
'鱟':'2',
'鼈':'2',
'鼞':'2',
'齹':'2',
'蠻':'2',
'臠':'2',
'臡':'2',
'覊':'2',
'籮':'2',
'籭':'2',
'籫':'2',
'靇':'2',
'鬣':'2',
'鸑':'2',
'鸎':'2',
'鼉':'2',
'鼟':'2',
'鼝':'2',
'戆':'2',
'戅':'2',
'虌':'2',
'虊':'2',
'糳':'2',
'籰':'2',
'籯':'2',
'釁':'2',
'靊':'2',
'鼊':'2',
'蠽':'2',
'蠿':'2',
'鑾':'2',
'靌':'2',
'靍':'2',
'靎':'2',
'靋':'2',
'鬤':'2',
'驡':'2',
'龞':'2',
'犫':'2',
'戇':'2',
'鑿':'2',
'雧':'2',
'鸗':'2',
'靏':'2',
'虋':'2',
'籱':'2',
'鸞':'2',
'籲':'2',
'龗':'2',
'齾':'2',
'巛':'3',
'彻':'3',
'吼':'3',
'抑':'3',
'沏':'3',
'侧':'3',
'例':'3',
'呦':'3',
'拊':'3',
'俐':'3',
'诳':'3',
'咿':'3',
'哟':'3',
'狲':'3',
'狱':'3',
'测':'3',
'洑':'3',
'浒':'3',
'浏':'3',
'绑':'3',
'恻':'3',
'树':'3',
'胤':'3',
'衎':'3',
'衍':'3',
'郷':'3',
'卿':'3',
'倻':'3',
'啊':'3',
'婀':'3',
'涨':'3',
'浙':'3',
'栿':'3',
'班':'3',
'衏':'3',
'衐':'3',
'假':'3',
'做':'3',
'啦':'3',
'啷':'3',
'啭':'3',
'嫏':'3',
'猕':'3',
'彬':'3',
'掀':'3',
'揶':'3',
'掷':'3',
'渐':'3',
'淋':'3',
'淑':'3',
'涮':'3',
'淞':'3',
'淅':'3',
'淤':'3',
'渕':'3',
'惭':'3',
'辄':'3',
'脚':'3',
'鸿':'3',
'硎':'3',
'衔':'3',
'衒':'3',
'術':'3',
'衑':'3',
'鄕':'3',
'傲':'3',
'储':'3',
'谢':'3',
'弼':'3',
'弻':'3',
'揿':'3',
'湖':'3',
'湘':'3',
'溆':'3',
'游':'3',
'慨':'3',
'榔':'3',
'棚':'3',
'椭':'3',
'椰':'3',
'椕':'3',
'棥':'3',
'晰':'3',
'掰':'3',
'琳':'3',
'斑':'3',
'锕':'3',
'粥':'3',
'街':'3',
'衕':'3',
'衖':'3',
'微':'3',
'嗍':'3',
'嫐':'3',
'搬':'3',
'搦':'3',
'摊':'3',
'溯':'3',
'滩':'3',
'溦':'3',
'滫':'3',
'潃':'3',
'楸':'3',
'楙':'3',
'暅':'3',
'瑚':'3',
'鹏':'3',
'硼':'3',
'褂':'3',
'貅':'3',
'衙':'3',
'衘':'3',
'徴':'3',
'幑':'3',
'嘞':'3',
'嗾':'3',
'嗽':'3',
'嘂':'3',
'嫩':'3',
'獄':'3',
'撇':'3',
'漱':'3',
'漩':'3',
'漪':'3',
'榭':'3',
'搿':'3',
'锹':'3',
'褓':'3',
'螂':'3',
'蜘':'3',
'銜':'3',
'谳':'3',
'徹':'3',
'嘲':'3',
'嘶':'3',
'撤':'3',
'撒':'3',
'撕':'3',
'撷':'3',
'潮':'3',
'澎':'3',
'潲':'3',
'澍':'3',
'澌':'3',
'缬':'3',
'墩':'3',
'璇':'3',
'蝴':'3',
'蝲':'3',
'糊':'3',
'衝':'3',
'衛':'3',
'衚':'3',
'衜':'3',
'凝':'3',
'獭':'3',
'擀':'3',
'擞':'3',
'濑':'3',
'濉':'3',
'懒':'3',
'懈':'3',
'辙':'3',
'膨':'3',
'镞':'3',
'瞰':'3',
'辨':'3',
'辩':'3',
'辦':'3',
'辧':'3',
'頥':'3',
'衡':'3',
'衞':'3',
'衟':'3',
'衠':'3',
'徽':'3',
'徾':'3',
'嬲':'3',
'檄':'3',
'镪':'3',
'瞮':'3',
'辫':'3',
'鞡':'3',
'鵆':'3',
'黝':'3',
'辬':'3',
'雠':'3',
'瀚':'3',
'瓣':'3',
'轍':'3',
'巇':'3',
'疈':'3',
'辮':'3',
'嚻':'3',
'灏':'3',
'欁':'3',
'辯':'3',
'鰴':'3',
'讎':'3',
'雦':'3',
'鸂':'3',
'亙':'4',
'合':'4',
'兑':'4',
'労':'4',
'克':'4',
'亨':'4',
'巠':'4',
'呂':'4',
'呉':'4',
'壱':'4',
'坙':'4',
'夋':'4',
'孛':'4',
'亞':'4',
'京':'4',
'苶':'4',
'苕':'4',
'苔':'4',
'茔':'4',
'帚':'4',
'夌':'4',
'靣':'4',
'亰':'4',
'亯':'4',
'荜':'4',
'荛':'4',
'荧':'4',
'巺':'4',
'尜':'4',
'贲':'4',
'炱':'4',
'栄':'4',
'桒':'4',
'泶':'4',
'韋':'4',
'羐':'4',
'卨':'4',
'冡':'4',
'荸':'4',
'莽':'4',
'莺':'4',
'奚':'4',
'帯':'4',
'害':'4',
'宴':'4',
'宻':'4',
'埀':'4',
'斚':'4',
'旁':'4',
'晏':'4',
'恴':'4',
'皋':'4',
'竞':'4',
'真':'4',
'眞':'4',
'鸴':'4',
'畟':'4',
'畗':'4',
'邕':'4',
'鬲':'4',
'衷':'4',
'衺':'4',
'兽':'4',
'菩':'4',
'萋':'4',
'萤':'4',
'营':'4',
'萦':'4',
'萞':'4',
'帶':'4',
'営':'4',
'壸':'4',
'曼':'4',
'曽':'4',
'竟':'4',
'章':'4',
'窓':'4',
'蛍':'4',
'髙':'4',
'黄':'4',
'魚':'4',
'袌':'4',
'袠':'4',
'袞':'4',
'袬':'4',
'棻':'4',
'亴':'4',
'葱':'4',
'葬':'4',
'菐':'4',
'蒆':'4',
'葘':'4',
'尋':'4',
'喾':'4',
'寍':'4',
'寕':'4',
'崽':'4',
'壹':'4',
'塁':'4',
'斝':'4',
'晷':'4',
'瓽':'4',
'惹':'4',
'畫':'4',
'甯':'4',
'貵':'4',
'軬':'4',
'覚':'4',
'黃':'4',
'袲':'4',
'兿':'4',
'僉':'4',
'蒸':'4',
'寚':'4',
'壼':'4',
'塞':'4',
'舝':'4',
'意':'4',
'甞':'4',
'睘':'4',
'禀':'4',
'畺':'4',
'當':'4',
'與':'4',
'輋':'4',
'鲎':'4',
'裏':'4',
'裛':'4',
'稥':'4',
'蔑':'4',
'嘗':'4',
'寨':'4',
'壽':'4',
'罴':'4',
'裹':'4',
'褏':'4',
'褎':'4',
'裵':'4',
'裦':'4',
'臺':'4',
'箅':'4',
'箬':'4',
'箆':'4',
'鼻':'4',
'蕐':'4',
'巤':'4',
'噐':'4',
'嬊':'4',
'瞢':'4',
'褒':'4',
'褢':'4',
'臱':'4',
'賞':'4',
'賫':'4',
'彛':'4',
'冀':'4',
'薨':'4',
'薯':'4',
'彜':'4',
'嶳':'4',
'燕':'4',
'橐':'4',
'疂':'4',
'窸':'4',
'興':'4',
'襃':'4',
'褱':'4',
'褭':'4',
'篹':'4',
'霎':'4',
'黉':'4',
'鴬':'4',
'藁':'4',
'薹':'4',
'赢':'4',
'曓':'4',
'簋':'4',
'竃':'4',
'褻':'4',
'翼':'4',
'篾':'4',
'簒':'4',
'賷':'4',
'輿':'4',
'謈':'4',
'龠':'4',
'彞':'4',
'彝':'4',
'嚣':'4',
'嚚':'4',
'嚢':'4',
'夓':'4',
'簪':'4',
'簠':'4',
'蟗':'4',
'簟':'4',
'簚':'4',
'雟':'4',
'蘃':'4',
'寳':'4',
'孽':'4',
'爂':'4',
'櫜':'4',
'羸':'4',
'寶':'4',
'矍':'4',
'纂':'4',
'黨':'4',
'蘷':'4',
'囂':'4',
'竈':'4',
'欎':'4',
'鬛':'4',
'鷰':'4',
'蠹':'4',
'蠺':'4',
'衋':'4',
'欝':'4',
'鬰':'4',
'鬱':'4',
'爨':'4',
'卂':'5',
'丮':'5',
'勾':'5',
'勼':'5',
'勿':'5',
'匀':'5',
'勽':'5',
'匂':'5',
'勻':'5',
'弌':'5',
'包':'5',
'匃':'5',
'匄':'5',
'匇':'5',
'句':'5',
'可':'5',
'司':'5',
'弍':'5',
'氕':'5',
'矛':'5',
'匈':'5',
'厾':'5',
'弎':'5',
'式':'5',
'戎':'5',
'灳':'5',
'氘':'5',
'氖':'5',
'気':'5',
'旬':'5',
'匉':'5',
'戒':'5',
'戓':'5',
'氚':'5',
'氙':'5',
'忒':'5',
'甸':'5',
'匋':'5',
'匌':'5',
'匊':'5',
'或':'5',
'氜':'5',
'氝':'5',
'忥':'5',
'武':'5',
'甙':'5',
'虱':'5',
'氛':'5',
'鳬':'5',
'匍':'5',
'哉':'5',
'贰':'5',
'耉':'5',
'氡':'5',
'氟':'5',
'氢':'5',
'氞':'5',
'氠':'5',
'訇':'5',
'匎':'5',
'島':'5',
'烏':'5',
'载':'5',
'烖':'5',
'栽':'5',
'氨':'5',
'氦':'5',
'氩':'5',
'氧':'5',
'氤':'5',
'氥':'5',
'氣':'5',
'訚':'5',
'馬':'5',
'匐':'5',
'匒':'5',
'匓':'5',
'戜':'5',
'梟':'5',
'氪':'5',
'氫':'5',
'貮':'5',
'鳥':'5',
'匑':'5',
'幾':'5',
'戠':'5',
'氮':'5',
'氯':'5',
'氰':'5',
'氬':'5',
'氭':'5',
'蛓':'5',
'胾':'5',
'臷':'5',
'貳':'5',
'裁':'5',
'氲':'5',
'氱':'5',
'載':'5',
'酨':'5',
'裊':'5',
'截':'5',
'氳':'5',
'匔':'5',
'韯':'5',
'戴':'5',
'韱':'5',
'厄':'6',
'历':'6',
'厅':'6',
'冇':'6',
'仄':'6',
'厷':'6',
'反':'6',
'友':'6',
'厉':'6',
'厈':'6',
'厇':'6',
'凥':'6',
'左':'6',
'庀':'6',
'広':'6',
'庁':'6',
'庂':'6',
'布':'6',
'右':'6',
'尻':'6',
'尼':'6',
'圧':'6',
'卮':'6',
'戹':'6',
'石':'6',
'厍':'6',
'压':'6',
'厌':'6',
'厊':'6',
'庆':'6',
'庄':'6',
'庅':'6',
'后':'6',
'在':'6',
'存':'6',
'灰':'6',
'虍':'6',
'乕':'6',
'厑':'6',
'厐':'6',
'厎':'6',
'厏':'6',
'兏':'6',
'庇':'6',
'床':'6',
'庋':'6',
'库':'6',
'庐':'6',
'庑':'6',
'序':'6',
'应':'6',
'庎':'6',
'庒':'6',
'庍':'6',
'庉':'6',
'庈':'6',
'庌':'6',
'帍':'6',
'启':'6',
'层':'6',
'局':'6',
'尿':'6',
'屁':'6',
'尾':'6',
'屃':'6',
'巵':'6',
'戻':'6',
'杘':'6',
'応':'6',
'疔':'6',
'疖':'6',
'疗':'6',
'疕':'6',
'疓':'6',
'厕':'6',
'厔':'6',
'厓':'6',
'厒':'6',
'底':'6',
'店':'6',
'废':'6',
'府':'6',
'庚':'6',
'庙':'6',
'庞':'6',
'庖':'6',
'庝':'6',
'庘':'6',
'屄':'6',
'届':'6',
'居':'6',
'屈':'6',
'屉':'6',
'屆':'6',
'屇':'6',
'质':'6',
'房':'6',
'戽':'6',
'戾':'6',
'肩':'6',
'疙':'6',
'疚':'6',
'疠':'6',
'疝':'6',
'疡':'6',
'疘':'6',
'疜':'6',
'疞':'6',
'疛':'6',
'疟':'6',
'虎':'6',
'虏':'6',
'厚':'6',
'厘':'6',
'厛':'6',
'厙':'6',
'厖':'6',
'厗':'6',
'度':'6',
'庭':'6',
'庠':'6',
'庥':'6',
'庡':'6',
'庰':'6',
'庛':'6',
'庣':'6',
'庢':'6',
'庤':'6',
'屏':'6',
'屌':'6',
'屎':'6',
'屋':'6',
'屍':'6',
'扁':'6',
'扃':'6',
'扂':'6',
'盾':'6',
'眉':'6',
'疤':'6',
'疢':'6',
'疮':'6',
'疯':'6',
'疥':'6',
'疬':'6',
'疧':'6',
'疫':'6',
'疣':'6',
'疭':'6',
'疪':'6',
'疺':'6',
'疩':'6',
'疦':'6',
'疨':'6',
'矦':'6',
'虐':'6',
'厝':'6',
'原':'6',
'厞':'6',
'厜':'6',
'庯':'6',
'座':'6',
'庩':'6',
'庫':'6',
'庪':'6',
'庬':'6',
'庨':'6',
'庮':'6',
'席':'6',
'唇':'6',
'唐':'6',
'屙':'6',
'屐':'6',
'屑':'6',
'展':'6',
'屖':'6',
'屓':'6',
'屒':'6',
'扇':'6',
'扅':'6',
'扆':'6',
'扄':'6',
'病':'6',
'疸':'6',
'疳':'6',
'疾':'6',
'痂':'6',
'痉':'6',
'疽':'6',
'疴':'6',
'痆':'6',
'疱':'6',
'疲':'6',
'痁':'6',
'疼':'6',
'痃':'6',
'痈':'6',
'痄':'6',
'疹':'6',
'症':'6',
'疻':'6',
'疰':'6',
'疿':'6',
'痀':'6',
'疶':'6',
'疷':'6',
'虑':'6',
'虔':'6',
'虒':'6',
'肁':'6',
'厩':'6',
'厢':'6',
'厣':'6',
'厡':'6',
'厠':'6',
'庵':'6',
'庳':'6',
'康':'6',
'廊':'6',
'庼':'6',
'庶':'6',
'庹':'6',
'庸':'6',
'庾':'6',
'庻':'6',
'庿':'6',
'庺':'6',
'庱':'6',
'庴':'6',
'庲':'6',
'屠':'6',
'屜':'6',
'屝':'6',
'屚':'6',
'屛':'6',
'戚':'6',
'扈':'6',
'脣':'6',
'疵':'6',
'痕':'6',
'痎':'6',
'痊':'6',
'痏':'6',
'痒':'6',
'痍':'6',
'痔':'6',
'痌':'6',
'痐':'6',
'痓':'6',
'痋':'6',
'痑':'6',
'痖':'6',
'産':'6',
'虚':'6',
'虖':'6',
'處':'6',
'虘':'6',
'虙':'6',
'虗':'6',
'貭':'6',
'鹿':'6',
'麻':'6',
'厨':'6',
'厥':'6',
'厦':'6',
'厫':'6',
'厤':'6',
'厧':'6',
'廂':'6',
'廁':'6',
'廄':'6',
'廃':'6',
'廀':'6',
'廆':'6',
'廋':'6',
'庽':'6',
'廐':'6',
'屡':'6',
'属':'6',
'屟':'6',
'孱':'6',
'赓':'6',
'扉':'6',
'扊':'6',
'犀':'6',
'痘':'6',
'痪':'6',
'痨':'6',
'痢':'6',
'痗':'6',
'痞':'6',
'痡':'6',
'痧':'6',
'痠':'6',
'痛':'6',
'痦':'6',
'痫':'6',
'痣':'6',
'痙':'6',
'痥':'6',
'痾':'6',
'痝':'6',
'痩':'6',
'痜':'6',
'痚':'6',
'痟':'6',
'虛':'6',
'雇':'6',
'雁':'6',
'厯':'6',
'厪':'6',
'剺':'6',
'廒':'6',
'廓':'6',
'廉':'6',
'廈':'6',
'廕':'6',
'廍':'6',
'廅':'6',
'廇':'6',
'廌':'6',
'嵟':'6',
'痹':'6',
'痴':'6',
'瘁':'6',
'瘅':'6',
'痱':'6',
'痼':'6',
'痯':'6',
'痵':'6',
'痲':'6',
'瘆':'6',
'痰':'6',
'痿':'6',
'瘀':'6',
'瘐':'6',
'瘃':'6',
'瘂':'6',
'痬':'6',
'痷':'6',
'痺':'6',
'痭':'6',
'痸':'6',
'瘄':'6',
'痶':'6',
'痽':'6',
'瘑':'6',
'瘔':'6',
'痳':'6',
'痻':'6',
'瘏':'6',
'痮':'6',
'蜃':'6',
'虡':'6',
'虞':'6',
'虜':'6',
'豦':'6',
'麂':'6',
'麀':'6',
'鳫':'6',
'厮':'6',
'厰':'6',
'厲':'6',
'厭':'6',
'厬':'6',
'廑':'6',
'廖':'6',
'廏':'6',
'廣':'6',
'廗':'6',
'廔':'6',
'廘':'6',
'廎':'6',
'廜':'6',
'廙':'6',
'屣':'6',
'屢':'6',
'塵':'6',
'塺':'6',
'孷':'6',
'暦':'6',
'愿':'6',
'歴':'6',
'瘥':'6',
'瘈':'6',
'瘩':'6',
'瘊':'6',
'瘕':'6',
'瘌':'6',
'瘘':'6',
'瘙':'6',
'瘦':'6',
'瘟':'6',
'瘗':'6',
'瘋':'6',
'瘉':'6',
'瘖':'6',
'瘎':'6',
'瘍':'6',
'瘓':'6',
'瘣':'6',
'瘒':'6',
'瘇':'6',
'臧':'6',
'腐':'6',
'雐':'6',
'麽':'6',
'麼':'6',
'瘧':'6',
'厱':'6',
'廛':'6',
'廚':'6',
'廝':'6',
'廤':'6',
'廟':'6',
'廠':'6',
'廡':'6',
'廢':'6',
'廞':'6',
'嶏':'6',
'屦':'6',
'履':'6',
'層':'6',
'屧':'6',
'氂':'6',
'犛':'6',
'犘':'6',
'摩':'6',
'漦':'6',
'慶':'6',
'慮':'6',
'膚':'6',
'瘢':'6',
'瘪':'6',
'瘛':'6',
'瘝':'6',
'瘠':'6',
'瘤':'6',
'瘼':'6',
'瘞':'6',
'瘡':'6',
'瘜':'6',
'瘫':'6',
'瘨':'6',
'瘚':'6',
'癊':'6',
'緳':'6',
'賡':'6',
'餍':'6',
'魇':'6',
'麃':'6',
'麾':'6',
'鴈':'6',
'鳸':'6',
'廪':'6',
'廨':'6',
'廩':'6',
'廥':'6',
'廦':'6',
'廧':'6',
'噟':'6',
'赝':'6',
'曆':'6',
'歷':'6',
'穈':'6',
'盧':'6',
'瘭':'6',
'瘳':'6',
'癀':'6',
'癃':'6',
'瘰':'6',
'瘸':'6',
'瘾':'6',
'瘿':'6',
'瘵':'6',
'瘴':'6',
'瘮':'6',
'瘯':'6',
'瘹':'6',
'瘺':'6',
'瘻':'6',
'瘽':'6',
'瘷':'6',
'瘶':'6',
'瘱':'6',
'瘬':'6',
'瘲':'6',
'磨':'6',
'鬳':'6',
'麇':'6',
'麅':'6',
'麈':'6',
'麆':'6',
'屨':'6',
'應':'6',
'膺':'6',
'癌':'6',
'癍':'6',
'療':'6',
'癉':'6',
'癆':'6',
'癇':'6',
'癘':'6',
'癈':'6',
'癁':'6',
'癋':'6',
'癅':'6',
'癄':'6',
'癎':'6',
'磿':'6',
'糜':'6',
'縻':'6',
'麋':'6',
'麿':'6',
'廫':'6',
'屩':'6',
'屪':'6',
'檿':'6',
'擪':'6',
'懕':'6',
'懬':'6',
'癜':'6',
'癞':'6',
'癖':'6',
'癔':'6',
'癒':'6',
'癤':'6',
'癛':'6',
'癝':'6',
'癚':'6',
'癏':'6',
'癐':'6',
'癗':'6',
'癑':'6',
'癙':'6',
'癓':'6',
'癕':'6',
'鹰':'6',
'蟨':'6',
'釐':'6',
'麐':'6',
'麎':'6',
'麏':'6',
'麍':'6',
'麌':'6',
'黡':'6',
'厴':'6',
'廭':'6',
'廬':'6',
'屫':'6',
'斄':'6',
'癣':'6',
'癟':'6',
'癡':'6',
'癢':'6',
'癠':'6',
'贋':'6',
'蹷':'6',
'靡':'6',
'鏖':'6',
'麖':'6',
'麑':'6',
'麕':'6',
'麔':'6',
'黀':'6',
'龎':'6',
'廰':'6',
'廯':'6',
'廮':'6',
'癥':'6',
'癦':'6',
'譍':'6',
'魔':'6',
'麚':'6',
'麛':'6',
'麙':'6',
'麘':'6',
'黁':'6',
'龐':'6',
'廱':'6',
'屬':'6',
'癫':'6',
'癧':'6',
'癩':'6',
'癮':'6',
'癨':'6',
'癪':'6',
'麝':'6',
'麜':'6',
'羼':'6',
'廲':'6',
'癭':'6',
'癬':'6',
'贗':'6',
'麞':'6',
'爢':'6',
'癯':'6',
'癰':'6',
'蠯':'6',
'饜':'6',
'魘':'6',
'靨':'6',
'鷢':'6',
'黂':'6',
'屭':'6',
'癱':'6',
'癲':'6',
'麠':'6',
'鷹':'6',
'廳':'6',
'麡':'6',
'癳':'6',
'黶':'6',
'癴':'6',
'麢':'6',
'癵':'6',
'亾':'7',
'兦':'7',
'辷':'7',
'処':'7',
'廵':'7',
'边':'7',
'辽':'7',
'辺':'7',
'辸':'7',
'込':'7',
'辻':'7',
'处':'7',
'朮':'7',
'犮':'7',
'氹':'7',
'乪':'7',
'廷':'7',
'延':'7',
'巡':'7',
'达':'7',
'过':'7',
'迈':'7',
'迄':'7',
'迁':'7',
'迅':'7',
'迆':'7',
'迂':'7',
'辿':'7',
'迀':'7',
'迉':'7',
'迃':'7',
'奿':'7',
'尥':'7',
'旭':'7',
'攰':'7',
'瓧':'7',
'廸':'7',
'廹':'7',
'迟':'7',
'返':'7',
'还':'7',
'迒':'7',
'进':'7',
'近':'7',
'连':'7',
'违':'7',
'迕':'7',
'迓':'7',
'迎':'7',
'远':'7',
'运':'7',
'这':'7',
'迍':'7',
'迏':'7',
'迖':'7',
'迗':'7',
'迋':'7',
'迌':'7',
'迊':'7',
'迚':'7',
'彣':'7',
'尫':'7',
'尬':'7',
'尪':'7',
'飏':'7',
'觃':'7',
'尦':'7',
'曵':'7',
'﨤':'7',
'毜':'7',
'毝':'7',
'瓩':'7',
'乸':'7',
'建':'7',
'廼':'7',
'廻':'7',
'迨':'7',
'迪':'7',
'迭':'7',
'迩':'7',
'迦':'7',
'迥':'7',
'迫':'7',
'述':'7',
'迢':'7',
'迤':'7',
'迮':'7',
'迯':'7',
'迠':'7',
'迧':'7',
'迡':'7',
'迣':'7',
'迳':'7',
'迲':'7',
'迱':'7',
'迬':'7',
'沊':'7',
'瓪':'7',
'尩':'7',
'瓝':'7',
'瓰':'7',
'瓱':'7',
'瓲':'7',
'兘':'7',
'勉':'7',
'勊':'7',
'廽':'7',
'迸':'7',
'逅':'7',
'迹':'7',
'迷':'7',
'迺':'7',
'逆':'7',
'逄':'7',
'适':'7',
'送':'7',
'逃':'7',
'退':'7',
'选':'7',
'逊':'7',
'迻':'7',
'追':'7',
'逈':'7',
'迵':'7',
'逇':'7',
'迴':'7',
'迼':'7',
'迾':'7',
'迿':'7',
'迶':'7',
'奊':'7',
'咫':'7',
'尮':'7',
'尯':'7',
'卼':'7',
'飑':'7',
'飐':'7',
'毡':'7',
'昶':'7',
'爮':'7',
'虺':'7',
'訄':'7',
'赴':'7',
'赳':'7',
'赵':'7',
'赲':'7',
'兙':'7',
'剋':'7',
'逋':'7',
'逞':'7',
'递':'7',
'逗':'7',
'逢':'7',
'逛':'7',
'逦':'7',
'逑':'7',
'逡':'7',
'逝':'7',
'速':'7',
'逖':'7',
'通':'7',
'透':'7',
'途':'7',
'逍':'7',
'造':'7',
'逐':'7',
'連':'7',
'逕':'7',
'這':'7',
'逓':'7',
'逧':'7',
'逥':'7',
'逎':'7',
'逘':'7',
'逤':'7',
'逜':'7',
'逌':'7',
'屘':'7',
'毪':'7',
'毨':'7',
'毩':'7',
'毧':'7',
'毢':'7',
'毤':'7',
'毥':'7',
'瓸':'7',
'瓟':'7',
'翅':'7',
'覎':'7',
'豗':'7',
'赶':'7',
'赸':'7',
'兛':'7',
'尅':'7',
'屗':'7',
'匙':'7',
'逴':'7',
'逮':'7',
'逭':'7',
'逵':'7',
'逯':'7',
'逻':'7',
'逶':'7',
'逸':'7',
'逩':'7',
'逷':'7',
'過':'7',
'進':'7',
'週':'7',
'逹':'7',
'逺':'7',
'逬':'7',
'逪':'7',
'逫':'7',
'逨':'7',
'逽':'7',
'逰':'7',
'逳':'7',
'彪':'7',
'毬':'7',
'覐':'7',
'赿':'7',
'赼':'7',
'趀':'7',
'赽':'7',
'赺':'7',
'赾':'7',
'赹':'7',
'赻':'7',
'馗':'7',
'兝':'7',
'兞':'7',
'瓼':'7',
'逼':'7',
'遍':'7',
'遄':'7',
'道':'7',
'遁':'7',
'遌':'7',
'遏':'7',
'遑':'7',
'遒':'7',
'遂':'7',
'遆':'7',
'遗':'7',
'遐':'7',
'逾':'7',
'遇':'7',
'遉':'7',
'遊':'7',
'運':'7',
'違':'7',
'遃':'7',
'遅':'7',
'遚':'7',
'達':'7',
'逿':'7',
'遖':'7',
'遈':'7',
'遀':'7',
'尳':'7',
'尰':'7',
'飓':'7',
'毽':'7',
'毰':'7',
'毯':'7',
'毴':'7',
'毱':'7',
'毶':'7',
'甦':'7',
'甤':'7',
'虝':'7',
'翘':'7',
'超':'7',
'趁':'7',
'趄':'7',
'趋':'7',
'越':'7',
'趂':'7',
'趆':'7',
'趃':'7',
'趉':'7',
'趇':'7',
'趈':'7',
'颩':'7',
'鬽':'7',
'遨':'7',
'遘':'7',
'遛':'7',
'遣':'7',
'遝':'7',
'遢':'7',
'遥':'7',
'遞':'7',
'遡':'7',
'遜':'7',
'遟':'7',
'遳':'7',
'遤':'7',
'遙':'7',
'遠':'7',
'尟':'7',
'尴':'7',
'尲':'7',
'飔':'7',
'毸':'7',
'毺':'7',
'甅':'7',
'韪':'7',
'甝':'7',
'兡':'7',
'趔':'7',
'趑':'7',
'趍':'7',
'趐':'7',
'趎':'7',
'趓':'7',
'趏':'7',
'趌':'7',
'趒':'7',
'颫':'7',
'颬':'7',
'魁':'7',
'魀':'7',
'鬾':'7',
'鬿':'7',
'遭':'7',
'遮':'7',
'遯':'7',
'適':'7',
'遪':'7',
'遫':'7',
'遰':'7',
'遦':'7',
'遱':'7',
'遬':'7',
'遧':'7',
'飗':'7',
'氁':'7',
'趖':'7',
'趙':'7',
'趕':'7',
'趗':'7',
'趚':'7',
'趘':'7',
'颭':'7',
'颮':'7',
'颱':'7',
'颰':'7',
'魃':'7',
'魅':'7',
'魆':'7',
'遴':'7',
'遹':'7',
'遵':'7',
'遶':'7',
'邁':'7',
'遷':'7',
'遼':'7',
'遺':'7',
'選':'7',
'遲':'7',
'遻':'7',
'邆':'7',
'尵':'7',
'暹':'7',
'趣':'7',
'趟':'7',
'趠':'7',
'趡':'7',
'趤':'7',
'趞':'7',
'趝':'7',
'趜':'7',
'趢':'7',
'趛':'7',
'颳':'7',
'颲':'7',
'靥':'7',
'韑':'7',
'题':'7',
'避':'7',
'遽':'7',
'邂':'7',
'邀':'7',
'邅':'7',
'還':'7',
'遾':'7',
'飚':'7',
'氇':'7',
'氆':'7',
'攳':'7',
'趥':'7',
'趧':'7',
'趦':'7',
'颵':'7',
'颴':'7',
'魉':'7',
'魈':'7',
'兣':'7',
'兤':'7',
'邈':'7',
'邃':'7',
'邇':'7',
'邉':'7',
'尶':'7',
'尷':'7',
'氊':'7',
'趨':'7',
'颶':'7',
'颷':'7',
'魋':'7',
'魍':'7',
'魊':'7',
'魎':'7',
'魌':'7',
'黋':'7',
'邋':'7',
'邊':'7',
'邌':'7',
'翹':'7',
'趩':'7',
'趪':'7',
'颺':'7',
'颸':'7',
'颼':'7',
'颾':'7',
'颹':'7',
'韙':'7',
'題':'7',
'邍':'7',
'氌':'7',
'趫':'7',
'趭':'7',
'趬':'7',
'飀':'7',
'魑':'7',
'魓':'7',
'魐':'7',
'趮':'7',
'飂':'7',
'飃':'7',
'魒':'7',
'魖':'7',
'鶗':'7',
'邎':'7',
'趯':'7',
'趰':'7',
'飅':'7',
'飇':'7',
'飈':'7',
'飉':'7',
'魕':'7',
'邐':'7',
'邏':'7',
'飋':'7',
'趱':'7',
'趲':'7'
}

StrokeDict = {'吖':'6',
'阿':'7',
'啊':'10',
'锕':'12',
'嗄':'13',
'哎':'8',
'哀':'9',
'埃':'10',
'唉':'10',
'锿':'14',
'挨':'10',
'捱':'11',
'皑':'11',
'癌':'17',
'矮':'13',
'蔼':'14',
'霭':'19',
'艾':'5',
'砹':'10',
'爱':'10',
'隘':'12',
'碍':'13',
'嗳':'13',
'嗌':'13',
'嫒':'13',
'瑷':'14',
'暧':'14',
'安':'6',
'桉':'10',
'氨':'10',
'庵':'11',
'谙':'11',
'鹌':'13',
'鞍':'15',
'俺':'10',
'埯':'11',
'铵':'11',
'揞':'12',
'犴':'6',
'岸':'8',
'按':'9',
'胺':'10',
'案':'10',
'暗':'13',
'黯':'21',
'肮':'8',
'昂':'8',
'盎':'10',
'凹':'5',
'敖':'10',
'遨':'13',
'嗷':'13',
'廒':'13',
'獒':'14',
'熬':'14',
'聱':'16',
'螯':'16',
'翱':'16',
'鳌':'18',
'鏖':'19',
'袄':'9',
'媪':'12',
'岙':'7',
'坳':'8',
'傲':'12',
'奥':'12',
'骜':'13',
'澳':'15',
'懊':'15',
'鏊':'18',
'八':'2',
'巴':'4',
'扒':'5',
'叭':'5',
'芭':'7',
'岜':'7',
'疤':'9',
'捌':'10',
'笆':'10',
'粑':'10',
'拔':'8',
'茇':'8',
'菝':'11',
'跋':'12',
'魃':'14',
'把':'7',
'靶':'13',
'坝':'7',
'爸':'8',
'罢':'10',
'鲅':'13',
'霸':'21',
'灞':'24',
'吧':'7',
'掰':'12',
'白':'5',
'百':'6',
'佰':'8',
'柏':'9',
'捭':'11',
'摆':'13',
'败':'8',
'拜':'9',
'稗':'13',
'扳':'7',
'班':'10',
'般':'10',
'颁':'10',
'斑':'12',
'搬':'13',
'瘢':'15',
'癍':'17',
'阪':'6',
'坂':'7',
'板':'8',
'版':'8',
'钣':'9',
'舨':'10',
'办':'4',
'半':'5',
'伴':'7',
'拌':'8',
'绊':'8',
'瓣':'19',
'扮':'7',
'邦':'6',
'帮':'9',
'梆':'10',
'浜':'10',
'绑':'9',
'榜':'14',
'蚌':'10',
'棒':'12',
'傍':'12',
'谤':'12',
'蒡':'13',
'磅':'15',
'镑':'15',
'勹':'2',
'包':'5',
'苞':'8',
'孢':'8',
'胞':'9',
'龅':'13',
'煲':'13',
'褒':'15',
'雹':'13',
'薄':'16',
'宀':'3',
'饱':'8',
'宝':'8',
'保':'9',
'鸨':'9',
'葆':'12',
'堡':'12',
'褓':'14',
'报':'7',
'抱':'8',
'趵':'10',
'豹':'10',
'鲍':'13',
'暴':'15',
'爆':'19',
'陂':'7',
'杯':'8',
'卑':'8',
'悲':'12',
'碑':'13',
'鹎':'13',
'北':'5',
'贝':'4',
'孛':'7',
'邶':'7',
'狈':'7',
'备':'8',
'背':'9',
'钡':'9',
'倍':'10',
'悖':'10',
'被':'10',
'辈':'12',
'惫':'12',
'焙':'12',
'蓓':'13',
'碚':'13',
'褙':'14',
'鞴':'19',
'鐾':'21',
'呗':'7',
'奔':'8',
'贲':'9',
'锛':'13',
'本':'5',
'苯':'8',
'畚':'10',
'坌':'7',
'笨':'11',
'崩':'11',
'绷':'11',
'嘣':'14',
'甭':'9',
'泵':'9',
'迸':'9',
'甏':'16',
'蹦':'18',
'逼':'12',
'荸':'10',
'鼻':'14',
'匕':'2',
'比':'4',
'吡':'7',
'妣':'7',
'彼':'8',
'秕':'9',
'笔':'10',
'俾':'10',
'舭':'10',
'鄙':'13',
'币':'4',
'必':'5',
'毕':'6',
'闭':'6',
'庇':'7',
'畀':'8',
'荜':'9',
'毖':'9',
'哔':'9',
'陛':'9',
'毙':'10',
'铋':'10',
'狴':'10',
'萆':'11',
'庳':'11',
'敝':'11',
'婢':'11',
'筚':'12',
'愎':'12',
'弼':'12',
'蓖':'13',
'跸':'13',
'痹':'13',
'滗':'13',
'裨':'13',
'碧':'14',
'蔽':'14',
'箅':'14',
'弊':'14',
'薜':'16',
'篦':'16',
'壁':'16',
'避':'16',
'嬖':'16',
'髀':'17',
'濞':'17',
'臂':'17',
'璧':'18',
'襞':'19',
'边':'5',
'砭':'9',
'笾':'11',
'编':'12',
'煸':'13',
'蝙':'15',
'鳊':'17',
'鞭':'18',
'贬':'8',
'窆':'9',
'扁':'9',
'匾':'11',
'碥':'14',
'褊':'14',
'卞':'4',
'弁':'5',
'苄':'7',
'汴':'7',
'忭':'7',
'变':'8',
'便':'9',
'遍':'12',
'缏':'12',
'辨':'16',
'辩':'16',
'辫':'17',
'标':'9',
'飑':'9',
'髟':'10',
'彪':'11',
'骠':'14',
'膘':'15',
'飙':'16',
'镖':'16',
'飚':'16',
'瘭':'16',
'镳':'20',
'表':'8',
'婊':'11',
'裱':'13',
'鳔':'19',
'憋':'15',
'鳖':'19',
'别':'7',
'蹩':'18',
'瘪':'15',
'玢':'8',
'宾':'10',
'彬':'11',
'傧':'12',
'斌':'12',
'滨':'13',
'缤':'13',
'槟':'14',
'镔':'15',
'濒':'16',
'豳':'17',
'摈':'13',
'殡':'14',
'膑':'14',
'髌':'19',
'鬓':'20',
'冰':'6',
'兵':'7',
'丙':'5',
'邴':'7',
'秉':'8',
'柄':'9',
'饼':'9',
'炳':'9',
'禀':'13',
'疒':'5',
'并':'6',
'病':'10',
'摒':'12',
'拨':'8',
'波':'8',
'玻':'9',
'钵':'10',
'饽':'10',
'剥':'10',
'菠':'11',
'播':'15',
'伯':'7',
'驳':'7',
'帛':'8',
'泊':'8',
'勃':'9',
'钹':'10',
'铂':'10',
'亳':'10',
'舶':'11',
'脖':'11',
'博':'12',
'鹁':'12',
'渤':'12',
'搏':'13',
'箔':'14',
'膊':'14',
'踣':'15',
'礴':'21',
'跛':'12',
'檗':'17',
'擘':'17',
'簸':'19',
'卜':'2',
'啵':'11',
'逋':'10',
'钸':'10',
'晡':'11',
'卟':'5',
'补':'7',
'捕':'10',
'哺':'10',
'不':'4',
'布':'5',
'步':'7',
'怖':'8',
'钚':'9',
'部':'10',
'埠':'11',
'瓿':'12',
'醭':'19',
'簿':'19',
'擦':'17',
'礤':'19',
'猜':'11',
'才':'3',
'材':'7',
'财':'7',
'裁':'12',
'采':'8',
'彩':'11',
'睬':'13',
'踩':'15',
'菜':'11',
'蔡':'14',
'参':'8',
'骖':'11',
'餐':'16',
'残':'9',
'蚕':'10',
'惭':'11',
'惨':'11',
'黪':'20',
'灿':'7',
'粲':'13',
'璨':'17',
'仓':'4',
'伧':'6',
'苍':'7',
'沧':'7',
'舱':'10',
'藏':'17',
'操':'16',
'糙':'16',
'曹':'11',
'嘈':'14',
'漕':'14',
'槽':'15',
'螬':'17',
'艚':'17',
'艹':'3',
'草':'9',
'刂':'2',
'册':'5',
'厕':'8',
'侧':'8',
'测':'9',
'恻':'9',
'策':'12',
'岑':'7',
'涔':'10',
'噌':'15',
'层':'7',
'曾':'12',
'蹭':'19',
'叉':'3',
'杈':'7',
'插':'12',
'馇':'12',
'锸':'14',
'嚓':'17',
'茬':'9',
'茶':'9',
'查':'9',
'搽':'12',
'猹':'12',
'槎':'13',
'碴':'14',
'察':'14',
'檫':'18',
'衩':'8',
'镲':'19',
'汊':'6',
'岔':'7',
'刹':'8',
'诧':'8',
'差':'9',
'姹':'9',
'拆':'8',
'钗':'8',
'侪':'8',
'柴':'10',
'豺':'10',
'虿':'9',
'瘥':'14',
'觇':'9',
'掺':'11',
'搀':'12',
'谗':'11',
'婵':'11',
'馋':'12',
'禅':'12',
'孱':'12',
'缠':'13',
'蝉':'14',
'廛':'15',
'潺':'15',
'澶':'16',
'蟾':'19',
'躔':'22',
'产':'6',
'谄':'10',
'铲':'11',
'阐':'11',
'蒇':'12',
'骣':'15',
'冁':'18',
'忏':'6',
'颤':'19',
'羼':'21',
'伥':'6',
'昌':'8',
'菖':'11',
'猖':'11',
'阊':'11',
'娼':'11',
'鲳':'16',
'苌':'7',
'肠':'7',
'尝':'9',
'常':'11',
'偿':'11',
'徜':'11',
'嫦':'14',
'厂':'2',
'场':'6',
'昶':'9',
'惝':'11',
'敞':'12',
'氅':'16',
'怅':'7',
'畅':'8',
'倡':'10',
'鬯':'10',
'唱':'11',
'抄':'7',
'怊':'8',
'钞':'9',
'绰':'11',
'超':'12',
'焯':'12',
'晁':'10',
'巢':'11',
'朝':'12',
'嘲':'15',
'潮':'15',
'吵':'7',
'炒':'8',
'耖':'10',
'车':'4',
'砗':'9',
'扯':'7',
'屮':'3',
'彻':'7',
'坼':'8',
'掣':'12',
'撤':'15',
'澈':'15',
'抻':'8',
'郴':'10',
'琛':'12',
'嗔':'13',
'臣':'6',
'尘':'6',
'辰':'7',
'沉':'7',
'忱':'7',
'陈':'7',
'宸':'10',
'晨':'11',
'谌':'11',
'碜':'13',
'衬':'8',
'龀':'10',
'趁':'12',
'榇':'13',
'谶':'19',
'柽':'9',
'称':'10',
'蛏':'11',
'撑':'15',
'瞠':'16',
'成':'6',
'丞':'6',
'呈':'7',
'枨':'8',
'诚':'8',
'承':'8',
'城':'9',
'埕':'10',
'乘':'10',
'铖':'11',
'程':'12',
'惩':'12',
'裎':'12',
'塍':'13',
'酲':'14',
'澄':'15',
'橙':'16',
'逞':'10',
'骋':'10',
'秤':'10',
'吃':'6',
'哧':'10',
'鸱':'10',
'蚩':'10',
'眵':'11',
'笞':'11',
'嗤':'13',
'痴':'13',
'媸':'13',
'螭':'16',
'魑':'19',
'池':'6',
'弛':'6',
'驰':'6',
'迟':'7',
'茌':'8',
'持':'9',
'墀':'15',
'踟':'15',
'篪':'16',
'尺':'4',
'齿':'8',
'侈':'8',
'耻':'10',
'豉':'11',
'褫':'15',
'彳':'3',
'叱':'5',
'斥':'5',
'赤':'7',
'饬':'7',
'炽':'9',
'翅':'10',
'敕':'11',
'啻':'12',
'傺':'13',
'瘛':'15',
'冲':'6',
'充':'6',
'忡':'7',
'茺':'9',
'舂':'11',
'憧':'15',
'艟':'18',
'虫':'6',
'崇':'11',
'宠':'8',
'铳':'11',
'抽':'8',
'瘳':'16',
'仇':'4',
'俦':'9',
'帱':'10',
'惆':'11',
'绸':'11',
'畴':'12',
'酬':'13',
'稠':'13',
'愁':'13',
'筹':'13',
'踌':'14',
'雠':'18',
'丑':'4',
'瞅':'14',
'臭':'10',
'出':'5',
'初':'7',
'樗':'15',
'刍':'5',
'除':'9',
'厨':'12',
'锄':'12',
'滁':'12',
'蜍':'13',
'雏':'13',
'橱':'16',
'躇':'18',
'蹰':'19',
'杵':'8',
'础':'10',
'楮':'12',
'储':'12',
'楚':'13',
'褚':'13',
'亍':'3',
'处':'5',
'怵':'8',
'绌':'8',
'畜':'10',
'搐':'13',
'触':'13',
'憷':'16',
'黜':'17',
'矗':'24',
'揣':'12',
'搋':'13',
'踹':'16',
'膪':'16',
'川':'3',
'巛':'3',
'氚':'7',
'穿':'9',
'传':'6',
'舡':'9',
'船':'11',
'遄':'12',
'椽':'13',
'舛':'6',
'喘':'12',
'串':'7',
'钏':'8',
'疮':'9',
'窗':'12',
'床':'7',
'闯':'6',
'创':'6',
'怆':'7',
'吹':'7',
'炊':'8',
'垂':'8',
'陲':'10',
'捶':'11',
'棰':'12',
'槌':'13',
'锤':'13',
'春':'9',
'椿':'13',
'蝽':'15',
'纯':'7',
'莼':'10',
'唇':'10',
'淳':'11',
'鹑':'13',
'醇':'15',
'蠢':'21',
'踔':'15',
'戳':'18',
'啜':'11',
'辍':'12',
'龊':'15',
'呲':'9',
'疵':'11',
'词':'7',
'茈':'9',
'茨':'9',
'祠':'9',
'瓷':'10',
'辞':'13',
'慈':'13',
'磁':'14',
'雌':'14',
'鹚':'14',
'糍':'15',
'此':'6',
'次':'6',
'刺':'8',
'赐':'12',
'匆':'5',
'苁':'7',
'囱':'7',
'枞':'8',
'葱':'12',
'骢':'14',
'璁':'15',
'聪':'15',
'从':'4',
'丛':'5',
'淙':'11',
'琮':'12',
'凑':'11',
'楱':'13',
'辏':'13',
'腠':'13',
'粗':'11',
'徂':'8',
'殂':'9',
'促':'9',
'猝':'11',
'蔟':'14',
'醋':'15',
'簇':'17',
'蹙':'18',
'蹴':'19',
'汆':'6',
'撺':'15',
'镩':'17',
'蹿':'19',
'窜':'12',
'篡':'16',
'爨':'30',
'崔':'11',
'催':'13',
'摧':'14',
'榱':'14',
'璀':'15',
'脆':'10',
'萃':'11',
'啐':'11',
'淬':'11',
'悴':'11',
'毳':'12',
'瘁':'13',
'粹':'14',
'翠':'14',
'村':'7',
'皴':'12',
'存':'6',
'忖':'6',
'寸':'3',
'搓':'12',
'磋':'14',
'撮':'15',
'蹉':'16',
'嵯':'12',
'矬':'12',
'痤':'12',
'鹾':'16',
'脞':'11',
'挫':'10',
'厝':'10',
'措':'11',
'锉':'12',
'错':'13',
'耷':'9',
'哒':'9',
'搭':'12',
'嗒':'12',
'褡':'14',
'达':'6',
'怛':'8',
'妲':'8',
'笪':'11',
'答':'12',
'靼':'14',
'瘩':'14',
'鞑':'15',
'打':'5',
'大':'3',
'呆':'7',
'歹':'4',
'逮':'11',
'傣':'12',
'代':'5',
'甙':'8',
'岱':'8',
'迨':'8',
'绐':'8',
'玳':'9',
'带':'9',
'殆':'9',
'贷':'9',
'待':'9',
'怠':'9',
'埭':'11',
'袋':'11',
'戴':'17',
'黛':'17',
'亻':'2',
'卩':'2',
'丹':'4',
'担':'8',
'单':'8',
'眈':'9',
'耽':'10',
'郸':'10',
'聃':'11',
'殚':'12',
'瘅':'13',
'箪':'14',
'儋':'15',
'胆':'9',
'疸':'10',
'掸':'11',
'旦':'5',
'但':'7',
'诞':'8',
'萏':'11',
'啖':'11',
'淡':'11',
'惮':'11',
'弹':'11',
'蛋':'11',
'氮':'12',
'澹':'16',
'当':'6',
'铛':'11',
'裆':'11',
'挡':'9',
'档':'10',
'党':'10',
'谠':'12',
'凼':'6',
'砀':'8',
'宕':'8',
'荡':'9',
'菪':'11',
'刀':'2',
'叨':'5',
'忉':'5',
'氘':'6',
'导':'6',
'岛':'7',
'捣':'10',
'倒':'10',
'祷':'11',
'蹈':'17',
'到':'8',
'盗':'11',
'悼':'11',
'道':'12',
'稻':'15',
'纛':'25',
'得':'11',
'锝':'13',
'德':'15',
'的':'8',
'灯':'6',
'登':'12',
'噔':'15',
'簦':'18',
'蹬':'19',
'等':'12',
'戥':'13',
'邓':'4',
'凳':'14',
'嶝':'15',
'磴':'17',
'瞪':'17',
'镫':'17',
'低':'7',
'羝':'11',
'堤':'12',
'嘀':'14',
'滴':'14',
'狄':'7',
'迪':'8',
'籴':'8',
'荻':'10',
'敌':'10',
'涤':'10',
'笛':'11',
'觌':'12',
'嫡':'14',
'镝':'16',
'氐':'5',
'邸':'7',
'诋':'7',
'坻':'8',
'抵':'8',
'底':'8',
'柢':'9',
'砥':'10',
'骶':'14',
'地':'6',
'弟':'7',
'帝':'9',
'递':'10',
'娣':'10',
'第':'11',
'谛':'11',
'蒂':'12',
'棣':'12',
'睇':'12',
'缔':'12',
'碲':'14',
'嗲':'13',
'掂':'11',
'滇':'13',
'颠':'16',
'巅':'19',
'癫':'21',
'丶':'1',
'典':'8',
'点':'9',
'碘':'13',
'踮':'15',
'电':'5',
'佃':'7',
'甸':'7',
'阽':'7',
'坫':'8',
'店':'8',
'玷':'9',
'垫':'9',
'钿':'10',
'淀':'11',
'惦':'11',
'奠':'12',
'殿':'13',
'靛':'16',
'簟':'18',
'癜':'18',
'刁':'2',
'叼':'5',
'凋':'10',
'貂':'12',
'碉':'13',
'雕':'16',
'鲷':'16',
'吊':'6',
'钓':'8',
'掉':'11',
'铞':'11',
'铫':'11',
'爹':'10',
'跌':'12',
'迭':'8',
'垤':'9',
'瓞':'10',
'谍':'11',
'堞':'12',
'揲':'12',
'耋':'12',
'喋':'12',
'牒':'13',
'叠':'13',
'碟':'14',
'蝶':'15',
'蹀':'16',
'鲽':'17',
'丁':'2',
'仃':'4',
'叮':'5',
'玎':'6',
'盯':'7',
'町':'7',
'疔':'7',
'耵':'8',
'顶':'8',
'酊':'9',
'鼎':'12',
'订':'4',
'钉':'7',
'定':'8',
'啶':'11',
'铤':'11',
'腚':'12',
'碇':'13',
'锭':'13',
'丢':'6',
'铥':'11',
'东':'5',
'冬':'5',
'咚':'8',
'岽':'8',
'氡':'9',
'鸫':'10',
'董':'12',
'懂':'15',
'动':'6',
'冻':'7',
'侗':'8',
'垌':'9',
'栋':'9',
'峒':'9',
'胨':'9',
'洞':'9',
'恫':'9',
'胴':'10',
'硐':'11',
'都':'10',
'兜':'11',
'蔸':'14',
'篼':'17',
'抖':'7',
'钭':'9',
'陡':'9',
'蚪':'10',
'斗':'4',
'豆':'7',
'逗':'10',
'痘':'12',
'窦':'13',
'督':'13',
'嘟':'13',
'毒':'9',
'独':'9',
'读':'10',
'渎':'11',
'椟':'12',
'犊':'12',
'牍':'12',
'黩':'20',
'髑':'22',
'笃':'9',
'堵':'11',
'赌':'12',
'睹':'13',
'芏':'6',
'杜':'7',
'肚':'7',
'妒':'7',
'度':'9',
'渡':'12',
'镀':'14',
'蠹':'24',
'端':'14',
'短':'12',
'段':'9',
'断':'11',
'缎':'12',
'椴':'13',
'煅':'13',
'锻':'14',
'簖':'17',
'堆':'11',
'队':'4',
'对':'5',
'兑':'7',
'怼':'9',
'碓':'13',
'憝':'16',
'吨':'7',
'敦':'12',
'墩':'15',
'礅':'17',
'镦':'17',
'蹲':'19',
'盹':'9',
'趸':'10',
'沌':'7',
'炖':'8',
'砘':'9',
'钝':'9',
'盾':'9',
'顿':'10',
'遁':'12',
'多':'6',
'咄':'8',
'哆':'9',
'掇':'11',
'裰':'13',
'夺':'6',
'铎':'10',
'踱':'16',
'朵':'6',
'垛':'9',
'哚':'9',
'缍':'11',
'躲':'13',
'剁':'8',
'舵':'11',
'堕':'11',
'惰':'12',
'跺':'13',
'屙':'10',
'婀':'10',
'讹':'6',
'俄':'9',
'莪':'10',
'峨':'10',
'娥':'10',
'锇':'12',
'鹅':'12',
'蛾':'13',
'额':'15',
'厄':'4',
'扼':'7',
'苊':'7',
'呃':'7',
'轭':'8',
'垩':'9',
'恶':'10',
'饿':'10',
'鄂':'11',
'阏':'11',
'谔':'11',
'萼':'12',
'遏':'12',
'愕':'12',
'腭':'13',
'鹗':'14',
'锷':'14',
'颚':'15',
'噩':'16',
'鳄':'17',
'诶':'9',
'恩':'10',
'蒽':'13',
'摁':'13',
'嗯':'13',
'儿':'2',
'而':'6',
'鸸':'11',
'鲕':'14',
'尔':'5',
'耳':'6',
'迩':'8',
'饵':'9',
'洱':'9',
'珥':'10',
'铒':'11',
'二':'2',
'佴':'8',
'贰':'9',
'发':'5',
'乏':'4',
'伐':'6',
'罚':'9',
'垡':'9',
'阀':'9',
'筏':'12',
'法':'8',
'砝':'10',
'珐':'9',
'帆':'6',
'番':'12',
'蕃':'15',
'幡':'15',
'藩':'18',
'翻':'18',
'凡':'3',
'矾':'8',
'钒':'8',
'烦':'10',
'樊':'15',
'燔':'16',
'繁':'17',
'蹯':'19',
'蘩':'20',
'犭':'3',
'攵':'4',
'反':'4',
'返':'7',
'犯':'5',
'饭':'7',
'泛':'7',
'范':'8',
'贩':'8',
'畈':'9',
'梵':'11',
'匚':'2',
'方':'4',
'邡':'6',
'坊':'7',
'芳':'7',
'枋':'8',
'钫':'9',
'防':'6',
'妨':'7',
'肪':'8',
'房':'8',
'鲂':'12',
'仿':'6',
'访':'6',
'纺':'7',
'舫':'10',
'放':'8',
'飞':'3',
'妃':'6',
'非':'8',
'菲':'11',
'啡':'11',
'绯':'11',
'扉':'12',
'蜚':'14',
'霏':'16',
'鲱':'16',
'肥':'8',
'淝':'11',
'腓':'12',
'匪':'10',
'诽':'10',
'悱':'11',
'斐':'12',
'榧':'14',
'翡':'14',
'篚':'16',
'芾':'7',
'吠':'7',
'肺':'8',
'狒':'8',
'废':'8',
'沸':'8',
'费':'9',
'痱':'13',
'镄':'14',
'分':'4',
'芬':'7',
'吩':'7',
'纷':'7',
'氛':'8',
'酚':'11',
'坟':'7',
'汾':'7',
'棼':'12',
'焚':'12',
'鼢':'17',
'粉':'10',
'份':'6',
'奋':'8',
'忿':'8',
'偾':'11',
'粪':'12',
'愤':'12',
'鲼':'17',
'瀵':'20',
'丰':'4',
'风':'4',
'沣':'7',
'枫':'8',
'封':'9',
'砜':'9',
'疯':'9',
'峰':'10',
'烽':'11',
'葑':'12',
'锋':'12',
'蜂':'13',
'酆':'20',
'冯':'5',
'逢':'10',
'缝':'13',
'讽':'6',
'唪':'11',
'凤':'4',
'奉':'8',
'俸':'10',
'佛':'7',
'缶':'6',
'否':'7',
'夫':'4',
'呋':'7',
'肤':'8',
'麸':'11',
'趺':'11',
'跗':'12',
'稃':'12',
'孵':'14',
'敷':'15',
'弗':'5',
'伏':'6',
'凫':'6',
'扶':'7',
'芙':'7',
'孚':'7',
'拂':'8',
'苻':'8',
'服':'8',
'怫':'8',
'绂':'8',
'绋':'8',
'茯':'9',
'罘':'9',
'氟':'9',
'俘':'9',
'郛':'9',
'祓':'9',
'莩':'10',
'砩':'10',
'蚨':'10',
'浮':'10',
'菔':'11',
'桴':'11',
'符':'11',
'匐':'11',
'涪':'11',
'艴':'11',
'幅':'12',
'辐':'13',
'蜉':'13',
'福':'13',
'蝠':'15',
'幞':'15',
'黻':'17',
'抚':'7',
'甫':'7',
'拊':'8',
'斧':'8',
'府':'8',
'俯':'10',
'釜':'10',
'辅':'11',
'腑':'12',
'滏':'13',
'腐':'14',
'黼':'19',
'父':'4',
'讣':'4',
'付':'5',
'负':'6',
'妇':'6',
'附':'7',
'咐':'8',
'阜':'8',
'驸':'8',
'赴':'9',
'复':'9',
'副':'11',
'赋':'12',
'傅':'12',
'富':'12',
'腹':'13',
'鲋':'13',
'缚':'13',
'赙':'14',
'蝮':'15',
'鳆':'17',
'覆':'18',
'馥':'18',
'袱':'11',
'旮':'6',
'伽':'7',
'呷':'8',
'嘎':'14',
'钆':'6',
'尜':'9',
'噶':'15',
'尕':'5',
'尬':'7',
'该':'8',
'陔':'8',
'垓':'9',
'赅':'10',
'改':'7',
'丐':'4',
'钙':'9',
'盖':'11',
'溉':'12',
'概':'13',
'戤':'13',
'甘':'5',
'肝':'7',
'坩':'8',
'苷':'8',
'矸':'8',
'泔':'8',
'柑':'9',
'竿':'9',
'酐':'10',
'疳':'10',
'尴':'13',
'杆':'7',
'秆':'8',
'赶':'10',
'敢':'11',
'感':'13',
'澉':'14',
'橄':'15',
'擀':'16',
'干':'3',
'旰':'7',
'绀':'8',
'淦':'11',
'赣':'21',
'冈':'4',
'刚':'6',
'肛':'7',
'纲':'7',
'钢':'9',
'缸':'9',
'罡':'10',
'岗':'7',
'港':'12',
'杠':'7',
'筻':'13',
'戆':'25',
'皋':'10',
'高':'10',
'羔':'10',
'槔':'14',
'睾':'14',
'膏':'14',
'篙':'16',
'糕':'16',
'杲':'8',
'搞':'13',
'缟':'13',
'槁':'14',
'镐':'15',
'稿':'15',
'藁':'17',
'告':'7',
'郜':'9',
'诰':'9',
'锆':'12',
'戈':'4',
'圪':'6',
'纥':'6',
'疙':'8',
'咯':'9',
'哥':'10',
'胳':'10',
'鸽':'11',
'袼':'11',
'搁':'12',
'割':'12',
'歌':'14',
'革':'9',
'阁':'9',
'格':'10',
'鬲':'10',
'隔':'12',
'塥':'13',
'嗝':'13',
'搿':'14',
'膈':'14',
'骼':'15',
'镉':'15',
'哿':'10',
'舸':'11',
'葛':'12',
'个':'3',
'各':'6',
'虼':'9',
'硌':'11',
'铬':'11',
'给':'9',
'根':'10',
'跟':'13',
'哏':'9',
'亘':'6',
'艮':'6',
'茛':'9',
'庚':'8',
'耕':'10',
'赓':'12',
'羹':'19',
'埂':'10',
'耿':'10',
'哽':'10',
'绠':'10',
'梗':'11',
'鲠':'15',
'更':'7',
'工':'3',
'弓':'3',
'公':'4',
'功':'5',
'攻':'7',
'肱':'8',
'宫':'9',
'恭':'10',
'蚣':'10',
'躬':'10',
'龚':'11',
'觥':'13',
'廾':'3',
'巩':'6',
'汞':'7',
'拱':'9',
'珙':'10',
'共':'6',
'贡':'7',
'供':'8',
'勾':'4',
'佝':'7',
'沟':'7',
'钩':'9',
'缑':'12',
'篝':'16',
'鞲':'19',
'苟':'8',
'岣':'8',
'狗':'8',
'枸':'9',
'笱':'11',
'构':'8',
'购':'8',
'诟':'8',
'垢':'9',
'够':'11',
'遘':'13',
'彀':'13',
'媾':'13',
'觏':'14',
'估':'7',
'咕':'8',
'沽':'8',
'孤':'8',
'姑':'8',
'轱':'9',
'鸪':'10',
'菰':'11',
'菇':'11',
'蛄':'11',
'辜':'12',
'酤':'12',
'觚':'12',
'毂':'13',
'箍':'14',
'古':'5',
'谷':'7',
'汩':'7',
'诂':'7',
'股':'8',
'骨':'9',
'牯':'9',
'罟':'10',
'钴':'10',
'蛊':'11',
'鼓':'13',
'嘏':'14',
'鹘':'14',
'臌':'17',
'瞽':'18',
'固':'8',
'故':'9',
'顾':'10',
'梏':'11',
'崮':'11',
'牿':'11',
'雇':'12',
'锢':'13',
'痼':'13',
'鲴':'16',
'瓜':'5',
'呱':'8',
'刮':'8',
'胍':'9',
'鸹':'11',
'剐':'9',
'寡':'14',
'卦':'8',
'诖':'8',
'挂':'9',
'褂':'13',
'乖':'8',
'拐':'8',
'怪':'8',
'关':'6',
'观':'6',
'官':'8',
'倌':'10',
'棺':'12',
'鳏':'18',
'莞':'10',
'馆':'11',
'管':'14',
'贯':'8',
'冠':'9',
'掼':'11',
'涫':'11',
'惯':'11',
'盥':'16',
'灌':'20',
'鹳':'22',
'罐':'23',
'光':'6',
'咣':'9',
'胱':'10',
'广':'3',
'犷':'6',
'桄':'10',
'逛':'10',
'归':'5',
'圭':'6',
'龟':'7',
'妫':'7',
'规':'8',
'皈':'9',
'闺':'9',
'硅':'11',
'瑰':'13',
'鲑':'14',
'宄':'5',
'轨':'6',
'庋':'7',
'匦':'8',
'诡':'8',
'鬼':'9',
'癸':'9',
'晷':'12',
'簋':'17',
'柜':'8',
'炅':'8',
'刿':'8',
'刽':'8',
'贵':'9',
'桂':'10',
'桧':'10',
'跪':'13',
'鳜':'20',
'衮':'10',
'绲':'11',
'辊':'12',
'滚':'13',
'磙':'15',
'鲧':'15',
'棍':'12',
'呙':'7',
'埚':'10',
'郭':'10',
'崞':'11',
'聒':'12',
'锅':'12',
'蝈':'14',
'国':'8',
'掴':'11',
'帼':'11',
'虢':'15',
'馘':'17',
'果':'8',
'猓':'11',
'椁':'12',
'蜾':'14',
'裹':'14',
'过':'6',
'哈':'9',
'铪':'11',
'蛤':'12',
'还':'7',
'孩':'9',
'骸':'15',
'胲':'10',
'海':'10',
'醢':'17',
'亥':'6',
'骇':'9',
'氦':'10',
'害':'10',
'顸':'9',
'蚶':'11',
'酣':'12',
'憨':'15',
'鼾':'17',
'邗':'5',
'邯':'7',
'含':'7',
'函':'8',
'晗':'11',
'焓':'11',
'涵':'11',
'韩':'12',
'寒':'12',
'罕':'7',
'喊':'12',
'汉':'5',
'汗':'6',
'旱':'7',
'捍':'10',
'悍':'10',
'菡':'11',
'焊':'11',
'颔':'13',
'撖':'14',
'撼':'16',
'翰':'16',
'憾':'16',
'瀚':'19',
'夯':'5',
'行':'6',
'杭':'8',
'绗':'9',
'航':'10',
'颃':'10',
'沆':'7',
'蒿':'13',
'薅':'16',
'嚆':'16',
'蚝':'10',
'毫':'11',
'嗥':'13',
'豪':'14',
'壕':'17',
'嚎':'17',
'濠':'17',
'好':'6',
'郝':'9',
'号':'5',
'昊':'8',
'耗':'10',
'浩':'10',
'皓':'12',
'颢':'18',
'灏':'21',
'诃':'7',
'呵':'8',
'喝':'12',
'嗬':'13',
'禾':'5',
'合':'6',
'何':'7',
'和':'8',
'劾':'8',
'河':'8',
'曷':'9',
'阂':'9',
'盍':'10',
'荷':'10',
'核':'10',
'菏':'11',
'盒':'11',
'涸':'11',
'颌':'12',
'阖':'13',
'翮':'16',
'贺':'9',
'赫':'14',
'褐':'14',
'鹤':'15',
'壑':'17',
'黑':'12',
'嗨':'13',
'嘿':'15',
'痕':'11',
'很':'9',
'狠':'9',
'恨':'9',
'亨':'7',
'哼':'10',
'恒':'9',
'珩':'10',
'桁':'10',
'横':'15',
'衡':'16',
'蘅':'19',
'轰':'8',
'訇':'9',
'烘':'10',
'薨':'16',
'弘':'5',
'红':'6',
'闳':'7',
'宏':'7',
'泓':'8',
'荭':'9',
'虹':'9',
'洪':'9',
'鸿':'11',
'蕻':'16',
'黉':'16',
'哄':'9',
'讧':'5',
'侯':'9',
'喉':'12',
'猴':'12',
'瘊':'14',
'骺':'15',
'篌':'15',
'糇':'15',
'吼':'7',
'后':'6',
'厚':'9',
'逅':'9',
'後':'9',
'候':'10',
'堠':'12',
'鲎':'13',
'乎':'5',
'呼':'8',
'忽':'8',
'轷':'9',
'烀':'9',
'唿':'11',
'惚':'11',
'滹':'14',
'囫':'7',
'狐':'8',
'弧':'8',
'胡':'9',
'壶':'10',
'斛':'11',
'葫':'12',
'鹄':'12',
'猢':'12',
'湖':'12',
'瑚':'13',
'煳':'13',
'鹕':'14',
'槲':'15',
'蝴':'15',
'糊':'15',
'醐':'16',
'觳':'17',
'虍':'6',
'虎':'8',
'浒':'9',
'唬':'11',
'琥':'12',
'互':'4',
'户':'4',
'冱':'6',
'护':'7',
'沪':'7',
'岵':'8',
'怙':'8',
'戽':'8',
'祜':'9',
'笏':'10',
'瓠':'11',
'扈':'11',
'鹱':'18',
'花':'7',
'砉':'9',
'划':'6',
'华':'6',
'哗':'9',
'骅':'9',
'铧':'11',
'猾':'12',
'滑':'12',
'化':'4',
'画':'8',
'话':'8',
'桦':'10',
'怀':'7',
'徊':'9',
'淮':'11',
'槐':'13',
'踝':'15',
'坏':'7',
'欢':'6',
'獾':'20',
'环':'8',
'洹':'9',
'桓':'10',
'萑':'11',
'锾':'14',
'圜':'16',
'寰':'16',
'缳':'16',
'鬟':'23',
'缓':'12',
'幻':'4',
'奂':'7',
'宦':'9',
'换':'10',
'唤':'10',
'涣':'10',
'浣':'10',
'患':'11',
'焕':'11',
'逭':'11',
'痪':'12',
'豢':'13',
'漶':'14',
'鲩':'15',
'擐':'16',
'肓':'7',
'荒':'9',
'慌':'12',
'皇':'9',
'黄':'11',
'凰':'11',
'隍':'11',
'遑':'12',
'徨':'12',
'湟':'12',
'惶':'12',
'煌':'13',
'潢':'14',
'璜':'15',
'蝗':'15',
'篁':'15',
'磺':'16',
'癀':'16',
'蟥':'17',
'簧':'17',
'鳇':'17',
'恍':'9',
'晃':'10',
'谎':'11',
'幌':'13',
'灰':'6',
'诙':'8',
'挥':'9',
'虺':'9',
'咴':'9',
'恢':'9',
'珲':'10',
'晖':'10',
'辉':'12',
'麾':'15',
'徽':'17',
'隳':'17',
'回':'6',
'茴':'9',
'洄':'9',
'蛔':'12',
'悔':'10',
'毁':'13',
'卉':'5',
'汇':'5',
'会':'6',
'讳':'6',
'荟':'9',
'哕':'9',
'浍':'9',
'诲':'9',
'绘':'9',
'恚':'10',
'贿':'10',
'烩':'10',
'彗':'11',
'晦':'11',
'秽':'11',
'惠':'12',
'喙':'12',
'缋':'12',
'慧':'15',
'蕙':'15',
'蟪':'18',
'昏':'8',
'荤':'9',
'阍':'11',
'婚':'11',
'浑':'9',
'馄':'11',
'混':'11',
'魂':'13',
'诨':'8',
'溷':'13',
'耠':'12',
'锪':'13',
'劐':'15',
'豁':'17',
'活':'9',
'火':'4',
'灬':'4',
'伙':'6',
'钬':'9',
'夥':'14',
'或':'8',
'货':'8',
'获':'10',
'祸':'11',
'惑':'12',
'霍':'16',
'镬':'18',
'攉':'19',
'藿':'19',
'嚯':'19',
'蠖':'19',
'丌':'3',
'讥':'4',
'击':'5',
'叽':'5',
'饥':'5',
'玑':'6',
'圾':'6',
'芨':'6',
'机':'6',
'乩':'6',
'肌':'6',
'矶':'7',
'鸡':'7',
'咭':'9',
'剞':'10',
'唧':'10',
'积':'10',
'笄':'10',
'屐':'10',
'姬':'10',
'基':'11',
'赍':'12',
'犄':'12',
'嵇':'12',
'缉':'12',
'畸':'13',
'跻':'13',
'箕':'14',
'稽':'15',
'齑':'15',
'畿':'15',
'墼':'16',
'激':'16',
'羁':'17',
'及':'3',
'吉':'6',
'岌':'6',
'汲':'6',
'级':'6',
'极':'7',
'即':'7',
'佶':'8',
'亟':'8',
'笈':'9',
'急':'9',
'疾':'10',
'棘':'12',
'殛':'12',
'戢':'12',
'集':'12',
'蒺':'13',
'楫':'13',
'辑':'13',
'嵴':'13',
'嫉':'13',
'蕺':'15',
'瘠':'15',
'藉':'17',
'籍':'20',
'几':'2',
'己':'3',
'虮':'8',
'挤':'9',
'脊':'10',
'掎':'11',
'戟':'12',
'麂':'13',
'彐':'3',
'计':'4',
'记':'5',
'伎':'6',
'纪':'6',
'技':'7',
'芰':'7',
'忌':'7',
'际':'7',
'妓':'7',
'季':'8',
'剂':'8',
'哜':'9',
'迹':'9',
'洎':'9',
'济':'9',
'既':'9',
'觊':'10',
'继':'10',
'偈':'11',
'祭':'11',
'悸':'11',
'寄':'11',
'寂':'11',
'绩':'11',
'蓟':'13',
'霁':'14',
'跽':'14',
'鲚':'14',
'暨':'14',
'稷':'15',
'鲫':'15',
'髻':'16',
'冀':'16',
'骥':'19',
'加':'5',
'佳':'8',
'迦':'8',
'珈':'9',
'挟':'9',
'枷':'9',
'浃':'9',
'痂':'10',
'家':'10',
'笳':'11',
'袈':'11',
'葭':'12',
'跏':'12',
'嘉':'14',
'镓':'15',
'夹':'6',
'郏':'8',
'荚':'9',
'恝':'10',
'戛':'11',
'铗':'11',
'袷':'11',
'颊':'12',
'蛱':'12',
'甲':'5',
'岬':'8',
'胛':'9',
'贾':'10',
'钾':'10',
'假':'11',
'瘕':'14',
'价':'6',
'驾':'8',
'架':'9',
'嫁':'13',
'稼':'15',
'戋':'5',
'尖':'6',
'奸':'6',
'歼':'7',
'坚':'7',
'间':'7',
'肩':'8',
'艰':'8',
'监':'10',
'兼':'10',
'菅':'11',
'笺':'11',
'犍':'12',
'湔':'12',
'缄':'12',
'搛':'13',
'蒹':'13',
'煎':'13',
'缣':'13',
'鲣':'15',
'鹣':'15',
'鞯':'18',
'囝':'6',
'拣':'8',
'枧':'8',
'茧':'9',
'柬':'9',
'俭':'9',
'捡':'10',
'笕':'10',
'检':'11',
'趼':'11',
'减':'11',
'剪':'11',
'硷':'12',
'睑':'12',
'裥':'12',
'简':'13',
'骞':'13',
'谫':'13',
'戬':'14',
'碱':'14',
'翦':'15',
'蹇':'17',
'謇':'17',
'见':'4',
'件':'6',
'饯':'8',
'建':'8',
'荐':'9',
'贱':'9',
'牮':'9',
'剑':'9',
'健':'10',
'舰':'10',
'涧':'10',
'渐':'11',
'谏':'11',
'楗':'12',
'践':'12',
'锏':'12',
'毽':'12',
'腱':'12',
'溅':'12',
'鉴':'13',
'键':'13',
'僭':'14',
'踺':'15',
'箭':'15',
'江':'6',
'茳':'9',
'将':'9',
'姜':'9',
'豇':'10',
'浆':'10',
'僵':'15',
'缰':'16',
'礓':'18',
'疆':'19',
'讲':'6',
'奖':'9',
'桨':'10',
'蒋':'12',
'耩':'16',
'匠':'6',
'降':'8',
'洚':'9',
'绛':'9',
'酱':'13',
'犟':'16',
'糨':'18',
'艽':'5',
'交':'6',
'郊':'8',
'茭':'9',
'浇':'9',
'娇':'9',
'姣':'9',
'骄':'9',
'胶':'10',
'椒':'12',
'蛟':'12',
'焦':'12',
'跤':'13',
'僬':'14',
'鲛':'14',
'蕉':'15',
'礁':'17',
'鹪':'17',
'嚼':'20',
'纟':'3',
'角':'7',
'佼':'8',
'挢':'9',
'狡':'9',
'饺':'9',
'绞':'9',
'铰':'11',
'矫':'11',
'皎':'11',
'脚':'11',
'搅':'12',
'敫':'13',
'剿':'13',
'徼':'16',
'缴':'16',
'叫':'5',
'觉':'9',
'轿':'10',
'较':'10',
'教':'11',
'窖':'12',
'酵':'14',
'噍':'15',
'醮':'19',
'阶':'6',
'疖':'7',
'皆':'9',
'接':'11',
'秸':'11',
'揭':'12',
'喈':'12',
'嗟':'12',
'街':'12',
'孑':'3',
'节':'5',
'讦':'5',
'劫':'7',
'杰':'8',
'诘':'8',
'拮':'9',
'洁':'9',
'结':'9',
'桀':'10',
'捷':'11',
'婕':'11',
'颉':'12',
'睫':'13',
'截':'14',
'碣':'14',
'鲒':'14',
'竭':'14',
'羯':'15',
'姐':'8',
'解':'13',
'介':'4',
'戒':'7',
'芥':'7',
'届':'8',
'界':'9',
'疥':'9',
'诫':'9',
'蚧':'10',
'借':'10',
'骱':'13',
'巾':'3',
'斤':'4',
'今':'4',
'钅':'5',
'金':'8',
'津':'9',
'衿':'9',
'矜':'9',
'筋':'12',
'襟':'18',
'仅':'4',
'卺':'8',
'紧':'10',
'堇':'11',
'锦':'13',
'谨':'13',
'馑':'14',
'廑':'14',
'瑾':'15',
'槿':'15',
'尽':'6',
'进':'7',
'近':'7',
'妗':'7',
'劲':'7',
'荩':'9',
'晋':'10',
'赆':'10',
'烬':'10',
'浸':'10',
'靳':'13',
'禁':'13',
'缙':'13',
'觐':'15',
'噤':'16',
'茎':'8',
'京':'8',
'泾':'8',
'经':'8',
'荆':'9',
'菁':'11',
'旌':'11',
'惊':'11',
'晶':'12',
'腈':'12',
'睛':'13',
'粳':'13',
'兢':'14',
'精':'14',
'鲸':'16',
'井':'4',
'阱':'6',
'刭':'7',
'肼':'8',
'颈':'11',
'景':'12',
'儆':'14',
'憬':'15',
'警':'19',
'陉':'7',
'径':'8',
'净':'8',
'弪':'8',
'迳':'8',
'胫':'9',
'痉':'10',
'竞':'10',
'竟':'11',
'婧':'11',
'敬':'12',
'靖':'13',
'静':'14',
'境':'14',
'獍':'14',
'镜':'16',
'扃':'9',
'迥':'8',
'炯':'9',
'窘':'12',
'纠':'5',
'鸠':'7',
'究':'7',
'赳':'9',
'阄':'10',
'揪':'12',
'啾':'12',
'鬏':'19',
'九':'2',
'久':'3',
'玖':'7',
'灸':'7',
'韭':'9',
'酒':'10',
'旧':'5',
'臼':'6',
'咎':'8',
'疚':'8',
'柩':'9',
'桕':'10',
'救':'11',
'厩':'11',
'就':'12',
'舅':'13',
'僦':'14',
'鹫':'17',
'拘':'8',
'苴':'8',
'狙':'8',
'居':'8',
'驹':'8',
'疽':'10',
'掬':'11',
'琚':'12',
'椐':'12',
'锔':'12',
'雎':'13',
'裾':'13',
'鞠':'17',
'鞫':'18',
'局':'7',
'桔':'10',
'菊':'11',
'橘':'16',
'咀':'8',
'沮':'8',
'莒':'9',
'矩':'9',
'举':'9',
'榉':'13',
'龃':'13',
'榘':'13',
'踽':'16',
'巨':'4',
'句':'5',
'讵':'6',
'拒':'7',
'苣':'7',
'具':'8',
'炬':'8',
'钜':'9',
'俱':'10',
'倨':'10',
'剧':'10',
'据':'11',
'距':'11',
'惧':'11',
'犋':'12',
'飓':'12',
'锯':'13',
'聚':'14',
'窭':'14',
'踞':'15',
'屦':'15',
'遽':'16',
'醵':'20',
'捐':'10',
'涓':'10',
'娟':'10',
'鹃':'12',
'镌':'15',
'蠲':'23',
'卷':'8',
'锩':'13',
'倦':'10',
'狷':'10',
'桊':'10',
'绢':'10',
'鄄':'11',
'眷':'11',
'撅':'15',
'噘':'15',
'孓':'3',
'决':'6',
'诀':'6',
'抉':'7',
'珏':'9',
'绝':'9',
'掘':'11',
'桷':'11',
'崛':'11',
'觖':'11',
'厥':'12',
'劂':'14',
'谲':'14',
'蕨':'15',
'獗':'15',
'橛':'16',
'镢':'17',
'爵':'17',
'蹶':'19',
'矍':'20',
'爝':'21',
'攫':'23',
'倔':'10',
'军':'6',
'均':'7',
'君':'7',
'钧':'9',
'菌':'11',
'皲':'11',
'筠':'13',
'麇':'16',
'俊':'9',
'郡':'9',
'捃':'10',
'峻':'10',
'隽':'10',
'浚':'10',
'骏':'10',
'竣':'12',
'咔':'8',
'咖':'8',
'喀':'12',
'卡':'5',
'佧':'7',
'胩':'9',
'开':'4',
'揩':'12',
'锎':'12',
'剀':'8',
'凯':'8',
'垲':'9',
'恺':'9',
'铠':'11',
'蒈':'12',
'慨':'12',
'楷':'13',
'锴':'14',
'忾':'7',
'刊':'5',
'勘':'11',
'龛':'11',
'堪':'12',
'戡':'13',
'坎':'7',
'侃':'8',
'砍':'9',
'莰':'10',
'槛':'14',
'看':'9',
'阚':'14',
'瞰':'16',
'闶':'7',
'康':'11',
'慷':'14',
'糠':'17',
'扛':'6',
'亢':'4',
'伉':'6',
'抗':'7',
'炕':'8',
'钪':'9',
'尻':'5',
'考':'6',
'拷':'9',
'栲':'10',
'烤':'10',
'铐':'11',
'犒':'14',
'靠':'15',
'苛':'8',
'珂':'9',
'柯':'9',
'轲':'9',
'科':'9',
'钶':'10',
'疴':'10',
'蚵':'11',
'棵':'12',
'颏':'12',
'嗑':'13',
'稞':'13',
'窠':'13',
'颗':'14',
'磕':'15',
'瞌':'15',
'蝌':'15',
'髁':'17',
'壳':'7',
'咳':'9',
'可':'5',
'坷':'8',
'岢':'8',
'渴':'12',
'克':'7',
'刻':'8',
'恪':'9',
'客':'9',
'课':'10',
'氪':'11',
'骒':'11',
'缂':'12',
'锞':'13',
'溘':'13',
'肯':'8',
'垦':'9',
'恳':'10',
'啃':'11',
'裉':'11',
'坑':'7',
'吭':'7',
'铿':'12',
'空':'8',
'倥':'10',
'崆':'11',
'箜':'14',
'孔':'4',
'恐':'10',
'控':'11',
'抠':'7',
'芤':'7',
'眍':'9',
'口':'3',
'叩':'5',
'扣':'6',
'寇':'11',
'筘':'12',
'蔻':'14',
'刳':'8',
'枯':'9',
'哭':'10',
'堀':'11',
'窟':'13',
'骷':'14',
'苦':'8',
'库':'7',
'绔':'9',
'喾':'12',
'裤':'12',
'酷':'14',
'夸':'6',
'侉':'8',
'垮':'9',
'挎':'9',
'胯':'10',
'跨':'13',
'蒯':'13',
'块':'7',
'快':'7',
'侩':'8',
'郐':'8',
'哙':'9',
'狯':'9',
'脍':'10',
'筷':'13',
'宽':'10',
'髋':'19',
'款':'12',
'匡':'6',
'诓':'8',
'哐':'9',
'筐':'12',
'狂':'7',
'诳':'9',
'夼':'6',
'邝':'5',
'圹':'6',
'纩':'6',
'旷':'7',
'况':'7',
'矿':'8',
'贶':'9',
'框':'10',
'眶':'11',
'亏':'3',
'岿':'8',
'悝':'10',
'盔':'11',
'窥':'13',
'奎':'9',
'逵':'11',
'馗':'11',
'揆':'12',
'葵':'12',
'喹':'12',
'暌':'13',
'魁':'13',
'睽':'14',
'蝰':'15',
'夔':'21',
'傀':'11',
'跬':'13',
'匮':'11',
'蒉':'12',
'喟':'12',
'馈':'12',
'溃':'12',
'愦':'12',
'愧':'12',
'聩':'15',
'篑':'15',
'坤':'8',
'昆':'8',
'琨':'12',
'髡':'13',
'锟':'13',
'醌':'15',
'鲲':'16',
'捆':'10',
'阃':'10',
'悃':'10',
'困':'7',
'扩':'6',
'括':'9',
'栝':'10',
'蛞':'12',
'阔':'12',
'廓':'13',
'垃':'8',
'拉':'8',
'啦':'11',
'邋':'18',
'旯':'6',
'剌':'9',
'砬':'10',
'喇':'12',
'腊':'12',
'蜡':'14',
'瘌':'14',
'辣':'14',
'来':'7',
'莱':'10',
'崃':'10',
'徕':'10',
'涞':'10',
'铼':'12',
'赉':'11',
'睐':'12',
'赖':'13',
'濑':'16',
'癞':'18',
'籁':'19',
'兰':'5',
'岚':'7',
'拦':'8',
'栏':'9',
'婪':'11',
'阑':'12',
'蓝':'13',
'谰':'14',
'澜':'15',
'褴':'15',
'篮':'16',
'斓':'16',
'镧':'17',
'览':'9',
'揽':'12',
'缆':'12',
'榄':'13',
'罱':'14',
'漤':'14',
'懒':'16',
'烂':'9',
'滥':'13',
'啷':'11',
'郎':'8',
'狼':'10',
'阆':'10',
'琅':'11',
'廊':'11',
'榔':'12',
'锒':'12',
'稂':'12',
'螂':'14',
'朗':'10',
'浪':'10',
'蒗':'13',
'捞':'10',
'劳':'7',
'牢':'7',
'崂':'10',
'铹':'12',
'痨':'12',
'醪':'18',
'老':'6',
'佬':'8',
'姥':'9',
'栳':'10',
'铑':'11',
'唠':'10',
'烙':'10',
'涝':'10',
'耢':'13',
'酪':'13',
'仂':'4',
'叻':'5',
'乐':'5',
'泐':'7',
'勒':'11',
'鳓':'19',
'了':'2',
'雷':'13',
'嫘':'14',
'缧':'14',
'檑':'17',
'镭':'18',
'羸':'19',
'耒':'6',
'诔':'8',
'垒':'9',
'磊':'15',
'蕾':'16',
'儡':'17',
'肋':'6',
'泪':'8',
'类':'9',
'累':'11',
'酹':'14',
'擂':'16',
'嘞':'14',
'塄':'12',
'棱':'12',
'楞':'13',
'冷':'7',
'愣':'12',
'厘':'9',
'狸':'10',
'离':'10',
'骊':'10',
'梨':'11',
'犁':'11',
'鹂':'12',
'喱':'12',
'蓠':'13',
'蜊':'13',
'漓':'13',
'缡':'13',
'璃':'14',
'嫠':'14',
'黎':'15',
'鲡':'15',
'罹':'16',
'篱':'16',
'藜':'18',
'黧':'20',
'蠡':'21',
'礼':'5',
'李':'7',
'里':'7',
'俚':'9',
'逦':'10',
'哩':'10',
'娌':'10',
'理':'11',
'锂':'12',
'鲤':'15',
'澧':'16',
'醴':'20',
'鳢':'21',
'力':'2',
'历':'4',
'厉':'5',
'立':'5',
'吏':'6',
'坜':'7',
'苈':'7',
'丽':'7',
'励':'7',
'呖':'7',
'利':'7',
'沥':'7',
'枥':'8',
'例':'8',
'疠':'8',
'戾':'8',
'隶':'8',
'荔':'9',
'栎':'9',
'郦':'9',
'轹':'9',
'俪':'9',
'俐':'9',
'疬':'9',
'莉':'10',
'莅':'10',
'栗':'10',
'砺':'10',
'砾':'10',
'猁':'10',
'蛎':'11',
'唳':'11',
'笠':'11',
'粝':'11',
'粒':'11',
'雳':'12',
'跞':'12',
'詈':'12',
'傈':'12',
'痢':'12',
'溧':'13',
'篥':'16',
'奁':'7',
'连':'7',
'怜':'8',
'帘':'8',
'莲':'10',
'涟':'10',
'联':'12',
'裢':'12',
'廉':'13',
'鲢':'15',
'濂':'16',
'臁':'17',
'镰':'18',
'蠊':'19',
'琏':'11',
'敛':'11',
'脸':'11',
'裣':'12',
'蔹':'14',
'练':'8',
'炼':'9',
'恋':'10',
'殓':'11',
'链':'12',
'楝':'13',
'潋':'14',
'良':'7',
'莨':'10',
'凉':'10',
'梁':'11',
'椋':'12',
'粮':'13',
'粱':'13',
'墚':'14',
'冫':'2',
'两':'7',
'俩':'9',
'魉':'16',
'亮':'9',
'谅':'10',
'辆':'11',
'靓':'12',
'量':'12',
'晾':'12',
'踉':'14',
'辽':'5',
'疗':'7',
'聊':'11',
'僚':'14',
'寥':'14',
'撩':'15',
'嘹':'15',
'獠':'15',
'潦':'15',
'寮':'15',
'缭':'15',
'燎':'16',
'鹩':'17',
'钌':'7',
'蓼':'14',
'尥':'6',
'料':'10',
'撂':'14',
'廖':'14',
'镣':'17',
'咧':'9',
'列':'6',
'劣':'6',
'冽':'8',
'洌':'9',
'埒':'10',
'烈':'10',
'捩':'11',
'猎':'11',
'裂':'12',
'趔':'13',
'躐':'22',
'鬣':'25',
'拎':'8',
'邻':'7',
'林':'8',
'临':'9',
'啉':'11',
'淋':'11',
'琳':'12',
'粼':'14',
'嶙':'15',
'遴':'15',
'霖':'16',
'辚':'16',
'磷':'17',
'瞵':'17',
'鳞':'20',
'麟':'23',
'凛':'15',
'廪':'16',
'懔':'16',
'檩':'17',
'吝':'7',
'赁':'10',
'蔺':'14',
'膦':'16',
'躏':'21',
'伶':'7',
'灵':'7',
'苓':'8',
'囹':'8',
'泠':'8',
'玲':'9',
'柃':'9',
'瓴':'9',
'铃':'10',
'凌':'10',
'陵':'10',
'聆':'11',
'菱':'11',
'棂':'11',
'蛉':'11',
'翎':'11',
'羚':'11',
'绫':'11',
'零':'13',
'龄':'13',
'鲮':'16',
'酃':'19',
'岭':'8',
'领':'11',
'另':'5',
'令':'5',
'呤':'8',
'溜':'13',
'熘':'14',
'刘':'6',
'浏':'9',
'留':'10',
'流':'10',
'琉':'11',
'硫':'12',
'馏':'13',
'旒':'13',
'骝':'13',
'榴':'14',
'镏':'15',
'瘤':'15',
'鎏':'18',
'柳':'9',
'绺':'11',
'锍':'12',
'六':'4',
'遛':'13',
'鹨':'16',
'龙':'5',
'茏':'8',
'咙':'8',
'泷':'8',
'珑':'9',
'栊':'9',
'胧':'9',
'砻':'10',
'聋':'11',
'笼':'11',
'隆':'11',
'癃':'16',
'窿':'16',
'陇':'7',
'垅':'8',
'拢':'8',
'垄':'8',
'娄':'9',
'偻':'11',
'蒌':'12',
'楼':'13',
'耧':'15',
'蝼':'15',
'髅':'18',
'搂':'12',
'嵝':'12',
'篓':'15',
'陋':'8',
'镂':'14',
'瘘':'14',
'漏':'14',
'喽':'12',
'撸':'15',
'噜':'15',
'氇':'16',
'卢':'5',
'芦':'7',
'庐':'7',
'垆':'8',
'炉':'8',
'泸':'8',
'栌':'9',
'轳':'9',
'胪':'9',
'鸬':'10',
'颅':'11',
'舻':'11',
'鲈':'13',
'卤':'7',
'虏':'8',
'掳':'11',
'鲁':'12',
'橹':'16',
'镥':'17',
'陆':'7',
'录':'8',
'辂':'10',
'赂':'10',
'鹿':'11',
'渌':'11',
'逯':'11',
'禄':'12',
'碌':'13',
'路':'13',
'漉':'14',
'辘':'15',
'戮':'15',
'潞':'16',
'璐':'17',
'簏':'17',
'鹭':'18',
'麓':'19',
'露':'21',
'峦':'9',
'孪':'9',
'娈':'9',
'栾':'10',
'挛':'10',
'鸾':'11',
'脔':'12',
'滦':'13',
'銮':'14',
'卵':'7',
'乱':'7',
'掠':'11',
'抡':'7',
'仑':'4',
'伦':'6',
'囵':'7',
'沦':'7',
'纶':'7',
'轮':'8',
'论':'6',
'罗':'8',
'萝':'11',
'逻':'11',
'脶':'11',
'猡':'11',
'椤':'12',
'锣':'13',
'箩':'14',
'骡':'14',
'镙':'16',
'螺':'17',
'倮':'10',
'裸':'13',
'瘰':'16',
'蠃':'19',
'泺':'8',
'荦':'9',
'洛':'9',
'络':'9',
'骆':'9',
'珞':'10',
'落':'12',
'摞':'14',
'雒':'14',
'漯':'14',
'驴':'7',
'闾':'9',
'榈':'13',
'吕':'6',
'侣':'8',
'捋':'10',
'旅':'10',
'铝':'11',
'稆':'11',
'屡':'12',
'缕':'12',
'膂':'14',
'褛':'14',
'履':'15',
'律':'9',
'虑':'10',
'率':'11',
'绿':'11',
'氯':'12',
'滤':'13',
'略':'11',
'锊':'12',
'妈':'6',
'麻':'11',
'蟆':'16',
'马':'3',
'犸':'6',
'玛':'7',
'码':'8',
'蚂':'9',
'杩':'7',
'骂':'9',
'吗':'6',
'嘛':'14',
'埋':'10',
'霾':'22',
'买':'6',
'荬':'9',
'劢':'5',
'迈':'6',
'麦':'7',
'卖':'8',
'脉':'9',
'唛':'10',
'颟':'16',
'蛮':'12',
'馒':'14',
'瞒':'15',
'鞔':'16',
'鳗':'19',
'满':'13',
'螨':'16',
'曼':'11',
'谩':'13',
'墁':'14',
'蔓':'14',
'幔':'14',
'漫':'14',
'慢':'14',
'缦':'14',
'熳':'15',
'镘':'16',
'邙':'5',
'芒':'6',
'忙':'6',
'盲':'8',
'氓':'8',
'茫':'9',
'硭':'11',
'莽':'10',
'漭':'13',
'蟒':'16',
'猫':'11',
'毛':'4',
'矛':'5',
'茆':'8',
'茅':'8',
'牦':'8',
'旄':'10',
'锚':'13',
'髦':'14',
'蝥':'15',
'蟊':'17',
'卯':'5',
'峁':'8',
'泖':'8',
'昴':'9',
'铆':'10',
'茂':'8',
'冒':'9',
'贸':'9',
'耄':'10',
'袤':'11',
'帽':'12',
'瑁':'13',
'貌':'14',
'瞀':'14',
'懋':'17',
'么':'3',
'麽':'14',
'没':'7',
'玫':'8',
'枚':'8',
'眉':'9',
'莓':'10',
'梅':'11',
'嵋':'12',
'猸':'12',
'湄':'12',
'媒':'12',
'楣':'13',
'煤':'13',
'酶':'14',
'镅':'14',
'鹛':'14',
'霉':'15',
'每':'7',
'美':'9',
'浼':'10',
'镁':'14',
'妹':'8',
'昧':'9',
'袂':'9',
'寐':'12',
'媚':'12',
'魅':'14',
'门':'3',
'扪':'6',
'钔':'8',
'闷':'7',
'焖':'11',
'懑':'17',
'们':'5',
'虻':'9',
'萌':'11',
'蒙':'13',
'盟':'13',
'甍':'14',
'瞢':'15',
'檬':'17',
'朦':'17',
'礞':'18',
'艨':'19',
'勐':'10',
'猛':'11',
'锰':'13',
'蜢':'14',
'艋':'14',
'懵':'18',
'蠓':'19',
'孟':'8',
'梦':'11',
'咪':'9',
'眯':'11',
'弥':'8',
'迷':'9',
'祢':'9',
'猕':'11',
'谜':'11',
'醚':'16',
'糜':'17',
'縻':'17',
'麋':'17',
'靡':'19',
'蘼':'22',
'米':'6',
'芈':'7',
'弭':'9',
'脒':'10',
'敉':'10',
'糸':'6',
'汨':'7',
'觅':'8',
'泌':'8',
'宓':'8',
'秘':'10',
'密':'11',
'幂':'12',
'谧':'12',
'嘧':'14',
'蜜':'14',
'眠':'10',
'绵':'11',
'棉':'12',
'免':'7',
'沔':'7',
'黾':'8',
'眄':'9',
'勉':'9',
'娩':'10',
'冕':'11',
'渑':'11',
'湎':'12',
'缅':'12',
'腼':'13',
'面':'9',
'喵':'11',
'苗':'8',
'描':'11',
'鹋':'13',
'瞄':'13',
'杪':'8',
'眇':'9',
'秒':'9',
'淼':'12',
'渺':'12',
'缈':'12',
'藐':'17',
'邈':'17',
'妙':'7',
'庙':'8',
'咩':'9',
'灭':'5',
'蔑':'14',
'篾':'17',
'蠛':'20',
'民':'5',
'玟':'8',
'苠':'8',
'岷':'8',
'珉':'9',
'缗':'12',
'皿':'5',
'闵':'7',
'抿':'8',
'泯':'8',
'闽':'9',
'悯':'10',
'敏':'11',
'愍':'13',
'鳘':'19',
'名':'6',
'明':'8',
'鸣':'8',
'茗':'9',
'冥':'10',
'铭':'11',
'溟':'13',
'暝':'14',
'瞑':'15',
'螟':'16',
'酩':'13',
'命':'8',
'谬':'13',
'缪':'14',
'摸':'13',
'谟':'12',
'馍':'13',
'嫫':'13',
'摹':'14',
'模':'14',
'膜':'14',
'摩':'15',
'磨':'16',
'蘑':'19',
'魔':'20',
'抹':'8',
'末':'5',
'茉':'8',
'殁':'8',
'沫':'8',
'陌':'8',
'莫':'10',
'秣':'10',
'蓦':'13',
'貊':'13',
'貉':'13',
'漠':'13',
'寞':'13',
'墨':'15',
'镆':'15',
'瘼':'15',
'默':'16',
'貘':'17',
'耱':'22',
'嬷':'17',
'哞':'9',
'牟':'6',
'侔':'8',
'眸':'11',
'谋':'11',
'蛑':'12',
'鍪':'17',
'某':'9',
'呒':'7',
'毪':'10',
'母':'5',
'牡':'7',
'亩':'7',
'坶':'8',
'拇':'8',
'姆':'8',
'木':'4',
'目':'5',
'仫':'5',
'沐':'7',
'苜':'8',
'牧':'8',
'钼':'10',
'募':'12',
'墓':'13',
'幕':'13',
'睦':'13',
'慕':'14',
'暮':'14',
'穆':'16',
'拿':'10',
'镎':'15',
'哪':'9',
'那':'6',
'呐':'7',
'纳':'7',
'肭':'8',
'钠':'9',
'衲':'9',
'娜':'9',
'捺':'11',
'乃':'2',
'艿':'5',
'奶':'5',
'氖':'6',
'奈':'8',
'柰':'9',
'耐':'9',
'萘':'11',
'鼐':'14',
'囡':'6',
'男':'7',
'南':'9',
'难':'10',
'喃':'12',
'楠':'13',
'赧':'11',
'腩':'13',
'蝻':'15',
'囔':'25',
'囊':'22',
'馕':'25',
'曩':'21',
'攮':'25',
'孬':'10',
'呶':'8',
'挠':'9',
'硇':'11',
'铙':'11',
'蛲':'12',
'猱':'12',
'垴':'9',
'恼':'9',
'脑':'10',
'瑙':'13',
'闹':'8',
'淖':'11',
'讷':'6',
'呢':'8',
'馁':'10',
'内':'4',
'嫩':'14',
'能':'10',
'妮':'8',
'尼':'5',
'坭':'8',
'泥':'8',
'怩':'8',
'铌':'10',
'倪':'10',
'猊':'11',
'霓':'16',
'鲵':'16',
'拟':'7',
'你':'7',
'旎':'11',
'伲':'7',
'昵':'9',
'逆':'9',
'匿':'10',
'睨':'13',
'腻':'13',
'溺':'13',
'拈':'8',
'蔫':'14',
'年':'6',
'鲇':'13',
'鲶':'16',
'黏':'17',
'捻':'11',
'辇':'12',
'撵':'15',
'碾':'15',
'廿':'4',
'念':'8',
'埝':'11',
'娘':'10',
'酿':'14',
'鸟':'5',
'茑':'8',
'袅':'10',
'嬲':'17',
'尿':'7',
'脲':'11',
'捏':'10',
'乜':'2',
'肀':'4',
'陧':'9',
'聂':'10',
'臬':'10',
'涅':'10',
'啮':'11',
'嗫':'13',
'镊':'15',
'镍':'15',
'颞':'16',
'蹑':'17',
'孽':'19',
'蘖':'20',
'恁':'10',
'您':'11',
'宁':'5',
'咛':'8',
'狞':'8',
'柠':'9',
'聍':'11',
'甯':'12',
'凝':'16',
'拧':'8',
'佞':'7',
'泞':'8',
'妞':'7',
'牛':'4',
'扭':'7',
'狃':'7',
'忸':'7',
'纽':'7',
'钮':'9',
'拗':'8',
'农':'6',
'侬':'8',
'哝':'9',
'浓':'9',
'脓':'10',
'弄':'7',
'耨':'16',
'奴':'5',
'孥':'8',
'驽':'8',
'努':'7',
'弩':'8',
'胬':'11',
'怒':'9',
'暖':'13',
'疟':'8',
'虐':'9',
'挪':'9',
'傩':'12',
'诺':'10',
'喏':'11',
'搦':'13',
'锘':'13',
'懦':'17',
'糯':'20',
'女':'3',
'钕':'8',
'恧':'10',
'衄':'10',
'噢':'15',
'哦':'10',
'讴':'6',
'沤':'7',
'瓯':'8',
'欧':'8',
'殴':'8',
'鸥':'9',
'呕':'7',
'偶':'11',
'耦':'15',
'藕':'18',
'怄':'7',
'趴':'9',
'啪':'11',
'葩':'12',
'杷':'8',
'爬':'8',
'钯':'9',
'耙':'10',
'琶':'12',
'筢':'13',
'帕':'8',
'怕':'8',
'拍':'8',
'俳':'10',
'排':'11',
'徘':'11',
'牌':'12',
'哌':'9',
'派':'9',
'蒎':'12',
'湃':'12',
'潘':'15',
'攀':'19',
'爿':'4',
'盘':'11',
'磐':'15',
'蹒':'17',
'蟠':'18',
'判':'7',
'泮':'8',
'盼':'9',
'叛':'9',
'畔':'10',
'袢':'10',
'襻':'24',
'乓':'6',
'滂':'13',
'彷':'7',
'庞':'8',
'逄':'9',
'旁':'10',
'膀':'14',
'螃':'16',
'耪':'16',
'胖':'9',
'抛':'7',
'脬':'11',
'刨':'7',
'咆':'8',
'狍':'8',
'庖':'8',
'袍':'10',
'匏':'11',
'跑':'12',
'泡':'8',
'炮':'9',
'疱':'10',
'呸':'8',
'胚':'9',
'醅':'15',
'陪':'10',
'培':'11',
'赔':'12',
'锫':'13',
'裴':'14',
'沛':'7',
'帔':'8',
'佩':'8',
'配':'10',
'旆':'10',
'淠':'11',
'辔':'13',
'霈':'15',
'喷':'12',
'盆':'9',
'湓':'12',
'抨':'8',
'怦':'8',
'砰':'10',
'烹':'11',
'嘭':'15',
'朋':'8',
'堋':'11',
'彭':'12',
'棚':'12',
'蓬':'13',
'硼':'13',
'鹏':'13',
'澎':'15',
'篷':'16',
'膨':'16',
'蟛':'18',
'捧':'11',
'碰':'13',
'丕':'5',
'批':'7',
'邳':'7',
'纰':'7',
'坯':'8',
'披':'8',
'砒':'9',
'劈':'15',
'噼':'16',
'霹':'21',
'皮':'5',
'芘':'7',
'枇':'8',
'毗':'9',
'蚍':'10',
'铍':'10',
'郫':'10',
'疲':'10',
'陴':'10',
'埤':'11',
'啤':'11',
'琵':'12',
'脾':'12',
'蜱':'14',
'罴':'14',
'貔':'17',
'鼙':'21',
'匹':'4',
'庀':'5',
'圮':'6',
'仳':'6',
'痞':'12',
'擗':'16',
'癖':'18',
'屁':'7',
'睥':'13',
'辟':'13',
'媲':'13',
'僻':'15',
'甓':'17',
'譬':'20',
'偏':'11',
'犏':'13',
'篇':'15',
'翩':'15',
'骈':'9',
'胼':'10',
'蹁':'16',
'谝':'11',
'片':'4',
'骗':'12',
'剽':'13',
'漂':'14',
'缥':'14',
'飘':'15',
'螵':'17',
'嫖':'14',
'瓢':'16',
'殍':'11',
'瞟':'16',
'票':'11',
'嘌':'14',
'氕':'5',
'瞥':'16',
'丿':'1',
'苤':'8',
'撇':'14',
'拚':'8',
'拼':'9',
'姘':'9',
'贫':'8',
'频':'13',
'嫔':'13',
'颦':'21',
'品':'9',
'榀':'13',
'牝':'6',
'聘':'13',
'乒':'6',
'俜':'9',
'娉':'10',
'冖':'2',
'平':'5',
'评':'7',
'坪':'8',
'苹':'8',
'凭':'8',
'枰':'9',
'屏':'9',
'瓶':'10',
'萍':'11',
'鲆':'13',
'攴':'4',
'钋':'7',
'坡':'8',
'泼':'8',
'颇':'11',
'婆':'11',
'鄱':'14',
'皤':'17',
'叵':'5',
'钷':'10',
'笸':'11',
'迫':'8',
'珀':'9',
'破':'10',
'粕':'11',
'魄':'14',
'剖':'10',
'掊':'11',
'裒':'12',
'扑':'5',
'铺':'12',
'噗':'15',
'仆':'4',
'匍':'9',
'莆':'10',
'菩':'11',
'脯':'11',
'葡':'12',
'蒲':'13',
'璞':'16',
'镤':'17',
'濮':'17',
'朴':'6',
'埔':'10',
'圃':'10',
'浦':'10',
'普':'12',
'溥':'13',
'谱':'14',
'氆':'16',
'镨':'17',
'蹼':'19',
'瀑':'18',
'曝':'19',
'七':'2',
'沏':'7',
'妻':'8',
'柒':'9',
'栖':'10',
'桤':'10',
'凄':'10',
'萋':'11',
'戚':'11',
'期':'12',
'欺':'12',
'嘁':'14',
'漆':'14',
'蹊':'17',
'亓':'4',
'齐':'6',
'祁':'6',
'圻':'7',
'芪':'7',
'岐':'7',
'其':'8',
'奇':'8',
'歧':'8',
'祈':'8',
'荠':'9',
'耆':'10',
'颀':'10',
'脐':'10',
'萁':'11',
'畦':'11',
'崎':'11',
'淇':'11',
'骐':'11',
'骑':'11',
'琪':'12',
'琦':'12',
'棋':'12',
'蛴':'12',
'祺':'12',
'綦':'14',
'蜞':'14',
'旗':'14',
'蕲':'15',
'鳍':'18',
'麒':'19',
'乞':'3',
'芑':'6',
'屺':'6',
'岂':'6',
'企':'6',
'杞':'7',
'启':'7',
'起':'10',
'绮':'11',
'綮':'14',
'气':'4',
'讫':'5',
'迄':'6',
'汔':'6',
'弃':'7',
'汽':'7',
'泣':'8',
'契':'9',
'砌':'9',
'葺':'12',
'碛':'13',
'槭':'15',
'器':'16',
'憩':'16',
'掐':'11',
'葜':'12',
'洽':'9',
'恰':'9',
'髂':'18',
'千':'3',
'仟':'5',
'阡':'5',
'扦':'6',
'芊':'6',
'迁':'6',
'岍':'7',
'佥':'7',
'钎':'8',
'牵':'9',
'铅':'10',
'悭':'10',
'谦':'12',
'签':'13',
'愆':'13',
'搴':'14',
'褰':'16',
'钤':'9',
'前':'9',
'虔':'10',
'钱':'10',
'钳':'10',
'掮':'11',
'乾':'11',
'箝':'14',
'潜':'15',
'黔':'16',
'凵':'2',
'肷':'8',
'浅':'8',
'遣':'13',
'谴':'15',
'缱':'16',
'欠':'4',
'芡':'7',
'茜':'9',
'倩':'10',
'堑':'11',
'椠':'12',
'嵌':'12',
'慊':'13',
'歉':'14',
'羌':'7',
'枪':'8',
'戗':'8',
'戕':'8',
'腔':'12',
'蜣':'13',
'锖':'13',
'锵':'14',
'强':'12',
'墙':'14',
'蔷':'14',
'嫱':'14',
'樯':'15',
'抢':'7',
'羟':'11',
'镪':'17',
'襁':'17',
'呛':'7',
'炝':'8',
'跄':'11',
'悄':'10',
'硗':'11',
'跷':'13',
'锹':'14',
'劁':'14',
'敲':'14',
'橇':'16',
'缲':'16',
'乔':'6',
'侨':'8',
'荞':'9',
'峤':'9',
'桥':'10',
'谯':'14',
'鞒':'15',
'憔':'15',
'樵':'16',
'瞧':'17',
'巧':'5',
'愀':'12',
'俏':'9',
'诮':'9',
'峭':'10',
'窍':'10',
'翘':'12',
'撬':'15',
'鞘':'16',
'切':'4',
'茄':'8',
'且':'5',
'郄':'8',
'妾':'8',
'怯':'8',
'窃':'9',
'挈':'10',
'惬':'11',
'趄':'12',
'锲':'14',
'箧':'14',
'钦':'9',
'侵':'9',
'亲':'9',
'衾':'10',
'芹':'7',
'芩':'7',
'秦':'10',
'琴':'12',
'禽':'12',
'勤':'13',
'嗪':'13',
'溱':'13',
'擒':'15',
'噙':'15',
'檎':'16',
'螓':'16',
'锓':'12',
'寝':'13',
'吣':'7',
'沁':'7',
'揿':'12',
'青':'8',
'轻':'9',
'氢':'9',
'倾':'10',
'卿':'10',
'圊':'11',
'清':'11',
'蜻':'14',
'鲭':'16',
'情':'11',
'晴':'12',
'氰':'12',
'檠':'16',
'擎':'16',
'黥':'20',
'苘':'8',
'顷':'8',
'请':'10',
'謦':'18',
'庆':'6',
'箐':'14',
'磬':'16',
'罄':'17',
'邛':'5',
'穷':'7',
'茕':'8',
'穹':'8',
'筇':'11',
'琼':'12',
'蛩':'12',
'跫':'13',
'銎':'14',
'丘':'5',
'邱':'7',
'秋':'9',
'蚯':'11',
'湫':'12',
'楸':'13',
'鳅':'17',
'囚':'5',
'犰':'5',
'求':'7',
'虬':'7',
'泅':'8',
'俅':'9',
'酋':'9',
'逑':'10',
'球':'11',
'赇':'11',
'遒':'12',
'巯':'12',
'裘':'13',
'蝤':'15',
'鼽':'16',
'糗':'16',
'区':'4',
'岖':'7',
'诎':'7',
'驱':'7',
'屈':'8',
'祛':'9',
'蛆':'11',
'躯':'11',
'趋':'12',
'蛐':'12',
'麴':'19',
'黢':'19',
'劬':'7',
'朐':'9',
'鸲':'10',
'渠':'11',
'蕖':'14',
'磲':'16',
'璩':'17',
'瞿':'18',
'蘧':'19',
'氍':'22',
'癯':'23',
'衢':'24',
'蠼':'26',
'曲':'6',
'取':'8',
'娶':'11',
'龋':'17',
'去':'5',
'阒':'12',
'趣':'15',
'觑':'15',
'悛':'10',
'圈':'11',
'权':'6',
'全':'6',
'诠':'8',
'荃':'9',
'泉':'9',
'辁':'10',
'拳':'10',
'铨':'11',
'痊':'11',
'筌':'12',
'蜷':'14',
'醛':'16',
'鬈':'18',
'颧':'23',
'犬':'4',
'畎':'9',
'绻':'11',
'劝':'4',
'券':'8',
'炔':'8',
'缺':'10',
'瘸':'16',
'却':'7',
'悫':'11',
'雀':'11',
'确':'12',
'阕':'12',
'鹊':'13',
'阙':'13',
'榷':'14',
'逡':'10',
'裙':'12',
'群':'13',
'蚺':'11',
'然':'12',
'髯':'15',
'燃':'16',
'冉':'5',
'苒':'8',
'染':'9',
'禳':'21',
'穰':'22',
'瓤':'22',
'壤':'20',
'攘':'20',
'嚷':'20',
'让':'5',
'荛':'9',
'饶':'9',
'娆':'9',
'桡':'10',
'扰':'7',
'绕':'9',
'惹':'12',
'热':'10',
'人':'2',
'壬':'4',
'仁':'4',
'忍':'7',
'荏':'9',
'稔':'13',
'刃':'3',
'认':'4',
'仞':'5',
'任':'6',
'纫':'6',
'韧':'7',
'轫':'7',
'饪':'7',
'妊':'7',
'衽':'9',
'扔':'5',
'仍':'4',
'日':'4',
'戎':'6',
'肜':'7',
'茸':'9',
'荣':'9',
'狨':'9',
'绒':'9',
'容':'10',
'嵘':'12',
'蓉':'13',
'溶':'13',
'榕':'14',
'熔':'14',
'蝾':'15',
'融':'16',
'冗':'4',
'柔':'9',
'揉':'12',
'糅':'15',
'蹂':'16',
'鞣':'18',
'肉':'6',
'如':'6',
'茹':'9',
'铷':'11',
'儒':'16',
'薷':'17',
'嚅':'17',
'濡':'17',
'孺':'17',
'襦':'19',
'颥':'20',
'蠕':'20',
'汝':'6',
'乳':'8',
'辱':'10',
'入':'2',
'洳':'9',
'蓐':'13',
'溽':'13',
'缛':'13',
'褥':'15',
'阮':'6',
'软':'8',
'朊':'8',
'蕤':'15',
'蕊':'15',
'芮':'7',
'枘':'8',
'蚋':'10',
'锐':'12',
'瑞':'13',
'睿':'14',
'闰':'7',
'润':'10',
'若':'8',
'偌':'10',
'弱':'10',
'箬':'14',
'仨':'5',
'洒':'9',
'撒':'15',
'卅':'4',
'飒':'9',
'脎':'10',
'萨':'11',
'腮':'13',
'塞':'13',
'噻':'16',
'鳃':'17',
'赛':'14',
'三':'3',
'彡':'3',
'氵':'3',
'叁':'8',
'毵':'12',
'伞':'6',
'糁':'14',
'馓':'15',
'散':'12',
'桑':'10',
'搡':'13',
'嗓':'13',
'磉':'15',
'颡':'16',
'丧':'8',
'搔':'12',
'骚':'12',
'缫':'14',
'鳋':'17',
'扫':'6',
'嫂':'12',
'埽':'11',
'瘙':'14',
'臊':'17',
'色':'6',
'涩':'10',
'啬':'11',
'铯':'11',
'瑟':'13',
'穑':'16',
'森':'12',
'僧':'14',
'杀':'6',
'沙':'7',
'纱':'7',
'砂':'9',
'莎':'10',
'铩':'11',
'痧':'12',
'裟':'13',
'鲨':'15',
'啥':'11',
'傻':'13',
'唼':'11',
'厦':'12',
'歃':'13',
'煞':'13',
'霎':'16',
'筛':'12',
'酾':'14',
'晒':'10',
'山':'3',
'芟':'7',
'杉':'7',
'删':'7',
'苫':'8',
'钐':'8',
'衫':'8',
'姗':'8',
'珊':'9',
'埏':'9',
'舢':'9',
'跚':'12',
'煽':'14',
'潸':'15',
'膻':'17',
'闪':'5',
'陕':'8',
'讪':'5',
'汕':'6',
'疝':'8',
'扇':'10',
'善':'12',
'骟':'13',
'鄯':'14',
'缮':'15',
'擅':'16',
'膳':'16',
'嬗':'16',
'赡':'17',
'蟮':'18',
'鳝':'20',
'伤':'6',
'殇':'9',
'商':'11',
'觞':'12',
'墒':'14',
'熵':'15',
'垧':'9',
'晌':'10',
'赏':'12',
'上':'3',
'尚':'8',
'绱':'11',
'裳':'14',
'捎':'10',
'烧':'10',
'梢':'11',
'稍':'12',
'蛸':'13',
'筲':'13',
'艄':'13',
'勺':'3',
'芍':'6',
'杓':'7',
'韶':'14',
'少':'4',
'邵':'7',
'劭':'7',
'绍':'8',
'哨':'10',
'潲':'15',
'奢':'11',
'赊':'11',
'猞':'11',
'畲':'12',
'舌':'6',
'佘':'7',
'蛇':'11',
'舍':'8',
'厍':'6',
'设':'6',
'社':'7',
'射':'10',
'涉':'10',
'赦':'11',
'摄':'13',
'滠':'13',
'慑':'13',
'麝':'21',
'申':'5',
'伸':'7',
'身':'7',
'呻':'8',
'诜':'8',
'绅':'8',
'莘':'10',
'砷':'10',
'娠':'10',
'深':'11',
'什':'4',
'神':'9',
'沈':'7',
'审':'8',
'哂':'9',
'矧':'9',
'谂':'10',
'渖':'11',
'婶':'11',
'肾':'8',
'甚':'9',
'胂':'9',
'渗':'11',
'葚':'12',
'椹':'13',
'蜃':'13',
'慎':'13',
'升':'4',
'生':'5',
'声':'7',
'牲':'9',
'笙':'11',
'甥':'12',
'绳':'11',
'省':'9',
'眚':'10',
'圣':'5',
'胜':'9',
'晟':'10',
'盛':'11',
'剩':'12',
'嵊':'13',
'尸':'3',
'失':'5',
'师':'6',
'诗':'8',
'虱':'8',
'狮':'9',
'施':'9',
'湿':'12',
'蓍':'13',
'鲺':'16',
'十':'2',
'饣':'3',
'石':'5',
'时':'7',
'识':'7',
'实':'8',
'拾':'9',
'食':'9',
'蚀':'9',
'炻':'9',
'埘':'10',
'莳':'10',
'鲥':'15',
'史':'5',
'矢':'5',
'豕':'7',
'使':'8',
'始':'8',
'驶':'8',
'屎':'9',
'士':'3',
'氏':'4',
'礻':'4',
'示':'5',
'世':'5',
'仕':'5',
'市':'5',
'式':'6',
'似':'6',
'势':'8',
'事':'8',
'侍':'8',
'饰':'8',
'试':'8',
'视':'8',
'拭':'9',
'贳':'9',
'柿':'9',
'是':'9',
'适':'9',
'恃':'9',
'室':'9',
'逝':'10',
'轼':'10',
'铈':'10',
'舐':'10',
'弑':'12',
'释':'12',
'谥':'12',
'嗜':'13',
'筮':'13',
'誓':'14',
'噬':'16',
'螫':'17',
'匙':'11',
'收':'6',
'手':'4',
'守':'6',
'首':'9',
'艏':'15',
'寿':'7',
'受':'8',
'狩':'9',
'授':'11',
'售':'11',
'兽':'11',
'绶':'11',
'瘦':'14',
'殳':'4',
'书':'4',
'疋':'5',
'抒':'7',
'纾':'7',
'枢':'8',
'叔':'8',
'姝':'9',
'殊':'10',
'倏':'10',
'菽':'11',
'梳':'11',
'淑':'11',
'舒':'12',
'疏':'12',
'摅':'13',
'输':'13',
'毹':'13',
'蔬':'15',
'秫':'10',
'孰':'11',
'赎':'12',
'塾':'14',
'熟':'15',
'暑':'12',
'黍':'12',
'属':'12',
'署':'13',
'蜀':'13',
'鼠':'13',
'薯':'16',
'曙':'17',
'丨':'1',
'忄':'3',
'术':'5',
'戍':'6',
'束':'7',
'述':'8',
'沭':'8',
'树':'9',
'竖':'9',
'恕':'10',
'庶':'11',
'腧':'13',
'数':'13',
'墅':'14',
'漱':'14',
'澍':'15',
'刷':'8',
'唰':'11',
'耍':'9',
'衰':'10',
'摔':'14',
'甩':'5',
'帅':'5',
'蟀':'17',
'闩':'4',
'拴':'9',
'栓':'10',
'涮':'11',
'双':'4',
'霜':'17',
'孀':'20',
'爽':'11',
'谁':'10',
'水':'4',
'税':'12',
'睡':'13',
'吮':'7',
'顺':'9',
'舜':'12',
'瞬':'17',
'说':'9',
'妁':'6',
'烁':'9',
'铄':'10',
'朔':'10',
'硕':'11',
'搠':'13',
'蒴':'13',
'槊':'14',
'厶':'2',
'司':'5',
'丝':'5',
'私':'7',
'咝':'8',
'思':'9',
'鸶':'10',
'斯':'12',
'蛳':'12',
'缌':'12',
'厮':'14',
'锶':'14',
'撕':'15',
'嘶':'15',
'澌':'15',
'死':'6',
'巳':'3',
'四':'5',
'寺':'6',
'汜':'6',
'兕':'7',
'伺':'7',
'祀':'7',
'姒':'7',
'饲':'8',
'泗':'8',
'驷':'8',
'俟':'9',
'耜':'11',
'笥':'11',
'肆':'13',
'嗣':'13',
'忪':'7',
'松':'8',
'凇':'10',
'菘':'11',
'崧':'11',
'淞':'11',
'嵩':'13',
'怂':'8',
'耸':'10',
'悚':'10',
'竦':'12',
'讼':'6',
'宋':'7',
'送':'9',
'诵':'9',
'颂':'10',
'搜':'12',
'嗖':'12',
'馊':'12',
'溲':'12',
'飕':'13',
'锼':'14',
'螋':'15',
'艘':'15',
'叟':'9',
'瞍':'14',
'嗾':'14',
'擞':'16',
'薮':'16',
'嗽':'14',
'苏':'7',
'酥':'12',
'稣':'13',
'俗':'9',
'夙':'6',
'诉':'7',
'肃':'8',
'素':'10',
'速':'10',
'涑':'10',
'粟':'12',
'谡':'12',
'嗉':'13',
'塑':'13',
'溯':'13',
'愫':'13',
'蔌':'14',
'僳':'14',
'觫':'14',
'簌':'17',
'狻':'10',
'酸':'14',
'蒜':'13',
'算':'14',
'虽':'9',
'荽':'10',
'眭':'11',
'睢':'13',
'濉':'16',
'绥':'10',
'隋':'11',
'随':'11',
'髓':'21',
'岁':'6',
'谇':'10',
'祟':'10',
'遂':'12',
'碎':'13',
'隧':'14',
'燧':'16',
'穗':'17',
'邃':'17',
'孙':'6',
'荪':'9',
'狲':'9',
'飧':'12',
'损':'10',
'笋':'10',
'隼':'10',
'榫':'14',
'唆':'10',
'娑':'10',
'桫':'11',
'梭':'11',
'挲':'11',
'睃':'12',
'蓑':'13',
'嗦':'13',
'嗍':'13',
'羧':'13',
'缩':'14',
'所':'8',
'索':'10',
'唢':'10',
'琐':'11',
'锁':'12',
'他':'5',
'它':'5',
'她':'6',
'趿':'10',
'铊':'10',
'塌':'13',
'遢':'13',
'溻':'13',
'塔':'12',
'獭':'16',
'鳎':'18',
'沓':'8',
'挞':'9',
'闼':'9',
'榻':'14',
'踏':'15',
'蹋':'17',
'胎':'9',
'台':'5',
'邰':'7',
'抬':'8',
'苔':'8',
'骀':'8',
'炱':'9',
'跆':'12',
'鲐':'13',
'薹':'17',
'呔':'7',
'太':'4',
'汰':'7',
'态':'8',
'肽':'8',
'钛':'9',
'泰':'10',
'酞':'11',
'坍':'7',
'贪':'8',
'摊':'13',
'滩':'13',
'瘫':'15',
'坛':'7',
'昙':'8',
'郯':'10',
'谈':'10',
'覃':'12',
'锬':'13',
'痰':'13',
'谭':'14',
'潭':'15',
'檀':'17',
'镡':'17',
'忐':'7',
'坦':'8',
'钽':'10',
'袒':'10',
'毯':'12',
'叹':'5',
'炭':'9',
'探':'11',
'赕':'12',
'碳':'14',
'汤':'6',
'铴':'11',
'耥':'14',
'羰':'15',
'饧':'6',
'唐':'10',
'堂':'11',
'棠':'12',
'塘':'13',
'搪':'13',
'溏':'13',
'瑭':'14',
'樘':'15',
'膛':'15',
'螗':'16',
'镗':'16',
'糖':'16',
'醣':'17',
'螳':'17',
'帑':'8',
'倘':'10',
'淌':'11',
'傥':'12',
'躺':'15',
'烫':'10',
'趟':'15',
'涛':'10',
'绦':'10',
'焘':'11',
'掏':'11',
'滔':'13',
'韬':'14',
'饕':'22',
'逃':'9',
'洮':'9',
'桃':'10',
'陶':'10',
'萄':'11',
'啕':'11',
'淘':'11',
'鼗':'19',
'讨':'5',
'套':'10',
'忑':'7',
'忒':'7',
'特':'10',
'铽':'12',
'慝':'14',
'疼':'10',
'腾':'13',
'誊':'13',
'滕':'15',
'藤':'18',
'剔':'10',
'梯':'11',
'锑':'12',
'踢':'15',
'扌':'3',
'绨':'10',
'提':'12',
'啼':'12',
'鹈':'12',
'缇':'12',
'题':'15',
'醍':'16',
'蹄':'16',
'体':'7',
'屉':'8',
'剃':'9',
'倜':'10',
'逖':'10',
'涕':'10',
'悌':'10',
'惕':'11',
'替':'12',
'裼':'13',
'嚏':'17',
'天':'4',
'添':'11',
'田':'5',
'畋':'9',
'恬':'9',
'甜':'11',
'填':'13',
'阗':'13',
'忝':'8',
'殄':'9',
'腆':'12',
'舔':'14',
'掭':'11',
'佻':'8',
'挑':'9',
'祧':'10',
'条':'7',
'苕':'8',
'迢':'8',
'调':'10',
'笤':'11',
'龆':'13',
'蜩':'14',
'髫':'15',
'鲦':'15',
'窕':'11',
'眺':'11',
'粜':'11',
'跳':'13',
'帖':'8',
'贴':'9',
'萜':'11',
'铁':'10',
'餮':'18',
'厅':'4',
'汀':'5',
'听':'7',
'烃':'9',
'廷':'6',
'莛':'9',
'亭':'9',
'庭':'9',
'停':'11',
'葶':'12',
'蜓':'12',
'婷':'12',
'霆':'14',
'挺':'9',
'梃':'10',
'艇':'12',
'通':'10',
'嗵':'13',
'冂':'2',
'仝':'5',
'同':'6',
'佟':'7',
'彤':'7',
'茼':'9',
'桐':'10',
'砼':'10',
'铜':'11',
'童':'12',
'酮':'13',
'僮':'14',
'潼':'15',
'瞳':'17',
'统':'9',
'捅':'10',
'桶':'11',
'筒':'12',
'恸':'9',
'痛':'12',
'偷':'11',
'头':'5',
'投':'7',
'骰':'13',
'透':'10',
'凸':'5',
'秃':'7',
'突':'9',
'图':'8',
'荼':'10',
'徒':'10',
'途':'10',
'涂':'10',
'屠':'11',
'酴':'14',
'土':'3',
'吐':'6',
'钍':'8',
'兔':'8',
'堍':'11',
'菟':'11',
'湍':'12',
'团':'6',
'抟':'7',
'疃':'17',
'彖':'9',
'推':'11',
'颓':'13',
'腿':'13',
'退':'9',
'蜕':'13',
'煺':'13',
'褪':'14',
'吞':'7',
'暾':'16',
'屯':'4',
'囤':'7',
'饨':'7',
'豚':'11',
'臀':'17',
'氽':'6',
'乇':'3',
'托':'6',
'拖':'8',
'脱':'11',
'驮':'6',
'佗':'7',
'陀':'7',
'坨':'8',
'沲':'8',
'沱':'8',
'驼':'8',
'柁':'9',
'砣':'10',
'鸵':'10',
'酡':'12',
'跎':'12',
'橐':'16',
'鼍':'20',
'妥':'7',
'庹':'11',
'椭':'12',
'拓':'8',
'柝':'9',
'唾':'11',
'箨':'14',
'挖':'9',
'哇':'9',
'洼':'9',
'娲':'10',
'蛙':'12',
'娃':'9',
'瓦':'4',
'佤':'6',
'袜':'10',
'腽':'13',
'歪':'9',
'崴':'12',
'外':'5',
'弯':'9',
'剜':'10',
'湾':'12',
'蜿':'14',
'箢':'14',
'豌':'15',
'丸':'3',
'芄':'6',
'纨':'6',
'完':'7',
'玩':'8',
'顽':'10',
'烷':'11',
'宛':'8',
'挽':'10',
'菀':'11',
'晚':'11',
'脘':'11',
'惋':'11',
'婉':'11',
'绾':'11',
'琬':'12',
'皖':'12',
'碗':'13',
'畹':'13',
'万':'3',
'腕':'12',
'汪':'7',
'亡':'3',
'王':'4',
'网':'6',
'枉':'8',
'罔':'8',
'往':'8',
'惘':'11',
'辋':'12',
'魍':'17',
'妄':'6',
'忘':'7',
'旺':'8',
'望':'11',
'危':'6',
'威':'9',
'逶':'11',
'偎':'11',
'隈':'11',
'葳':'12',
'微':'13',
'煨':'13',
'薇':'16',
'巍':'20',
'囗':'3',
'韦':'4',
'为':'4',
'圩':'6',
'违':'7',
'围':'7',
'帏':'7',
'闱':'7',
'沩':'7',
'桅':'10',
'涠':'10',
'唯':'11',
'帷':'11',
'惟':'11',
'维':'11',
'嵬':'12',
'潍':'14',
'伟':'6',
'伪':'6',
'苇':'7',
'尾':'7',
'纬':'7',
'玮':'8',
'委':'8',
'炜':'8',
'洧':'9',
'诿':'10',
'娓':'10',
'萎':'11',
'隗':'11',
'猥':'12',
'韪':'13',
'艉':'13',
'痿':'13',
'鲔':'14',
'卫':'3',
'未':'5',
'位':'7',
'味':'8',
'畏':'9',
'胃':'9',
'軎':'10',
'谓':'11',
'尉':'11',
'喂':'12',
'猬':'12',
'渭':'12',
'蔚':'14',
'慰':'15',
'魏':'17',
'温':'12',
'瘟':'14',
'亠':'2',
'文':'4',
'纹':'7',
'闻':'9',
'蚊':'10',
'阌':'11',
'雯':'12',
'刎':'6',
'吻':'7',
'紊':'10',
'稳':'14',
'问':'6',
'汶':'7',
'璺':'20',
'翁':'10',
'嗡':'13',
'蓊':'13',
'瓮':'8',
'蕹':'16',
'挝':'9',
'莴':'10',
'倭':'10',
'涡':'10',
'喔':'12',
'窝':'12',
'蜗':'13',
'我':'7',
'肟':'7',
'沃':'7',
'卧':'8',
'握':'12',
'硪':'12',
'幄':'12',
'渥':'12',
'斡':'14',
'龌':'17',
'乌':'4',
'圬':'6',
'邬':'6',
'污':'6',
'巫':'7',
'呜':'7',
'钨':'9',
'诬':'9',
'屋':'9',
'无':'4',
'毋':'4',
'芜':'7',
'吾':'7',
'吴':'7',
'唔':'10',
'浯':'10',
'梧':'11',
'蜈':'13',
'鼯':'20',
'五':'4',
'午':'4',
'伍':'6',
'仵':'6',
'迕':'7',
'庑':'7',
'怃':'7',
'忤':'7',
'妩':'7',
'武':'8',
'侮':'9',
'捂':'10',
'牾':'11',
'鹉':'13',
'舞':'14',
'兀':'3',
'勿':'4',
'戊':'5',
'务':'5',
'阢':'5',
'坞':'7',
'芴':'7',
'杌':'7',
'物':'8',
'误':'9',
'悟':'10',
'晤':'11',
'焐':'11',
'痦':'12',
'婺':'12',
'骛':'12',
'雾':'13',
'寤':'14',
'鹜':'14',
'鋈':'15',
'夕':'3',
'兮':'4',
'西':'6',
'吸':'6',
'汐':'6',
'希':'7',
'昔':'8',
'析':'8',
'矽':'8',
'穸':'8',
'郗':'9',
'唏':'10',
'牺':'10',
'息':'10',
'奚':'10',
'浠':'10',
'菥':'11',
'硒':'11',
'欷':'11',
'悉':'11',
'烯':'11',
'淅':'11',
'惜':'11',
'晰':'12',
'稀':'12',
'舾':'12',
'翕':'12',
'粞':'12',
'犀':'12',
'皙':'12',
'锡':'13',
'溪':'13',
'熙':'14',
'蜥':'14',
'僖':'14',
'熄':'14',
'嘻':'15',
'膝':'15',
'嬉':'15',
'熹':'16',
'樨':'16',
'螅':'16',
'歙':'16',
'羲':'16',
'蟋':'17',
'醯':'19',
'曦':'20',
'鼷':'23',
'习':'3',
'席':'10',
'觋':'11',
'袭':'11',
'媳':'13',
'隰':'16',
'檄':'17',
'洗':'9',
'玺':'10',
'铣':'11',
'徙':'11',
'喜':'12',
'葸':'12',
'蓰':'14',
'屣':'14',
'禧':'16',
'戏':'6',
'饩':'7',
'系':'7',
'细':'8',
'阋':'11',
'舄':'12',
'隙':'12',
'禊':'13',
'虾':'9',
'瞎':'15',
'匣':'7',
'侠':'8',
'狎':'8',
'柙':'9',
'峡':'9',
'狭':'9',
'硖':'11',
'遐':'12',
'瑕':'13',
'暇':'13',
'辖':'14',
'霞':'17',
'黠':'18',
'下':'3',
'吓':'6',
'夏':'10',
'罅':'17',
'仙':'5',
'先':'6',
'纤':'6',
'氙':'7',
'祆':'8',
'籼':'9',
'莶':'10',
'掀':'11',
'酰':'13',
'跹':'13',
'锨':'13',
'鲜':'14',
'暹':'15',
'闲':'7',
'贤':'8',
'弦':'8',
'咸':'9',
'涎':'9',
'娴':'10',
'衔':'11',
'舷':'11',
'痫':'12',
'鹇':'12',
'嫌':'13',
'冼':'8',
'显':'9',
'险':'9',
'蚬':'10',
'猃':'10',
'筅':'12',
'跣':'13',
'藓':'17',
'燹':'18',
'苋':'7',
'县':'7',
'岘':'7',
'现':'8',
'限':'8',
'线':'8',
'宪':'9',
'陷':'10',
'馅':'11',
'羡':'12',
'献':'13',
'腺':'13',
'霰':'20',
'乡':'3',
'芗':'6',
'相':'9',
'香':'9',
'厢':'11',
'葙':'12',
'湘':'12',
'缃':'12',
'箱':'15',
'襄':'17',
'骧':'20',
'镶':'22',
'详':'8',
'庠':'9',
'祥':'10',
'翔':'12',
'享':'8',
'响':'9',
'饷':'9',
'飨':'12',
'想':'13',
'鲞':'14',
'向':'6',
'项':'9',
'巷':'9',
'象':'11',
'像':'13',
'橡':'15',
'蟓':'17',
'肖':'7',
'枭':'8',
'枵':'9',
'哓':'9',
'骁':'9',
'逍':'10',
'消':'10',
'宵':'10',
'绡':'10',
'萧':'11',
'硝':'12',
'销':'12',
'箫':'14',
'潇':'14',
'霄':'15',
'魈':'16',
'嚣':'18',
'崤':'11',
'淆':'11',
'小':'3',
'晓':'10',
'筱':'13',
'孝':'7',
'校':'10',
'哮':'10',
'笑':'10',
'效':'10',
'啸':'11',
'些':'8',
'楔':'13',
'歇':'13',
'蝎':'15',
'协':'6',
'邪':'6',
'胁':'8',
'偕':'11',
'斜':'11',
'谐':'11',
'携':'13',
'撷':'15',
'鞋':'15',
'勰':'15',
'缬':'15',
'写':'5',
'泄':'8',
'泻':'8',
'绁':'8',
'卸':'9',
'屑':'10',
'械':'11',
'亵':'12',
'渫':'12',
'谢':'12',
'榭':'14',
'榍':'14',
'薤':'16',
'獬':'16',
'邂':'16',
'廨':'16',
'懈':'16',
'燮':'17',
'蟹':'19',
'瀣':'19',
'躞':'24',
'心':'4',
'芯':'7',
'辛':'7',
'忻':'7',
'昕':'8',
'欣':'8',
'锌':'12',
'新':'13',
'歆':'13',
'薪':'16',
'馨':'20',
'鑫':'24',
'囟':'6',
'信':'9',
'衅':'11',
'星':'9',
'猩':'12',
'惺':'12',
'腥':'13',
'刑':'6',
'邢':'6',
'形':'7',
'型':'9',
'硎':'11',
'醒':'16',
'擤':'17',
'兴':'6',
'杏':'7',
'幸':'8',
'性':'8',
'姓':'8',
'荇':'9',
'悻':'11',
'凶':'4',
'兄':'5',
'芎':'6',
'匈':'6',
'汹':'7',
'胸':'10',
'雄':'12',
'熊':'14',
'休':'6',
'咻':'9',
'修':'9',
'庥':'9',
'羞':'10',
'鸺':'11',
'貅':'13',
'馐':'13',
'髹':'16',
'朽':'6',
'宿':'11',
'秀':'7',
'岫':'8',
'袖':'10',
'绣':'10',
'锈':'12',
'嗅':'13',
'溴':'13',
'戌':'6',
'吁':'6',
'盱':'8',
'须':'9',
'胥':'9',
'顼':'10',
'虚':'11',
'墟':'14',
'需':'14',
'嘘':'14',
'徐':'10',
'许':'6',
'诩':'8',
'栩':'10',
'糈':'15',
'醑':'16',
'旭':'6',
'序':'7',
'叙':'9',
'洫':'9',
'恤':'9',
'酗':'11',
'勖':'11',
'绪':'11',
'续':'11',
'溆':'12',
'絮':'12',
'婿':'12',
'蓄':'13',
'煦':'13',
'蓿':'14',
'轩':'7',
'宣':'9',
'谖':'11',
'揎':'12',
'萱':'12',
'喧':'12',
'暄':'13',
'煊':'13',
'儇':'15',
'玄':'5',
'痃':'10',
'悬':'11',
'旋':'11',
'漩':'14',
'璇':'15',
'选':'9',
'癣':'19',
'泫':'8',
'炫':'9',
'绚':'9',
'眩':'10',
'铉':'10',
'渲':'12',
'楦':'13',
'碹':'14',
'镟':'16',
'削':'9',
'靴':'13',
'薛':'16',
'穴':'5',
'学':'8',
'泶':'9',
'踅':'14',
'噱':'16',
'雪':'11',
'鳕':'19',
'血':'6',
'谑':'11',
'勋':'9',
'埙':'10',
'熏':'14',
'窨':'14',
'薰':'17',
'獯':'17',
'曛':'18',
'醺':'21',
'旬':'6',
'寻':'6',
'巡':'6',
'郇':'8',
'询':'8',
'荀':'9',
'荨':'9',
'峋':'9',
'洵':'9',
'浔':'9',
'恂':'9',
'循':'12',
'鲟':'14',
'训':'5',
'讯':'5',
'汛':'6',
'迅':'6',
'驯':'6',
'徇':'9',
'逊':'9',
'殉':'10',
'巽':'12',
'蕈':'15',
'丫':'3',
'压':'6',
'押':'8',
'鸦':'9',
'桠':'10',
'鸭':'10',
'牙':'4',
'伢':'6',
'芽':'7',
'岈':'7',
'琊':'10',
'蚜':'10',
'崖':'11',
'涯':'11',
'睚':'13',
'衙':'13',
'哑':'9',
'痖':'11',
'雅':'12',
'亚':'6',
'讶':'6',
'迓':'7',
'垭':'9',
'砑':'9',
'娅':'9',
'氩':'10',
'揠':'12',
'呀':'7',
'咽':'9',
'恹':'9',
'胭':'10',
'烟':'10',
'焉':'11',
'菸':'11',
'崦':'11',
'阉':'11',
'淹':'11',
'腌':'12',
'湮':'12',
'鄢':'13',
'嫣':'14',
'讠':'2',
'延':'6',
'闫':'6',
'严':'7',
'言':'7',
'妍':'7',
'岩':'8',
'炎':'8',
'沿':'8',
'研':'9',
'盐':'10',
'阎':'11',
'蜒':'12',
'筵':'12',
'颜':'15',
'檐':'17',
'奄':'8',
'兖':'8',
'俨':'9',
'衍':'9',
'剡':'10',
'掩':'11',
'郾':'11',
'厣':'11',
'眼':'11',
'偃':'11',
'琰':'12',
'罨':'13',
'演':'14',
'魇':'15',
'鼹':'23',
'厌':'6',
'砚':'9',
'彦':'9',
'艳':'10',
'晏':'10',
'唁':'10',
'宴':'10',
'验':'10',
'谚':'11',
'堰':'12',
'雁':'12',
'焰':'12',
'焱':'12',
'滟':'13',
'酽':'14',
'餍':'15',
'谳':'15',
'燕':'16',
'赝':'16',
'央':'5',
'泱':'8',
'殃':'9',
'鸯':'10',
'秧':'10',
'鞅':'14',
'扬':'6',
'羊':'6',
'阳':'6',
'杨':'7',
'炀':'7',
'佯':'8',
'疡':'8',
'徉':'9',
'洋':'9',
'蛘':'12',
'仰':'6',
'养':'9',
'氧':'10',
'痒':'11',
'怏':'8',
'样':'10',
'恙':'10',
'烊':'10',
'漾':'14',
'幺':'3',
'夭':'4',
'吆':'6',
'妖':'7',
'腰':'13',
'邀':'16',
'爻':'4',
'尧':'6',
'侥':'8',
'肴':'8',
'轺':'9',
'姚':'9',
'珧':'10',
'窑':'11',
'谣':'12',
'摇':'13',
'徭':'13',
'遥':'13',
'瑶':'14',
'繇':'17',
'鳐':'18',
'杳':'8',
'咬':'9',
'舀':'10',
'窈':'10',
'崾':'12',
'药':'9',
'要':'9',
'钥':'9',
'鹞':'15',
'曜':'18',
'耀':'20',
'耶':'8',
'掖':'11',
'椰':'12',
'噎':'15',
'爷':'6',
'揶':'11',
'铘':'11',
'也':'3',
'冶':'7',
'野':'11',
'业':'5',
'叶':'5',
'页':'6',
'曳':'6',
'邺':'7',
'夜':'8',
'晔':'10',
'烨':'10',
'液':'11',
'谒':'11',
'腋':'12',
'靥':'15',
'一':'1',
'衤':'5',
'伊':'6',
'衣':'6',
'医':'7',
'依':'8',
'咿':'9',
'铱':'11',
'猗':'11',
'揖':'12',
'壹':'12',
'欹':'12',
'漪':'14',
'噫':'16',
'黟':'18',
'仪':'5',
'圯':'6',
'夷':'6',
'沂':'7',
'诒':'7',
'饴':'8',
'怡':'8',
'宜':'8',
'荑':'9',
'咦':'9',
'贻':'9',
'姨':'9',
'眙':'10',
'胰':'10',
'移':'11',
'痍':'11',
'遗':'12',
'颐':'13',
'疑':'14',
'嶷':'17',
'彝':'18',
'乙':'1',
'已':'3',
'以':'4',
'钇':'6',
'苡':'7',
'矣':'7',
'迤':'8',
'蚁':'9',
'舣':'9',
'倚':'10',
'椅':'12',
'旖':'14',
'弋':'3',
'亿':'3',
'义':'3',
'艺':'4',
'刈':'4',
'忆':'4',
'仡':'5',
'议':'5',
'屹':'6',
'亦':'6',
'异':'6',
'抑':'7',
'呓':'7',
'邑':'7',
'佚':'7',
'役':'7',
'译':'7',
'易':'8',
'峄':'8',
'佾':'8',
'怿':'8',
'诣':'8',
'绎':'8',
'驿':'8',
'轶':'9',
'弈':'9',
'奕':'9',
'疫':'9',
'羿':'9',
'挹':'10',
'酏':'10',
'益':'10',
'悒':'10',
'谊':'10',
'埸':'11',
'逸':'11',
'翊':'11',
'翌':'11',
'肄':'13',
'裔':'13',
'意':'13',
'溢':'13',
'缢':'13',
'蜴':'14',
'瘗':'14',
'镒':'15',
'毅':'15',
'熠':'15',
'薏':'16',
'殪':'16',
'劓':'16',
'翳':'17',
'臆':'17',
'翼':'17',
'镱':'18',
'癔':'18',
'懿':'22',
'因':'6',
'阴':'6',
'茵':'9',
'荫':'9',
'音':'9',
'洇':'9',
'姻':'9',
'氤':'10',
'殷':'10',
'铟':'11',
'堙':'12',
'喑':'12',
'吟':'7',
'垠':'9',
'狺':'10',
'银':'11',
'淫':'11',
'寅':'11',
'鄞':'13',
'龈':'14',
'夤':'14',
'霪':'19',
'尹':'4',
'引':'4',
'吲':'7',
'饮':'7',
'蚓':'10',
'隐':'11',
'瘾':'16',
'廴':'2',
'印':'5',
'茚':'8',
'胤':'9',
'英':'8',
'莺':'10',
'婴':'11',
'瑛':'12',
'撄':'14',
'嘤':'14',
'罂':'14',
'缨':'14',
'璎':'15',
'樱':'15',
'鹦':'16',
'膺':'17',
'鹰':'18',
'迎':'7',
'茔':'8',
'荥':'9',
'荧':'9',
'盈':'9',
'莹':'10',
'萤':'11',
'营':'11',
'萦':'11',
'蓥':'13',
'楹':'13',
'滢':'13',
'蝇':'14',
'潆':'14',
'嬴':'16',
'赢':'17',
'瀛':'19',
'郢':'9',
'颍':'12',
'颖':'13',
'影':'15',
'瘿':'16',
'应':'7',
'映':'9',
'硬':'12',
'媵':'13',
'哟':'9',
'唷':'11',
'佣':'7',
'拥':'8',
'痈':'10',
'邕':'10',
'庸':'11',
'雍':'13',
'墉':'14',
'慵':'14',
'镛':'16',
'壅':'16',
'臃':'17',
'鳙':'19',
'饔':'22',
'永':'5',
'甬':'7',
'咏':'8',
'泳':'8',
'俑':'9',
'勇':'9',
'涌':'10',
'恿':'11',
'蛹':'13',
'踊':'14',
'用':'5',
'优':'6',
'攸':'7',
'忧':'7',
'呦':'8',
'幽':'9',
'悠':'11',
'尢':'3',
'尤':'4',
'由':'5',
'邮':'7',
'犹':'7',
'油':'8',
'疣':'9',
'莜':'10',
'莸':'10',
'铀':'10',
'蚰':'11',
'鱿':'12',
'游':'12',
'猷':'13',
'蝣':'15',
'友':'4',
'有':'6',
'酉':'7',
'卣':'7',
'莠':'10',
'铕':'11',
'牖':'15',
'黝':'17',
'又':'2',
'右':'5',
'幼':'5',
'佑':'7',
'侑':'8',
'柚':'9',
'囿':'9',
'宥':'9',
'诱':'9',
'蚴':'11',
'釉':'12',
'鼬':'18',
'迂':'6',
'纡':'6',
'於':'8',
'淤':'11',
'瘀':'13',
'于':'3',
'欤':'7',
'余':'7',
'妤':'7',
'盂':'8',
'臾':'8',
'鱼':'8',
'禺':'9',
'竽':'9',
'舁':'9',
'俞':'9',
'狳':'10',
'馀':'10',
'谀':'10',
'娱':'10',
'萸':'11',
'雩':'11',
'渔':'11',
'隅':'11',
'揄':'12',
'喁':'12',
'嵛':'12',
'逾':'12',
'腴':'12',
'渝':'12',
'愉':'12',
'瑜':'13',
'榆':'13',
'虞':'13',
'愚':'13',
'觎':'13',
'舆':'14',
'窬':'14',
'蝓':'15',
'与':'3',
'予':'4',
'屿':'6',
'伛':'6',
'宇':'6',
'羽':'6',
'雨':'8',
'俣':'9',
'禹':'9',
'语':'9',
'圄':'10',
'圉':'11',
'庾':'11',
'瘐':'13',
'龉':'15',
'窳':'15',
'玉':'5',
'驭':'5',
'芋':'6',
'聿':'6',
'饫':'7',
'妪':'7',
'郁':'8',
'育':'8',
'昱':'9',
'狱':'9',
'峪':'10',
'钰':'10',
'浴':'10',
'预':'10',
'域':'11',
'欲':'11',
'阈':'11',
'谕':'11',
'遇':'12',
'喻':'12',
'御':'12',
'鹆':'12',
'寓':'12',
'裕':'12',
'蓣':'13',
'愈':'13',
'煜':'13',
'誉':'13',
'蜮':'14',
'毓':'14',
'豫':'15',
'燠':'16',
'鹬':'17',
'鬻':'22',
'鸢':'8',
'眢':'10',
'鸳':'10',
'冤':'10',
'渊':'11',
'元':'4',
'芫':'7',
'园':'7',
'员':'7',
'沅':'7',
'垣':'9',
'爰':'9',
'袁':'10',
'原':'10',
'圆':'10',
'鼋':'12',
'援':'12',
'媛':'12',
'缘':'12',
'塬':'13',
'猿':'13',
'源':'13',
'辕':'14',
'橼':'16',
'螈':'16',
'远':'7',
'苑':'8',
'怨':'9',
'院':'9',
'垸':'10',
'掾':'12',
'瑗':'13',
'愿':'14',
'曰':'4',
'约':'6',
'月':'4',
'刖':'6',
'岳':'8',
'钺':'10',
'阅':'10',
'悦':'10',
'跃':'11',
'越':'12',
'粤':'12',
'樾':'16',
'龠':'17',
'瀹':'20',
'晕':'10',
'氲':'13',
'云':'4',
'匀':'4',
'芸':'7',
'纭':'7',
'昀':'8',
'郧':'9',
'耘':'10',
'允':'4',
'狁':'7',
'陨':'9',
'殒':'11',
'孕':'5',
'运':'7',
'郓':'8',
'恽':'9',
'酝':'11',
'愠':'12',
'韫':'13',
'韵':'13',
'蕴':'15',
'熨':'15',
'匝':'5',
'咂':'8',
'拶':'9',
'杂':'6',
'砸':'10',
'咋':'8',
'灾':'7',
'甾':'8',
'哉':'9',
'栽':'10',
'仔':'5',
'载':'10',
'宰':'10',
'崽':'12',
'再':'6',
'在':'6',
'糌':'15',
'簪':'18',
'咱':'9',
'昝':'9',
'攒':'19',
'趱':'23',
'暂':'12',
'錾':'16',
'赞':'16',
'瓒':'20',
'赃':'10',
'脏':'10',
'臧':'14',
'驵':'8',
'奘':'10',
'葬':'12',
'遭':'14',
'糟':'17',
'凿':'12',
'早':'6',
'枣':'8',
'蚤':'9',
'澡':'16',
'藻':'19',
'皂':'7',
'灶':'7',
'唣':'10',
'造':'10',
'噪':'16',
'燥':'17',
'躁':'20',
'则':'6',
'责':'8',
'择':'8',
'迮':'8',
'泽':'8',
'啧':'11',
'帻':'11',
'笮':'11',
'舴':'11',
'箦':'14',
'赜':'15',
'仄':'4',
'昃':'8',
'贼':'10',
'怎':'9',
'谮':'14',
'增':'15',
'憎':'15',
'罾':'17',
'锃':'12',
'缯':'15',
'赠':'16',
'甑':'16',
'扎':'4',
'吒':'6',
'哳':'10',
'揸':'12',
'喳':'12',
'渣':'12',
'楂':'13',
'齄':'23',
'札':'5',
'轧':'5',
'闸':'8',
'铡':'11',
'眨':'9',
'砟':'10',
'乍':'5',
'诈':'7',
'柞':'9',
'栅':'9',
'咤':'9',
'炸':'9',
'痄':'10',
'蚱':'11',
'榨':'14',
'斋':'10',
'摘':'14',
'宅':'6',
'翟':'14',
'窄':'10',
'债':'10',
'砦':'11',
'寨':'14',
'瘵':'16',
'沾':'8',
'毡':'9',
'旃':'10',
'粘':'11',
'詹':'13',
'谵':'15',
'瞻':'18',
'斩':'8',
'盏':'10',
'展':'10',
'崭':'11',
'搌':'13',
'辗':'14',
'占':'5',
'栈':'9',
'战':'9',
'站':'10',
'绽':'11',
'湛':'12',
'蘸':'22',
'张':'7',
'章':'11',
'鄣':'13',
'獐':'14',
'彰':'14',
'漳':'14',
'嫜':'14',
'璋':'15',
'樟':'15',
'蟑':'17',
'长':'4',
'仉':'4',
'涨':'10',
'掌':'12',
'丈':'3',
'仗':'5',
'杖':'7',
'帐':'7',
'账':'8',
'胀':'8',
'障':'13',
'嶂':'14',
'幛':'14',
'瘴':'16',
'钊':'7',
'招':'8',
'昭':'9',
'爪':'4',
'找':'7',
'沼':'8',
'召':'5',
'兆':'6',
'诏':'7',
'赵':'9',
'笊':'10',
'棹':'12',
'照':'13',
'罩':'13',
'肇':'14',
'蜇':'13',
'遮':'14',
'折':'7',
'哲':'10',
'辄':'11',
'蛰':'12',
'谪':'13',
'摺':'14',
'磔':'15',
'辙':'16',
'者':'8',
'锗':'13',
'赭':'15',
'褶':'16',
'这':'7',
'柘':'9',
'浙':'10',
'蔗':'14',
'鹧':'16',
'着':'11',
'贞':'6',
'针':'7',
'侦':'8',
'珍':'9',
'帧':'9',
'胗':'9',
'浈':'9',
'真':'10',
'桢':'10',
'砧':'10',
'祯':'10',
'蓁':'13',
'斟':'13',
'甄':'13',
'榛':'14',
'箴':'15',
'臻':'16',
'诊':'7',
'枕':'8',
'轸':'9',
'畛':'10',
'疹':'10',
'缜':'13',
'稹':'15',
'圳':'6',
'阵':'6',
'鸩':'9',
'振':'10',
'朕':'10',
'赈':'11',
'震':'15',
'镇':'15',
'争':'6',
'征':'8',
'怔':'8',
'峥':'9',
'狰':'9',
'钲':'10',
'睁':'11',
'铮':'11',
'筝':'12',
'蒸':'13',
'拯':'9',
'整':'16',
'正':'5',
'证':'7',
'郑':'8',
'诤':'8',
'政':'9',
'挣':'9',
'症':'10',
'之':'3',
'支':'4',
'只':'5',
'卮':'5',
'汁':'5',
'芝':'6',
'吱':'7',
'枝':'8',
'知':'8',
'肢':'8',
'织':'8',
'栀':'9',
'胝':'9',
'祗':'9',
'脂':'10',
'蜘':'14',
'执':'6',
'直':'8',
'侄':'8',
'值':'10',
'埴':'11',
'职':'11',
'絷':'12',
'植':'12',
'殖':'12',
'跖':'12',
'摭':'14',
'踯':'15',
'夂':'3',
'止':'4',
'旨':'6',
'址':'7',
'芷':'7',
'纸':'7',
'祉':'8',
'指':'9',
'枳':'9',
'轵':'9',
'咫':'9',
'趾':'11',
'黹':'12',
'酯':'13',
'徵':'15',
'至':'6',
'志':'7',
'豸':'7',
'忮':'7',
'郅':'8',
'帜':'8',
'帙':'8',
'制':'8',
'质':'8',
'炙':'8',
'治':'8',
'栉':'9',
'峙':'9',
'陟':'9',
'贽':'10',
'挚':'10',
'桎':'10',
'轾':'10',
'致':'10',
'秩':'10',
'鸷':'11',
'掷':'11',
'痔':'11',
'窒':'11',
'蛭':'12',
'智':'12',
'痣':'12',
'滞':'12',
'骘':'12',
'彘':'12',
'置':'13',
'雉':'13',
'稚':'13',
'踬':'15',
'膣':'15',
'觯':'15',
'中':'4',
'忠':'8',
'终':'8',
'盅':'9',
'钟':'9',
'舯':'10',
'衷':'10',
'锺':'14',
'螽':'17',
'肿':'8',
'种':'9',
'冢':'10',
'踵':'16',
'仲':'6',
'众':'6',
'重':'9',
'舟':'6',
'州':'6',
'诌':'7',
'周':'8',
'洲':'9',
'啁':'11',
'粥':'12',
'妯':'8',
'轴':'9',
'碡':'14',
'肘':'7',
'纣':'6',
'咒':'8',
'宙':'8',
'绉':'8',
'荮':'9',
'胄':'9',
'昼':'9',
'酎':'10',
'皱':'10',
'骤':'17',
'籀':'19',
'帚':'8',
'朱':'6',
'邾':'8',
'侏':'8',
'诛':'8',
'茱':'9',
'洙':'9',
'珠':'10',
'株':'10',
'诸':'10',
'铢':'11',
'猪':'11',
'蛛':'12',
'槠':'14',
'潴':'14',
'橥':'15',
'竹':'6',
'竺':'8',
'逐':'10',
'烛':'10',
'舳':'11',
'瘃':'13',
'躅':'20',
'主':'5',
'拄':'8',
'渚':'11',
'煮':'12',
'嘱':'15',
'麈':'16',
'瞩':'17',
'伫':'6',
'苎':'7',
'助':'7',
'住':'7',
'杼':'8',
'贮':'8',
'注':'8',
'驻':'8',
'柱':'9',
'炷':'9',
'祝':'9',
'疰':'10',
'著':'11',
'蛀':'11',
'铸':'12',
'筑':'12',
'翥':'14',
'箸':'14',
'抓':'7',
'拽':'9',
'专':'4',
'砖':'9',
'颛':'15',
'转':'8',
'啭':'11',
'赚':'14',
'撰':'15',
'篆':'15',
'馔':'15',
'妆':'6',
'庄':'6',
'桩':'10',
'装':'12',
'丬':'3',
'壮':'6',
'状':'7',
'撞':'15',
'幢':'15',
'隹':'8',
'追':'9',
'骓':'11',
'椎':'12',
'锥':'13',
'坠':'7',
'缀':'11',
'惴':'12',
'缒':'12',
'赘':'14',
'肫':'8',
'窀':'9',
'谆':'10',
'准':'10',
'拙':'8',
'捉':'10',
'桌':'10',
'倬':'10',
'涿':'11',
'灼':'7',
'茁':'8',
'卓':'8',
'斫':'9',
'浊':'9',
'酌':'10',
'浞':'10',
'诼':'10',
'啄':'11',
'琢':'12',
'禚':'14',
'擢':'17',
'濯':'17',
'镯':'18',
'孜':'7',
'咨':'9',
'姿':'9',
'兹':'9',
'赀':'10',
'资':'10',
'淄':'11',
'谘':'11',
'缁':'11',
'辎':'12',
'嵫':'12',
'粢':'12',
'孳':'12',
'滋':'12',
'趑':'13',
'锱':'13',
'龇':'14',
'髭':'16',
'鲻':'16',
'子':'3',
'姊':'7',
'耔':'9',
'秭':'9',
'籽':'9',
'笫':'10',
'梓':'11',
'紫':'12',
'訾':'13',
'滓':'13',
'自':'6',
'字':'6',
'恣':'10',
'眦':'11',
'渍':'11',
'宗':'8',
'综':'11',
'棕':'12',
'腙':'12',
'踪':'15',
'鬃':'18',
'总':'9',
'偬':'11',
'纵':'7',
'粽':'14',
'邹':'7',
'驺':'8',
'诹':'10',
'陬':'10',
'鄹':'16',
'鲰':'16',
'辶':'3',
'走':'7',
'奏':'9',
'揍':'12',
'租':'10',
'菹':'11',
'足':'7',
'卒':'8',
'族':'11',
'镞':'16',
'诅':'7',
'阻':'7',
'组':'8',
'俎':'9',
'祖':'9',
'躜':'23',
'缵':'19',
'纂':'20',
'钻':'10',
'攥':'23',
'觜':'13',
'嘴':'16',
'最':'12',
'罪':'13',
'蕞':'15',
'醉':'15',
'尊':'12',
'遵':'15',
'樽':'16',
'鳟':'20',
'撙':'15',
'嘬':'15',
'昨':'9',
'阝':'2',
'左':'5',
'佐':'7',
'作':'7',
'坐':'7',
'阼':'7',
'怍':'8',
'胙':'9',
'祚':'9',
'唑':'10',
'座':'10',
'做':'11',
'酢':'12'
}


def get_similar_by_shape(char1, char2, rounded=4):
    """   计算字形相似度   """
    # 获取四码和汉字笔画数
    structure1 = StructureDict.get(char1, None)
    structure2 = StructureDict.get(char2, None)
    stroke1 = StrokeDict.get(char1, None)
    stroke2 = StrokeDict.get(char2, None)
    code1 = FourAngleDict.get(char1, None)
    code2 = FourAngleDict.get(char2, None)

    # 定义结构相似度
    if structure1 and structure2 and structure1 == structure2:
        score_structure = 1
    else:
        score_structure = 0

    # 定义四码相似度
    score_code = 0
    if code1 and code2:
        # 四码分为四位计算，若相同则指数+1，不同为0,总权数除以4再加权
        for idx in range(4):
            if code1[idx] == code2[idx]:
                score_code += 1
        score_code /= 4

    # 笔画数利用相对偏差的方式进行计算
    score_stroke = 0
    if stroke1 and stroke2:
        stroke1 = int(stroke1)
        stroke2 = int(stroke2)
        score_stroke = 1 - abs((stroke1 - stroke2) / max(stroke1, stroke2))
    # 四码权重、笔画权重和结构权重分别为为 0.4 0.3 0.3
    score_shape = score_code * 0.4 + score_stroke * 0.3 + score_structure * 0.3
    score_shape = round(score_shape, rounded)
    return score_shape
def save_json(jsons, json_path, indent=4):
    """
        保存json
    Args:
        path[String]:, path of file of save, eg. "corpus/xuexiqiangguo.lib"
        jsons[Json]: json of input data, eg. [{"桂林": 132}]
        indent[int]: pretty-printed with that indent level, eg. 4
    Returns:
        None
    """
    with open(json_path, "w", encoding="utf-8") as fj:
        fj.write(json.dumps(jsons, ensure_ascii=False, indent=indent))
    fj.close()
def load_json(path, parse_int=None):
    """
        加载json
    Args:
        path_file[String]:, path of file of save, eg. "corpus/xuexiqiangguo.lib"
        parse_int[Boolean]: equivalent to int(num_str), eg. True or False
    Returns:
        data[Any]
    """
    with open(path, mode="r", encoding="utf-8") as fj:
        model_json = json.load(fj, parse_int=parse_int)
    return model_json

def calculate_char_similarity():
    """   计算 单字 相似度   """
    path_confusion = "D:/workspace/code_yxp/code_own/text-composition/sample_v2_2023/confusion_merge_all_fix_dict.json"
    with open(path_confusion, mode="r", encoding="utf-8") as fj:
        model_json = json.load(fj)
        model_json_new = {}
        count = 0
        for k, v in tqdm(model_json.items(), desc="data"):
            v_score = []
            for vi in v:
                try:
                    score_sim = get_similar_by_shape(k, vi)
                except Exception as e:
                    print(traceback.print_exc())
                    print(k, vi)
                    score_sim = 0
                if k != vi:
                    v_score.append((vi, score_sim))
            v_score_sorted = sorted(iter(v_score), key=lambda x: x[-1], reverse=True)
            # model_json_new[k] = v_score_sorted[:5]
            if len(v_score_sorted) <= 5:
                v_score_sorted = [v[0] for v in v_score_sorted]
            else:
                v_score_sorted = [v[0] for v in v_score_sorted if v[-1] > 0.6]
            # model_json_new[k] = v_score_sorted[:5]

            if v_score_sorted:
                model_json_new[k] = v_score_sorted[:20]
                count += len(v_score_sorted[:20])
        save_json(model_json_new, "confusion_merge_all_fix_dict.sort_v2.json")
        print(len(model_json_new))
        print(count)
        """
        5520, 143005

        5520  80770
        """


if __name__ == '__main__':
    ee = 0





